/* chess-clock.c generated by valac 0.42.6, the Vala compiler
 * generated from chess-clock.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2014 Michael Catanzaro
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	CLOCK_TYPE_SIMPLE,
	CLOCK_TYPE_FISCHER,
	CLOCK_TYPE_BRONSTEIN,
	CLOCK_TYPE_INVALID
} ClockType;


#define TYPE_CLOCK_TYPE (clock_type_get_type ())

#define TYPE_CHESS_CLOCK (chess_clock_get_type ())
#define CHESS_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_CLOCK, ChessClock))
#define CHESS_CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_CLOCK, ChessClockClass))
#define IS_CHESS_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_CLOCK))
#define IS_CHESS_CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_CLOCK))
#define CHESS_CLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_CLOCK, ChessClockClass))

typedef struct _ChessClock ChessClock;
typedef struct _ChessClockClass ChessClockClass;
typedef struct _ChessClockPrivate ChessClockPrivate;
typedef enum  {
	COLOR_WHITE,
	COLOR_BLACK
} Color;


#define TYPE_COLOR (color_get_type ())
enum  {
	CHESS_CLOCK_0_PROPERTY,
	CHESS_CLOCK_EXTRA_SECONDS_PROPERTY,
	CHESS_CLOCK_WHITE_REMAINING_SECONDS_PROPERTY,
	CHESS_CLOCK_BLACK_REMAINING_SECONDS_PROPERTY,
	CHESS_CLOCK_CLOCK_TYPE_PROPERTY,
	CHESS_CLOCK_ACTIVE_COLOR_PROPERTY,
	CHESS_CLOCK_NUM_PROPERTIES
};
static GParamSpec* chess_clock_properties[CHESS_CLOCK_NUM_PROPERTIES];
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
enum  {
	CHESS_CLOCK_TICK_SIGNAL,
	CHESS_CLOCK_EXPIRED_SIGNAL,
	CHESS_CLOCK_NUM_SIGNALS
};
static guint chess_clock_signals[CHESS_CLOCK_NUM_SIGNALS] = {0};

struct _ChessClock {
	GObject parent_instance;
	ChessClockPrivate * priv;
};

struct _ChessClockClass {
	GObjectClass parent_class;
};

struct _ChessClockPrivate {
	gint white_initial_seconds;
	gint black_initial_seconds;
	gint white_seconds_used;
	gint black_seconds_used;
	gint white_prev_move_seconds;
	gint black_prev_move_seconds;
	gint white_extra_seconds;
	gint black_extra_seconds;
	gint _extra_seconds;
	ClockType _clock_type;
	Color _active_color;
	GTimer* timer;
	guint tick_timeout_id;
	gboolean is_active;
};


static gint ChessClock_private_offset;
static gpointer chess_clock_parent_class = NULL;

GType clock_type_get_type (void) G_GNUC_CONST;
gchar* clock_type_to_string (ClockType self);
ClockType clock_type_string_to_enum (const gchar* s);
GType chess_clock_get_type (void) G_GNUC_CONST;
GType color_get_type (void) G_GNUC_CONST;
ChessClock* chess_clock_new (gint white_initial_seconds,
                             gint black_initial_seconds);
ChessClock* chess_clock_construct (GType object_type,
                                   gint white_initial_seconds,
                                   gint black_initial_seconds);
void chess_clock_start (ChessClock* self);
static void chess_clock_watch_timer (ChessClock* self);
static gboolean chess_clock_tick_cb (ChessClock* self);
Color chess_clock_get_active_color (ChessClock* self);
void chess_clock_stop (ChessClock* self);
static void chess_clock_stop_watching_timer (ChessClock* self);
void chess_clock_pause (ChessClock* self);
void chess_clock_unpause (ChessClock* self);
static gboolean _chess_clock_tick_cb_gsource_func (gpointer self);
void chess_clock_update_prev_move_time (ChessClock* self);
static void chess_clock_update_extra_seconds (ChessClock* self);
ClockType chess_clock_get_clock_type (ChessClock* self);
gint chess_clock_get_extra_seconds (ChessClock* self);
void chess_clock_set_extra_seconds (ChessClock* self,
                                    gint value);
gint chess_clock_get_white_remaining_seconds (ChessClock* self);
gint chess_clock_get_black_remaining_seconds (ChessClock* self);
void chess_clock_set_clock_type (ChessClock* self,
                                 ClockType value);
void chess_clock_set_active_color (ChessClock* self,
                                   Color value);
static void chess_clock_finalize (GObject * obj);
static void _vala_chess_clock_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_chess_clock_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);


gchar*
clock_type_to_string (ClockType self)
{
	gchar* result = NULL;
#line 23 "../lib/chess-clock.vala"
	switch (self) {
#line 23 "../lib/chess-clock.vala"
		case CLOCK_TYPE_SIMPLE:
#line 149 "chess-clock.c"
		{
			gchar* _tmp0_;
#line 26 "../lib/chess-clock.vala"
			_tmp0_ = g_strdup ("simple");
#line 26 "../lib/chess-clock.vala"
			result = _tmp0_;
#line 26 "../lib/chess-clock.vala"
			return result;
#line 158 "chess-clock.c"
		}
#line 23 "../lib/chess-clock.vala"
		case CLOCK_TYPE_FISCHER:
#line 162 "chess-clock.c"
		{
			gchar* _tmp1_;
#line 28 "../lib/chess-clock.vala"
			_tmp1_ = g_strdup ("fischer");
#line 28 "../lib/chess-clock.vala"
			result = _tmp1_;
#line 28 "../lib/chess-clock.vala"
			return result;
#line 171 "chess-clock.c"
		}
#line 23 "../lib/chess-clock.vala"
		case CLOCK_TYPE_BRONSTEIN:
#line 175 "chess-clock.c"
		{
			gchar* _tmp2_;
#line 30 "../lib/chess-clock.vala"
			_tmp2_ = g_strdup ("bronstein");
#line 30 "../lib/chess-clock.vala"
			result = _tmp2_;
#line 30 "../lib/chess-clock.vala"
			return result;
#line 184 "chess-clock.c"
		}
		default:
		{
#line 32 "../lib/chess-clock.vala"
			g_assert_not_reached ();
#line 190 "chess-clock.c"
		}
	}
}


ClockType
clock_type_string_to_enum (const gchar* s)
{
	ClockType result = 0;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 38 "../lib/chess-clock.vala"
	static GQuark _tmp1_label0 = 0;
#line 38 "../lib/chess-clock.vala"
	static GQuark _tmp1_label1 = 0;
#line 38 "../lib/chess-clock.vala"
	static GQuark _tmp1_label2 = 0;
#line 36 "../lib/chess-clock.vala"
	g_return_val_if_fail (s != NULL, 0);
#line 38 "../lib/chess-clock.vala"
	_tmp0_ = s;
#line 38 "../lib/chess-clock.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 38 "../lib/chess-clock.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("simple")))) {
#line 38 "../lib/chess-clock.vala"
		switch (0) {
#line 218 "chess-clock.c"
			default:
			{
#line 41 "../lib/chess-clock.vala"
				result = CLOCK_TYPE_SIMPLE;
#line 41 "../lib/chess-clock.vala"
				return result;
#line 225 "chess-clock.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("fischer")))) {
#line 38 "../lib/chess-clock.vala"
		switch (0) {
#line 231 "chess-clock.c"
			default:
			{
#line 43 "../lib/chess-clock.vala"
				result = CLOCK_TYPE_FISCHER;
#line 43 "../lib/chess-clock.vala"
				return result;
#line 238 "chess-clock.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("bronstein")))) {
#line 38 "../lib/chess-clock.vala"
		switch (0) {
#line 244 "chess-clock.c"
			default:
			{
#line 45 "../lib/chess-clock.vala"
				result = CLOCK_TYPE_BRONSTEIN;
#line 45 "../lib/chess-clock.vala"
				return result;
#line 251 "chess-clock.c"
			}
		}
	} else {
#line 38 "../lib/chess-clock.vala"
		switch (0) {
#line 257 "chess-clock.c"
			default:
			{
#line 47 "../lib/chess-clock.vala"
				result = CLOCK_TYPE_INVALID;
#line 47 "../lib/chess-clock.vala"
				return result;
#line 264 "chess-clock.c"
			}
		}
	}
}


GType
clock_type_get_type (void)
{
	static volatile gsize clock_type_type_id__volatile = 0;
	if (g_once_init_enter (&clock_type_type_id__volatile)) {
		static const GEnumValue values[] = {{CLOCK_TYPE_SIMPLE, "CLOCK_TYPE_SIMPLE", "simple"}, {CLOCK_TYPE_FISCHER, "CLOCK_TYPE_FISCHER", "fischer"}, {CLOCK_TYPE_BRONSTEIN, "CLOCK_TYPE_BRONSTEIN", "bronstein"}, {CLOCK_TYPE_INVALID, "CLOCK_TYPE_INVALID", "invalid"}, {0, NULL, NULL}};
		GType clock_type_type_id;
		clock_type_type_id = g_enum_register_static ("ClockType", values);
		g_once_init_leave (&clock_type_type_id__volatile, clock_type_type_id);
	}
	return clock_type_type_id__volatile;
}


static inline gpointer
chess_clock_get_instance_private (ChessClock* self)
{
	return G_STRUCT_MEMBER_P (self, ChessClock_private_offset);
}


ChessClock*
chess_clock_construct (GType object_type,
                       gint white_initial_seconds,
                       gint black_initial_seconds)
{
	ChessClock * self = NULL;
#line 109 "../lib/chess-clock.vala"
	self = (ChessClock*) g_object_new (object_type, NULL);
#line 111 "../lib/chess-clock.vala"
	self->priv->white_initial_seconds = white_initial_seconds;
#line 112 "../lib/chess-clock.vala"
	self->priv->black_initial_seconds = black_initial_seconds;
#line 109 "../lib/chess-clock.vala"
	return self;
#line 306 "chess-clock.c"
}


ChessClock*
chess_clock_new (gint white_initial_seconds,
                 gint black_initial_seconds)
{
#line 109 "../lib/chess-clock.vala"
	return chess_clock_construct (TYPE_CHESS_CLOCK, white_initial_seconds, black_initial_seconds);
#line 316 "chess-clock.c"
}


void
chess_clock_start (ChessClock* self)
{
	gboolean _tmp0_;
	GTimer* _tmp1_;
#line 115 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 117 "../lib/chess-clock.vala"
	_tmp0_ = self->priv->is_active;
#line 117 "../lib/chess-clock.vala"
	if (_tmp0_) {
#line 118 "../lib/chess-clock.vala"
		return;
#line 333 "chess-clock.c"
	}
#line 120 "../lib/chess-clock.vala"
	self->priv->is_active = TRUE;
#line 122 "../lib/chess-clock.vala"
	_tmp1_ = self->priv->timer;
#line 122 "../lib/chess-clock.vala"
	if (_tmp1_ == NULL) {
#line 341 "chess-clock.c"
		GTimer* _tmp2_;
#line 125 "../lib/chess-clock.vala"
		_tmp2_ = g_timer_new ();
#line 125 "../lib/chess-clock.vala"
		_g_timer_destroy0 (self->priv->timer);
#line 125 "../lib/chess-clock.vala"
		self->priv->timer = _tmp2_;
#line 349 "chess-clock.c"
	} else {
		GTimer* _tmp3_;
#line 129 "../lib/chess-clock.vala"
		_tmp3_ = self->priv->timer;
#line 129 "../lib/chess-clock.vala"
		g_timer_start (_tmp3_);
#line 356 "chess-clock.c"
	}
#line 132 "../lib/chess-clock.vala"
	chess_clock_watch_timer (self);
#line 360 "chess-clock.c"
}


static gboolean
chess_clock_tick_cb (ChessClock* self)
{
	gboolean result = FALSE;
	Color _tmp0_;
	Color _tmp1_;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 135 "../lib/chess-clock.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 137 "../lib/chess-clock.vala"
	_tmp0_ = chess_clock_get_active_color (self);
#line 137 "../lib/chess-clock.vala"
	_tmp1_ = _tmp0_;
#line 137 "../lib/chess-clock.vala"
	if (_tmp1_ == COLOR_WHITE) {
#line 382 "chess-clock.c"
		gint _tmp2_;
#line 138 "../lib/chess-clock.vala"
		_tmp2_ = self->priv->white_seconds_used;
#line 138 "../lib/chess-clock.vala"
		self->priv->white_seconds_used = _tmp2_ + 1;
#line 388 "chess-clock.c"
	} else {
		gint _tmp3_;
#line 140 "../lib/chess-clock.vala"
		_tmp3_ = self->priv->black_seconds_used;
#line 140 "../lib/chess-clock.vala"
		self->priv->black_seconds_used = _tmp3_ + 1;
#line 395 "chess-clock.c"
	}
#line 142 "../lib/chess-clock.vala"
	g_signal_emit (self, chess_clock_signals[CHESS_CLOCK_TICK_SIGNAL], 0);
#line 144 "../lib/chess-clock.vala"
	_tmp5_ = self->priv->white_seconds_used;
#line 144 "../lib/chess-clock.vala"
	_tmp6_ = self->priv->white_initial_seconds;
#line 144 "../lib/chess-clock.vala"
	_tmp7_ = self->priv->white_extra_seconds;
#line 144 "../lib/chess-clock.vala"
	if (_tmp5_ >= (_tmp6_ + _tmp7_)) {
#line 144 "../lib/chess-clock.vala"
		_tmp4_ = TRUE;
#line 409 "chess-clock.c"
	} else {
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 145 "../lib/chess-clock.vala"
		_tmp8_ = self->priv->black_seconds_used;
#line 145 "../lib/chess-clock.vala"
		_tmp9_ = self->priv->black_initial_seconds;
#line 145 "../lib/chess-clock.vala"
		_tmp10_ = self->priv->black_extra_seconds;
#line 145 "../lib/chess-clock.vala"
		_tmp4_ = _tmp8_ >= (_tmp9_ + _tmp10_);
#line 422 "chess-clock.c"
	}
#line 144 "../lib/chess-clock.vala"
	if (_tmp4_) {
#line 147 "../lib/chess-clock.vala"
		chess_clock_stop (self);
#line 148 "../lib/chess-clock.vala"
		g_signal_emit (self, chess_clock_signals[CHESS_CLOCK_EXPIRED_SIGNAL], 0);
#line 430 "chess-clock.c"
	}
#line 151 "../lib/chess-clock.vala"
	result = G_SOURCE_CONTINUE;
#line 151 "../lib/chess-clock.vala"
	return result;
#line 436 "chess-clock.c"
}


void
chess_clock_stop (ChessClock* self)
{
	gboolean _tmp0_;
	GTimer* _tmp1_;
#line 154 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 156 "../lib/chess-clock.vala"
	_tmp0_ = self->priv->is_active;
#line 156 "../lib/chess-clock.vala"
	if (!_tmp0_) {
#line 157 "../lib/chess-clock.vala"
		return;
#line 453 "chess-clock.c"
	}
#line 159 "../lib/chess-clock.vala"
	_tmp1_ = self->priv->timer;
#line 159 "../lib/chess-clock.vala"
	g_timer_stop (_tmp1_);
#line 160 "../lib/chess-clock.vala"
	chess_clock_stop_watching_timer (self);
#line 161 "../lib/chess-clock.vala"
	self->priv->is_active = FALSE;
#line 463 "chess-clock.c"
}


void
chess_clock_pause (ChessClock* self)
{
	gboolean _tmp0_;
	GTimer* _tmp1_;
#line 164 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 166 "../lib/chess-clock.vala"
	_tmp0_ = self->priv->is_active;
#line 166 "../lib/chess-clock.vala"
	if (!_tmp0_) {
#line 167 "../lib/chess-clock.vala"
		return;
#line 480 "chess-clock.c"
	}
#line 169 "../lib/chess-clock.vala"
	_tmp1_ = self->priv->timer;
#line 169 "../lib/chess-clock.vala"
	g_timer_stop (_tmp1_);
#line 170 "../lib/chess-clock.vala"
	chess_clock_stop_watching_timer (self);
#line 171 "../lib/chess-clock.vala"
	self->priv->is_active = FALSE;
#line 490 "chess-clock.c"
}


void
chess_clock_unpause (ChessClock* self)
{
	gboolean _tmp0_ = FALSE;
	GTimer* _tmp1_;
	GTimer* _tmp3_;
#line 174 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 176 "../lib/chess-clock.vala"
	_tmp1_ = self->priv->timer;
#line 176 "../lib/chess-clock.vala"
	if (_tmp1_ == NULL) {
#line 176 "../lib/chess-clock.vala"
		_tmp0_ = TRUE;
#line 508 "chess-clock.c"
	} else {
		gboolean _tmp2_;
#line 176 "../lib/chess-clock.vala"
		_tmp2_ = self->priv->is_active;
#line 176 "../lib/chess-clock.vala"
		_tmp0_ = _tmp2_;
#line 515 "chess-clock.c"
	}
#line 176 "../lib/chess-clock.vala"
	if (_tmp0_) {
#line 177 "../lib/chess-clock.vala"
		return;
#line 521 "chess-clock.c"
	}
#line 179 "../lib/chess-clock.vala"
	_tmp3_ = self->priv->timer;
#line 179 "../lib/chess-clock.vala"
	g_timer_continue (_tmp3_);
#line 180 "../lib/chess-clock.vala"
	chess_clock_watch_timer (self);
#line 181 "../lib/chess-clock.vala"
	self->priv->is_active = TRUE;
#line 531 "chess-clock.c"
}


static gboolean
_chess_clock_tick_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = chess_clock_tick_cb ((ChessClock*) self);
#line 187 "../lib/chess-clock.vala"
	return result;
#line 542 "chess-clock.c"
}


static void
chess_clock_watch_timer (ChessClock* self)
{
#line 184 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 187 "../lib/chess-clock.vala"
	self->priv->tick_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, _chess_clock_tick_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 553 "chess-clock.c"
}


static void
chess_clock_stop_watching_timer (ChessClock* self)
{
	guint _tmp0_;
#line 190 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 192 "../lib/chess-clock.vala"
	_tmp0_ = self->priv->tick_timeout_id;
#line 192 "../lib/chess-clock.vala"
	g_source_remove (_tmp0_);
#line 193 "../lib/chess-clock.vala"
	self->priv->tick_timeout_id = (guint) 0;
#line 569 "chess-clock.c"
}


void
chess_clock_update_prev_move_time (ChessClock* self)
{
	Color _tmp0_;
	Color _tmp1_;
#line 196 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 198 "../lib/chess-clock.vala"
	_tmp0_ = chess_clock_get_active_color (self);
#line 198 "../lib/chess-clock.vala"
	_tmp1_ = _tmp0_;
#line 198 "../lib/chess-clock.vala"
	if (_tmp1_ == COLOR_WHITE) {
#line 586 "chess-clock.c"
		gint _tmp2_;
#line 199 "../lib/chess-clock.vala"
		_tmp2_ = self->priv->black_seconds_used;
#line 199 "../lib/chess-clock.vala"
		self->priv->black_prev_move_seconds = _tmp2_;
#line 592 "chess-clock.c"
	} else {
		gint _tmp3_;
#line 201 "../lib/chess-clock.vala"
		_tmp3_ = self->priv->white_seconds_used;
#line 201 "../lib/chess-clock.vala"
		self->priv->white_prev_move_seconds = _tmp3_;
#line 599 "chess-clock.c"
	}
}


static void
chess_clock_update_extra_seconds (ChessClock* self)
{
	gint white_move_used = 0;
	gint black_move_used = 0;
	ClockType _tmp0_;
#line 204 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 206 "../lib/chess-clock.vala"
	white_move_used = 0;
#line 206 "../lib/chess-clock.vala"
	black_move_used = 0;
#line 207 "../lib/chess-clock.vala"
	_tmp0_ = self->priv->_clock_type;
#line 207 "../lib/chess-clock.vala"
	switch (_tmp0_) {
#line 207 "../lib/chess-clock.vala"
		case CLOCK_TYPE_SIMPLE:
#line 622 "chess-clock.c"
		{
#line 210 "../lib/chess-clock.vala"
			break;
#line 626 "chess-clock.c"
		}
#line 207 "../lib/chess-clock.vala"
		case CLOCK_TYPE_FISCHER:
#line 630 "chess-clock.c"
		{
			Color _tmp1_;
			Color _tmp2_;
#line 212 "../lib/chess-clock.vala"
			_tmp1_ = chess_clock_get_active_color (self);
#line 212 "../lib/chess-clock.vala"
			_tmp2_ = _tmp1_;
#line 212 "../lib/chess-clock.vala"
			if (_tmp2_ == COLOR_WHITE) {
#line 640 "chess-clock.c"
				gint _tmp3_;
				gint _tmp4_;
#line 213 "../lib/chess-clock.vala"
				_tmp3_ = self->priv->white_extra_seconds;
#line 213 "../lib/chess-clock.vala"
				_tmp4_ = self->priv->_extra_seconds;
#line 213 "../lib/chess-clock.vala"
				self->priv->white_extra_seconds = _tmp3_ + _tmp4_;
#line 649 "chess-clock.c"
			} else {
				gint _tmp5_;
				gint _tmp6_;
#line 215 "../lib/chess-clock.vala"
				_tmp5_ = self->priv->black_extra_seconds;
#line 215 "../lib/chess-clock.vala"
				_tmp6_ = self->priv->_extra_seconds;
#line 215 "../lib/chess-clock.vala"
				self->priv->black_extra_seconds = _tmp5_ + _tmp6_;
#line 659 "chess-clock.c"
			}
#line 216 "../lib/chess-clock.vala"
			break;
#line 663 "chess-clock.c"
		}
#line 207 "../lib/chess-clock.vala"
		case CLOCK_TYPE_BRONSTEIN:
#line 667 "chess-clock.c"
		{
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			Color _tmp11_;
			Color _tmp12_;
#line 218 "../lib/chess-clock.vala"
			_tmp7_ = self->priv->white_seconds_used;
#line 218 "../lib/chess-clock.vala"
			_tmp8_ = self->priv->white_prev_move_seconds;
#line 218 "../lib/chess-clock.vala"
			white_move_used = _tmp7_ - _tmp8_;
#line 219 "../lib/chess-clock.vala"
			_tmp9_ = self->priv->black_seconds_used;
#line 219 "../lib/chess-clock.vala"
			_tmp10_ = self->priv->black_prev_move_seconds;
#line 219 "../lib/chess-clock.vala"
			black_move_used = _tmp9_ - _tmp10_;
#line 220 "../lib/chess-clock.vala"
			_tmp11_ = chess_clock_get_active_color (self);
#line 220 "../lib/chess-clock.vala"
			_tmp12_ = _tmp11_;
#line 220 "../lib/chess-clock.vala"
			if (_tmp12_ != COLOR_WHITE) {
#line 693 "chess-clock.c"
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 221 "../lib/chess-clock.vala"
				_tmp13_ = self->priv->white_extra_seconds;
#line 221 "../lib/chess-clock.vala"
				_tmp14_ = self->priv->_extra_seconds;
#line 221 "../lib/chess-clock.vala"
				_tmp15_ = white_move_used;
#line 221 "../lib/chess-clock.vala"
				self->priv->white_extra_seconds = _tmp13_ + MIN (_tmp14_, _tmp15_);
#line 705 "chess-clock.c"
			} else {
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
#line 223 "../lib/chess-clock.vala"
				_tmp16_ = self->priv->black_extra_seconds;
#line 223 "../lib/chess-clock.vala"
				_tmp17_ = self->priv->_extra_seconds;
#line 223 "../lib/chess-clock.vala"
				_tmp18_ = black_move_used;
#line 223 "../lib/chess-clock.vala"
				self->priv->black_extra_seconds = _tmp16_ + MIN (_tmp17_, _tmp18_);
#line 718 "chess-clock.c"
			}
#line 224 "../lib/chess-clock.vala"
			break;
#line 722 "chess-clock.c"
		}
		default:
#line 207 "../lib/chess-clock.vala"
		break;
#line 727 "chess-clock.c"
	}
}


gint
chess_clock_get_extra_seconds (ChessClock* self)
{
	gint result;
	gint _tmp0_;
#line 66 "../lib/chess-clock.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "../lib/chess-clock.vala"
	_tmp0_ = self->priv->_extra_seconds;
#line 66 "../lib/chess-clock.vala"
	result = _tmp0_;
#line 66 "../lib/chess-clock.vala"
	return result;
#line 745 "chess-clock.c"
}


void
chess_clock_set_extra_seconds (ChessClock* self,
                               gint value)
{
#line 66 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 66 "../lib/chess-clock.vala"
	if (chess_clock_get_extra_seconds (self) != value) {
#line 66 "../lib/chess-clock.vala"
		self->priv->_extra_seconds = value;
#line 66 "../lib/chess-clock.vala"
		g_object_notify_by_pspec ((GObject *) self, chess_clock_properties[CHESS_CLOCK_EXTRA_SECONDS_PROPERTY]);
#line 761 "chess-clock.c"
	}
}


gint
chess_clock_get_white_remaining_seconds (ChessClock* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 70 "../lib/chess-clock.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 70 "../lib/chess-clock.vala"
	_tmp0_ = self->priv->white_initial_seconds;
#line 70 "../lib/chess-clock.vala"
	_tmp1_ = self->priv->white_extra_seconds;
#line 70 "../lib/chess-clock.vala"
	_tmp2_ = self->priv->white_seconds_used;
#line 70 "../lib/chess-clock.vala"
	result = (_tmp0_ + _tmp1_) - _tmp2_;
#line 70 "../lib/chess-clock.vala"
	return result;
#line 785 "chess-clock.c"
}


gint
chess_clock_get_black_remaining_seconds (ChessClock* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 75 "../lib/chess-clock.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 75 "../lib/chess-clock.vala"
	_tmp0_ = self->priv->black_initial_seconds;
#line 75 "../lib/chess-clock.vala"
	_tmp1_ = self->priv->black_extra_seconds;
#line 75 "../lib/chess-clock.vala"
	_tmp2_ = self->priv->black_seconds_used;
#line 75 "../lib/chess-clock.vala"
	result = (_tmp0_ + _tmp1_) - _tmp2_;
#line 75 "../lib/chess-clock.vala"
	return result;
#line 808 "chess-clock.c"
}


ClockType
chess_clock_get_clock_type (ChessClock* self)
{
	ClockType result;
	ClockType _tmp0_;
#line 78 "../lib/chess-clock.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 78 "../lib/chess-clock.vala"
	_tmp0_ = self->priv->_clock_type;
#line 78 "../lib/chess-clock.vala"
	result = _tmp0_;
#line 78 "../lib/chess-clock.vala"
	return result;
#line 825 "chess-clock.c"
}


void
chess_clock_set_clock_type (ChessClock* self,
                            ClockType value)
{
#line 78 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 78 "../lib/chess-clock.vala"
	if (chess_clock_get_clock_type (self) != value) {
#line 78 "../lib/chess-clock.vala"
		self->priv->_clock_type = value;
#line 78 "../lib/chess-clock.vala"
		g_object_notify_by_pspec ((GObject *) self, chess_clock_properties[CHESS_CLOCK_CLOCK_TYPE_PROPERTY]);
#line 841 "chess-clock.c"
	}
}


Color
chess_clock_get_active_color (ChessClock* self)
{
	Color result;
	Color _tmp0_;
#line 83 "../lib/chess-clock.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 83 "../lib/chess-clock.vala"
	_tmp0_ = self->priv->_active_color;
#line 83 "../lib/chess-clock.vala"
	result = _tmp0_;
#line 83 "../lib/chess-clock.vala"
	return result;
#line 859 "chess-clock.c"
}


void
chess_clock_set_active_color (ChessClock* self,
                              Color value)
{
	Color _tmp0_;
	Color _tmp1_;
#line 84 "../lib/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 86 "../lib/chess-clock.vala"
	_tmp0_ = chess_clock_get_active_color (self);
#line 86 "../lib/chess-clock.vala"
	_tmp1_ = _tmp0_;
#line 86 "../lib/chess-clock.vala"
	if (value == _tmp1_) {
#line 87 "../lib/chess-clock.vala"
		return;
#line 879 "chess-clock.c"
	}
#line 89 "../lib/chess-clock.vala"
	chess_clock_stop (self);
#line 90 "../lib/chess-clock.vala"
	self->priv->_active_color = value;
#line 94 "../lib/chess-clock.vala"
	chess_clock_update_extra_seconds (self);
#line 95 "../lib/chess-clock.vala"
	chess_clock_update_prev_move_time (self);
#line 97 "../lib/chess-clock.vala"
	chess_clock_start (self);
#line 84 "../lib/chess-clock.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_clock_properties[CHESS_CLOCK_ACTIVE_COLOR_PROPERTY]);
#line 893 "chess-clock.c"
}


static void
chess_clock_class_init (ChessClockClass * klass)
{
#line 52 "../lib/chess-clock.vala"
	chess_clock_parent_class = g_type_class_peek_parent (klass);
#line 52 "../lib/chess-clock.vala"
	g_type_class_adjust_private_offset (klass, &ChessClock_private_offset);
#line 52 "../lib/chess-clock.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_clock_get_property;
#line 52 "../lib/chess-clock.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_clock_set_property;
#line 52 "../lib/chess-clock.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_clock_finalize;
#line 52 "../lib/chess-clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_CLOCK_EXTRA_SECONDS_PROPERTY, chess_clock_properties[CHESS_CLOCK_EXTRA_SECONDS_PROPERTY] = g_param_spec_int ("extra-seconds", "extra-seconds", "extra-seconds", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 52 "../lib/chess-clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_CLOCK_WHITE_REMAINING_SECONDS_PROPERTY, chess_clock_properties[CHESS_CLOCK_WHITE_REMAINING_SECONDS_PROPERTY] = g_param_spec_int ("white-remaining-seconds", "white-remaining-seconds", "white-remaining-seconds", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 52 "../lib/chess-clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_CLOCK_BLACK_REMAINING_SECONDS_PROPERTY, chess_clock_properties[CHESS_CLOCK_BLACK_REMAINING_SECONDS_PROPERTY] = g_param_spec_int ("black-remaining-seconds", "black-remaining-seconds", "black-remaining-seconds", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 52 "../lib/chess-clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_CLOCK_CLOCK_TYPE_PROPERTY, chess_clock_properties[CHESS_CLOCK_CLOCK_TYPE_PROPERTY] = g_param_spec_enum ("clock-type", "clock-type", "clock-type", TYPE_CLOCK_TYPE, CLOCK_TYPE_SIMPLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 52 "../lib/chess-clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_CLOCK_ACTIVE_COLOR_PROPERTY, chess_clock_properties[CHESS_CLOCK_ACTIVE_COLOR_PROPERTY] = g_param_spec_enum ("active-color", "active-color", "active-color", TYPE_COLOR, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 52 "../lib/chess-clock.vala"
	chess_clock_signals[CHESS_CLOCK_TICK_SIGNAL] = g_signal_new ("tick", TYPE_CHESS_CLOCK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 52 "../lib/chess-clock.vala"
	chess_clock_signals[CHESS_CLOCK_EXPIRED_SIGNAL] = g_signal_new ("expired", TYPE_CHESS_CLOCK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 924 "chess-clock.c"
}


static void
chess_clock_instance_init (ChessClock * self)
{
#line 52 "../lib/chess-clock.vala"
	self->priv = chess_clock_get_instance_private (self);
#line 57 "../lib/chess-clock.vala"
	self->priv->white_seconds_used = 0;
#line 58 "../lib/chess-clock.vala"
	self->priv->black_seconds_used = 0;
#line 60 "../lib/chess-clock.vala"
	self->priv->white_prev_move_seconds = 0;
#line 61 "../lib/chess-clock.vala"
	self->priv->black_prev_move_seconds = 0;
#line 63 "../lib/chess-clock.vala"
	self->priv->white_extra_seconds = 0;
#line 64 "../lib/chess-clock.vala"
	self->priv->black_extra_seconds = 0;
#line 66 "../lib/chess-clock.vala"
	self->priv->_extra_seconds = 0;
#line 78 "../lib/chess-clock.vala"
	self->priv->_clock_type = CLOCK_TYPE_SIMPLE;
#line 80 "../lib/chess-clock.vala"
	self->priv->_active_color = COLOR_WHITE;
#line 102 "../lib/chess-clock.vala"
	self->priv->tick_timeout_id = (guint) 0;
#line 107 "../lib/chess-clock.vala"
	self->priv->is_active = FALSE;
#line 955 "chess-clock.c"
}


static void
chess_clock_finalize (GObject * obj)
{
	ChessClock * self;
#line 52 "../lib/chess-clock.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_CLOCK, ChessClock);
#line 101 "../lib/chess-clock.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 52 "../lib/chess-clock.vala"
	G_OBJECT_CLASS (chess_clock_parent_class)->finalize (obj);
#line 969 "chess-clock.c"
}


GType
chess_clock_get_type (void)
{
	static volatile gsize chess_clock_type_id__volatile = 0;
	if (g_once_init_enter (&chess_clock_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessClockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_clock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessClock), 0, (GInstanceInitFunc) chess_clock_instance_init, NULL };
		GType chess_clock_type_id;
		chess_clock_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessClock", &g_define_type_info, 0);
		ChessClock_private_offset = g_type_add_instance_private (chess_clock_type_id, sizeof (ChessClockPrivate));
		g_once_init_leave (&chess_clock_type_id__volatile, chess_clock_type_id);
	}
	return chess_clock_type_id__volatile;
}


static void
_vala_chess_clock_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessClock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_CLOCK, ChessClock);
#line 52 "../lib/chess-clock.vala"
	switch (property_id) {
#line 52 "../lib/chess-clock.vala"
		case CHESS_CLOCK_EXTRA_SECONDS_PROPERTY:
#line 52 "../lib/chess-clock.vala"
		g_value_set_int (value, chess_clock_get_extra_seconds (self));
#line 52 "../lib/chess-clock.vala"
		break;
#line 52 "../lib/chess-clock.vala"
		case CHESS_CLOCK_WHITE_REMAINING_SECONDS_PROPERTY:
#line 52 "../lib/chess-clock.vala"
		g_value_set_int (value, chess_clock_get_white_remaining_seconds (self));
#line 52 "../lib/chess-clock.vala"
		break;
#line 52 "../lib/chess-clock.vala"
		case CHESS_CLOCK_BLACK_REMAINING_SECONDS_PROPERTY:
#line 52 "../lib/chess-clock.vala"
		g_value_set_int (value, chess_clock_get_black_remaining_seconds (self));
#line 52 "../lib/chess-clock.vala"
		break;
#line 52 "../lib/chess-clock.vala"
		case CHESS_CLOCK_CLOCK_TYPE_PROPERTY:
#line 52 "../lib/chess-clock.vala"
		g_value_set_enum (value, chess_clock_get_clock_type (self));
#line 52 "../lib/chess-clock.vala"
		break;
#line 52 "../lib/chess-clock.vala"
		case CHESS_CLOCK_ACTIVE_COLOR_PROPERTY:
#line 52 "../lib/chess-clock.vala"
		g_value_set_enum (value, chess_clock_get_active_color (self));
#line 52 "../lib/chess-clock.vala"
		break;
#line 1028 "chess-clock.c"
		default:
#line 52 "../lib/chess-clock.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 52 "../lib/chess-clock.vala"
		break;
#line 1034 "chess-clock.c"
	}
}


static void
_vala_chess_clock_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ChessClock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_CLOCK, ChessClock);
#line 52 "../lib/chess-clock.vala"
	switch (property_id) {
#line 52 "../lib/chess-clock.vala"
		case CHESS_CLOCK_EXTRA_SECONDS_PROPERTY:
#line 52 "../lib/chess-clock.vala"
		chess_clock_set_extra_seconds (self, g_value_get_int (value));
#line 52 "../lib/chess-clock.vala"
		break;
#line 52 "../lib/chess-clock.vala"
		case CHESS_CLOCK_CLOCK_TYPE_PROPERTY:
#line 52 "../lib/chess-clock.vala"
		chess_clock_set_clock_type (self, g_value_get_enum (value));
#line 52 "../lib/chess-clock.vala"
		break;
#line 52 "../lib/chess-clock.vala"
		case CHESS_CLOCK_ACTIVE_COLOR_PROPERTY:
#line 52 "../lib/chess-clock.vala"
		chess_clock_set_active_color (self, g_value_get_enum (value));
#line 52 "../lib/chess-clock.vala"
		break;
#line 1067 "chess-clock.c"
		default:
#line 52 "../lib/chess-clock.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 52 "../lib/chess-clock.vala"
		break;
#line 1073 "chess-clock.c"
	}
}



