/* chess-game.c generated by valac 0.42.6, the Vala compiler
 * generated from chess-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

typedef enum  {
	CHESS_RESULT_IN_PROGRESS,
	CHESS_RESULT_WHITE_WON,
	CHESS_RESULT_BLACK_WON,
	CHESS_RESULT_DRAW,
	CHESS_RESULT_BUG
} ChessResult;


#define TYPE_CHESS_RESULT (chess_result_get_type ())
typedef enum  {
	CHESS_RULE_UNKNOWN,
	CHESS_RULE_CHECKMATE,
	CHESS_RULE_STALEMATE,
	CHESS_RULE_FIFTY_MOVES,
	CHESS_RULE_SEVENTY_FIVE_MOVES,
	CHESS_RULE_TIMEOUT,
	CHESS_RULE_THREE_FOLD_REPETITION,
	CHESS_RULE_FIVE_FOLD_REPETITION,
	CHESS_RULE_INSUFFICIENT_MATERIAL,
	CHESS_RULE_RESIGN,
	CHESS_RULE_ABANDONMENT,
	CHESS_RULE_DEATH,
	CHESS_RULE_BUG
} ChessRule;


#define TYPE_CHESS_RULE (chess_rule_get_type ())

#define TYPE_CHESS_GAME (chess_game_get_type ())
#define CHESS_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_GAME, ChessGame))
#define CHESS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_GAME, ChessGameClass))
#define IS_CHESS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_GAME))
#define IS_CHESS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_GAME))
#define CHESS_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_GAME, ChessGameClass))

typedef struct _ChessGame ChessGame;
typedef struct _ChessGameClass ChessGameClass;
typedef struct _ChessGamePrivate ChessGamePrivate;

#define TYPE_CHESS_STATE (chess_state_get_type ())
#define CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_STATE, ChessState))
#define CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_STATE, ChessStateClass))
#define IS_CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_STATE))
#define IS_CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_STATE))
#define CHESS_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_STATE, ChessStateClass))

typedef struct _ChessState ChessState;
typedef struct _ChessStateClass ChessStateClass;

#define TYPE_CHESS_CLOCK (chess_clock_get_type ())
#define CHESS_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_CLOCK, ChessClock))
#define CHESS_CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_CLOCK, ChessClockClass))
#define IS_CHESS_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_CLOCK))
#define IS_CHESS_CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_CLOCK))
#define CHESS_CLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_CLOCK, ChessClockClass))

typedef struct _ChessClock ChessClock;
typedef struct _ChessClockClass ChessClockClass;
enum  {
	CHESS_GAME_0_PROPERTY,
	CHESS_GAME_IS_PAUSED_PROPERTY,
	CHESS_GAME_SHOULD_SHOW_PAUSED_OVERLAY_PROPERTY,
	CHESS_GAME_CURRENT_STATE_PROPERTY,
	CHESS_GAME_WHITE_PROPERTY,
	CHESS_GAME_BLACK_PROPERTY,
	CHESS_GAME_CURRENT_PLAYER_PROPERTY,
	CHESS_GAME_OPPONENT_PROPERTY,
	CHESS_GAME_CLOCK_PROPERTY,
	CHESS_GAME_N_MOVES_PROPERTY,
	CHESS_GAME_NUM_PROPERTIES
};
static GParamSpec* chess_game_properties[CHESS_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CHESS_PLAYER (chess_player_get_type ())
#define CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PLAYER, ChessPlayer))
#define CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PLAYER, ChessPlayerClass))
#define IS_CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PLAYER))
#define IS_CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PLAYER))
#define CHESS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PLAYER, ChessPlayerClass))

typedef struct _ChessPlayer ChessPlayer;
typedef struct _ChessPlayerClass ChessPlayerClass;
typedef struct _ChessStatePrivate ChessStatePrivate;
typedef enum  {
	CHECK_STATE_NONE,
	CHECK_STATE_CHECK,
	CHECK_STATE_CHECKMATE
} CheckState;


#define TYPE_CHECK_STATE (check_state_get_type ())

#define TYPE_CHESS_PIECE (chess_piece_get_type ())
#define CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PIECE, ChessPiece))
#define CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PIECE, ChessPieceClass))
#define IS_CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PIECE))
#define IS_CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PIECE))
#define CHESS_PIECE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PIECE, ChessPieceClass))

typedef struct _ChessPiece ChessPiece;
typedef struct _ChessPieceClass ChessPieceClass;

#define TYPE_CHESS_MOVE (chess_move_get_type ())
#define CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MOVE, ChessMove))
#define CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MOVE, ChessMoveClass))
#define IS_CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MOVE))
#define IS_CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MOVE))
#define CHESS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MOVE, ChessMoveClass))

typedef struct _ChessMove ChessMove;
typedef struct _ChessMoveClass ChessMoveClass;
typedef struct _ChessMovePrivate ChessMovePrivate;
typedef struct _ChessPlayerPrivate ChessPlayerPrivate;
typedef enum  {
	COLOR_WHITE,
	COLOR_BLACK
} Color;


#define TYPE_COLOR (color_get_type ())
enum  {
	CHESS_GAME_TURN_STARTED_SIGNAL,
	CHESS_GAME_MOVED_SIGNAL,
	CHESS_GAME_PAUSED_SIGNAL,
	CHESS_GAME_UNPAUSED_SIGNAL,
	CHESS_GAME_UNDO_SIGNAL,
	CHESS_GAME_ENDED_SIGNAL,
	CHESS_GAME_NUM_SIGNALS
};
static guint chess_game_signals[CHESS_GAME_NUM_SIGNALS] = {0};

struct _ChessGame {
	GObject parent_instance;
	ChessGamePrivate * priv;
	gboolean is_started;
	ChessResult result;
	ChessRule rule;
	GList* move_stack;
};

struct _ChessGameClass {
	GObjectClass parent_class;
};

struct _ChessGamePrivate {
	gint hold_count;
	gboolean _is_paused;
	gboolean _should_show_paused_overlay;
	ChessClock* _clock;
};

typedef enum  {
	PGN_ERROR_LOAD_ERROR
} PGNError;
#define PGN_ERROR pgn_error_quark ()
struct _ChessState {
	GObject parent_instance;
	ChessStatePrivate * priv;
	gint number;
	ChessPlayer* players[2];
	ChessPlayer* current_player;
	gboolean can_castle_kingside[2];
	gboolean can_castle_queenside[2];
	gint en_passant_index;
	CheckState check_state;
	gint halfmove_clock;
	ChessPiece* board[64];
	ChessMove* last_move;
};

struct _ChessStateClass {
	GObjectClass parent_class;
};

struct _ChessMove {
	GObject parent_instance;
	ChessMovePrivate * priv;
	gint number;
	ChessPiece* piece;
	ChessPiece* promotion_piece;
	ChessPiece* castling_rook;
	ChessPiece* victim;
	gint r0;
	gint f0;
	gint r1;
	gint f1;
	gboolean ambiguous_rank;
	gboolean ambiguous_file;
	gboolean en_passant;
	CheckState check_state;
};

struct _ChessMoveClass {
	GObjectClass parent_class;
};

struct _ChessPlayer {
	GObject parent_instance;
	ChessPlayerPrivate * priv;
	Color color;
};

struct _ChessPlayerClass {
	GObjectClass parent_class;
};


static gint ChessGame_private_offset;
static gpointer chess_game_parent_class = NULL;

GType chess_result_get_type (void) G_GNUC_CONST;
GType chess_rule_get_type (void) G_GNUC_CONST;
GType chess_game_get_type (void) G_GNUC_CONST;
GType chess_state_get_type (void) G_GNUC_CONST;
GType chess_clock_get_type (void) G_GNUC_CONST;
void chess_clock_stop (ChessClock* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
#define CHESS_GAME_STANDARD_SETUP "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1"
GQuark pgn_error_quark (void);
ChessGame* chess_game_new (const gchar* fen,
                           gchar** moves,
                           int moves_length1,
                           GError** error);
ChessGame* chess_game_construct (GType object_type,
                                 const gchar* fen,
                                 gchar** moves,
                                 int moves_length1,
                                 GError** error);
ChessState* chess_state_new (const gchar* fen);
ChessState* chess_state_construct (GType object_type,
                                   const gchar* fen);
GType chess_player_get_type (void) G_GNUC_CONST;
static gboolean chess_game_do_move (ChessGame* self,
                             ChessPlayer* player,
                             const gchar* move,
                             gboolean apply);
ChessPlayer* chess_game_get_current_player (ChessGame* self);
ChessPlayer* chess_game_get_white (ChessGame* self);
static gboolean chess_game_move_cb (ChessGame* self,
                             ChessPlayer* player,
                             const gchar* move,
                             gboolean apply);
static gboolean _chess_game_move_cb_chess_player_do_move (ChessPlayer* _sender,
                                                   const gchar* move,
                                                   gboolean apply,
                                                   gpointer self);
static void chess_game_undo_cb (ChessGame* self,
                         ChessPlayer* player);
static void _chess_game_undo_cb_chess_player_do_undo (ChessPlayer* _sender,
                                               gpointer self);
static gboolean chess_game_resign_cb (ChessGame* self,
                               ChessPlayer* player);
static gboolean _chess_game_resign_cb_chess_player_do_resign (ChessPlayer* _sender,
                                                       gpointer self);
static void chess_game_claim_draw_cb (ChessGame* self);
static void _chess_game_claim_draw_cb_chess_player_do_claim_draw (ChessPlayer* _sender,
                                                           gpointer self);
ChessPlayer* chess_game_get_black (ChessGame* self);
ChessState* chess_game_get_current_state (ChessGame* self);
ChessState* chess_state_copy (ChessState* self);
GType check_state_get_type (void) G_GNUC_CONST;
GType chess_piece_get_type (void) G_GNUC_CONST;
GType chess_move_get_type (void) G_GNUC_CONST;
gboolean chess_state_move (ChessState* self,
                           const gchar* move,
                           gboolean apply);
static void chess_game_complete_move (ChessGame* self);
void chess_game_add_hold (ChessGame* self);
void chess_game_remove_hold (ChessGame* self);
ChessResult chess_state_get_result (ChessState* self,
                                    ChessRule* rule);
void chess_game_stop (ChessGame* self,
                      ChessResult _result_,
                      ChessRule rule);
gboolean chess_game_is_five_fold_repeat (ChessGame* self);
gboolean chess_game_is_seventy_five_move_rule_fulfilled (ChessGame* self);
GType color_get_type (void) G_GNUC_CONST;
void chess_clock_set_active_color (ChessClock* self,
                                   Color value);
ChessPlayer* chess_game_get_opponent (ChessGame* self);
static gint chess_game_state_repeated_times (ChessGame* self,
                                      ChessState* s1);
gboolean chess_state_equals (ChessState* self,
                             ChessState* state);
static gboolean chess_game_is_n_fold_repeat (ChessGame* self,
                                      gint n);
gboolean chess_game_is_three_fold_repeat (ChessGame* self);
gboolean chess_game_is_fifty_move_rule_fulfilled (ChessGame* self);
gboolean chess_game_can_claim_draw (ChessGame* self);
void chess_game_start (ChessGame* self);
static void chess_game_clock_expired_cb (ChessGame* self,
                                  ChessClock* clock);
static void _chess_game_clock_expired_cb_chess_clock_expired (ChessClock* _sender,
                                                       gpointer self);
gint chess_clock_get_white_remaining_seconds (ChessClock* self);
gint chess_clock_get_black_remaining_seconds (ChessClock* self);
ChessPiece* chess_game_get_piece (ChessGame* self,
                                  gint rank,
                                  gint file,
                                  gint move_number);
gint chess_state_get_index (ChessState* self,
                            gint rank,
                            gint file);
void chess_game_pause (ChessGame* self,
                       gboolean show_overlay);
ChessClock* chess_game_get_clock (ChessGame* self);
gboolean chess_game_get_is_paused (ChessGame* self);
void chess_clock_pause (ChessClock* self);
static void chess_game_set_is_paused (ChessGame* self,
                               gboolean value);
static void chess_game_set_should_show_paused_overlay (ChessGame* self,
                                                gboolean value);
void chess_game_unpause (ChessGame* self);
void chess_clock_unpause (ChessClock* self);
gboolean chess_game_get_should_show_paused_overlay (ChessGame* self);
ChessPlayer* chess_state_get_opponent (ChessState* self);
void chess_game_set_clock (ChessGame* self,
                           ChessClock* value);
guint chess_game_get_n_moves (ChessGame* self);
static void chess_game_finalize (GObject * obj);
static void _vala_chess_game_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_chess_game_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);


GType
chess_result_get_type (void)
{
	static volatile gsize chess_result_type_id__volatile = 0;
	if (g_once_init_enter (&chess_result_type_id__volatile)) {
		static const GEnumValue values[] = {{CHESS_RESULT_IN_PROGRESS, "CHESS_RESULT_IN_PROGRESS", "in-progress"}, {CHESS_RESULT_WHITE_WON, "CHESS_RESULT_WHITE_WON", "white-won"}, {CHESS_RESULT_BLACK_WON, "CHESS_RESULT_BLACK_WON", "black-won"}, {CHESS_RESULT_DRAW, "CHESS_RESULT_DRAW", "draw"}, {CHESS_RESULT_BUG, "CHESS_RESULT_BUG", "bug"}, {0, NULL, NULL}};
		GType chess_result_type_id;
		chess_result_type_id = g_enum_register_static ("ChessResult", values);
		g_once_init_leave (&chess_result_type_id__volatile, chess_result_type_id);
	}
	return chess_result_type_id__volatile;
}


GType
chess_rule_get_type (void)
{
	static volatile gsize chess_rule_type_id__volatile = 0;
	if (g_once_init_enter (&chess_rule_type_id__volatile)) {
		static const GEnumValue values[] = {{CHESS_RULE_UNKNOWN, "CHESS_RULE_UNKNOWN", "unknown"}, {CHESS_RULE_CHECKMATE, "CHESS_RULE_CHECKMATE", "checkmate"}, {CHESS_RULE_STALEMATE, "CHESS_RULE_STALEMATE", "stalemate"}, {CHESS_RULE_FIFTY_MOVES, "CHESS_RULE_FIFTY_MOVES", "fifty-moves"}, {CHESS_RULE_SEVENTY_FIVE_MOVES, "CHESS_RULE_SEVENTY_FIVE_MOVES", "seventy-five-moves"}, {CHESS_RULE_TIMEOUT, "CHESS_RULE_TIMEOUT", "timeout"}, {CHESS_RULE_THREE_FOLD_REPETITION, "CHESS_RULE_THREE_FOLD_REPETITION", "three-fold-repetition"}, {CHESS_RULE_FIVE_FOLD_REPETITION, "CHESS_RULE_FIVE_FOLD_REPETITION", "five-fold-repetition"}, {CHESS_RULE_INSUFFICIENT_MATERIAL, "CHESS_RULE_INSUFFICIENT_MATERIAL", "insufficient-material"}, {CHESS_RULE_RESIGN, "CHESS_RULE_RESIGN", "resign"}, {CHESS_RULE_ABANDONMENT, "CHESS_RULE_ABANDONMENT", "abandonment"}, {CHESS_RULE_DEATH, "CHESS_RULE_DEATH", "death"}, {CHESS_RULE_BUG, "CHESS_RULE_BUG", "bug"}, {0, NULL, NULL}};
		GType chess_rule_type_id;
		chess_rule_type_id = g_enum_register_static ("ChessRule", values);
		g_once_init_leave (&chess_rule_type_id__volatile, chess_rule_type_id);
	}
	return chess_rule_type_id__volatile;
}


static inline gpointer
chess_game_get_instance_private (ChessGame* self)
{
	return G_STRUCT_MEMBER_P (self, ChessGame_private_offset);
}


static void
_g_object_unref0_ (gpointer var)
{
#line 44 "../lib/chess-game.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 397 "chess-game.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 44 "../lib/chess-game.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 406 "chess-game.c"
}


static gboolean
_chess_game_move_cb_chess_player_do_move (ChessPlayer* _sender,
                                          const gchar* move,
                                          gboolean apply,
                                          gpointer self)
{
	gboolean result;
	result = chess_game_move_cb ((ChessGame*) self, _sender, move, apply);
#line 111 "../lib/chess-game.vala"
	return result;
#line 420 "chess-game.c"
}


static void
_chess_game_undo_cb_chess_player_do_undo (ChessPlayer* _sender,
                                          gpointer self)
{
#line 112 "../lib/chess-game.vala"
	chess_game_undo_cb ((ChessGame*) self, _sender);
#line 430 "chess-game.c"
}


static gboolean
_chess_game_resign_cb_chess_player_do_resign (ChessPlayer* _sender,
                                              gpointer self)
{
	gboolean result;
	result = chess_game_resign_cb ((ChessGame*) self, _sender);
#line 113 "../lib/chess-game.vala"
	return result;
#line 442 "chess-game.c"
}


static void
_chess_game_claim_draw_cb_chess_player_do_claim_draw (ChessPlayer* _sender,
                                                      gpointer self)
{
#line 114 "../lib/chess-game.vala"
	chess_game_claim_draw_cb ((ChessGame*) self);
#line 452 "chess-game.c"
}


ChessGame*
chess_game_construct (GType object_type,
                      const gchar* fen,
                      gchar** moves,
                      int moves_length1,
                      GError** error)
{
	ChessGame * self = NULL;
	ChessState* _tmp0_;
	ChessPlayer* _tmp11_;
	ChessPlayer* _tmp12_;
	ChessPlayer* _tmp13_;
	ChessPlayer* _tmp14_;
	ChessPlayer* _tmp15_;
	ChessPlayer* _tmp16_;
	ChessPlayer* _tmp17_;
	ChessPlayer* _tmp18_;
	ChessPlayer* _tmp19_;
	ChessPlayer* _tmp20_;
	ChessPlayer* _tmp21_;
	ChessPlayer* _tmp22_;
	ChessPlayer* _tmp23_;
	ChessPlayer* _tmp24_;
	ChessPlayer* _tmp25_;
	ChessPlayer* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 93 "../lib/chess-game.vala"
	g_return_val_if_fail (fen != NULL, NULL);
#line 93 "../lib/chess-game.vala"
	self = (ChessGame*) g_object_new (object_type, NULL);
#line 95 "../lib/chess-game.vala"
	self->is_started = FALSE;
#line 96 "../lib/chess-game.vala"
	_tmp0_ = chess_state_new (fen);
#line 96 "../lib/chess-game.vala"
	self->move_stack = g_list_prepend (self->move_stack, _tmp0_);
#line 97 "../lib/chess-game.vala"
	self->result = CHESS_RESULT_IN_PROGRESS;
#line 99 "../lib/chess-game.vala"
	if (moves != NULL) {
#line 496 "chess-game.c"
		{
			gint i = 0;
#line 101 "../lib/chess-game.vala"
			i = 0;
#line 501 "chess-game.c"
			{
				gboolean _tmp1_ = FALSE;
#line 101 "../lib/chess-game.vala"
				_tmp1_ = TRUE;
#line 101 "../lib/chess-game.vala"
				while (TRUE) {
#line 508 "chess-game.c"
					gint _tmp3_;
					ChessPlayer* _tmp4_;
					ChessPlayer* _tmp5_;
					gint _tmp6_;
					const gchar* _tmp7_;
#line 101 "../lib/chess-game.vala"
					if (!_tmp1_) {
#line 516 "chess-game.c"
						gint _tmp2_;
#line 101 "../lib/chess-game.vala"
						_tmp2_ = i;
#line 101 "../lib/chess-game.vala"
						i = _tmp2_ + 1;
#line 522 "chess-game.c"
					}
#line 101 "../lib/chess-game.vala"
					_tmp1_ = FALSE;
#line 101 "../lib/chess-game.vala"
					_tmp3_ = i;
#line 101 "../lib/chess-game.vala"
					if (!(_tmp3_ < moves_length1)) {
#line 101 "../lib/chess-game.vala"
						break;
#line 532 "chess-game.c"
					}
#line 103 "../lib/chess-game.vala"
					_tmp4_ = chess_game_get_current_player (self);
#line 103 "../lib/chess-game.vala"
					_tmp5_ = _tmp4_;
#line 103 "../lib/chess-game.vala"
					_tmp6_ = i;
#line 103 "../lib/chess-game.vala"
					_tmp7_ = moves[_tmp6_];
#line 103 "../lib/chess-game.vala"
					if (!chess_game_do_move (self, _tmp5_, _tmp7_, TRUE)) {
#line 544 "chess-game.c"
						gint _tmp8_;
						const gchar* _tmp9_;
						GError* _tmp10_;
#line 106 "../lib/chess-game.vala"
						_tmp8_ = i;
#line 106 "../lib/chess-game.vala"
						_tmp9_ = moves[_tmp8_];
#line 106 "../lib/chess-game.vala"
						_tmp10_ = g_error_new (PGN_ERROR, PGN_ERROR_LOAD_ERROR, _ ("Failed to load PGN: move %s is invalid."), _tmp9_);
#line 106 "../lib/chess-game.vala"
						_inner_error0_ = _tmp10_;
#line 106 "../lib/chess-game.vala"
						if (_inner_error0_->domain == PGN_ERROR) {
#line 106 "../lib/chess-game.vala"
							g_propagate_error (error, _inner_error0_);
#line 106 "../lib/chess-game.vala"
							_g_object_unref0 (self);
#line 106 "../lib/chess-game.vala"
							return NULL;
#line 564 "chess-game.c"
						} else {
#line 106 "../lib/chess-game.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "../lib/chess-game.vala"
							g_clear_error (&_inner_error0_);
#line 106 "../lib/chess-game.vala"
							return NULL;
#line 572 "chess-game.c"
						}
					}
				}
			}
		}
	}
#line 111 "../lib/chess-game.vala"
	_tmp11_ = chess_game_get_white (self);
#line 111 "../lib/chess-game.vala"
	_tmp12_ = _tmp11_;
#line 111 "../lib/chess-game.vala"
	g_signal_connect_object (_tmp12_, "do-move", (GCallback) _chess_game_move_cb_chess_player_do_move, self, 0);
#line 112 "../lib/chess-game.vala"
	_tmp13_ = chess_game_get_white (self);
#line 112 "../lib/chess-game.vala"
	_tmp14_ = _tmp13_;
#line 112 "../lib/chess-game.vala"
	g_signal_connect_object (_tmp14_, "do-undo", (GCallback) _chess_game_undo_cb_chess_player_do_undo, self, 0);
#line 113 "../lib/chess-game.vala"
	_tmp15_ = chess_game_get_white (self);
#line 113 "../lib/chess-game.vala"
	_tmp16_ = _tmp15_;
#line 113 "../lib/chess-game.vala"
	g_signal_connect_object (_tmp16_, "do-resign", (GCallback) _chess_game_resign_cb_chess_player_do_resign, self, 0);
#line 114 "../lib/chess-game.vala"
	_tmp17_ = chess_game_get_white (self);
#line 114 "../lib/chess-game.vala"
	_tmp18_ = _tmp17_;
#line 114 "../lib/chess-game.vala"
	g_signal_connect_object (_tmp18_, "do-claim-draw", (GCallback) _chess_game_claim_draw_cb_chess_player_do_claim_draw, self, 0);
#line 115 "../lib/chess-game.vala"
	_tmp19_ = chess_game_get_black (self);
#line 115 "../lib/chess-game.vala"
	_tmp20_ = _tmp19_;
#line 115 "../lib/chess-game.vala"
	g_signal_connect_object (_tmp20_, "do-move", (GCallback) _chess_game_move_cb_chess_player_do_move, self, 0);
#line 116 "../lib/chess-game.vala"
	_tmp21_ = chess_game_get_black (self);
#line 116 "../lib/chess-game.vala"
	_tmp22_ = _tmp21_;
#line 116 "../lib/chess-game.vala"
	g_signal_connect_object (_tmp22_, "do-undo", (GCallback) _chess_game_undo_cb_chess_player_do_undo, self, 0);
#line 117 "../lib/chess-game.vala"
	_tmp23_ = chess_game_get_black (self);
#line 117 "../lib/chess-game.vala"
	_tmp24_ = _tmp23_;
#line 117 "../lib/chess-game.vala"
	g_signal_connect_object (_tmp24_, "do-resign", (GCallback) _chess_game_resign_cb_chess_player_do_resign, self, 0);
#line 118 "../lib/chess-game.vala"
	_tmp25_ = chess_game_get_black (self);
#line 118 "../lib/chess-game.vala"
	_tmp26_ = _tmp25_;
#line 118 "../lib/chess-game.vala"
	g_signal_connect_object (_tmp26_, "do-claim-draw", (GCallback) _chess_game_claim_draw_cb_chess_player_do_claim_draw, self, 0);
#line 93 "../lib/chess-game.vala"
	return self;
#line 629 "chess-game.c"
}


ChessGame*
chess_game_new (const gchar* fen,
                gchar** moves,
                int moves_length1,
                GError** error)
{
#line 93 "../lib/chess-game.vala"
	return chess_game_construct (TYPE_CHESS_GAME, fen, moves, moves_length1, error);
#line 641 "chess-game.c"
}


static gboolean
chess_game_move_cb (ChessGame* self,
                    ChessPlayer* player,
                    const gchar* move,
                    gboolean apply)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 127 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 127 "../lib/chess-game.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 127 "../lib/chess-game.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 129 "../lib/chess-game.vala"
	_tmp0_ = self->is_started;
#line 129 "../lib/chess-game.vala"
	if (!_tmp0_) {
#line 130 "../lib/chess-game.vala"
		result = FALSE;
#line 130 "../lib/chess-game.vala"
		return result;
#line 667 "chess-game.c"
	}
#line 132 "../lib/chess-game.vala"
	result = chess_game_do_move (self, player, move, apply);
#line 132 "../lib/chess-game.vala"
	return result;
#line 673 "chess-game.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 148 "../lib/chess-game.vala"
	return self ? g_object_ref (self) : NULL;
#line 682 "chess-game.c"
}


static gboolean
chess_game_do_move (ChessGame* self,
                    ChessPlayer* player,
                    const gchar* move,
                    gboolean apply)
{
	gboolean result = FALSE;
	ChessPlayer* _tmp0_;
	ChessPlayer* _tmp1_;
	ChessState* state = NULL;
	ChessState* _tmp2_;
	ChessState* _tmp3_;
	ChessState* _tmp4_;
	ChessState* _tmp5_;
	gint _tmp6_;
	ChessState* _tmp7_;
	ChessState* _tmp8_;
	ChessState* _tmp9_;
	ChessState* _tmp10_;
	ChessMove* _tmp11_;
	ChessPiece* _tmp12_;
	ChessState* _tmp16_;
	ChessMove* _tmp17_;
	ChessPiece* _tmp18_;
	ChessState* _tmp19_;
	ChessMove* _tmp20_;
	ChessPiece* _tmp21_;
	ChessState* _tmp25_;
	ChessMove* _tmp26_;
#line 135 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 135 "../lib/chess-game.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 137 "../lib/chess-game.vala"
	_tmp0_ = chess_game_get_current_player (self);
#line 137 "../lib/chess-game.vala"
	_tmp1_ = _tmp0_;
#line 137 "../lib/chess-game.vala"
	if (player != _tmp1_) {
#line 138 "../lib/chess-game.vala"
		result = FALSE;
#line 138 "../lib/chess-game.vala"
		return result;
#line 729 "chess-game.c"
	}
#line 140 "../lib/chess-game.vala"
	_tmp2_ = chess_game_get_current_state (self);
#line 140 "../lib/chess-game.vala"
	_tmp3_ = _tmp2_;
#line 140 "../lib/chess-game.vala"
	_tmp4_ = chess_state_copy (_tmp3_);
#line 140 "../lib/chess-game.vala"
	state = _tmp4_;
#line 141 "../lib/chess-game.vala"
	_tmp5_ = state;
#line 141 "../lib/chess-game.vala"
	_tmp6_ = _tmp5_->number;
#line 141 "../lib/chess-game.vala"
	_tmp5_->number = _tmp6_ + 1;
#line 142 "../lib/chess-game.vala"
	_tmp7_ = state;
#line 142 "../lib/chess-game.vala"
	if (!chess_state_move (_tmp7_, move, apply)) {
#line 143 "../lib/chess-game.vala"
		result = FALSE;
#line 143 "../lib/chess-game.vala"
		_g_object_unref0 (state);
#line 143 "../lib/chess-game.vala"
		return result;
#line 755 "chess-game.c"
	}
#line 145 "../lib/chess-game.vala"
	if (!apply) {
#line 146 "../lib/chess-game.vala"
		result = TRUE;
#line 146 "../lib/chess-game.vala"
		_g_object_unref0 (state);
#line 146 "../lib/chess-game.vala"
		return result;
#line 765 "chess-game.c"
	}
#line 148 "../lib/chess-game.vala"
	_tmp8_ = state;
#line 148 "../lib/chess-game.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 148 "../lib/chess-game.vala"
	self->move_stack = g_list_prepend (self->move_stack, _tmp9_);
#line 149 "../lib/chess-game.vala"
	_tmp10_ = state;
#line 149 "../lib/chess-game.vala"
	_tmp11_ = _tmp10_->last_move;
#line 149 "../lib/chess-game.vala"
	_tmp12_ = _tmp11_->victim;
#line 149 "../lib/chess-game.vala"
	if (_tmp12_ != NULL) {
#line 781 "chess-game.c"
		ChessState* _tmp13_;
		ChessMove* _tmp14_;
		ChessPiece* _tmp15_;
#line 150 "../lib/chess-game.vala"
		_tmp13_ = state;
#line 150 "../lib/chess-game.vala"
		_tmp14_ = _tmp13_->last_move;
#line 150 "../lib/chess-game.vala"
		_tmp15_ = _tmp14_->victim;
#line 150 "../lib/chess-game.vala"
		g_signal_emit_by_name (_tmp15_, "died");
#line 793 "chess-game.c"
	}
#line 151 "../lib/chess-game.vala"
	_tmp16_ = state;
#line 151 "../lib/chess-game.vala"
	_tmp17_ = _tmp16_->last_move;
#line 151 "../lib/chess-game.vala"
	_tmp18_ = _tmp17_->piece;
#line 151 "../lib/chess-game.vala"
	g_signal_emit_by_name (_tmp18_, "moved");
#line 152 "../lib/chess-game.vala"
	_tmp19_ = state;
#line 152 "../lib/chess-game.vala"
	_tmp20_ = _tmp19_->last_move;
#line 152 "../lib/chess-game.vala"
	_tmp21_ = _tmp20_->castling_rook;
#line 152 "../lib/chess-game.vala"
	if (_tmp21_ != NULL) {
#line 811 "chess-game.c"
		ChessState* _tmp22_;
		ChessMove* _tmp23_;
		ChessPiece* _tmp24_;
#line 153 "../lib/chess-game.vala"
		_tmp22_ = state;
#line 153 "../lib/chess-game.vala"
		_tmp23_ = _tmp22_->last_move;
#line 153 "../lib/chess-game.vala"
		_tmp24_ = _tmp23_->castling_rook;
#line 153 "../lib/chess-game.vala"
		g_signal_emit_by_name (_tmp24_, "moved");
#line 823 "chess-game.c"
	}
#line 154 "../lib/chess-game.vala"
	_tmp25_ = state;
#line 154 "../lib/chess-game.vala"
	_tmp26_ = _tmp25_->last_move;
#line 154 "../lib/chess-game.vala"
	g_signal_emit (self, chess_game_signals[CHESS_GAME_MOVED_SIGNAL], 0, _tmp26_);
#line 155 "../lib/chess-game.vala"
	chess_game_complete_move (self);
#line 157 "../lib/chess-game.vala"
	result = TRUE;
#line 157 "../lib/chess-game.vala"
	_g_object_unref0 (state);
#line 157 "../lib/chess-game.vala"
	return result;
#line 839 "chess-game.c"
}


void
chess_game_add_hold (ChessGame* self)
{
	gint _tmp0_;
#line 160 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 162 "../lib/chess-game.vala"
	_tmp0_ = self->priv->hold_count;
#line 162 "../lib/chess-game.vala"
	self->priv->hold_count = _tmp0_ + 1;
#line 853 "chess-game.c"
}


void
chess_game_remove_hold (ChessGame* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 165 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 167 "../lib/chess-game.vala"
	_tmp0_ = self->priv->hold_count;
#line 167 "../lib/chess-game.vala"
	g_return_if_fail (_tmp0_ > 0);
#line 169 "../lib/chess-game.vala"
	_tmp1_ = self->priv->hold_count;
#line 169 "../lib/chess-game.vala"
	self->priv->hold_count = _tmp1_ - 1;
#line 170 "../lib/chess-game.vala"
	_tmp2_ = self->priv->hold_count;
#line 170 "../lib/chess-game.vala"
	if (_tmp2_ == 0) {
#line 171 "../lib/chess-game.vala"
		chess_game_complete_move (self);
#line 879 "chess-game.c"
	}
}


static void
chess_game_complete_move (ChessGame* self)
{
	gint _tmp0_;
	gboolean _tmp1_;
	ChessRule rule = 0;
	ChessResult _result_ = 0;
	ChessState* _tmp2_;
	ChessState* _tmp3_;
	ChessRule _tmp4_ = 0;
	ChessResult _tmp5_;
	ChessResult _tmp6_;
	ChessClock* _tmp9_;
	ChessPlayer* _tmp14_;
	ChessPlayer* _tmp15_;
#line 174 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 177 "../lib/chess-game.vala"
	_tmp0_ = self->priv->hold_count;
#line 177 "../lib/chess-game.vala"
	if (_tmp0_ > 0) {
#line 178 "../lib/chess-game.vala"
		return;
#line 907 "chess-game.c"
	}
#line 180 "../lib/chess-game.vala"
	_tmp1_ = self->is_started;
#line 180 "../lib/chess-game.vala"
	if (!_tmp1_) {
#line 181 "../lib/chess-game.vala"
		return;
#line 915 "chess-game.c"
	}
#line 184 "../lib/chess-game.vala"
	_tmp2_ = chess_game_get_current_state (self);
#line 184 "../lib/chess-game.vala"
	_tmp3_ = _tmp2_;
#line 184 "../lib/chess-game.vala"
	_tmp5_ = chess_state_get_result (_tmp3_, &_tmp4_);
#line 184 "../lib/chess-game.vala"
	rule = _tmp4_;
#line 184 "../lib/chess-game.vala"
	_result_ = _tmp5_;
#line 185 "../lib/chess-game.vala"
	_tmp6_ = _result_;
#line 185 "../lib/chess-game.vala"
	if (_tmp6_ != CHESS_RESULT_IN_PROGRESS) {
#line 931 "chess-game.c"
		ChessResult _tmp7_;
		ChessRule _tmp8_;
#line 187 "../lib/chess-game.vala"
		_tmp7_ = _result_;
#line 187 "../lib/chess-game.vala"
		_tmp8_ = rule;
#line 187 "../lib/chess-game.vala"
		chess_game_stop (self, _tmp7_, _tmp8_);
#line 188 "../lib/chess-game.vala"
		return;
#line 942 "chess-game.c"
	}
#line 191 "../lib/chess-game.vala"
	if (chess_game_is_five_fold_repeat (self)) {
#line 193 "../lib/chess-game.vala"
		chess_game_stop (self, CHESS_RESULT_DRAW, CHESS_RULE_FIVE_FOLD_REPETITION);
#line 194 "../lib/chess-game.vala"
		return;
#line 950 "chess-game.c"
	}
#line 198 "../lib/chess-game.vala"
	if (chess_game_is_seventy_five_move_rule_fulfilled (self)) {
#line 200 "../lib/chess-game.vala"
		chess_game_stop (self, CHESS_RESULT_DRAW, CHESS_RULE_SEVENTY_FIVE_MOVES);
#line 201 "../lib/chess-game.vala"
		return;
#line 958 "chess-game.c"
	}
#line 204 "../lib/chess-game.vala"
	_tmp9_ = self->priv->_clock;
#line 204 "../lib/chess-game.vala"
	if (_tmp9_ != NULL) {
#line 964 "chess-game.c"
		ChessClock* _tmp10_;
		ChessPlayer* _tmp11_;
		ChessPlayer* _tmp12_;
		Color _tmp13_;
#line 205 "../lib/chess-game.vala"
		_tmp10_ = self->priv->_clock;
#line 205 "../lib/chess-game.vala"
		_tmp11_ = chess_game_get_current_player (self);
#line 205 "../lib/chess-game.vala"
		_tmp12_ = _tmp11_;
#line 205 "../lib/chess-game.vala"
		_tmp13_ = _tmp12_->color;
#line 205 "../lib/chess-game.vala"
		chess_clock_set_active_color (_tmp10_, _tmp13_);
#line 979 "chess-game.c"
	}
#line 206 "../lib/chess-game.vala"
	_tmp14_ = chess_game_get_current_player (self);
#line 206 "../lib/chess-game.vala"
	_tmp15_ = _tmp14_;
#line 206 "../lib/chess-game.vala"
	g_signal_emit (self, chess_game_signals[CHESS_GAME_TURN_STARTED_SIGNAL], 0, _tmp15_);
#line 987 "chess-game.c"
}


static void
chess_game_undo_cb (ChessGame* self,
                    ChessPlayer* player)
{
	ChessPlayer* _tmp0_;
	ChessPlayer* _tmp1_;
	GList* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
#line 209 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 209 "../lib/chess-game.vala"
	g_return_if_fail (player != NULL);
#line 212 "../lib/chess-game.vala"
	_tmp0_ = chess_game_get_current_player (self);
#line 212 "../lib/chess-game.vala"
	_tmp1_ = _tmp0_;
#line 212 "../lib/chess-game.vala"
	if (player == _tmp1_) {
#line 1010 "chess-game.c"
		ChessPlayer* _tmp2_;
		ChessPlayer* _tmp3_;
#line 213 "../lib/chess-game.vala"
		_tmp2_ = chess_game_get_opponent (self);
#line 213 "../lib/chess-game.vala"
		_tmp3_ = _tmp2_;
#line 213 "../lib/chess-game.vala"
		chess_game_undo_cb (self, _tmp3_);
#line 1019 "chess-game.c"
	}
#line 216 "../lib/chess-game.vala"
	_tmp4_ = self->move_stack;
#line 216 "../lib/chess-game.vala"
	_tmp5_ = _tmp4_->next;
#line 216 "../lib/chess-game.vala"
	if (_tmp5_ == NULL) {
#line 217 "../lib/chess-game.vala"
		return;
#line 1029 "chess-game.c"
	}
#line 220 "../lib/chess-game.vala"
	_tmp6_ = self->move_stack;
#line 220 "../lib/chess-game.vala"
	self->move_stack = g_list_remove_link (self->move_stack, _tmp6_);
#line 221 "../lib/chess-game.vala"
	g_signal_emit (self, chess_game_signals[CHESS_GAME_UNDO_SIGNAL], 0);
#line 1037 "chess-game.c"
}


static gboolean
chess_game_resign_cb (ChessGame* self,
                      ChessPlayer* player)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	Color _tmp1_;
#line 224 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "../lib/chess-game.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 226 "../lib/chess-game.vala"
	_tmp0_ = self->is_started;
#line 226 "../lib/chess-game.vala"
	if (!_tmp0_) {
#line 227 "../lib/chess-game.vala"
		result = FALSE;
#line 227 "../lib/chess-game.vala"
		return result;
#line 1060 "chess-game.c"
	}
#line 229 "../lib/chess-game.vala"
	_tmp1_ = player->color;
#line 229 "../lib/chess-game.vala"
	if (_tmp1_ == COLOR_WHITE) {
#line 230 "../lib/chess-game.vala"
		chess_game_stop (self, CHESS_RESULT_BLACK_WON, CHESS_RULE_RESIGN);
#line 1068 "chess-game.c"
	} else {
#line 232 "../lib/chess-game.vala"
		chess_game_stop (self, CHESS_RESULT_WHITE_WON, CHESS_RULE_RESIGN);
#line 1072 "chess-game.c"
	}
#line 234 "../lib/chess-game.vala"
	result = TRUE;
#line 234 "../lib/chess-game.vala"
	return result;
#line 1078 "chess-game.c"
}


static gint
chess_game_state_repeated_times (ChessGame* self,
                                 ChessState* s1)
{
	gint result = 0;
	gint count = 0;
	GList* _tmp0_;
#line 237 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 237 "../lib/chess-game.vala"
	g_return_val_if_fail (s1 != NULL, 0);
#line 239 "../lib/chess-game.vala"
	count = 1;
#line 241 "../lib/chess-game.vala"
	_tmp0_ = self->move_stack;
#line 1097 "chess-game.c"
	{
		GList* s2_collection = NULL;
		GList* s2_it = NULL;
#line 241 "../lib/chess-game.vala"
		s2_collection = _tmp0_;
#line 241 "../lib/chess-game.vala"
		for (s2_it = s2_collection; s2_it != NULL; s2_it = s2_it->next) {
#line 1105 "chess-game.c"
			ChessState* _tmp1_;
			ChessState* s2 = NULL;
#line 241 "../lib/chess-game.vala"
			_tmp1_ = _g_object_ref0 ((ChessState*) s2_it->data);
#line 241 "../lib/chess-game.vala"
			s2 = _tmp1_;
#line 1112 "chess-game.c"
			{
				gboolean _tmp2_ = FALSE;
				ChessState* _tmp3_;
#line 243 "../lib/chess-game.vala"
				_tmp3_ = s2;
#line 243 "../lib/chess-game.vala"
				if (s1 != _tmp3_) {
#line 1120 "chess-game.c"
					ChessState* _tmp4_;
#line 243 "../lib/chess-game.vala"
					_tmp4_ = s2;
#line 243 "../lib/chess-game.vala"
					_tmp2_ = chess_state_equals (s1, _tmp4_);
#line 1126 "chess-game.c"
				} else {
#line 243 "../lib/chess-game.vala"
					_tmp2_ = FALSE;
#line 1130 "chess-game.c"
				}
#line 243 "../lib/chess-game.vala"
				if (_tmp2_) {
#line 1134 "chess-game.c"
					gint _tmp5_;
#line 244 "../lib/chess-game.vala"
					_tmp5_ = count;
#line 244 "../lib/chess-game.vala"
					count = _tmp5_ + 1;
#line 1140 "chess-game.c"
				}
#line 241 "../lib/chess-game.vala"
				_g_object_unref0 (s2);
#line 1144 "chess-game.c"
			}
		}
	}
#line 247 "../lib/chess-game.vala"
	result = count;
#line 247 "../lib/chess-game.vala"
	return result;
#line 1152 "chess-game.c"
}


static gboolean
chess_game_is_n_fold_repeat (ChessGame* self,
                             gint n)
{
	gboolean result = FALSE;
	GList* _tmp0_;
#line 250 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 252 "../lib/chess-game.vala"
	_tmp0_ = self->move_stack;
#line 1166 "chess-game.c"
	{
		GList* state_collection = NULL;
		GList* state_it = NULL;
#line 252 "../lib/chess-game.vala"
		state_collection = _tmp0_;
#line 252 "../lib/chess-game.vala"
		for (state_it = state_collection; state_it != NULL; state_it = state_it->next) {
#line 1174 "chess-game.c"
			ChessState* _tmp1_;
			ChessState* state = NULL;
#line 252 "../lib/chess-game.vala"
			_tmp1_ = _g_object_ref0 ((ChessState*) state_it->data);
#line 252 "../lib/chess-game.vala"
			state = _tmp1_;
#line 1181 "chess-game.c"
			{
				ChessState* _tmp2_;
#line 254 "../lib/chess-game.vala"
				_tmp2_ = state;
#line 254 "../lib/chess-game.vala"
				if (chess_game_state_repeated_times (self, _tmp2_) >= n) {
#line 255 "../lib/chess-game.vala"
					result = TRUE;
#line 255 "../lib/chess-game.vala"
					_g_object_unref0 (state);
#line 255 "../lib/chess-game.vala"
					return result;
#line 1194 "chess-game.c"
				}
#line 252 "../lib/chess-game.vala"
				_g_object_unref0 (state);
#line 1198 "chess-game.c"
			}
		}
	}
#line 258 "../lib/chess-game.vala"
	result = FALSE;
#line 258 "../lib/chess-game.vala"
	return result;
#line 1206 "chess-game.c"
}


gboolean
chess_game_is_three_fold_repeat (ChessGame* self)
{
	gboolean result = FALSE;
#line 261 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 263 "../lib/chess-game.vala"
	result = chess_game_is_n_fold_repeat (self, 3);
#line 263 "../lib/chess-game.vala"
	return result;
#line 1220 "chess-game.c"
}


gboolean
chess_game_is_five_fold_repeat (ChessGame* self)
{
	gboolean result = FALSE;
#line 266 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 268 "../lib/chess-game.vala"
	result = chess_game_is_n_fold_repeat (self, 5);
#line 268 "../lib/chess-game.vala"
	return result;
#line 1234 "chess-game.c"
}


gboolean
chess_game_is_fifty_move_rule_fulfilled (ChessGame* self)
{
	gboolean result = FALSE;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	gint _tmp2_;
#line 271 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 274 "../lib/chess-game.vala"
	_tmp0_ = chess_game_get_current_state (self);
#line 274 "../lib/chess-game.vala"
	_tmp1_ = _tmp0_;
#line 274 "../lib/chess-game.vala"
	_tmp2_ = _tmp1_->halfmove_clock;
#line 274 "../lib/chess-game.vala"
	result = _tmp2_ >= 100;
#line 274 "../lib/chess-game.vala"
	return result;
#line 1257 "chess-game.c"
}


gboolean
chess_game_is_seventy_five_move_rule_fulfilled (ChessGame* self)
{
	gboolean result = FALSE;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	gint _tmp2_;
#line 277 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 280 "../lib/chess-game.vala"
	_tmp0_ = chess_game_get_current_state (self);
#line 280 "../lib/chess-game.vala"
	_tmp1_ = _tmp0_;
#line 280 "../lib/chess-game.vala"
	_tmp2_ = _tmp1_->halfmove_clock;
#line 280 "../lib/chess-game.vala"
	result = _tmp2_ >= 150;
#line 280 "../lib/chess-game.vala"
	return result;
#line 1280 "chess-game.c"
}


gboolean
chess_game_can_claim_draw (ChessGame* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 283 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 285 "../lib/chess-game.vala"
	if (chess_game_is_fifty_move_rule_fulfilled (self)) {
#line 285 "../lib/chess-game.vala"
		_tmp0_ = TRUE;
#line 1295 "chess-game.c"
	} else {
#line 285 "../lib/chess-game.vala"
		_tmp0_ = chess_game_is_three_fold_repeat (self);
#line 1299 "chess-game.c"
	}
#line 285 "../lib/chess-game.vala"
	result = _tmp0_;
#line 285 "../lib/chess-game.vala"
	return result;
#line 1305 "chess-game.c"
}


static void
chess_game_claim_draw_cb (ChessGame* self)
{
#line 288 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 290 "../lib/chess-game.vala"
	if (chess_game_is_fifty_move_rule_fulfilled (self)) {
#line 291 "../lib/chess-game.vala"
		chess_game_stop (self, CHESS_RESULT_DRAW, CHESS_RULE_FIFTY_MOVES);
#line 1318 "chess-game.c"
	} else {
#line 292 "../lib/chess-game.vala"
		if (chess_game_is_three_fold_repeat (self)) {
#line 293 "../lib/chess-game.vala"
			chess_game_stop (self, CHESS_RESULT_DRAW, CHESS_RULE_THREE_FOLD_REPETITION);
#line 1324 "chess-game.c"
		}
	}
}


static void
_chess_game_clock_expired_cb_chess_clock_expired (ChessClock* _sender,
                                                  gpointer self)
{
#line 307 "../lib/chess-game.vala"
	chess_game_clock_expired_cb ((ChessGame*) self, _sender);
#line 1336 "chess-game.c"
}


void
chess_game_start (ChessGame* self)
{
	ChessResult _tmp0_;
	gboolean _tmp1_;
	ChessClock* _tmp2_;
	ChessPlayer* _tmp8_;
	ChessPlayer* _tmp9_;
#line 296 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 298 "../lib/chess-game.vala"
	_tmp0_ = self->result;
#line 298 "../lib/chess-game.vala"
	if (_tmp0_ != CHESS_RESULT_IN_PROGRESS) {
#line 299 "../lib/chess-game.vala"
		return;
#line 1356 "chess-game.c"
	}
#line 301 "../lib/chess-game.vala"
	_tmp1_ = self->is_started;
#line 301 "../lib/chess-game.vala"
	if (_tmp1_) {
#line 302 "../lib/chess-game.vala"
		return;
#line 1364 "chess-game.c"
	}
#line 303 "../lib/chess-game.vala"
	self->is_started = TRUE;
#line 305 "../lib/chess-game.vala"
	_tmp2_ = self->priv->_clock;
#line 305 "../lib/chess-game.vala"
	if (_tmp2_ != NULL) {
#line 1372 "chess-game.c"
		ChessClock* _tmp3_;
		ChessClock* _tmp4_;
		ChessPlayer* _tmp5_;
		ChessPlayer* _tmp6_;
		Color _tmp7_;
#line 307 "../lib/chess-game.vala"
		_tmp3_ = self->priv->_clock;
#line 307 "../lib/chess-game.vala"
		g_signal_connect_object (_tmp3_, "expired", (GCallback) _chess_game_clock_expired_cb_chess_clock_expired, self, 0);
#line 308 "../lib/chess-game.vala"
		_tmp4_ = self->priv->_clock;
#line 308 "../lib/chess-game.vala"
		_tmp5_ = chess_game_get_current_player (self);
#line 308 "../lib/chess-game.vala"
		_tmp6_ = _tmp5_;
#line 308 "../lib/chess-game.vala"
		_tmp7_ = _tmp6_->color;
#line 308 "../lib/chess-game.vala"
		chess_clock_set_active_color (_tmp4_, _tmp7_);
#line 1392 "chess-game.c"
	}
#line 311 "../lib/chess-game.vala"
	_tmp8_ = chess_game_get_current_player (self);
#line 311 "../lib/chess-game.vala"
	_tmp9_ = _tmp8_;
#line 311 "../lib/chess-game.vala"
	g_signal_emit (self, chess_game_signals[CHESS_GAME_TURN_STARTED_SIGNAL], 0, _tmp9_);
#line 1400 "chess-game.c"
}


static void
chess_game_clock_expired_cb (ChessGame* self,
                             ChessClock* clock)
{
	gint _tmp0_;
	gint _tmp1_;
#line 314 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 314 "../lib/chess-game.vala"
	g_return_if_fail (clock != NULL);
#line 316 "../lib/chess-game.vala"
	_tmp0_ = chess_clock_get_white_remaining_seconds (clock);
#line 316 "../lib/chess-game.vala"
	_tmp1_ = _tmp0_;
#line 316 "../lib/chess-game.vala"
	if (_tmp1_ <= 0) {
#line 317 "../lib/chess-game.vala"
		chess_game_stop (self, CHESS_RESULT_BLACK_WON, CHESS_RULE_TIMEOUT);
#line 1422 "chess-game.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 318 "../lib/chess-game.vala"
		_tmp2_ = chess_clock_get_black_remaining_seconds (clock);
#line 318 "../lib/chess-game.vala"
		_tmp3_ = _tmp2_;
#line 318 "../lib/chess-game.vala"
		if (_tmp3_ <= 0) {
#line 319 "../lib/chess-game.vala"
			chess_game_stop (self, CHESS_RESULT_WHITE_WON, CHESS_RULE_TIMEOUT);
#line 1434 "chess-game.c"
		} else {
#line 321 "../lib/chess-game.vala"
			g_assert_not_reached ();
#line 1438 "chess-game.c"
		}
	}
}


ChessPiece*
chess_game_get_piece (ChessGame* self,
                      gint rank,
                      gint file,
                      gint move_number)
{
	ChessPiece* result = NULL;
	ChessState* state = NULL;
	GList* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	ChessState* _tmp4_;
	ChessPiece* _tmp5_;
	ChessPiece* _tmp6_;
#line 324 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 326 "../lib/chess-game.vala"
	if (move_number < 0) {
#line 1462 "chess-game.c"
		GList* _tmp0_;
#line 327 "../lib/chess-game.vala"
		_tmp0_ = self->move_stack;
#line 327 "../lib/chess-game.vala"
		move_number = move_number + ((gint) g_list_length (_tmp0_));
#line 1468 "chess-game.c"
	}
#line 329 "../lib/chess-game.vala"
	_tmp1_ = self->move_stack;
#line 329 "../lib/chess-game.vala"
	_tmp2_ = self->move_stack;
#line 329 "../lib/chess-game.vala"
	_tmp3_ = g_list_nth_data (_tmp1_, (g_list_length (_tmp2_) - move_number) - 1);
#line 329 "../lib/chess-game.vala"
	_tmp4_ = _g_object_ref0 ((ChessState*) _tmp3_);
#line 329 "../lib/chess-game.vala"
	state = _tmp4_;
#line 331 "../lib/chess-game.vala"
	_tmp5_ = state->board[chess_state_get_index (state, rank, file)];
#line 331 "../lib/chess-game.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 331 "../lib/chess-game.vala"
	result = _tmp6_;
#line 331 "../lib/chess-game.vala"
	_g_object_unref0 (state);
#line 331 "../lib/chess-game.vala"
	return result;
#line 1490 "chess-game.c"
}


void
chess_game_pause (ChessGame* self,
                  gboolean show_overlay)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ChessClock* _tmp2_;
	ChessClock* _tmp3_;
#line 339 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 341 "../lib/chess-game.vala"
	_tmp2_ = chess_game_get_clock (self);
#line 341 "../lib/chess-game.vala"
	_tmp3_ = _tmp2_;
#line 341 "../lib/chess-game.vala"
	if (_tmp3_ != NULL) {
#line 1510 "chess-game.c"
		ChessResult _tmp4_;
#line 341 "../lib/chess-game.vala"
		_tmp4_ = self->result;
#line 341 "../lib/chess-game.vala"
		_tmp1_ = _tmp4_ == CHESS_RESULT_IN_PROGRESS;
#line 1516 "chess-game.c"
	} else {
#line 341 "../lib/chess-game.vala"
		_tmp1_ = FALSE;
#line 1520 "chess-game.c"
	}
#line 341 "../lib/chess-game.vala"
	if (_tmp1_) {
#line 1524 "chess-game.c"
		gboolean _tmp5_;
#line 341 "../lib/chess-game.vala"
		_tmp5_ = self->priv->_is_paused;
#line 341 "../lib/chess-game.vala"
		_tmp0_ = !_tmp5_;
#line 1530 "chess-game.c"
	} else {
#line 341 "../lib/chess-game.vala"
		_tmp0_ = FALSE;
#line 1534 "chess-game.c"
	}
#line 341 "../lib/chess-game.vala"
	if (_tmp0_) {
#line 1538 "chess-game.c"
		ChessClock* _tmp6_;
		ChessClock* _tmp7_;
#line 343 "../lib/chess-game.vala"
		_tmp6_ = chess_game_get_clock (self);
#line 343 "../lib/chess-game.vala"
		_tmp7_ = _tmp6_;
#line 343 "../lib/chess-game.vala"
		chess_clock_pause (_tmp7_);
#line 344 "../lib/chess-game.vala"
		chess_game_set_is_paused (self, TRUE);
#line 345 "../lib/chess-game.vala"
		chess_game_set_should_show_paused_overlay (self, show_overlay);
#line 346 "../lib/chess-game.vala"
		g_signal_emit (self, chess_game_signals[CHESS_GAME_PAUSED_SIGNAL], 0);
#line 1553 "chess-game.c"
	}
}


void
chess_game_unpause (ChessGame* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ChessClock* _tmp2_;
	ChessClock* _tmp3_;
#line 350 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 352 "../lib/chess-game.vala"
	_tmp2_ = chess_game_get_clock (self);
#line 352 "../lib/chess-game.vala"
	_tmp3_ = _tmp2_;
#line 352 "../lib/chess-game.vala"
	if (_tmp3_ != NULL) {
#line 1573 "chess-game.c"
		ChessResult _tmp4_;
#line 352 "../lib/chess-game.vala"
		_tmp4_ = self->result;
#line 352 "../lib/chess-game.vala"
		_tmp1_ = _tmp4_ == CHESS_RESULT_IN_PROGRESS;
#line 1579 "chess-game.c"
	} else {
#line 352 "../lib/chess-game.vala"
		_tmp1_ = FALSE;
#line 1583 "chess-game.c"
	}
#line 352 "../lib/chess-game.vala"
	if (_tmp1_) {
#line 1587 "chess-game.c"
		gboolean _tmp5_;
#line 352 "../lib/chess-game.vala"
		_tmp5_ = self->priv->_is_paused;
#line 352 "../lib/chess-game.vala"
		_tmp0_ = _tmp5_;
#line 1593 "chess-game.c"
	} else {
#line 352 "../lib/chess-game.vala"
		_tmp0_ = FALSE;
#line 1597 "chess-game.c"
	}
#line 352 "../lib/chess-game.vala"
	if (_tmp0_) {
#line 1601 "chess-game.c"
		ChessClock* _tmp6_;
		ChessClock* _tmp7_;
#line 354 "../lib/chess-game.vala"
		_tmp6_ = chess_game_get_clock (self);
#line 354 "../lib/chess-game.vala"
		_tmp7_ = _tmp6_;
#line 354 "../lib/chess-game.vala"
		chess_clock_unpause (_tmp7_);
#line 355 "../lib/chess-game.vala"
		chess_game_set_is_paused (self, FALSE);
#line 356 "../lib/chess-game.vala"
		chess_game_set_should_show_paused_overlay (self, FALSE);
#line 357 "../lib/chess-game.vala"
		g_signal_emit (self, chess_game_signals[CHESS_GAME_UNPAUSED_SIGNAL], 0);
#line 1616 "chess-game.c"
	}
}


void
chess_game_stop (ChessGame* self,
                 ChessResult _result_,
                 ChessRule rule)
{
	gboolean _tmp0_;
	ChessClock* _tmp1_;
#line 361 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 363 "../lib/chess-game.vala"
	_tmp0_ = self->is_started;
#line 363 "../lib/chess-game.vala"
	if (!_tmp0_) {
#line 364 "../lib/chess-game.vala"
		return;
#line 1636 "chess-game.c"
	}
#line 365 "../lib/chess-game.vala"
	self->result = _result_;
#line 366 "../lib/chess-game.vala"
	self->rule = rule;
#line 367 "../lib/chess-game.vala"
	self->is_started = FALSE;
#line 368 "../lib/chess-game.vala"
	_tmp1_ = self->priv->_clock;
#line 368 "../lib/chess-game.vala"
	if (_tmp1_ != NULL) {
#line 1648 "chess-game.c"
		ChessClock* _tmp2_;
#line 369 "../lib/chess-game.vala"
		_tmp2_ = self->priv->_clock;
#line 369 "../lib/chess-game.vala"
		chess_clock_stop (_tmp2_);
#line 1654 "chess-game.c"
	}
#line 370 "../lib/chess-game.vala"
	g_signal_emit (self, chess_game_signals[CHESS_GAME_ENDED_SIGNAL], 0);
#line 1658 "chess-game.c"
}


gboolean
chess_game_get_is_paused (ChessGame* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 57 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../lib/chess-game.vala"
	_tmp0_ = self->priv->_is_paused;
#line 57 "../lib/chess-game.vala"
	result = _tmp0_;
#line 57 "../lib/chess-game.vala"
	return result;
#line 1675 "chess-game.c"
}


static void
chess_game_set_is_paused (ChessGame* self,
                          gboolean value)
{
#line 57 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 57 "../lib/chess-game.vala"
	if (chess_game_get_is_paused (self) != value) {
#line 57 "../lib/chess-game.vala"
		self->priv->_is_paused = value;
#line 57 "../lib/chess-game.vala"
		g_object_notify_by_pspec ((GObject *) self, chess_game_properties[CHESS_GAME_IS_PAUSED_PROPERTY]);
#line 1691 "chess-game.c"
	}
}


gboolean
chess_game_get_should_show_paused_overlay (ChessGame* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 58 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "../lib/chess-game.vala"
	_tmp0_ = self->priv->_should_show_paused_overlay;
#line 58 "../lib/chess-game.vala"
	result = _tmp0_;
#line 58 "../lib/chess-game.vala"
	return result;
#line 1709 "chess-game.c"
}


static void
chess_game_set_should_show_paused_overlay (ChessGame* self,
                                           gboolean value)
{
#line 58 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 58 "../lib/chess-game.vala"
	if (chess_game_get_should_show_paused_overlay (self) != value) {
#line 58 "../lib/chess-game.vala"
		self->priv->_should_show_paused_overlay = value;
#line 58 "../lib/chess-game.vala"
		g_object_notify_by_pspec ((GObject *) self, chess_game_properties[CHESS_GAME_SHOULD_SHOW_PAUSED_OVERLAY_PROPERTY]);
#line 1725 "chess-game.c"
	}
}


ChessState*
chess_game_get_current_state (ChessGame* self)
{
	ChessState* result;
	GList* _tmp0_;
	gconstpointer _tmp1_;
#line 62 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../lib/chess-game.vala"
	_tmp0_ = self->move_stack;
#line 62 "../lib/chess-game.vala"
	_tmp1_ = _tmp0_->data;
#line 62 "../lib/chess-game.vala"
	result = (ChessState*) _tmp1_;
#line 62 "../lib/chess-game.vala"
	return result;
#line 1746 "chess-game.c"
}


ChessPlayer*
chess_game_get_white (ChessGame* self)
{
	ChessPlayer* result;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	ChessPlayer* _tmp2_;
#line 67 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../lib/chess-game.vala"
	_tmp0_ = chess_game_get_current_state (self);
#line 67 "../lib/chess-game.vala"
	_tmp1_ = _tmp0_;
#line 67 "../lib/chess-game.vala"
	_tmp2_ = _tmp1_->players[COLOR_WHITE];
#line 67 "../lib/chess-game.vala"
	result = _tmp2_;
#line 67 "../lib/chess-game.vala"
	return result;
#line 1769 "chess-game.c"
}


ChessPlayer*
chess_game_get_black (ChessGame* self)
{
	ChessPlayer* result;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	ChessPlayer* _tmp2_;
#line 71 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../lib/chess-game.vala"
	_tmp0_ = chess_game_get_current_state (self);
#line 71 "../lib/chess-game.vala"
	_tmp1_ = _tmp0_;
#line 71 "../lib/chess-game.vala"
	_tmp2_ = _tmp1_->players[COLOR_BLACK];
#line 71 "../lib/chess-game.vala"
	result = _tmp2_;
#line 71 "../lib/chess-game.vala"
	return result;
#line 1792 "chess-game.c"
}


ChessPlayer*
chess_game_get_current_player (ChessGame* self)
{
	ChessPlayer* result;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	ChessPlayer* _tmp2_;
#line 75 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../lib/chess-game.vala"
	_tmp0_ = chess_game_get_current_state (self);
#line 75 "../lib/chess-game.vala"
	_tmp1_ = _tmp0_;
#line 75 "../lib/chess-game.vala"
	_tmp2_ = _tmp1_->current_player;
#line 75 "../lib/chess-game.vala"
	result = _tmp2_;
#line 75 "../lib/chess-game.vala"
	return result;
#line 1815 "chess-game.c"
}


ChessPlayer*
chess_game_get_opponent (ChessGame* self)
{
	ChessPlayer* result;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	ChessPlayer* _tmp2_;
	ChessPlayer* _tmp3_;
#line 79 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../lib/chess-game.vala"
	_tmp0_ = chess_game_get_current_state (self);
#line 79 "../lib/chess-game.vala"
	_tmp1_ = _tmp0_;
#line 79 "../lib/chess-game.vala"
	_tmp2_ = chess_state_get_opponent (_tmp1_);
#line 79 "../lib/chess-game.vala"
	_tmp3_ = _tmp2_;
#line 79 "../lib/chess-game.vala"
	result = _tmp3_;
#line 79 "../lib/chess-game.vala"
	return result;
#line 1841 "chess-game.c"
}


ChessClock*
chess_game_get_clock (ChessGame* self)
{
	ChessClock* result;
	ChessClock* _tmp0_;
#line 84 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../lib/chess-game.vala"
	_tmp0_ = self->priv->_clock;
#line 84 "../lib/chess-game.vala"
	result = _tmp0_;
#line 84 "../lib/chess-game.vala"
	return result;
#line 1858 "chess-game.c"
}


void
chess_game_set_clock (ChessGame* self,
                      ChessClock* value)
{
	gboolean _tmp0_;
	ChessClock* _tmp1_;
#line 85 "../lib/chess-game.vala"
	g_return_if_fail (self != NULL);
#line 87 "../lib/chess-game.vala"
	_tmp0_ = self->is_started;
#line 87 "../lib/chess-game.vala"
	if (_tmp0_) {
#line 88 "../lib/chess-game.vala"
		return;
#line 1876 "chess-game.c"
	}
#line 89 "../lib/chess-game.vala"
	_tmp1_ = _g_object_ref0 (value);
#line 89 "../lib/chess-game.vala"
	_g_object_unref0 (self->priv->_clock);
#line 89 "../lib/chess-game.vala"
	self->priv->_clock = _tmp1_;
#line 85 "../lib/chess-game.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_game_properties[CHESS_GAME_CLOCK_PROPERTY]);
#line 1886 "chess-game.c"
}


guint
chess_game_get_n_moves (ChessGame* self)
{
	guint result;
	GList* _tmp0_;
#line 336 "../lib/chess-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 336 "../lib/chess-game.vala"
	_tmp0_ = self->move_stack;
#line 336 "../lib/chess-game.vala"
	result = g_list_length (_tmp0_) - 1;
#line 336 "../lib/chess-game.vala"
	return result;
#line 1903 "chess-game.c"
}


static void
chess_game_class_init (ChessGameClass * klass)
{
#line 39 "../lib/chess-game.vala"
	chess_game_parent_class = g_type_class_peek_parent (klass);
#line 39 "../lib/chess-game.vala"
	g_type_class_adjust_private_offset (klass, &ChessGame_private_offset);
#line 39 "../lib/chess-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_game_get_property;
#line 39 "../lib/chess-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_game_set_property;
#line 39 "../lib/chess-game.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_game_finalize;
#line 39 "../lib/chess-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_GAME_IS_PAUSED_PROPERTY, chess_game_properties[CHESS_GAME_IS_PAUSED_PROPERTY] = g_param_spec_boolean ("is-paused", "is-paused", "is-paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../lib/chess-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_GAME_SHOULD_SHOW_PAUSED_OVERLAY_PROPERTY, chess_game_properties[CHESS_GAME_SHOULD_SHOW_PAUSED_OVERLAY_PROPERTY] = g_param_spec_boolean ("should-show-paused-overlay", "should-show-paused-overlay", "should-show-paused-overlay", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../lib/chess-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_GAME_CURRENT_STATE_PROPERTY, chess_game_properties[CHESS_GAME_CURRENT_STATE_PROPERTY] = g_param_spec_object ("current-state", "current-state", "current-state", TYPE_CHESS_STATE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../lib/chess-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_GAME_WHITE_PROPERTY, chess_game_properties[CHESS_GAME_WHITE_PROPERTY] = g_param_spec_object ("white", "white", "white", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../lib/chess-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_GAME_BLACK_PROPERTY, chess_game_properties[CHESS_GAME_BLACK_PROPERTY] = g_param_spec_object ("black", "black", "black", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../lib/chess-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_GAME_CURRENT_PLAYER_PROPERTY, chess_game_properties[CHESS_GAME_CURRENT_PLAYER_PROPERTY] = g_param_spec_object ("current-player", "current-player", "current-player", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../lib/chess-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_GAME_OPPONENT_PROPERTY, chess_game_properties[CHESS_GAME_OPPONENT_PROPERTY] = g_param_spec_object ("opponent", "opponent", "opponent", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../lib/chess-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_GAME_CLOCK_PROPERTY, chess_game_properties[CHESS_GAME_CLOCK_PROPERTY] = g_param_spec_object ("clock", "clock", "clock", TYPE_CHESS_CLOCK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "../lib/chess-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_GAME_N_MOVES_PROPERTY, chess_game_properties[CHESS_GAME_N_MOVES_PROPERTY] = g_param_spec_uint ("n-moves", "n-moves", "n-moves", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../lib/chess-game.vala"
	chess_game_signals[CHESS_GAME_TURN_STARTED_SIGNAL] = g_signal_new ("turn-started", TYPE_CHESS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_CHESS_PLAYER);
#line 39 "../lib/chess-game.vala"
	chess_game_signals[CHESS_GAME_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_CHESS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_CHESS_MOVE);
#line 39 "../lib/chess-game.vala"
	chess_game_signals[CHESS_GAME_PAUSED_SIGNAL] = g_signal_new ("paused", TYPE_CHESS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 39 "../lib/chess-game.vala"
	chess_game_signals[CHESS_GAME_UNPAUSED_SIGNAL] = g_signal_new ("unpaused", TYPE_CHESS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 39 "../lib/chess-game.vala"
	chess_game_signals[CHESS_GAME_UNDO_SIGNAL] = g_signal_new ("undo", TYPE_CHESS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 39 "../lib/chess-game.vala"
	chess_game_signals[CHESS_GAME_ENDED_SIGNAL] = g_signal_new ("ended", TYPE_CHESS_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1950 "chess-game.c"
}


static void
chess_game_instance_init (ChessGame * self)
{
#line 39 "../lib/chess-game.vala"
	self->priv = chess_game_get_instance_private (self);
#line 46 "../lib/chess-game.vala"
	self->priv->hold_count = 0;
#line 57 "../lib/chess-game.vala"
	self->priv->_is_paused = FALSE;
#line 58 "../lib/chess-game.vala"
	self->priv->_should_show_paused_overlay = FALSE;
#line 1965 "chess-game.c"
}


static void
chess_game_finalize (GObject * obj)
{
	ChessGame * self;
	ChessClock* _tmp0_;
#line 39 "../lib/chess-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_GAME, ChessGame);
#line 123 "../lib/chess-game.vala"
	_tmp0_ = self->priv->_clock;
#line 123 "../lib/chess-game.vala"
	if (_tmp0_ != NULL) {
#line 1980 "chess-game.c"
		ChessClock* _tmp1_;
#line 124 "../lib/chess-game.vala"
		_tmp1_ = self->priv->_clock;
#line 124 "../lib/chess-game.vala"
		chess_clock_stop (_tmp1_);
#line 1986 "chess-game.c"
	}
#line 44 "../lib/chess-game.vala"
	(self->move_stack == NULL) ? NULL : (self->move_stack = (_g_list_free__g_object_unref0_ (self->move_stack), NULL));
#line 81 "../lib/chess-game.vala"
	_g_object_unref0 (self->priv->_clock);
#line 39 "../lib/chess-game.vala"
	G_OBJECT_CLASS (chess_game_parent_class)->finalize (obj);
#line 1994 "chess-game.c"
}


GType
chess_game_get_type (void)
{
	static volatile gsize chess_game_type_id__volatile = 0;
	if (g_once_init_enter (&chess_game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessGame), 0, (GInstanceInitFunc) chess_game_instance_init, NULL };
		GType chess_game_type_id;
		chess_game_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessGame", &g_define_type_info, 0);
		ChessGame_private_offset = g_type_add_instance_private (chess_game_type_id, sizeof (ChessGamePrivate));
		g_once_init_leave (&chess_game_type_id__volatile, chess_game_type_id);
	}
	return chess_game_type_id__volatile;
}


static void
_vala_chess_game_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	ChessGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_GAME, ChessGame);
#line 39 "../lib/chess-game.vala"
	switch (property_id) {
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_IS_PAUSED_PROPERTY:
#line 39 "../lib/chess-game.vala"
		g_value_set_boolean (value, chess_game_get_is_paused (self));
#line 39 "../lib/chess-game.vala"
		break;
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_SHOULD_SHOW_PAUSED_OVERLAY_PROPERTY:
#line 39 "../lib/chess-game.vala"
		g_value_set_boolean (value, chess_game_get_should_show_paused_overlay (self));
#line 39 "../lib/chess-game.vala"
		break;
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_CURRENT_STATE_PROPERTY:
#line 39 "../lib/chess-game.vala"
		g_value_set_object (value, chess_game_get_current_state (self));
#line 39 "../lib/chess-game.vala"
		break;
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_WHITE_PROPERTY:
#line 39 "../lib/chess-game.vala"
		g_value_set_object (value, chess_game_get_white (self));
#line 39 "../lib/chess-game.vala"
		break;
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_BLACK_PROPERTY:
#line 39 "../lib/chess-game.vala"
		g_value_set_object (value, chess_game_get_black (self));
#line 39 "../lib/chess-game.vala"
		break;
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_CURRENT_PLAYER_PROPERTY:
#line 39 "../lib/chess-game.vala"
		g_value_set_object (value, chess_game_get_current_player (self));
#line 39 "../lib/chess-game.vala"
		break;
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_OPPONENT_PROPERTY:
#line 39 "../lib/chess-game.vala"
		g_value_set_object (value, chess_game_get_opponent (self));
#line 39 "../lib/chess-game.vala"
		break;
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_CLOCK_PROPERTY:
#line 39 "../lib/chess-game.vala"
		g_value_set_object (value, chess_game_get_clock (self));
#line 39 "../lib/chess-game.vala"
		break;
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_N_MOVES_PROPERTY:
#line 39 "../lib/chess-game.vala"
		g_value_set_uint (value, chess_game_get_n_moves (self));
#line 39 "../lib/chess-game.vala"
		break;
#line 2077 "chess-game.c"
		default:
#line 39 "../lib/chess-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "../lib/chess-game.vala"
		break;
#line 2083 "chess-game.c"
	}
}


static void
_vala_chess_game_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	ChessGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_GAME, ChessGame);
#line 39 "../lib/chess-game.vala"
	switch (property_id) {
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_IS_PAUSED_PROPERTY:
#line 39 "../lib/chess-game.vala"
		chess_game_set_is_paused (self, g_value_get_boolean (value));
#line 39 "../lib/chess-game.vala"
		break;
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_SHOULD_SHOW_PAUSED_OVERLAY_PROPERTY:
#line 39 "../lib/chess-game.vala"
		chess_game_set_should_show_paused_overlay (self, g_value_get_boolean (value));
#line 39 "../lib/chess-game.vala"
		break;
#line 39 "../lib/chess-game.vala"
		case CHESS_GAME_CLOCK_PROPERTY:
#line 39 "../lib/chess-game.vala"
		chess_game_set_clock (self, g_value_get_object (value));
#line 39 "../lib/chess-game.vala"
		break;
#line 2116 "chess-game.c"
		default:
#line 39 "../lib/chess-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "../lib/chess-game.vala"
		break;
#line 2122 "chess-game.c"
	}
}



