/* chess-move.c generated by valac 0.42.6, the Vala compiler
 * generated from chess-move.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2016 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_CHESS_MOVE (chess_move_get_type ())
#define CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MOVE, ChessMove))
#define CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MOVE, ChessMoveClass))
#define IS_CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MOVE))
#define IS_CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MOVE))
#define CHESS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MOVE, ChessMoveClass))

typedef struct _ChessMove ChessMove;
typedef struct _ChessMoveClass ChessMoveClass;
typedef struct _ChessMovePrivate ChessMovePrivate;

#define TYPE_CHESS_PIECE (chess_piece_get_type ())
#define CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PIECE, ChessPiece))
#define CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PIECE, ChessPieceClass))
#define IS_CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PIECE))
#define IS_CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PIECE))
#define CHESS_PIECE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PIECE, ChessPieceClass))

typedef struct _ChessPiece ChessPiece;
typedef struct _ChessPieceClass ChessPieceClass;
typedef enum  {
	CHECK_STATE_NONE,
	CHECK_STATE_CHECK,
	CHECK_STATE_CHECKMATE
} CheckState;


#define TYPE_CHECK_STATE (check_state_get_type ())
enum  {
	CHESS_MOVE_0_PROPERTY,
	CHESS_MOVE_NUM_PROPERTIES
};
static GParamSpec* chess_move_properties[CHESS_MOVE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ChessPiecePrivate ChessPiecePrivate;

#define TYPE_CHESS_PLAYER (chess_player_get_type ())
#define CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PLAYER, ChessPlayer))
#define CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PLAYER, ChessPlayerClass))
#define IS_CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PLAYER))
#define IS_CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PLAYER))
#define CHESS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PLAYER, ChessPlayerClass))

typedef struct _ChessPlayer ChessPlayer;
typedef struct _ChessPlayerClass ChessPlayerClass;
typedef enum  {
	PIECE_TYPE_PAWN,
	PIECE_TYPE_ROOK,
	PIECE_TYPE_KNIGHT,
	PIECE_TYPE_BISHOP,
	PIECE_TYPE_QUEEN,
	PIECE_TYPE_KING
} PieceType;


#define TYPE_PIECE_TYPE (piece_type_get_type ())
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef enum  {
	COLOR_WHITE,
	COLOR_BLACK
} Color;


#define TYPE_COLOR (color_get_type ())

struct _ChessMove {
	GObject parent_instance;
	ChessMovePrivate * priv;
	gint number;
	ChessPiece* piece;
	ChessPiece* promotion_piece;
	ChessPiece* castling_rook;
	ChessPiece* victim;
	gint r0;
	gint f0;
	gint r1;
	gint f1;
	gboolean ambiguous_rank;
	gboolean ambiguous_file;
	gboolean en_passant;
	CheckState check_state;
};

struct _ChessMoveClass {
	GObjectClass parent_class;
};

struct _ChessPiece {
	GObject parent_instance;
	ChessPiecePrivate * priv;
	ChessPlayer* player;
	PieceType type;
};

struct _ChessPieceClass {
	GObjectClass parent_class;
};


static gpointer chess_move_parent_class = NULL;

GType chess_move_get_type (void) G_GNUC_CONST;
GType chess_piece_get_type (void) G_GNUC_CONST;
GType check_state_get_type (void) G_GNUC_CONST;
gchar* chess_move_get_lan (ChessMove* self);
GType chess_player_get_type (void) G_GNUC_CONST;
GType piece_type_get_type (void) G_GNUC_CONST;
gchar* chess_move_get_san (ChessMove* self);
static gchar* chess_move_make_san (ChessMove* self,
                            gchar** piece_names,
                            int piece_names_length1);
gchar* chess_move_get_fan (ChessMove* self);
GType color_get_type (void) G_GNUC_CONST;
Color chess_piece_get_color (ChessPiece* self);
gchar* chess_move_get_engine (ChessMove* self);
ChessMove* chess_move_copy (ChessMove* self);
ChessMove* chess_move_new (void);
ChessMove* chess_move_construct (GType object_type);
static void chess_move_finalize (GObject * obj);


gchar*
chess_move_get_lan (ChessMove* self)
{
	gchar* result = NULL;
	ChessPiece* _tmp0_;
	GString* builder = NULL;
	GString* _tmp5_;
	ChessPiece* _tmp6_;
#line 44 "../lib/chess-move.vala"
	static const gchar promotion_symbols[6] = {' ', 'R', 'N', 'B', 'Q', 'K'};
#line 154 "chess-move.c"
	ChessPiece* _tmp17_;
	CheckState _tmp22_;
	GString* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
#line 28 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../lib/chess-move.vala"
	_tmp0_ = self->castling_rook;
#line 30 "../lib/chess-move.vala"
	if (_tmp0_ != NULL) {
#line 166 "chess-move.c"
		gint _tmp1_;
		gint _tmp2_;
#line 32 "../lib/chess-move.vala"
		_tmp1_ = self->f1;
#line 32 "../lib/chess-move.vala"
		_tmp2_ = self->f0;
#line 32 "../lib/chess-move.vala"
		if (_tmp1_ > _tmp2_) {
#line 175 "chess-move.c"
			gchar* _tmp3_;
#line 33 "../lib/chess-move.vala"
			_tmp3_ = g_strdup ("O-O");
#line 33 "../lib/chess-move.vala"
			result = _tmp3_;
#line 33 "../lib/chess-move.vala"
			return result;
#line 183 "chess-move.c"
		} else {
			gchar* _tmp4_;
#line 35 "../lib/chess-move.vala"
			_tmp4_ = g_strdup ("O-O-O");
#line 35 "../lib/chess-move.vala"
			result = _tmp4_;
#line 35 "../lib/chess-move.vala"
			return result;
#line 192 "chess-move.c"
		}
	}
#line 38 "../lib/chess-move.vala"
	_tmp5_ = g_string_new ("");
#line 38 "../lib/chess-move.vala"
	builder = _tmp5_;
#line 39 "../lib/chess-move.vala"
	_tmp6_ = self->victim;
#line 39 "../lib/chess-move.vala"
	if (_tmp6_ != NULL) {
#line 203 "chess-move.c"
		GString* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 40 "../lib/chess-move.vala"
		_tmp7_ = builder;
#line 40 "../lib/chess-move.vala"
		_tmp8_ = self->f0;
#line 40 "../lib/chess-move.vala"
		_tmp9_ = self->r0;
#line 40 "../lib/chess-move.vala"
		_tmp10_ = self->f1;
#line 40 "../lib/chess-move.vala"
		_tmp11_ = self->r1;
#line 40 "../lib/chess-move.vala"
		g_string_append_printf (_tmp7_, "%c%dx%c%d", 'a' + _tmp8_, _tmp9_ + 1, 'a' + _tmp10_, _tmp11_ + 1);
#line 221 "chess-move.c"
	} else {
		GString* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
#line 42 "../lib/chess-move.vala"
		_tmp12_ = builder;
#line 42 "../lib/chess-move.vala"
		_tmp13_ = self->f0;
#line 42 "../lib/chess-move.vala"
		_tmp14_ = self->r0;
#line 42 "../lib/chess-move.vala"
		_tmp15_ = self->f1;
#line 42 "../lib/chess-move.vala"
		_tmp16_ = self->r1;
#line 42 "../lib/chess-move.vala"
		g_string_append_printf (_tmp12_, "%c%d-%c%d", 'a' + _tmp13_, _tmp14_ + 1, 'a' + _tmp15_, _tmp16_ + 1);
#line 240 "chess-move.c"
	}
#line 45 "../lib/chess-move.vala"
	_tmp17_ = self->promotion_piece;
#line 45 "../lib/chess-move.vala"
	if (_tmp17_ != NULL) {
#line 246 "chess-move.c"
		GString* _tmp18_;
		ChessPiece* _tmp19_;
		PieceType _tmp20_;
		gchar _tmp21_;
#line 46 "../lib/chess-move.vala"
		_tmp18_ = builder;
#line 46 "../lib/chess-move.vala"
		_tmp19_ = self->promotion_piece;
#line 46 "../lib/chess-move.vala"
		_tmp20_ = _tmp19_->type;
#line 46 "../lib/chess-move.vala"
		_tmp21_ = promotion_symbols[_tmp20_];
#line 46 "../lib/chess-move.vala"
		g_string_append_printf (_tmp18_, "=%c", (gint) _tmp21_);
#line 261 "chess-move.c"
	}
#line 48 "../lib/chess-move.vala"
	_tmp22_ = self->check_state;
#line 48 "../lib/chess-move.vala"
	switch (_tmp22_) {
#line 48 "../lib/chess-move.vala"
		case CHECK_STATE_CHECK:
#line 269 "chess-move.c"
		{
			GString* _tmp23_;
#line 51 "../lib/chess-move.vala"
			_tmp23_ = builder;
#line 51 "../lib/chess-move.vala"
			g_string_append_c (_tmp23_, '+');
#line 52 "../lib/chess-move.vala"
			break;
#line 278 "chess-move.c"
		}
#line 48 "../lib/chess-move.vala"
		case CHECK_STATE_CHECKMATE:
#line 282 "chess-move.c"
		{
			GString* _tmp24_;
#line 54 "../lib/chess-move.vala"
			_tmp24_ = builder;
#line 54 "../lib/chess-move.vala"
			g_string_append_c (_tmp24_, '#');
#line 55 "../lib/chess-move.vala"
			break;
#line 291 "chess-move.c"
		}
		default:
#line 48 "../lib/chess-move.vala"
		break;
#line 296 "chess-move.c"
	}
#line 58 "../lib/chess-move.vala"
	_tmp25_ = builder;
#line 58 "../lib/chess-move.vala"
	_tmp26_ = _tmp25_->str;
#line 58 "../lib/chess-move.vala"
	_tmp27_ = g_strdup (_tmp26_);
#line 58 "../lib/chess-move.vala"
	result = _tmp27_;
#line 58 "../lib/chess-move.vala"
	_g_string_free0 (builder);
#line 58 "../lib/chess-move.vala"
	return result;
#line 310 "chess-move.c"
}


gchar*
chess_move_get_san (ChessMove* self)
{
	gchar* result = NULL;
#line 63 "../lib/chess-move.vala"
	static const gchar* piece_names[6] = {"", "R", "N", "B", "Q", "K"};
#line 320 "chess-move.c"
	gchar* _tmp0_;
#line 61 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../lib/chess-move.vala"
	_tmp0_ = chess_move_make_san (self, (gchar**) piece_names, (G_N_ELEMENTS (piece_names) * sizeof (const gchar*)) / sizeof (gchar*));
#line 64 "../lib/chess-move.vala"
	result = _tmp0_;
#line 64 "../lib/chess-move.vala"
	return result;
#line 330 "chess-move.c"
}


gchar*
chess_move_get_fan (ChessMove* self)
{
	gchar* result = NULL;
#line 69 "../lib/chess-move.vala"
	static const gchar* white_piece_names[6] = {"", "♖", "♘", "♗", "♕", "♔"};
#line 70 "../lib/chess-move.vala"
	static const gchar* black_piece_names[6] = {"", "♜", "♞", "♝", "♛", "♚"};
#line 342 "chess-move.c"
	ChessPiece* _tmp0_;
	Color _tmp1_;
	Color _tmp2_;
#line 67 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../lib/chess-move.vala"
	_tmp0_ = self->piece;
#line 71 "../lib/chess-move.vala"
	_tmp1_ = chess_piece_get_color (_tmp0_);
#line 71 "../lib/chess-move.vala"
	_tmp2_ = _tmp1_;
#line 71 "../lib/chess-move.vala"
	if (_tmp2_ == COLOR_WHITE) {
#line 356 "chess-move.c"
		gchar* _tmp3_;
#line 72 "../lib/chess-move.vala"
		_tmp3_ = chess_move_make_san (self, (gchar**) white_piece_names, (G_N_ELEMENTS (white_piece_names) * sizeof (const gchar*)) / sizeof (gchar*));
#line 72 "../lib/chess-move.vala"
		result = _tmp3_;
#line 72 "../lib/chess-move.vala"
		return result;
#line 364 "chess-move.c"
	} else {
		gchar* _tmp4_;
#line 74 "../lib/chess-move.vala"
		_tmp4_ = chess_move_make_san (self, (gchar**) black_piece_names, (G_N_ELEMENTS (black_piece_names) * sizeof (const gchar*)) / sizeof (gchar*));
#line 74 "../lib/chess-move.vala"
		result = _tmp4_;
#line 74 "../lib/chess-move.vala"
		return result;
#line 373 "chess-move.c"
	}
}


static gchar*
chess_move_make_san (ChessMove* self,
                     gchar** piece_names,
                     int piece_names_length1)
{
	gchar* result = NULL;
	ChessPiece* _tmp0_;
	GString* builder = NULL;
	GString* _tmp5_;
	GString* _tmp6_;
	ChessPiece* _tmp7_;
	PieceType _tmp8_;
	const gchar* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp13_;
	ChessPiece* _tmp16_;
	GString* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	ChessPiece* _tmp21_;
	CheckState _tmp26_;
	GString* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
#line 77 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../lib/chess-move.vala"
	_tmp0_ = self->castling_rook;
#line 79 "../lib/chess-move.vala"
	if (_tmp0_ != NULL) {
#line 408 "chess-move.c"
		gint _tmp1_;
		gint _tmp2_;
#line 81 "../lib/chess-move.vala"
		_tmp1_ = self->f1;
#line 81 "../lib/chess-move.vala"
		_tmp2_ = self->f0;
#line 81 "../lib/chess-move.vala"
		if (_tmp1_ > _tmp2_) {
#line 417 "chess-move.c"
			gchar* _tmp3_;
#line 82 "../lib/chess-move.vala"
			_tmp3_ = g_strdup ("O-O");
#line 82 "../lib/chess-move.vala"
			result = _tmp3_;
#line 82 "../lib/chess-move.vala"
			return result;
#line 425 "chess-move.c"
		} else {
			gchar* _tmp4_;
#line 84 "../lib/chess-move.vala"
			_tmp4_ = g_strdup ("O-O-O");
#line 84 "../lib/chess-move.vala"
			result = _tmp4_;
#line 84 "../lib/chess-move.vala"
			return result;
#line 434 "chess-move.c"
		}
	}
#line 87 "../lib/chess-move.vala"
	_tmp5_ = g_string_new ("");
#line 87 "../lib/chess-move.vala"
	builder = _tmp5_;
#line 88 "../lib/chess-move.vala"
	_tmp6_ = builder;
#line 88 "../lib/chess-move.vala"
	_tmp7_ = self->piece;
#line 88 "../lib/chess-move.vala"
	_tmp8_ = _tmp7_->type;
#line 88 "../lib/chess-move.vala"
	_tmp9_ = piece_names[_tmp8_];
#line 88 "../lib/chess-move.vala"
	g_string_append (_tmp6_, _tmp9_);
#line 89 "../lib/chess-move.vala"
	_tmp10_ = self->ambiguous_file;
#line 89 "../lib/chess-move.vala"
	if (_tmp10_) {
#line 455 "chess-move.c"
		GString* _tmp11_;
		gint _tmp12_;
#line 90 "../lib/chess-move.vala"
		_tmp11_ = builder;
#line 90 "../lib/chess-move.vala"
		_tmp12_ = self->f0;
#line 90 "../lib/chess-move.vala"
		g_string_append_printf (_tmp11_, "%c", 'a' + _tmp12_);
#line 464 "chess-move.c"
	}
#line 91 "../lib/chess-move.vala"
	_tmp13_ = self->ambiguous_rank;
#line 91 "../lib/chess-move.vala"
	if (_tmp13_) {
#line 470 "chess-move.c"
		GString* _tmp14_;
		gint _tmp15_;
#line 92 "../lib/chess-move.vala"
		_tmp14_ = builder;
#line 92 "../lib/chess-move.vala"
		_tmp15_ = self->r0;
#line 92 "../lib/chess-move.vala"
		g_string_append_printf (_tmp14_, "%d", _tmp15_ + 1);
#line 479 "chess-move.c"
	}
#line 93 "../lib/chess-move.vala"
	_tmp16_ = self->victim;
#line 93 "../lib/chess-move.vala"
	if (_tmp16_ != NULL) {
#line 485 "chess-move.c"
		GString* _tmp17_;
#line 94 "../lib/chess-move.vala"
		_tmp17_ = builder;
#line 94 "../lib/chess-move.vala"
		g_string_append (_tmp17_, "x");
#line 491 "chess-move.c"
	}
#line 95 "../lib/chess-move.vala"
	_tmp18_ = builder;
#line 95 "../lib/chess-move.vala"
	_tmp19_ = self->f1;
#line 95 "../lib/chess-move.vala"
	_tmp20_ = self->r1;
#line 95 "../lib/chess-move.vala"
	g_string_append_printf (_tmp18_, "%c%d", 'a' + _tmp19_, _tmp20_ + 1);
#line 97 "../lib/chess-move.vala"
	_tmp21_ = self->promotion_piece;
#line 97 "../lib/chess-move.vala"
	if (_tmp21_ != NULL) {
#line 505 "chess-move.c"
		GString* _tmp22_;
		ChessPiece* _tmp23_;
		PieceType _tmp24_;
		const gchar* _tmp25_;
#line 98 "../lib/chess-move.vala"
		_tmp22_ = builder;
#line 98 "../lib/chess-move.vala"
		_tmp23_ = self->promotion_piece;
#line 98 "../lib/chess-move.vala"
		_tmp24_ = _tmp23_->type;
#line 98 "../lib/chess-move.vala"
		_tmp25_ = piece_names[_tmp24_];
#line 98 "../lib/chess-move.vala"
		g_string_append_printf (_tmp22_, "=%s", _tmp25_);
#line 520 "chess-move.c"
	}
#line 100 "../lib/chess-move.vala"
	_tmp26_ = self->check_state;
#line 100 "../lib/chess-move.vala"
	switch (_tmp26_) {
#line 100 "../lib/chess-move.vala"
		case CHECK_STATE_CHECK:
#line 528 "chess-move.c"
		{
			GString* _tmp27_;
#line 103 "../lib/chess-move.vala"
			_tmp27_ = builder;
#line 103 "../lib/chess-move.vala"
			g_string_append_c (_tmp27_, '+');
#line 104 "../lib/chess-move.vala"
			break;
#line 537 "chess-move.c"
		}
#line 100 "../lib/chess-move.vala"
		case CHECK_STATE_CHECKMATE:
#line 541 "chess-move.c"
		{
			GString* _tmp28_;
#line 106 "../lib/chess-move.vala"
			_tmp28_ = builder;
#line 106 "../lib/chess-move.vala"
			g_string_append_c (_tmp28_, '#');
#line 107 "../lib/chess-move.vala"
			break;
#line 550 "chess-move.c"
		}
		default:
#line 100 "../lib/chess-move.vala"
		break;
#line 555 "chess-move.c"
	}
#line 110 "../lib/chess-move.vala"
	_tmp29_ = builder;
#line 110 "../lib/chess-move.vala"
	_tmp30_ = _tmp29_->str;
#line 110 "../lib/chess-move.vala"
	_tmp31_ = g_strdup (_tmp30_);
#line 110 "../lib/chess-move.vala"
	result = _tmp31_;
#line 110 "../lib/chess-move.vala"
	_g_string_free0 (builder);
#line 110 "../lib/chess-move.vala"
	return result;
#line 569 "chess-move.c"
}


gchar*
chess_move_get_engine (ChessMove* self)
{
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
#line 117 "../lib/chess-move.vala"
	static const gchar promotion_symbols[6] = {' ', 'r', 'n', 'b', 'q', ' '};
#line 581 "chess-move.c"
	ChessPiece* _tmp1_;
	GString* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
#line 114 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../lib/chess-move.vala"
	_tmp0_ = g_string_new ("");
#line 116 "../lib/chess-move.vala"
	builder = _tmp0_;
#line 118 "../lib/chess-move.vala"
	_tmp1_ = self->promotion_piece;
#line 118 "../lib/chess-move.vala"
	if (_tmp1_ != NULL) {
#line 596 "chess-move.c"
		GString* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		ChessPiece* _tmp7_;
		PieceType _tmp8_;
		gchar _tmp9_;
#line 119 "../lib/chess-move.vala"
		_tmp2_ = builder;
#line 119 "../lib/chess-move.vala"
		_tmp3_ = self->f0;
#line 119 "../lib/chess-move.vala"
		_tmp4_ = self->r0;
#line 119 "../lib/chess-move.vala"
		_tmp5_ = self->f1;
#line 119 "../lib/chess-move.vala"
		_tmp6_ = self->r1;
#line 119 "../lib/chess-move.vala"
		_tmp7_ = self->promotion_piece;
#line 119 "../lib/chess-move.vala"
		_tmp8_ = _tmp7_->type;
#line 119 "../lib/chess-move.vala"
		_tmp9_ = promotion_symbols[_tmp8_];
#line 119 "../lib/chess-move.vala"
		g_string_append_printf (_tmp2_, "%c%d%c%d%c", 'a' + _tmp3_, _tmp4_ + 1, 'a' + _tmp5_, _tmp6_ + 1, (gint) _tmp9_);
#line 623 "chess-move.c"
	} else {
		GString* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 121 "../lib/chess-move.vala"
		_tmp10_ = builder;
#line 121 "../lib/chess-move.vala"
		_tmp11_ = self->f0;
#line 121 "../lib/chess-move.vala"
		_tmp12_ = self->r0;
#line 121 "../lib/chess-move.vala"
		_tmp13_ = self->f1;
#line 121 "../lib/chess-move.vala"
		_tmp14_ = self->r1;
#line 121 "../lib/chess-move.vala"
		g_string_append_printf (_tmp10_, "%c%d%c%d", 'a' + _tmp11_, _tmp12_ + 1, 'a' + _tmp13_, _tmp14_ + 1);
#line 642 "chess-move.c"
	}
#line 122 "../lib/chess-move.vala"
	_tmp15_ = builder;
#line 122 "../lib/chess-move.vala"
	_tmp16_ = _tmp15_->str;
#line 122 "../lib/chess-move.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 122 "../lib/chess-move.vala"
	result = _tmp17_;
#line 122 "../lib/chess-move.vala"
	_g_string_free0 (builder);
#line 122 "../lib/chess-move.vala"
	return result;
#line 656 "chess-move.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 129 "../lib/chess-move.vala"
	return self ? g_object_ref (self) : NULL;
#line 665 "chess-move.c"
}


ChessMove*
chess_move_copy (ChessMove* self)
{
	ChessMove* result = NULL;
	ChessMove* move = NULL;
	ChessMove* _tmp0_;
	gint _tmp1_;
	ChessPiece* _tmp2_;
	ChessPiece* _tmp3_;
	ChessPiece* _tmp4_;
	ChessPiece* _tmp5_;
	ChessPiece* _tmp6_;
	ChessPiece* _tmp7_;
	ChessPiece* _tmp8_;
	ChessPiece* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	CheckState _tmp17_;
#line 125 "../lib/chess-move.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 127 "../lib/chess-move.vala"
	_tmp0_ = chess_move_new ();
#line 127 "../lib/chess-move.vala"
	move = _tmp0_;
#line 128 "../lib/chess-move.vala"
	_tmp1_ = self->number;
#line 128 "../lib/chess-move.vala"
	move->number = _tmp1_;
#line 129 "../lib/chess-move.vala"
	_tmp2_ = self->piece;
#line 129 "../lib/chess-move.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 129 "../lib/chess-move.vala"
	_g_object_unref0 (move->piece);
#line 129 "../lib/chess-move.vala"
	move->piece = _tmp3_;
#line 130 "../lib/chess-move.vala"
	_tmp4_ = self->promotion_piece;
#line 130 "../lib/chess-move.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 130 "../lib/chess-move.vala"
	_g_object_unref0 (move->promotion_piece);
#line 130 "../lib/chess-move.vala"
	move->promotion_piece = _tmp5_;
#line 131 "../lib/chess-move.vala"
	_tmp6_ = self->castling_rook;
#line 131 "../lib/chess-move.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 131 "../lib/chess-move.vala"
	_g_object_unref0 (move->castling_rook);
#line 131 "../lib/chess-move.vala"
	move->castling_rook = _tmp7_;
#line 132 "../lib/chess-move.vala"
	_tmp8_ = self->victim;
#line 132 "../lib/chess-move.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 132 "../lib/chess-move.vala"
	_g_object_unref0 (move->victim);
#line 132 "../lib/chess-move.vala"
	move->victim = _tmp9_;
#line 133 "../lib/chess-move.vala"
	_tmp10_ = self->r0;
#line 133 "../lib/chess-move.vala"
	move->r0 = _tmp10_;
#line 134 "../lib/chess-move.vala"
	_tmp11_ = self->f0;
#line 134 "../lib/chess-move.vala"
	move->f0 = _tmp11_;
#line 135 "../lib/chess-move.vala"
	_tmp12_ = self->r1;
#line 135 "../lib/chess-move.vala"
	move->r1 = _tmp12_;
#line 136 "../lib/chess-move.vala"
	_tmp13_ = self->f1;
#line 136 "../lib/chess-move.vala"
	move->f1 = _tmp13_;
#line 137 "../lib/chess-move.vala"
	_tmp14_ = self->ambiguous_rank;
#line 137 "../lib/chess-move.vala"
	move->ambiguous_rank = _tmp14_;
#line 138 "../lib/chess-move.vala"
	_tmp15_ = self->ambiguous_file;
#line 138 "../lib/chess-move.vala"
	move->ambiguous_file = _tmp15_;
#line 139 "../lib/chess-move.vala"
	_tmp16_ = self->en_passant;
#line 139 "../lib/chess-move.vala"
	move->en_passant = _tmp16_;
#line 140 "../lib/chess-move.vala"
	_tmp17_ = self->check_state;
#line 140 "../lib/chess-move.vala"
	move->check_state = _tmp17_;
#line 141 "../lib/chess-move.vala"
	result = move;
#line 141 "../lib/chess-move.vala"
	return result;
#line 770 "chess-move.c"
}


ChessMove*
chess_move_construct (GType object_type)
{
	ChessMove * self = NULL;
#line 12 "../lib/chess-move.vala"
	self = (ChessMove*) g_object_new (object_type, NULL);
#line 12 "../lib/chess-move.vala"
	return self;
#line 782 "chess-move.c"
}


ChessMove*
chess_move_new (void)
{
#line 12 "../lib/chess-move.vala"
	return chess_move_construct (TYPE_CHESS_MOVE);
#line 791 "chess-move.c"
}


static void
chess_move_class_init (ChessMoveClass * klass)
{
#line 12 "../lib/chess-move.vala"
	chess_move_parent_class = g_type_class_peek_parent (klass);
#line 12 "../lib/chess-move.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_move_finalize;
#line 802 "chess-move.c"
}


static void
chess_move_instance_init (ChessMove * self)
{
}


static void
chess_move_finalize (GObject * obj)
{
	ChessMove * self;
#line 12 "../lib/chess-move.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_MOVE, ChessMove);
#line 15 "../lib/chess-move.vala"
	_g_object_unref0 (self->piece);
#line 16 "../lib/chess-move.vala"
	_g_object_unref0 (self->promotion_piece);
#line 17 "../lib/chess-move.vala"
	_g_object_unref0 (self->castling_rook);
#line 18 "../lib/chess-move.vala"
	_g_object_unref0 (self->victim);
#line 12 "../lib/chess-move.vala"
	G_OBJECT_CLASS (chess_move_parent_class)->finalize (obj);
#line 828 "chess-move.c"
}


GType
chess_move_get_type (void)
{
	static volatile gsize chess_move_type_id__volatile = 0;
	if (g_once_init_enter (&chess_move_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessMoveClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_move_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessMove), 0, (GInstanceInitFunc) chess_move_instance_init, NULL };
		GType chess_move_type_id;
		chess_move_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessMove", &g_define_type_info, 0);
		g_once_init_leave (&chess_move_type_id__volatile, chess_move_type_id);
	}
	return chess_move_type_id__volatile;
}



