/* chess-engine-uci.c generated by valac 0.42.6, the Vala compiler
 * generated from chess-engine-uci.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2016 Michael Catanzaro
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include "libchess.h"
#include <stdlib.h>
#include <string.h>


#define TYPE_CHESS_ENGINE (chess_engine_get_type ())
#define CHESS_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_ENGINE, ChessEngine))
#define CHESS_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_ENGINE, ChessEngineClass))
#define IS_CHESS_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_ENGINE))
#define IS_CHESS_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_ENGINE))
#define CHESS_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_ENGINE, ChessEngineClass))

typedef struct _ChessEngine ChessEngine;
typedef struct _ChessEngineClass ChessEngineClass;
typedef struct _ChessEnginePrivate ChessEnginePrivate;

#define TYPE_CHESS_ENGINE_UCI (chess_engine_uci_get_type ())
#define CHESS_ENGINE_UCI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_ENGINE_UCI, ChessEngineUCI))
#define CHESS_ENGINE_UCI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_ENGINE_UCI, ChessEngineUCIClass))
#define IS_CHESS_ENGINE_UCI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_ENGINE_UCI))
#define IS_CHESS_ENGINE_UCI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_ENGINE_UCI))
#define CHESS_ENGINE_UCI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_ENGINE_UCI, ChessEngineUCIClass))

typedef struct _ChessEngineUCI ChessEngineUCI;
typedef struct _ChessEngineUCIClass ChessEngineUCIClass;
typedef struct _ChessEngineUCIPrivate ChessEngineUCIPrivate;
enum  {
	CHESS_ENGINE_UCI_0_PROPERTY,
	CHESS_ENGINE_UCI_NUM_PROPERTIES
};
static GParamSpec* chess_engine_uci_properties[CHESS_ENGINE_UCI_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ChessEngine {
	GObject parent_instance;
	ChessEnginePrivate * priv;
};

struct _ChessEngineClass {
	GObjectClass parent_class;
	void (*process_input) (ChessEngine* self, gchar* data, int data_length1);
	void (*start_game) (ChessEngine* self);
	void (*report_move) (ChessEngine* self, ChessMove* move);
	void (*do_undo) (ChessEngine* self);
	void (*request_move) (ChessEngine* self);
};

struct _ChessEngineUCI {
	ChessEngine parent_instance;
	ChessEngineUCIPrivate * priv;
};

struct _ChessEngineUCIClass {
	ChessEngineClass parent_class;
};

struct _ChessEngineUCIPrivate {
	gchar* buffer;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* moves;
	gchar** options;
	gint options_length1;
	gint _options_size_;
	gchar* go_options;
	gboolean waiting_for_move;
};


static gint ChessEngineUCI_private_offset;
static gpointer chess_engine_uci_parent_class = NULL;

GType chess_engine_get_type (void) G_GNUC_CONST;
GType chess_engine_uci_get_type (void) G_GNUC_CONST;
ChessEngineUCI* chess_engine_uci_new (const gchar* binary,
                                      gchar** args,
                                      int args_length1,
                                      guint delay_seconds,
                                      gchar** options,
                                      int options_length1,
                                      gchar** go_options,
                                      int go_options_length1);
ChessEngineUCI* chess_engine_uci_construct (GType object_type,
                                            const gchar* binary,
                                            gchar** args,
                                            int args_length1,
                                            guint delay_seconds,
                                            gchar** options,
                                            int options_length1,
                                            gchar** go_options,
                                            int go_options_length1);
ChessEngine* chess_engine_construct (GType object_type,
                                     const gchar* binary,
                                     gchar** args,
                                     int args_length1,
                                     guint delay_seconds);
static gchar** _vala_array_dup12 (gchar** self,
                           int length);
static void chess_engine_uci_start_cb (ChessEngineUCI* self);
static void _chess_engine_uci_start_cb_chess_engine_starting (ChessEngine* _sender,
                                                       gpointer self);
void chess_engine_write_line (ChessEngine* self,
                              const gchar* line);
static void chess_engine_uci_real_start_game (ChessEngine* base);
static void chess_engine_uci_real_request_move (ChessEngine* base);
static void chess_engine_uci_real_report_move (ChessEngine* base,
                                        ChessMove* move);
static void chess_engine_uci_real_do_undo (ChessEngine* base);
static void chess_engine_uci_real_process_input (ChessEngine* base,
                                          gchar* data,
                                          int data_length1);
static void chess_engine_uci_configure (ChessEngineUCI* self);
void chess_engine_set_ready (ChessEngine* self,
                             gboolean value);
static gchar* _vala_array_dup13 (gchar* self,
                          int length);
static gchar** _vala_array_dup14 (gchar** self,
                           int length);
static void chess_engine_uci_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
chess_engine_uci_get_instance_private (ChessEngineUCI* self)
{
	return G_STRUCT_MEMBER_P (self, ChessEngineUCI_private_offset);
}


static gchar**
_vala_array_dup12 (gchar** self,
                   int length)
{
	gchar** result;
	int i;
#line 24 "../src/chess-engine-uci.vala"
	result = g_new0 (gchar*, length + 1);
#line 24 "../src/chess-engine-uci.vala"
	for (i = 0; i < length; i++) {
#line 165 "chess-engine-uci.c"
		gchar* _tmp0_;
#line 24 "../src/chess-engine-uci.vala"
		_tmp0_ = g_strdup (self[i]);
#line 24 "../src/chess-engine-uci.vala"
		result[i] = _tmp0_;
#line 171 "chess-engine-uci.c"
	}
#line 24 "../src/chess-engine-uci.vala"
	return result;
#line 175 "chess-engine-uci.c"
}


static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  int str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 1148 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1149 "glib-2.0.vapi"
		separator = "";
#line 190 "chess-engine-uci.c"
	}
#line 1151 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 194 "chess-engine-uci.c"
		gboolean _tmp1_ = FALSE;
#line 1151 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1151 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 200 "chess-engine-uci.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1151 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 205 "chess-engine-uci.c"
				const gchar* _tmp3_;
#line 1151 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1151 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 211 "chess-engine-uci.c"
			} else {
#line 1151 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 215 "chess-engine-uci.c"
			}
#line 1151 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 219 "chess-engine-uci.c"
		}
#line 1151 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 223 "chess-engine-uci.c"
	} else {
#line 1151 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 227 "chess-engine-uci.c"
	}
#line 1151 "glib-2.0.vapi"
	if (_tmp0_) {
#line 231 "chess-engine-uci.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp20_;
		gint _tmp22_;
		gsize _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		const gchar* res = NULL;
		gsize _tmp27_;
		void* _tmp28_;
		void* ptr = NULL;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		void* _tmp31_;
		const gchar* _tmp44_;
#line 1153 "glib-2.0.vapi"
		len = (gsize) 1;
#line 250 "chess-engine-uci.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
			i = 0;
#line 1154 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1154 "glib-2.0.vapi"
			while (TRUE) {
#line 259 "chess-engine-uci.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_;
				const gchar* _tmp14_;
				gsize _tmp19_;
#line 1154 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 268 "chess-engine-uci.c"
					gint _tmp5_;
#line 1154 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1154 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 274 "chess-engine-uci.c"
				}
#line 1154 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 280 "chess-engine-uci.c"
					gint _tmp8_;
#line 1154 "glib-2.0.vapi"
					_tmp8_ = i;
#line 1154 "glib-2.0.vapi"
					_tmp7_ = _tmp8_ < str_array_length1;
#line 286 "chess-engine-uci.c"
				} else {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 290 "chess-engine-uci.c"
				}
#line 1154 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1154 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 296 "chess-engine-uci.c"
				} else {
					gboolean _tmp9_ = FALSE;
#line 1154 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 301 "chess-engine-uci.c"
						gint _tmp10_;
						const gchar* _tmp11_;
#line 1154 "glib-2.0.vapi"
						_tmp10_ = i;
#line 1154 "glib-2.0.vapi"
						_tmp11_ = str_array[_tmp10_];
#line 1154 "glib-2.0.vapi"
						_tmp9_ = _tmp11_ != NULL;
#line 310 "chess-engine-uci.c"
					} else {
#line 1154 "glib-2.0.vapi"
						_tmp9_ = FALSE;
#line 314 "chess-engine-uci.c"
					}
#line 1154 "glib-2.0.vapi"
					_tmp6_ = _tmp9_;
#line 318 "chess-engine-uci.c"
				}
#line 1154 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1154 "glib-2.0.vapi"
					break;
#line 324 "chess-engine-uci.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp13_ = i;
#line 1155 "glib-2.0.vapi"
				_tmp14_ = str_array[_tmp13_];
#line 1155 "glib-2.0.vapi"
				if (_tmp14_ != NULL) {
#line 332 "chess-engine-uci.c"
					gint _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
#line 1155 "glib-2.0.vapi"
					_tmp15_ = i;
#line 1155 "glib-2.0.vapi"
					_tmp16_ = str_array[_tmp15_];
#line 1155 "glib-2.0.vapi"
					_tmp17_ = strlen ((const gchar*) _tmp16_);
#line 1155 "glib-2.0.vapi"
					_tmp18_ = _tmp17_;
#line 1155 "glib-2.0.vapi"
					_tmp12_ = _tmp18_;
#line 347 "chess-engine-uci.c"
				} else {
#line 1155 "glib-2.0.vapi"
					_tmp12_ = 0;
#line 351 "chess-engine-uci.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp19_ = len;
#line 1155 "glib-2.0.vapi"
				len = _tmp19_ + _tmp12_;
#line 357 "chess-engine-uci.c"
			}
		}
#line 1157 "glib-2.0.vapi"
		_tmp20_ = i;
#line 1157 "glib-2.0.vapi"
		if (_tmp20_ == 0) {
#line 364 "chess-engine-uci.c"
			gchar* _tmp21_;
#line 1158 "glib-2.0.vapi"
			_tmp21_ = g_strdup ("");
#line 1158 "glib-2.0.vapi"
			result = _tmp21_;
#line 1158 "glib-2.0.vapi"
			return result;
#line 372 "chess-engine-uci.c"
		}
#line 1160 "glib-2.0.vapi"
		_tmp22_ = i;
#line 1160 "glib-2.0.vapi"
		str_array_length1 = _tmp22_;
#line 1161 "glib-2.0.vapi"
		_tmp23_ = len;
#line 1161 "glib-2.0.vapi"
		_tmp24_ = strlen ((const gchar*) separator);
#line 1161 "glib-2.0.vapi"
		_tmp25_ = _tmp24_;
#line 1161 "glib-2.0.vapi"
		_tmp26_ = i;
#line 1161 "glib-2.0.vapi"
		len = _tmp23_ + (_tmp25_ * (_tmp26_ - 1));
#line 1163 "glib-2.0.vapi"
		_tmp27_ = len;
#line 1163 "glib-2.0.vapi"
		_tmp28_ = g_malloc (_tmp27_);
#line 1163 "glib-2.0.vapi"
		res = _tmp28_;
#line 1164 "glib-2.0.vapi"
		_tmp29_ = res;
#line 1164 "glib-2.0.vapi"
		_tmp30_ = str_array[0];
#line 1164 "glib-2.0.vapi"
		_tmp31_ = g_stpcpy ((void*) _tmp29_, (const gchar*) _tmp30_);
#line 1164 "glib-2.0.vapi"
		ptr = _tmp31_;
#line 402 "chess-engine-uci.c"
		{
			gboolean _tmp32_ = FALSE;
#line 1165 "glib-2.0.vapi"
			i = 1;
#line 1165 "glib-2.0.vapi"
			_tmp32_ = TRUE;
#line 1165 "glib-2.0.vapi"
			while (TRUE) {
#line 411 "chess-engine-uci.c"
				gint _tmp34_;
				void* _tmp35_;
				void* _tmp36_;
				const gchar* _tmp37_ = NULL;
				gint _tmp38_;
				const gchar* _tmp39_;
				void* _tmp42_;
				void* _tmp43_;
#line 1165 "glib-2.0.vapi"
				if (!_tmp32_) {
#line 422 "chess-engine-uci.c"
					gint _tmp33_;
#line 1165 "glib-2.0.vapi"
					_tmp33_ = i;
#line 1165 "glib-2.0.vapi"
					i = _tmp33_ + 1;
#line 428 "chess-engine-uci.c"
				}
#line 1165 "glib-2.0.vapi"
				_tmp32_ = FALSE;
#line 1165 "glib-2.0.vapi"
				_tmp34_ = i;
#line 1165 "glib-2.0.vapi"
				if (!(_tmp34_ < str_array_length1)) {
#line 1165 "glib-2.0.vapi"
					break;
#line 438 "chess-engine-uci.c"
				}
#line 1166 "glib-2.0.vapi"
				_tmp35_ = ptr;
#line 1166 "glib-2.0.vapi"
				_tmp36_ = g_stpcpy (_tmp35_, (const gchar*) separator);
#line 1166 "glib-2.0.vapi"
				ptr = _tmp36_;
#line 1167 "glib-2.0.vapi"
				_tmp38_ = i;
#line 1167 "glib-2.0.vapi"
				_tmp39_ = str_array[_tmp38_];
#line 1167 "glib-2.0.vapi"
				if (_tmp39_ != NULL) {
#line 452 "chess-engine-uci.c"
					gint _tmp40_;
					const gchar* _tmp41_;
#line 1167 "glib-2.0.vapi"
					_tmp40_ = i;
#line 1167 "glib-2.0.vapi"
					_tmp41_ = str_array[_tmp40_];
#line 1167 "glib-2.0.vapi"
					_tmp37_ = (const gchar*) _tmp41_;
#line 461 "chess-engine-uci.c"
				} else {
#line 1167 "glib-2.0.vapi"
					_tmp37_ = "";
#line 465 "chess-engine-uci.c"
				}
#line 1167 "glib-2.0.vapi"
				_tmp42_ = ptr;
#line 1167 "glib-2.0.vapi"
				_tmp43_ = g_stpcpy (_tmp42_, _tmp37_);
#line 1167 "glib-2.0.vapi"
				ptr = _tmp43_;
#line 473 "chess-engine-uci.c"
			}
		}
#line 1170 "glib-2.0.vapi"
		_tmp44_ = res;
#line 1170 "glib-2.0.vapi"
		res = NULL;
#line 1170 "glib-2.0.vapi"
		result = (gchar*) _tmp44_;
#line 1170 "glib-2.0.vapi"
		return result;
#line 484 "chess-engine-uci.c"
	} else {
		gchar* _tmp45_;
#line 1172 "glib-2.0.vapi"
		_tmp45_ = g_strdup ("");
#line 1172 "glib-2.0.vapi"
		result = _tmp45_;
#line 1172 "glib-2.0.vapi"
		return result;
#line 493 "chess-engine-uci.c"
	}
}


static void
_chess_engine_uci_start_cb_chess_engine_starting (ChessEngine* _sender,
                                                  gpointer self)
{
#line 28 "../src/chess-engine-uci.vala"
	chess_engine_uci_start_cb ((ChessEngineUCI*) self);
#line 504 "chess-engine-uci.c"
}


ChessEngineUCI*
chess_engine_uci_construct (GType object_type,
                            const gchar* binary,
                            gchar** args,
                            int args_length1,
                            guint delay_seconds,
                            gchar** options,
                            int options_length1,
                            gchar** go_options,
                            int go_options_length1)
{
	ChessEngineUCI * self = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 21 "../src/chess-engine-uci.vala"
	g_return_val_if_fail (binary != NULL, NULL);
#line 23 "../src/chess-engine-uci.vala"
	self = (ChessEngineUCI*) chess_engine_construct (object_type, binary, args, args_length1, delay_seconds);
#line 24 "../src/chess-engine-uci.vala"
	_tmp0_ = (options != NULL) ? _vala_array_dup12 (options, options_length1) : ((gpointer) options);
#line 24 "../src/chess-engine-uci.vala"
	_tmp0__length1 = options_length1;
#line 24 "../src/chess-engine-uci.vala"
	self->priv->options = (_vala_array_free (self->priv->options, self->priv->options_length1, (GDestroyNotify) g_free), NULL);
#line 24 "../src/chess-engine-uci.vala"
	self->priv->options = _tmp0_;
#line 24 "../src/chess-engine-uci.vala"
	self->priv->options_length1 = _tmp0__length1;
#line 24 "../src/chess-engine-uci.vala"
	self->priv->_options_size_ = self->priv->options_length1;
#line 25 "../src/chess-engine-uci.vala"
	_tmp1_ = _vala_g_strjoinv (" ", go_options, go_options_length1);
#line 25 "../src/chess-engine-uci.vala"
	_g_free0 (self->priv->go_options);
#line 25 "../src/chess-engine-uci.vala"
	self->priv->go_options = _tmp1_;
#line 26 "../src/chess-engine-uci.vala"
	_tmp2_ = g_new0 (gchar, 0);
#line 26 "../src/chess-engine-uci.vala"
	self->priv->buffer = (g_free (self->priv->buffer), NULL);
#line 26 "../src/chess-engine-uci.vala"
	self->priv->buffer = _tmp2_;
#line 26 "../src/chess-engine-uci.vala"
	self->priv->buffer_length1 = 0;
#line 26 "../src/chess-engine-uci.vala"
	self->priv->_buffer_size_ = self->priv->buffer_length1;
#line 27 "../src/chess-engine-uci.vala"
	_tmp3_ = g_strdup ("");
#line 27 "../src/chess-engine-uci.vala"
	_g_free0 (self->priv->moves);
#line 27 "../src/chess-engine-uci.vala"
	self->priv->moves = _tmp3_;
#line 28 "../src/chess-engine-uci.vala"
	g_signal_connect_object ((ChessEngine*) self, "starting", (GCallback) _chess_engine_uci_start_cb_chess_engine_starting, self, 0);
#line 21 "../src/chess-engine-uci.vala"
	return self;
#line 567 "chess-engine-uci.c"
}


ChessEngineUCI*
chess_engine_uci_new (const gchar* binary,
                      gchar** args,
                      int args_length1,
                      guint delay_seconds,
                      gchar** options,
                      int options_length1,
                      gchar** go_options,
                      int go_options_length1)
{
#line 21 "../src/chess-engine-uci.vala"
	return chess_engine_uci_construct (TYPE_CHESS_ENGINE_UCI, binary, args, args_length1, delay_seconds, options, options_length1, go_options, go_options_length1);
#line 583 "chess-engine-uci.c"
}


static void
chess_engine_uci_start_cb (ChessEngineUCI* self)
{
#line 31 "../src/chess-engine-uci.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/chess-engine-uci.vala"
	chess_engine_write_line ((ChessEngine*) self, "uci");
#line 594 "chess-engine-uci.c"
}


static void
chess_engine_uci_real_start_game (ChessEngine* base)
{
	ChessEngineUCI * self;
#line 36 "../src/chess-engine-uci.vala"
	self = (ChessEngineUCI*) base;
#line 38 "../src/chess-engine-uci.vala"
	chess_engine_write_line ((ChessEngine*) self, "ucinewgame");
#line 606 "chess-engine-uci.c"
}


static void
chess_engine_uci_real_request_move (ChessEngine* base)
{
	ChessEngineUCI * self;
	const gchar* _tmp0_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 41 "../src/chess-engine-uci.vala"
	self = (ChessEngineUCI*) base;
#line 43 "../src/chess-engine-uci.vala"
	_tmp0_ = self->priv->moves;
#line 43 "../src/chess-engine-uci.vala"
	if (g_strcmp0 (_tmp0_, "") != 0) {
#line 624 "chess-engine-uci.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 44 "../src/chess-engine-uci.vala"
		_tmp1_ = self->priv->moves;
#line 44 "../src/chess-engine-uci.vala"
		_tmp2_ = g_strconcat ("position startpos moves", _tmp1_, NULL);
#line 44 "../src/chess-engine-uci.vala"
		_tmp3_ = _tmp2_;
#line 44 "../src/chess-engine-uci.vala"
		chess_engine_write_line ((ChessEngine*) self, _tmp3_);
#line 44 "../src/chess-engine-uci.vala"
		_g_free0 (_tmp3_);
#line 638 "chess-engine-uci.c"
	} else {
#line 46 "../src/chess-engine-uci.vala"
		chess_engine_write_line ((ChessEngine*) self, "position startpos");
#line 642 "chess-engine-uci.c"
	}
#line 47 "../src/chess-engine-uci.vala"
	self->priv->waiting_for_move = TRUE;
#line 48 "../src/chess-engine-uci.vala"
	_tmp4_ = self->priv->go_options;
#line 48 "../src/chess-engine-uci.vala"
	_tmp5_ = g_strdup_printf ("go wtime 30000 btime 30000 %s", _tmp4_);
#line 48 "../src/chess-engine-uci.vala"
	_tmp6_ = _tmp5_;
#line 48 "../src/chess-engine-uci.vala"
	chess_engine_write_line ((ChessEngine*) self, _tmp6_);
#line 48 "../src/chess-engine-uci.vala"
	_g_free0 (_tmp6_);
#line 656 "chess-engine-uci.c"
}


static void
chess_engine_uci_real_report_move (ChessEngine* base,
                                   ChessMove* move)
{
	ChessEngineUCI * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 51 "../src/chess-engine-uci.vala"
	self = (ChessEngineUCI*) base;
#line 51 "../src/chess-engine-uci.vala"
	g_return_if_fail (move != NULL);
#line 53 "../src/chess-engine-uci.vala"
	_tmp0_ = self->priv->moves;
#line 53 "../src/chess-engine-uci.vala"
	_tmp1_ = chess_move_get_engine (move);
#line 53 "../src/chess-engine-uci.vala"
	_tmp2_ = _tmp1_;
#line 53 "../src/chess-engine-uci.vala"
	_tmp3_ = g_strconcat (" ", _tmp2_, NULL);
#line 53 "../src/chess-engine-uci.vala"
	_tmp4_ = _tmp3_;
#line 53 "../src/chess-engine-uci.vala"
	_tmp5_ = g_strconcat (_tmp0_, _tmp4_, NULL);
#line 53 "../src/chess-engine-uci.vala"
	_g_free0 (self->priv->moves);
#line 53 "../src/chess-engine-uci.vala"
	self->priv->moves = _tmp5_;
#line 53 "../src/chess-engine-uci.vala"
	_g_free0 (_tmp4_);
#line 53 "../src/chess-engine-uci.vala"
	_g_free0 (_tmp2_);
#line 695 "chess-engine-uci.c"
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1425 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1426 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1426 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1426 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1427 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 721 "chess-engine-uci.c"
		glong _tmp2_;
#line 1428 "glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1428 "glib-2.0.vapi"
		start = _tmp2_ + start;
#line 727 "chess-engine-uci.c"
	}
#line 1430 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 731 "chess-engine-uci.c"
		glong _tmp3_;
#line 1431 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1431 "glib-2.0.vapi"
		end = _tmp3_ + end;
#line 737 "chess-engine-uci.c"
	}
#line 1433 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 741 "chess-engine-uci.c"
		glong _tmp5_;
#line 1433 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1433 "glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 747 "chess-engine-uci.c"
	} else {
#line 1433 "glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 751 "chess-engine-uci.c"
	}
#line 1433 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1434 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 757 "chess-engine-uci.c"
		glong _tmp7_;
#line 1434 "glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1434 "glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 763 "chess-engine-uci.c"
	} else {
#line 1434 "glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 767 "chess-engine-uci.c"
	}
#line 1434 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1435 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1436 "glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1436 "glib-2.0.vapi"
	result = _tmp8_;
#line 1436 "glib-2.0.vapi"
	return result;
#line 779 "chess-engine-uci.c"
}


static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1092 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1092 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1094 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1094 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 804 "chess-engine-uci.c"
		gchar* _tmp2_;
#line 1095 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1095 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1095 "glib-2.0.vapi"
		return result;
#line 812 "chess-engine-uci.c"
	} else {
#line 1097 "glib-2.0.vapi"
		result = -1;
#line 1097 "glib-2.0.vapi"
		return result;
#line 818 "chess-engine-uci.c"
	}
}


static void
chess_engine_uci_real_do_undo (ChessEngine* base)
{
	ChessEngineUCI * self;
	gboolean _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 56 "../src/chess-engine-uci.vala"
	self = (ChessEngineUCI*) base;
#line 58 "../src/chess-engine-uci.vala"
	_tmp0_ = self->priv->waiting_for_move;
#line 58 "../src/chess-engine-uci.vala"
	if (_tmp0_) {
#line 59 "../src/chess-engine-uci.vala"
		chess_engine_write_line ((ChessEngine*) self, "stop");
#line 839 "chess-engine-uci.c"
	}
#line 60 "../src/chess-engine-uci.vala"
	self->priv->waiting_for_move = FALSE;
#line 61 "../src/chess-engine-uci.vala"
	_tmp1_ = self->priv->moves;
#line 61 "../src/chess-engine-uci.vala"
	_tmp2_ = self->priv->moves;
#line 61 "../src/chess-engine-uci.vala"
	_tmp3_ = string_slice (_tmp1_, (glong) 0, (glong) string_last_index_of (_tmp2_, " ", 0));
#line 61 "../src/chess-engine-uci.vala"
	_g_free0 (self->priv->moves);
#line 61 "../src/chess-engine-uci.vala"
	self->priv->moves = _tmp3_;
#line 853 "chess-engine-uci.c"
}


static gchar*
_vala_array_dup13 (gchar* self,
                   int length)
{
#line 129 "../src/chess-engine-uci.vala"
	return g_memdup (self, length * sizeof (gchar));
#line 863 "chess-engine-uci.c"
}


static void
chess_engine_uci_real_process_input (ChessEngine* base,
                                     gchar* data,
                                     int data_length1)
{
	ChessEngineUCI * self;
	gint current = 0;
	gchar* _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_;
#line 64 "../src/chess-engine-uci.vala"
	self = (ChessEngineUCI*) base;
#line 67 "../src/chess-engine-uci.vala"
	_tmp0_ = self->priv->buffer;
#line 67 "../src/chess-engine-uci.vala"
	_tmp0__length1 = self->priv->buffer_length1;
#line 67 "../src/chess-engine-uci.vala"
	current = _tmp0__length1;
#line 68 "../src/chess-engine-uci.vala"
	_tmp1_ = self->priv->buffer;
#line 68 "../src/chess-engine-uci.vala"
	_tmp1__length1 = self->priv->buffer_length1;
#line 68 "../src/chess-engine-uci.vala"
	_tmp2_ = (gint) (_tmp1__length1 + data_length1);
#line 68 "../src/chess-engine-uci.vala"
	self->priv->buffer = g_renew (gchar, self->priv->buffer, (gint) (_tmp1__length1 + data_length1));
#line 68 "../src/chess-engine-uci.vala"
	(_tmp2_ > self->priv->buffer_length1) ? memset (self->priv->buffer + self->priv->buffer_length1, 0, sizeof (gchar) * (_tmp2_ - self->priv->buffer_length1)) : NULL;
#line 68 "../src/chess-engine-uci.vala"
	self->priv->buffer_length1 = _tmp2_;
#line 68 "../src/chess-engine-uci.vala"
	self->priv->_buffer_size_ = _tmp2_;
#line 901 "chess-engine-uci.c"
	{
		gint i = 0;
#line 69 "../src/chess-engine-uci.vala"
		i = 0;
#line 906 "chess-engine-uci.c"
		{
			gboolean _tmp3_ = FALSE;
#line 69 "../src/chess-engine-uci.vala"
			_tmp3_ = TRUE;
#line 69 "../src/chess-engine-uci.vala"
			while (TRUE) {
#line 913 "chess-engine-uci.c"
				gint _tmp5_;
				gchar* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				gchar _tmp10_;
#line 69 "../src/chess-engine-uci.vala"
				if (!_tmp3_) {
#line 923 "chess-engine-uci.c"
					gint _tmp4_;
#line 69 "../src/chess-engine-uci.vala"
					_tmp4_ = i;
#line 69 "../src/chess-engine-uci.vala"
					i = _tmp4_ + 1;
#line 929 "chess-engine-uci.c"
				}
#line 69 "../src/chess-engine-uci.vala"
				_tmp3_ = FALSE;
#line 69 "../src/chess-engine-uci.vala"
				_tmp5_ = i;
#line 69 "../src/chess-engine-uci.vala"
				if (!(_tmp5_ < data_length1)) {
#line 69 "../src/chess-engine-uci.vala"
					break;
#line 939 "chess-engine-uci.c"
				}
#line 70 "../src/chess-engine-uci.vala"
				_tmp6_ = self->priv->buffer;
#line 70 "../src/chess-engine-uci.vala"
				_tmp6__length1 = self->priv->buffer_length1;
#line 70 "../src/chess-engine-uci.vala"
				_tmp7_ = current;
#line 70 "../src/chess-engine-uci.vala"
				_tmp8_ = i;
#line 70 "../src/chess-engine-uci.vala"
				_tmp9_ = i;
#line 70 "../src/chess-engine-uci.vala"
				_tmp10_ = data[_tmp9_];
#line 70 "../src/chess-engine-uci.vala"
				_tmp6_[_tmp7_ + _tmp8_] = _tmp10_;
#line 955 "chess-engine-uci.c"
			}
		}
	}
#line 73 "../src/chess-engine-uci.vala"
	while (TRUE) {
#line 961 "chess-engine-uci.c"
		gint offset = 0;
		gint _tmp19_;
		gchar* _tmp20_;
		gint _tmp20__length1;
		gchar* _tmp21_;
		gint _tmp21__length1;
		gint _tmp22_;
		gchar* line = NULL;
		gchar* _tmp23_;
		gint _tmp23__length1;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar** tokens = NULL;
		const gchar* _tmp26_;
		gchar** _tmp27_;
		gchar** _tmp28_;
		gint tokens_length1;
		gint _tokens_size_;
		gchar** _tmp29_;
		gint _tmp29__length1;
		gchar* _tmp48_;
		gint _tmp48__length1;
		gint _tmp49_;
		gchar* _tmp50_;
		gint _tmp50__length1;
		gchar* _tmp51_;
		gint _tmp51__length1;
		{
			gboolean _tmp11_ = FALSE;
#line 77 "../src/chess-engine-uci.vala"
			offset = 0;
#line 77 "../src/chess-engine-uci.vala"
			_tmp11_ = TRUE;
#line 77 "../src/chess-engine-uci.vala"
			while (TRUE) {
#line 997 "chess-engine-uci.c"
				gboolean _tmp13_ = FALSE;
				gint _tmp14_;
				gchar* _tmp15_;
				gint _tmp15__length1;
#line 77 "../src/chess-engine-uci.vala"
				if (!_tmp11_) {
#line 1004 "chess-engine-uci.c"
					gint _tmp12_;
#line 77 "../src/chess-engine-uci.vala"
					_tmp12_ = offset;
#line 77 "../src/chess-engine-uci.vala"
					offset = _tmp12_ + 1;
#line 1010 "chess-engine-uci.c"
				}
#line 77 "../src/chess-engine-uci.vala"
				_tmp11_ = FALSE;
#line 77 "../src/chess-engine-uci.vala"
				_tmp14_ = offset;
#line 77 "../src/chess-engine-uci.vala"
				_tmp15_ = self->priv->buffer;
#line 77 "../src/chess-engine-uci.vala"
				_tmp15__length1 = self->priv->buffer_length1;
#line 77 "../src/chess-engine-uci.vala"
				if (_tmp14_ < _tmp15__length1) {
#line 1022 "chess-engine-uci.c"
					gchar* _tmp16_;
					gint _tmp16__length1;
					gint _tmp17_;
					gchar _tmp18_;
#line 77 "../src/chess-engine-uci.vala"
					_tmp16_ = self->priv->buffer;
#line 77 "../src/chess-engine-uci.vala"
					_tmp16__length1 = self->priv->buffer_length1;
#line 77 "../src/chess-engine-uci.vala"
					_tmp17_ = offset;
#line 77 "../src/chess-engine-uci.vala"
					_tmp18_ = _tmp16_[_tmp17_];
#line 77 "../src/chess-engine-uci.vala"
					_tmp13_ = _tmp18_ != '\n';
#line 1037 "chess-engine-uci.c"
				} else {
#line 77 "../src/chess-engine-uci.vala"
					_tmp13_ = FALSE;
#line 1041 "chess-engine-uci.c"
				}
#line 77 "../src/chess-engine-uci.vala"
				if (!_tmp13_) {
#line 77 "../src/chess-engine-uci.vala"
					break;
#line 1047 "chess-engine-uci.c"
				}
			}
		}
#line 78 "../src/chess-engine-uci.vala"
		_tmp19_ = offset;
#line 78 "../src/chess-engine-uci.vala"
		_tmp20_ = self->priv->buffer;
#line 78 "../src/chess-engine-uci.vala"
		_tmp20__length1 = self->priv->buffer_length1;
#line 78 "../src/chess-engine-uci.vala"
		if (_tmp19_ >= _tmp20__length1) {
#line 79 "../src/chess-engine-uci.vala"
			return;
#line 1061 "chess-engine-uci.c"
		}
#line 81 "../src/chess-engine-uci.vala"
		_tmp21_ = self->priv->buffer;
#line 81 "../src/chess-engine-uci.vala"
		_tmp21__length1 = self->priv->buffer_length1;
#line 81 "../src/chess-engine-uci.vala"
		_tmp22_ = offset;
#line 81 "../src/chess-engine-uci.vala"
		_tmp21_[_tmp22_] = '\0';
#line 82 "../src/chess-engine-uci.vala"
		_tmp23_ = self->priv->buffer;
#line 82 "../src/chess-engine-uci.vala"
		_tmp23__length1 = self->priv->buffer_length1;
#line 82 "../src/chess-engine-uci.vala"
		_tmp24_ = g_strdup ((const gchar*) _tmp23_);
#line 82 "../src/chess-engine-uci.vala"
		line = _tmp24_;
#line 84 "../src/chess-engine-uci.vala"
		_tmp25_ = line;
#line 84 "../src/chess-engine-uci.vala"
		g_debug ("chess-engine-uci.vala:84: Read from engine: '%s'", _tmp25_);
#line 86 "../src/chess-engine-uci.vala"
		_tmp26_ = line;
#line 86 "../src/chess-engine-uci.vala"
		_tmp28_ = _tmp27_ = g_strsplit (_tmp26_, " ", 0);
#line 86 "../src/chess-engine-uci.vala"
		tokens = _tmp28_;
#line 86 "../src/chess-engine-uci.vala"
		tokens_length1 = _vala_array_length (_tmp27_);
#line 86 "../src/chess-engine-uci.vala"
		_tokens_size_ = tokens_length1;
#line 87 "../src/chess-engine-uci.vala"
		_tmp29_ = tokens;
#line 87 "../src/chess-engine-uci.vala"
		_tmp29__length1 = tokens_length1;
#line 87 "../src/chess-engine-uci.vala"
		if (_tmp29__length1 > 0) {
#line 1099 "chess-engine-uci.c"
			gchar** _tmp30_;
			gint _tmp30__length1;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			GQuark _tmp34_ = 0U;
#line 89 "../src/chess-engine-uci.vala"
			static GQuark _tmp33_label0 = 0;
#line 89 "../src/chess-engine-uci.vala"
			static GQuark _tmp33_label1 = 0;
#line 89 "../src/chess-engine-uci.vala"
			static GQuark _tmp33_label2 = 0;
#line 89 "../src/chess-engine-uci.vala"
			_tmp30_ = tokens;
#line 89 "../src/chess-engine-uci.vala"
			_tmp30__length1 = tokens_length1;
#line 89 "../src/chess-engine-uci.vala"
			_tmp31_ = _tmp30_[0];
#line 89 "../src/chess-engine-uci.vala"
			_tmp32_ = _tmp31_;
#line 89 "../src/chess-engine-uci.vala"
			_tmp34_ = (NULL == _tmp32_) ? 0 : g_quark_from_string (_tmp32_);
#line 89 "../src/chess-engine-uci.vala"
			if (_tmp34_ == ((0 != _tmp33_label0) ? _tmp33_label0 : (_tmp33_label0 = g_quark_from_static_string ("uciok")))) {
#line 89 "../src/chess-engine-uci.vala"
				switch (0) {
#line 1125 "chess-engine-uci.c"
					default:
					{
						gchar** _tmp35_;
						gint _tmp35__length1;
#line 92 "../src/chess-engine-uci.vala"
						_tmp35_ = tokens;
#line 92 "../src/chess-engine-uci.vala"
						_tmp35__length1 = tokens_length1;
#line 92 "../src/chess-engine-uci.vala"
						if (_tmp35__length1 != 1) {
#line 1136 "chess-engine-uci.c"
							const gchar* _tmp36_;
#line 93 "../src/chess-engine-uci.vala"
							_tmp36_ = line;
#line 93 "../src/chess-engine-uci.vala"
							g_warning ("chess-engine-uci.vala:93: Unexpected arguments on uciok: %s", _tmp36_);
#line 1142 "chess-engine-uci.c"
						}
#line 95 "../src/chess-engine-uci.vala"
						chess_engine_uci_configure (self);
#line 96 "../src/chess-engine-uci.vala"
						break;
#line 1148 "chess-engine-uci.c"
					}
				}
			} else if (_tmp34_ == ((0 != _tmp33_label1) ? _tmp33_label1 : (_tmp33_label1 = g_quark_from_static_string ("readyok")))) {
#line 89 "../src/chess-engine-uci.vala"
				switch (0) {
#line 1154 "chess-engine-uci.c"
					default:
					{
						gchar** _tmp37_;
						gint _tmp37__length1;
#line 99 "../src/chess-engine-uci.vala"
						_tmp37_ = tokens;
#line 99 "../src/chess-engine-uci.vala"
						_tmp37__length1 = tokens_length1;
#line 99 "../src/chess-engine-uci.vala"
						if (_tmp37__length1 != 1) {
#line 1165 "chess-engine-uci.c"
							const gchar* _tmp38_;
#line 100 "../src/chess-engine-uci.vala"
							_tmp38_ = line;
#line 100 "../src/chess-engine-uci.vala"
							g_warning ("chess-engine-uci.vala:100: Unexpected arguments on readyok: %s", _tmp38_);
#line 1171 "chess-engine-uci.c"
						}
#line 102 "../src/chess-engine-uci.vala"
						chess_engine_set_ready ((ChessEngine*) self, TRUE);
#line 103 "../src/chess-engine-uci.vala"
						break;
#line 1177 "chess-engine-uci.c"
					}
				}
			} else if (_tmp34_ == ((0 != _tmp33_label2) ? _tmp33_label2 : (_tmp33_label2 = g_quark_from_static_string ("bestmove")))) {
#line 89 "../src/chess-engine-uci.vala"
				switch (0) {
#line 1183 "chess-engine-uci.c"
					default:
					{
						gchar** _tmp39_;
						gint _tmp39__length1;
						gboolean _tmp41_;
#line 106 "../src/chess-engine-uci.vala"
						_tmp39_ = tokens;
#line 106 "../src/chess-engine-uci.vala"
						_tmp39__length1 = tokens_length1;
#line 106 "../src/chess-engine-uci.vala"
						if (_tmp39__length1 < 2) {
#line 1195 "chess-engine-uci.c"
							const gchar* _tmp40_;
#line 107 "../src/chess-engine-uci.vala"
							_tmp40_ = line;
#line 107 "../src/chess-engine-uci.vala"
							g_warning ("chess-engine-uci.vala:107: No move with bestmove: %s", _tmp40_);
#line 1201 "chess-engine-uci.c"
						}
#line 115 "../src/chess-engine-uci.vala"
						_tmp41_ = self->priv->waiting_for_move;
#line 115 "../src/chess-engine-uci.vala"
						if (_tmp41_) {
#line 1207 "chess-engine-uci.c"
							gchar** _tmp42_;
							gint _tmp42__length1;
							const gchar* _tmp43_;
							gchar** _tmp44_;
							gint _tmp44__length1;
							const gchar* _tmp45_;
#line 117 "../src/chess-engine-uci.vala"
							_tmp42_ = tokens;
#line 117 "../src/chess-engine-uci.vala"
							_tmp42__length1 = tokens_length1;
#line 117 "../src/chess-engine-uci.vala"
							_tmp43_ = _tmp42_[1];
#line 117 "../src/chess-engine-uci.vala"
							g_debug ("chess-engine-uci.vala:117: Engine moves %s", _tmp43_);
#line 118 "../src/chess-engine-uci.vala"
							self->priv->waiting_for_move = FALSE;
#line 119 "../src/chess-engine-uci.vala"
							_tmp44_ = tokens;
#line 119 "../src/chess-engine-uci.vala"
							_tmp44__length1 = tokens_length1;
#line 119 "../src/chess-engine-uci.vala"
							_tmp45_ = _tmp44_[1];
#line 119 "../src/chess-engine-uci.vala"
							g_signal_emit_by_name ((ChessEngine*) self, "moved", _tmp45_);
#line 1232 "chess-engine-uci.c"
						} else {
							gchar** _tmp46_;
							gint _tmp46__length1;
							const gchar* _tmp47_;
#line 123 "../src/chess-engine-uci.vala"
							_tmp46_ = tokens;
#line 123 "../src/chess-engine-uci.vala"
							_tmp46__length1 = tokens_length1;
#line 123 "../src/chess-engine-uci.vala"
							_tmp47_ = _tmp46_[1];
#line 123 "../src/chess-engine-uci.vala"
							g_debug ("chess-engine-uci.vala:123: Discarding engine move %s during human's tu" \
"rn", _tmp47_);
#line 1245 "chess-engine-uci.c"
						}
#line 125 "../src/chess-engine-uci.vala"
						break;
#line 1249 "chess-engine-uci.c"
					}
				}
			}
		}
#line 129 "../src/chess-engine-uci.vala"
		_tmp48_ = self->priv->buffer;
#line 129 "../src/chess-engine-uci.vala"
		_tmp48__length1 = self->priv->buffer_length1;
#line 129 "../src/chess-engine-uci.vala"
		_tmp49_ = offset;
#line 129 "../src/chess-engine-uci.vala"
		_tmp50_ = self->priv->buffer;
#line 129 "../src/chess-engine-uci.vala"
		_tmp50__length1 = self->priv->buffer_length1;
#line 129 "../src/chess-engine-uci.vala"
		_tmp51_ = ((_tmp48_ + (_tmp49_ + 1)) != NULL) ? _vala_array_dup13 (_tmp48_ + (_tmp49_ + 1), _tmp50__length1 - (_tmp49_ + 1)) : ((gpointer) (_tmp48_ + (_tmp49_ + 1)));
#line 129 "../src/chess-engine-uci.vala"
		_tmp51__length1 = _tmp50__length1 - (_tmp49_ + 1);
#line 129 "../src/chess-engine-uci.vala"
		self->priv->buffer = (g_free (self->priv->buffer), NULL);
#line 129 "../src/chess-engine-uci.vala"
		self->priv->buffer = _tmp51_;
#line 129 "../src/chess-engine-uci.vala"
		self->priv->buffer_length1 = _tmp51__length1;
#line 129 "../src/chess-engine-uci.vala"
		self->priv->_buffer_size_ = self->priv->buffer_length1;
#line 73 "../src/chess-engine-uci.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 73 "../src/chess-engine-uci.vala"
		_g_free0 (line);
#line 1280 "chess-engine-uci.c"
	}
}


static gchar**
_vala_array_dup14 (gchar** self,
                   int length)
{
	gchar** result;
	int i;
#line 139 "../src/chess-engine-uci.vala"
	result = g_new0 (gchar*, length + 1);
#line 139 "../src/chess-engine-uci.vala"
	for (i = 0; i < length; i++) {
#line 1295 "chess-engine-uci.c"
		gchar* _tmp0_;
#line 139 "../src/chess-engine-uci.vala"
		_tmp0_ = g_strdup (self[i]);
#line 139 "../src/chess-engine-uci.vala"
		result[i] = _tmp0_;
#line 1301 "chess-engine-uci.c"
	}
#line 139 "../src/chess-engine-uci.vala"
	return result;
#line 1305 "chess-engine-uci.c"
}


static void
chess_engine_uci_configure (ChessEngineUCI* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 133 "../src/chess-engine-uci.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/chess-engine-uci.vala"
	_tmp0_ = self->priv->options;
#line 135 "../src/chess-engine-uci.vala"
	_tmp0__length1 = self->priv->options_length1;
#line 1320 "chess-engine-uci.c"
	{
		gchar** o_collection = NULL;
		gint o_collection_length1 = 0;
		gint _o_collection_size_ = 0;
		gint o_it = 0;
#line 135 "../src/chess-engine-uci.vala"
		o_collection = _tmp0_;
#line 135 "../src/chess-engine-uci.vala"
		o_collection_length1 = _tmp0__length1;
#line 135 "../src/chess-engine-uci.vala"
		for (o_it = 0; o_it < _tmp0__length1; o_it = o_it + 1) {
#line 1332 "chess-engine-uci.c"
			gchar* _tmp1_;
			gchar* o = NULL;
#line 135 "../src/chess-engine-uci.vala"
			_tmp1_ = g_strdup (o_collection[o_it]);
#line 135 "../src/chess-engine-uci.vala"
			o = _tmp1_;
#line 1339 "chess-engine-uci.c"
			{
				gchar** line = NULL;
				const gchar* _tmp2_;
				gchar** _tmp3_;
				gchar** _tmp4_;
				gint line_length1;
				gint _line_size_;
				gchar* option_value = NULL;
				gchar** _tmp5_;
				gint _tmp5__length1;
				gchar** _tmp6_;
				gint _tmp6__length1;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				gchar** _tmp10_;
				gint _tmp10__length1;
				gchar** _tmp11_;
				gint _tmp11__length1;
				gchar* option_name = NULL;
				gchar** _tmp12_;
				gint _tmp12__length1;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
#line 137 "../src/chess-engine-uci.vala"
				_tmp2_ = o;
#line 137 "../src/chess-engine-uci.vala"
				_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, " ", 0);
#line 137 "../src/chess-engine-uci.vala"
				line = _tmp4_;
#line 137 "../src/chess-engine-uci.vala"
				line_length1 = _vala_array_length (_tmp3_);
#line 137 "../src/chess-engine-uci.vala"
				_line_size_ = line_length1;
#line 138 "../src/chess-engine-uci.vala"
				_tmp5_ = line;
#line 138 "../src/chess-engine-uci.vala"
				_tmp5__length1 = line_length1;
#line 138 "../src/chess-engine-uci.vala"
				_tmp6_ = line;
#line 138 "../src/chess-engine-uci.vala"
				_tmp6__length1 = line_length1;
#line 138 "../src/chess-engine-uci.vala"
				_tmp7_ = _tmp5_[_tmp6__length1 - 1];
#line 138 "../src/chess-engine-uci.vala"
				_tmp8_ = g_strdup (_tmp7_);
#line 138 "../src/chess-engine-uci.vala"
				option_value = _tmp8_;
#line 139 "../src/chess-engine-uci.vala"
				_tmp9_ = line;
#line 139 "../src/chess-engine-uci.vala"
				_tmp9__length1 = line_length1;
#line 139 "../src/chess-engine-uci.vala"
				_tmp10_ = line;
#line 139 "../src/chess-engine-uci.vala"
				_tmp10__length1 = line_length1;
#line 139 "../src/chess-engine-uci.vala"
				_tmp11_ = ((_tmp9_ + 0) != NULL) ? _vala_array_dup14 (_tmp9_ + 0, (_tmp10__length1 - 1) - 0) : ((gpointer) (_tmp9_ + 0));
#line 139 "../src/chess-engine-uci.vala"
				_tmp11__length1 = (_tmp10__length1 - 1) - 0;
#line 139 "../src/chess-engine-uci.vala"
				line = (_vala_array_free (line, line_length1, (GDestroyNotify) g_free), NULL);
#line 139 "../src/chess-engine-uci.vala"
				line = _tmp11_;
#line 139 "../src/chess-engine-uci.vala"
				line_length1 = _tmp11__length1;
#line 139 "../src/chess-engine-uci.vala"
				_line_size_ = line_length1;
#line 140 "../src/chess-engine-uci.vala"
				_tmp12_ = line;
#line 140 "../src/chess-engine-uci.vala"
				_tmp12__length1 = line_length1;
#line 140 "../src/chess-engine-uci.vala"
				_tmp13_ = _vala_g_strjoinv (" ", _tmp12_, _tmp12__length1);
#line 140 "../src/chess-engine-uci.vala"
				option_name = _tmp13_;
#line 141 "../src/chess-engine-uci.vala"
				_tmp14_ = option_name;
#line 141 "../src/chess-engine-uci.vala"
				_tmp15_ = option_value;
#line 141 "../src/chess-engine-uci.vala"
				_tmp16_ = g_strdup_printf ("setoption name %s value %s", _tmp14_, _tmp15_);
#line 141 "../src/chess-engine-uci.vala"
				_tmp17_ = _tmp16_;
#line 141 "../src/chess-engine-uci.vala"
				chess_engine_write_line ((ChessEngine*) self, _tmp17_);
#line 141 "../src/chess-engine-uci.vala"
				_g_free0 (_tmp17_);
#line 135 "../src/chess-engine-uci.vala"
				_g_free0 (option_name);
#line 135 "../src/chess-engine-uci.vala"
				_g_free0 (option_value);
#line 135 "../src/chess-engine-uci.vala"
				line = (_vala_array_free (line, line_length1, (GDestroyNotify) g_free), NULL);
#line 135 "../src/chess-engine-uci.vala"
				_g_free0 (o);
#line 1440 "chess-engine-uci.c"
			}
		}
	}
#line 143 "../src/chess-engine-uci.vala"
	chess_engine_write_line ((ChessEngine*) self, "isready");
#line 1446 "chess-engine-uci.c"
}


static void
chess_engine_uci_class_init (ChessEngineUCIClass * klass)
{
#line 13 "../src/chess-engine-uci.vala"
	chess_engine_uci_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/chess-engine-uci.vala"
	g_type_class_adjust_private_offset (klass, &ChessEngineUCI_private_offset);
#line 13 "../src/chess-engine-uci.vala"
	((ChessEngineClass *) klass)->start_game = (void (*) (ChessEngine*)) chess_engine_uci_real_start_game;
#line 13 "../src/chess-engine-uci.vala"
	((ChessEngineClass *) klass)->request_move = (void (*) (ChessEngine*)) chess_engine_uci_real_request_move;
#line 13 "../src/chess-engine-uci.vala"
	((ChessEngineClass *) klass)->report_move = (void (*) (ChessEngine*, ChessMove*)) chess_engine_uci_real_report_move;
#line 13 "../src/chess-engine-uci.vala"
	((ChessEngineClass *) klass)->do_undo = (void (*) (ChessEngine*)) chess_engine_uci_real_do_undo;
#line 13 "../src/chess-engine-uci.vala"
	((ChessEngineClass *) klass)->process_input = (void (*) (ChessEngine*, gchar*, int)) chess_engine_uci_real_process_input;
#line 13 "../src/chess-engine-uci.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_engine_uci_finalize;
#line 1469 "chess-engine-uci.c"
}


static void
chess_engine_uci_instance_init (ChessEngineUCI * self)
{
#line 13 "../src/chess-engine-uci.vala"
	self->priv = chess_engine_uci_get_instance_private (self);
#line 1478 "chess-engine-uci.c"
}


static void
chess_engine_uci_finalize (GObject * obj)
{
	ChessEngineUCI * self;
#line 13 "../src/chess-engine-uci.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_ENGINE_UCI, ChessEngineUCI);
#line 15 "../src/chess-engine-uci.vala"
	self->priv->buffer = (g_free (self->priv->buffer), NULL);
#line 16 "../src/chess-engine-uci.vala"
	_g_free0 (self->priv->moves);
#line 17 "../src/chess-engine-uci.vala"
	self->priv->options = (_vala_array_free (self->priv->options, self->priv->options_length1, (GDestroyNotify) g_free), NULL);
#line 18 "../src/chess-engine-uci.vala"
	_g_free0 (self->priv->go_options);
#line 13 "../src/chess-engine-uci.vala"
	G_OBJECT_CLASS (chess_engine_uci_parent_class)->finalize (obj);
#line 1498 "chess-engine-uci.c"
}


GType
chess_engine_uci_get_type (void)
{
	static volatile gsize chess_engine_uci_type_id__volatile = 0;
	if (g_once_init_enter (&chess_engine_uci_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessEngineUCIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_engine_uci_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessEngineUCI), 0, (GInstanceInitFunc) chess_engine_uci_instance_init, NULL };
		GType chess_engine_uci_type_id;
		chess_engine_uci_type_id = g_type_register_static (TYPE_CHESS_ENGINE, "ChessEngineUCI", &g_define_type_info, 0);
		ChessEngineUCI_private_offset = g_type_add_instance_private (chess_engine_uci_type_id, sizeof (ChessEngineUCIPrivate));
		g_once_init_leave (&chess_engine_uci_type_id__volatile, chess_engine_uci_type_id);
	}
	return chess_engine_uci_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



