/* chess-engine.c generated by valac 0.42.6, the Vala compiler
 * generated from chess-engine.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2014 Michael Catanzaro
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include "libchess.h"
#include "portability.h"
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <string.h>
#include <stdlib.h>


#define TYPE_CHESS_ENGINE (chess_engine_get_type ())
#define CHESS_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_ENGINE, ChessEngine))
#define CHESS_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_ENGINE, ChessEngineClass))
#define IS_CHESS_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_ENGINE))
#define IS_CHESS_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_ENGINE))
#define CHESS_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_ENGINE, ChessEngineClass))

typedef struct _ChessEngine ChessEngine;
typedef struct _ChessEngineClass ChessEngineClass;
typedef struct _ChessEnginePrivate ChessEnginePrivate;
enum  {
	CHESS_ENGINE_0_PROPERTY,
	CHESS_ENGINE_READY_PROPERTY,
	CHESS_ENGINE_NUM_PROPERTIES
};
static GParamSpec* chess_engine_properties[CHESS_ENGINE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	CHESS_ENGINE_STARTING_SIGNAL,
	CHESS_ENGINE_READY_CHANGED_SIGNAL,
	CHESS_ENGINE_MOVED_SIGNAL,
	CHESS_ENGINE_RESIGNED_SIGNAL,
	CHESS_ENGINE_STOPPED_UNEXPECTEDLY_SIGNAL,
	CHESS_ENGINE_ERROR_SIGNAL,
	CHESS_ENGINE_CLAIM_DRAW_SIGNAL,
	CHESS_ENGINE_OFFER_DRAW_SIGNAL,
	CHESS_ENGINE_NUM_SIGNALS
};
static guint chess_engine_signals[CHESS_ENGINE_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ChessEngine {
	GObject parent_instance;
	ChessEnginePrivate * priv;
};

struct _ChessEngineClass {
	GObjectClass parent_class;
	void (*process_input) (ChessEngine* self, gchar* data, int data_length1);
	void (*start_game) (ChessEngine* self);
	void (*report_move) (ChessEngine* self, ChessMove* move);
	void (*do_undo) (ChessEngine* self);
	void (*request_move) (ChessEngine* self);
};

struct _ChessEnginePrivate {
	gchar* binary;
	gchar** args;
	gint args_length1;
	gint _args_size_;
	guint delay_seconds;
	guint pending_move_source_id;
	GPid pid;
	gint stdin_fd;
	gint stderr_fd;
	GIOChannel* stdout_channel;
	guint child_watch_id;
	guint stdout_watch_id;
	gboolean started;
	gboolean _ready;
};


static gint ChessEngine_private_offset;
static gpointer chess_engine_parent_class = NULL;

GType chess_engine_get_type (void) G_GNUC_CONST;
void chess_engine_process_input (ChessEngine* self,
                                 gchar* data,
                                 int data_length1);
static void chess_engine_real_process_input (ChessEngine* self,
                                      gchar* data,
                                      int data_length1);
ChessEngine* chess_engine_construct (GType object_type,
                                     const gchar* binary,
                                     gchar** args,
                                     int args_length1,
                                     guint delay_seconds);
static gchar** _vala_array_dup15 (gchar** self,
                           int length);
gboolean chess_engine_start (ChessEngine* self);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void ___lambda4_ (ChessEngine* self);
static void ____lambda4__gspawn_child_setup_func (gpointer self);
static void chess_engine_engine_stopped_cb (ChessEngine* self,
                                     GPid pid);
static void _chess_engine_engine_stopped_cb_gchild_watch_func (GPid pid,
                                                        gint status,
                                                        gpointer self);
static gboolean chess_engine_read_cb (ChessEngine* self,
                               GIOChannel* source,
                               GIOCondition condition);
static gboolean _chess_engine_read_cb_gio_func (GIOChannel* source,
                                         GIOCondition condition,
                                         gpointer self);
void chess_engine_stop (ChessEngine* self,
                        gboolean kill_engine);
void chess_engine_start_game (ChessEngine* self);
static void chess_engine_real_start_game (ChessEngine* self);
void chess_engine_report_move (ChessEngine* self,
                               ChessMove* move);
static void chess_engine_real_report_move (ChessEngine* self,
                                    ChessMove* move);
void chess_engine_do_undo (ChessEngine* self);
static void chess_engine_real_do_undo (ChessEngine* self);
void chess_engine_request_move (ChessEngine* self);
static void chess_engine_real_request_move (ChessEngine* self);
void chess_engine_move (ChessEngine* self);
static gboolean __lambda5_ (ChessEngine* self);
static gboolean ___lambda5__gsource_func (gpointer self);
void chess_engine_undo (ChessEngine* self);
void chess_engine_write (ChessEngine* self,
                         gchar* data,
                         int data_length1);
void chess_engine_write_line (ChessEngine* self,
                              const gchar* line);
gboolean chess_engine_get_ready (ChessEngine* self);
void chess_engine_set_ready (ChessEngine* self,
                             gboolean value);
static void chess_engine_finalize (GObject * obj);
static void _vala_chess_engine_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_chess_engine_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
chess_engine_get_instance_private (ChessEngine* self)
{
	return G_STRUCT_MEMBER_P (self, ChessEngine_private_offset);
}


static void
chess_engine_real_process_input (ChessEngine* self,
                                 gchar* data,
                                 int data_length1)
{
}


void
chess_engine_process_input (ChessEngine* self,
                            gchar* data,
                            int data_length1)
{
#line 30 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/chess-engine.vala"
	CHESS_ENGINE_GET_CLASS (self)->process_input (self, data, data_length1);
#line 203 "chess-engine.c"
}


static gchar**
_vala_array_dup15 (gchar** self,
                   int length)
{
	gchar** result;
	int i;
#line 58 "../src/chess-engine.vala"
	result = g_new0 (gchar*, length + 1);
#line 58 "../src/chess-engine.vala"
	for (i = 0; i < length; i++) {
#line 217 "chess-engine.c"
		gchar* _tmp0_;
#line 58 "../src/chess-engine.vala"
		_tmp0_ = g_strdup (self[i]);
#line 58 "../src/chess-engine.vala"
		result[i] = _tmp0_;
#line 223 "chess-engine.c"
	}
#line 58 "../src/chess-engine.vala"
	return result;
#line 227 "chess-engine.c"
}


ChessEngine*
chess_engine_construct (GType object_type,
                        const gchar* binary,
                        gchar** args,
                        int args_length1,
                        guint delay_seconds)
{
	ChessEngine * self = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 55 "../src/chess-engine.vala"
	g_return_val_if_fail (binary != NULL, NULL);
#line 55 "../src/chess-engine.vala"
	self = (ChessEngine*) g_object_new (object_type, NULL);
#line 57 "../src/chess-engine.vala"
	_tmp0_ = g_strdup (binary);
#line 57 "../src/chess-engine.vala"
	_g_free0 (self->priv->binary);
#line 57 "../src/chess-engine.vala"
	self->priv->binary = _tmp0_;
#line 58 "../src/chess-engine.vala"
	_tmp1_ = (args != NULL) ? _vala_array_dup15 (args, args_length1) : ((gpointer) args);
#line 58 "../src/chess-engine.vala"
	_tmp1__length1 = args_length1;
#line 58 "../src/chess-engine.vala"
	self->priv->args = (_vala_array_free (self->priv->args, self->priv->args_length1, (GDestroyNotify) g_free), NULL);
#line 58 "../src/chess-engine.vala"
	self->priv->args = _tmp1_;
#line 58 "../src/chess-engine.vala"
	self->priv->args_length1 = _tmp1__length1;
#line 58 "../src/chess-engine.vala"
	self->priv->_args_size_ = self->priv->args_length1;
#line 59 "../src/chess-engine.vala"
	self->priv->delay_seconds = delay_seconds;
#line 55 "../src/chess-engine.vala"
	return self;
#line 268 "chess-engine.c"
}


static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 77 "../src/chess-engine.vala"
	if ((*length) == (*size)) {
#line 77 "../src/chess-engine.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 77 "../src/chess-engine.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 284 "chess-engine.c"
	}
#line 77 "../src/chess-engine.vala"
	(*array)[(*length)++] = value;
#line 77 "../src/chess-engine.vala"
	(*array)[*length] = NULL;
#line 290 "chess-engine.c"
}


static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 78 "../src/chess-engine.vala"
	if ((*length) == (*size)) {
#line 78 "../src/chess-engine.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 78 "../src/chess-engine.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 306 "chess-engine.c"
	}
#line 78 "../src/chess-engine.vala"
	(*array)[(*length)++] = value;
#line 78 "../src/chess-engine.vala"
	(*array)[*length] = NULL;
#line 312 "chess-engine.c"
}


static void
___lambda4_ (ChessEngine* self)
{
#line 85 "../src/chess-engine.vala"
	maybe_kill_orphan_engine ();
#line 321 "chess-engine.c"
}


static void
____lambda4__gspawn_child_setup_func (gpointer self)
{
#line 83 "../src/chess-engine.vala"
	___lambda4_ ((ChessEngine*) self);
#line 330 "chess-engine.c"
}


static void
_chess_engine_engine_stopped_cb_gchild_watch_func (GPid pid,
                                                   gint status,
                                                   gpointer self)
{
#line 94 "../src/chess-engine.vala"
	chess_engine_engine_stopped_cb ((ChessEngine*) self, pid);
#line 341 "chess-engine.c"
}


static gboolean
_chess_engine_read_cb_gio_func (GIOChannel* source,
                                GIOCondition condition,
                                gpointer self)
{
	gboolean result;
	result = chess_engine_read_cb ((ChessEngine*) self, source, condition);
#line 106 "../src/chess-engine.vala"
	return result;
#line 354 "chess-engine.c"
}


gboolean
chess_engine_start (ChessEngine* self)
{
	gboolean result = FALSE;
	GPid _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	gchar** argv = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gint stdout_fd = 0;
	GPid _tmp24_;
	gint _tmp25_;
	GIOChannel* _tmp26_;
	GIOChannel* _tmp32_;
	GIOChannel* _tmp33_;
	GError* _inner_error0_ = NULL;
#line 67 "../src/chess-engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 67 "../src/chess-engine.vala"
	_tmp0_ = self->priv->pid;
#line 67 "../src/chess-engine.vala"
	_vala_return_val_if_fail (_tmp0_ == ((GPid) 0), "pid == 0", FALSE);
#line 67 "../src/chess-engine.vala"
	_tmp1_ = self->priv->child_watch_id;
#line 67 "../src/chess-engine.vala"
	_vala_return_val_if_fail (_tmp1_ == ((guint) 0), "child_watch_id == 0", FALSE);
#line 67 "../src/chess-engine.vala"
	_tmp2_ = self->priv->stdout_watch_id;
#line 67 "../src/chess-engine.vala"
	_vala_return_val_if_fail (_tmp2_ == ((guint) 0), "stdout_watch_id == 0", FALSE);
#line 67 "../src/chess-engine.vala"
	_tmp3_ = self->priv->stdin_fd;
#line 67 "../src/chess-engine.vala"
	_vala_return_val_if_fail (_tmp3_ == -1, "stdin_fd == -1", FALSE);
#line 67 "../src/chess-engine.vala"
	_tmp4_ = self->priv->stderr_fd;
#line 67 "../src/chess-engine.vala"
	_vala_return_val_if_fail (_tmp4_ == -1, "stderr_fd == -1", FALSE);
#line 67 "../src/chess-engine.vala"
	_tmp5_ = self->priv->started;
#line 67 "../src/chess-engine.vala"
	_vala_return_val_if_fail (!_tmp5_, "!started", FALSE);
#line 75 "../src/chess-engine.vala"
	_tmp6_ = self->priv->binary;
#line 75 "../src/chess-engine.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 75 "../src/chess-engine.vala"
	_tmp8_ = g_new0 (gchar*, 1 + 1);
#line 75 "../src/chess-engine.vala"
	_tmp8_[0] = _tmp7_;
#line 75 "../src/chess-engine.vala"
	argv = _tmp8_;
#line 75 "../src/chess-engine.vala"
	argv_length1 = 1;
#line 75 "../src/chess-engine.vala"
	_argv_size_ = argv_length1;
#line 76 "../src/chess-engine.vala"
	_tmp9_ = self->priv->args;
#line 76 "../src/chess-engine.vala"
	_tmp9__length1 = self->priv->args_length1;
#line 429 "chess-engine.c"
	{
		gchar** arg_collection = NULL;
		gint arg_collection_length1 = 0;
		gint _arg_collection_size_ = 0;
		gint arg_it = 0;
#line 76 "../src/chess-engine.vala"
		arg_collection = _tmp9_;
#line 76 "../src/chess-engine.vala"
		arg_collection_length1 = _tmp9__length1;
#line 76 "../src/chess-engine.vala"
		for (arg_it = 0; arg_it < _tmp9__length1; arg_it = arg_it + 1) {
#line 441 "chess-engine.c"
			gchar* _tmp10_;
			gchar* arg = NULL;
#line 76 "../src/chess-engine.vala"
			_tmp10_ = g_strdup (arg_collection[arg_it]);
#line 76 "../src/chess-engine.vala"
			arg = _tmp10_;
#line 448 "chess-engine.c"
			{
				gchar** _tmp11_;
				gint _tmp11__length1;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 77 "../src/chess-engine.vala"
				_tmp11_ = argv;
#line 77 "../src/chess-engine.vala"
				_tmp11__length1 = argv_length1;
#line 77 "../src/chess-engine.vala"
				_tmp12_ = arg;
#line 77 "../src/chess-engine.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 77 "../src/chess-engine.vala"
				_vala_array_add1 (&argv, &argv_length1, &_argv_size_, _tmp13_);
#line 76 "../src/chess-engine.vala"
				_g_free0 (arg);
#line 466 "chess-engine.c"
			}
		}
	}
#line 78 "../src/chess-engine.vala"
	_tmp14_ = argv;
#line 78 "../src/chess-engine.vala"
	_tmp14__length1 = argv_length1;
#line 78 "../src/chess-engine.vala"
	_vala_array_add2 (&argv, &argv_length1, &_argv_size_, NULL);
#line 476 "chess-engine.c"
	{
		gchar** _tmp15_;
		gint _tmp15__length1;
		GPid _tmp16_ = 0;
		gint _tmp17_ = 0;
		gint _tmp18_ = 0;
		gint _tmp19_ = 0;
#line 83 "../src/chess-engine.vala"
		_tmp15_ = argv;
#line 83 "../src/chess-engine.vala"
		_tmp15__length1 = argv_length1;
#line 83 "../src/chess-engine.vala"
		g_spawn_async_with_pipes (NULL, _tmp15_, NULL, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, ____lambda4__gspawn_child_setup_func, self, &_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_, &_inner_error0_);
#line 83 "../src/chess-engine.vala"
		self->priv->pid = _tmp16_;
#line 83 "../src/chess-engine.vala"
		self->priv->stdin_fd = _tmp17_;
#line 83 "../src/chess-engine.vala"
		stdout_fd = _tmp18_;
#line 83 "../src/chess-engine.vala"
		self->priv->stderr_fd = _tmp19_;
#line 83 "../src/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 500 "chess-engine.c"
			gboolean _tmp20_ = FALSE;
#line 83 "../src/chess-engine.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 504 "chess-engine.c"
				goto __catch2_g_spawn_error;
			}
#line 83 "../src/chess-engine.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 83 "../src/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "../src/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 83 "../src/chess-engine.vala"
			return _tmp20_;
#line 515 "chess-engine.c"
		}
	}
	goto __finally2;
	__catch2_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
#line 81 "../src/chess-engine.vala"
		e = _inner_error0_;
#line 81 "../src/chess-engine.vala"
		_inner_error0_ = NULL;
#line 90 "../src/chess-engine.vala"
		_tmp21_ = e;
#line 90 "../src/chess-engine.vala"
		_tmp22_ = _tmp21_->message;
#line 90 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:90: Failed to execute chess engine: %s\n", _tmp22_);
#line 91 "../src/chess-engine.vala"
		result = FALSE;
#line 91 "../src/chess-engine.vala"
		_g_error_free0 (e);
#line 91 "../src/chess-engine.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 91 "../src/chess-engine.vala"
		return result;
#line 542 "chess-engine.c"
	}
	__finally2:
#line 81 "../src/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 547 "chess-engine.c"
		gboolean _tmp23_ = FALSE;
#line 81 "../src/chess-engine.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 81 "../src/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 81 "../src/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 81 "../src/chess-engine.vala"
		return _tmp23_;
#line 557 "chess-engine.c"
	}
#line 94 "../src/chess-engine.vala"
	_tmp24_ = self->priv->pid;
#line 94 "../src/chess-engine.vala"
	self->priv->child_watch_id = g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp24_, _chess_engine_engine_stopped_cb_gchild_watch_func, g_object_ref (self), g_object_unref);
#line 96 "../src/chess-engine.vala"
	_tmp25_ = stdout_fd;
#line 96 "../src/chess-engine.vala"
	_tmp26_ = g_io_channel_unix_new (_tmp25_);
#line 96 "../src/chess-engine.vala"
	_g_io_channel_unref0 (self->priv->stdout_channel);
#line 96 "../src/chess-engine.vala"
	self->priv->stdout_channel = _tmp26_;
#line 571 "chess-engine.c"
	{
		GIOChannel* _tmp27_;
#line 99 "../src/chess-engine.vala"
		_tmp27_ = self->priv->stdout_channel;
#line 99 "../src/chess-engine.vala"
		g_io_channel_set_flags (_tmp27_, G_IO_FLAG_NONBLOCK, &_inner_error0_);
#line 99 "../src/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 580 "chess-engine.c"
			gboolean _tmp28_ = FALSE;
#line 99 "../src/chess-engine.vala"
			if (_inner_error0_->domain == G_IO_CHANNEL_ERROR) {
#line 584 "chess-engine.c"
				goto __catch3_g_io_channel_error;
			}
#line 99 "../src/chess-engine.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 99 "../src/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 99 "../src/chess-engine.vala"
			return _tmp28_;
#line 595 "chess-engine.c"
		}
	}
	goto __finally3;
	__catch3_g_io_channel_error:
	{
		GError* e = NULL;
		GError* _tmp29_;
		const gchar* _tmp30_;
#line 97 "../src/chess-engine.vala"
		e = _inner_error0_;
#line 97 "../src/chess-engine.vala"
		_inner_error0_ = NULL;
#line 103 "../src/chess-engine.vala"
		_tmp29_ = e;
#line 103 "../src/chess-engine.vala"
		_tmp30_ = _tmp29_->message;
#line 103 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:103: Failed to set input from chess engine to non-bl" \
"ocking: %s", _tmp30_);
#line 97 "../src/chess-engine.vala"
		_g_error_free0 (e);
#line 616 "chess-engine.c"
	}
	__finally3:
#line 97 "../src/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 621 "chess-engine.c"
		gboolean _tmp31_ = FALSE;
#line 97 "../src/chess-engine.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 97 "../src/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 97 "../src/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 97 "../src/chess-engine.vala"
		return _tmp31_;
#line 631 "chess-engine.c"
	}
#line 105 "../src/chess-engine.vala"
	_tmp32_ = self->priv->stdout_channel;
#line 105 "../src/chess-engine.vala"
	g_io_channel_set_close_on_unref (_tmp32_, TRUE);
#line 106 "../src/chess-engine.vala"
	_tmp33_ = self->priv->stdout_channel;
#line 106 "../src/chess-engine.vala"
	self->priv->stdout_watch_id = g_io_add_watch (_tmp33_, G_IO_IN, _chess_engine_read_cb_gio_func, self);
#line 108 "../src/chess-engine.vala"
	self->priv->started = TRUE;
#line 109 "../src/chess-engine.vala"
	g_signal_emit (self, chess_engine_signals[CHESS_ENGINE_STARTING_SIGNAL], 0);
#line 111 "../src/chess-engine.vala"
	result = TRUE;
#line 111 "../src/chess-engine.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 111 "../src/chess-engine.vala"
	return result;
#line 651 "chess-engine.c"
}


static void
chess_engine_engine_stopped_cb (ChessEngine* self,
                                GPid pid)
{
	gboolean _tmp0_;
	GPid _tmp1_;
#line 114 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/chess-engine.vala"
	_tmp0_ = self->priv->started;
#line 114 "../src/chess-engine.vala"
	_vala_return_if_fail (_tmp0_, "started");
#line 114 "../src/chess-engine.vala"
	_tmp1_ = self->priv->pid;
#line 114 "../src/chess-engine.vala"
	_vala_return_if_fail (pid == _tmp1_, "pid == this.pid");
#line 118 "../src/chess-engine.vala"
	chess_engine_stop (self, FALSE);
#line 119 "../src/chess-engine.vala"
	g_signal_emit (self, chess_engine_signals[CHESS_ENGINE_STOPPED_UNEXPECTEDLY_SIGNAL], 0);
#line 675 "chess-engine.c"
}


static void
chess_engine_real_start_game (ChessEngine* self)
{
#line 122 "../src/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_start_game'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 122 "../src/chess-engine.vala"
	return;
#line 686 "chess-engine.c"
}


void
chess_engine_start_game (ChessEngine* self)
{
#line 122 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/chess-engine.vala"
	CHESS_ENGINE_GET_CLASS (self)->start_game (self);
#line 697 "chess-engine.c"
}


static void
chess_engine_real_report_move (ChessEngine* self,
                               ChessMove* move)
{
#line 124 "../src/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_report_move'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 124 "../src/chess-engine.vala"
	return;
#line 709 "chess-engine.c"
}


void
chess_engine_report_move (ChessEngine* self,
                          ChessMove* move)
{
#line 124 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/chess-engine.vala"
	CHESS_ENGINE_GET_CLASS (self)->report_move (self, move);
#line 721 "chess-engine.c"
}


static void
chess_engine_real_do_undo (ChessEngine* self)
{
#line 126 "../src/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_do_undo'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 126 "../src/chess-engine.vala"
	return;
#line 732 "chess-engine.c"
}


void
chess_engine_do_undo (ChessEngine* self)
{
#line 126 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/chess-engine.vala"
	CHESS_ENGINE_GET_CLASS (self)->do_undo (self);
#line 743 "chess-engine.c"
}


static void
chess_engine_real_request_move (ChessEngine* self)
{
#line 128 "../src/chess-engine.vala"
	g_critical ("Type `%s' does not implement abstract method `chess_engine_request_move'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 128 "../src/chess-engine.vala"
	return;
#line 754 "chess-engine.c"
}


void
chess_engine_request_move (ChessEngine* self)
{
#line 128 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/chess-engine.vala"
	CHESS_ENGINE_GET_CLASS (self)->request_move (self);
#line 765 "chess-engine.c"
}


static gboolean
__lambda5_ (ChessEngine* self)
{
	gboolean result = FALSE;
#line 133 "../src/chess-engine.vala"
	self->priv->pending_move_source_id = (guint) 0;
#line 134 "../src/chess-engine.vala"
	chess_engine_request_move (self);
#line 135 "../src/chess-engine.vala"
	result = G_SOURCE_REMOVE;
#line 135 "../src/chess-engine.vala"
	return result;
#line 781 "chess-engine.c"
}


static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((ChessEngine*) self);
#line 132 "../src/chess-engine.vala"
	return result;
#line 792 "chess-engine.c"
}


void
chess_engine_move (ChessEngine* self)
{
	guint _tmp0_;
#line 130 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/chess-engine.vala"
	_tmp0_ = self->priv->delay_seconds;
#line 132 "../src/chess-engine.vala"
	self->priv->pending_move_source_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, _tmp0_, ___lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 806 "chess-engine.c"
}


void
chess_engine_undo (ChessEngine* self)
{
	guint _tmp0_;
#line 139 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/chess-engine.vala"
	_tmp0_ = self->priv->pending_move_source_id;
#line 141 "../src/chess-engine.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 820 "chess-engine.c"
		guint _tmp1_;
#line 143 "../src/chess-engine.vala"
		_tmp1_ = self->priv->pending_move_source_id;
#line 143 "../src/chess-engine.vala"
		g_source_remove (_tmp1_);
#line 144 "../src/chess-engine.vala"
		self->priv->pending_move_source_id = (guint) 0;
#line 828 "chess-engine.c"
	}
#line 147 "../src/chess-engine.vala"
	chess_engine_do_undo (self);
#line 832 "chess-engine.c"
}


void
chess_engine_stop (ChessEngine* self,
                   gboolean kill_engine)
{
	gboolean _tmp0_;
	GIOChannel* _tmp1_;
	gboolean _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_;
	GPid _tmp7_;
	gboolean _tmp8_;
	guint _tmp9_;
	gboolean _tmp10_;
	guint _tmp11_;
	gint _tmp16_;
	gint _tmp19_;
	guint _tmp22_;
	gboolean _tmp23_ = FALSE;
	GPid _tmp27_;
	GError* _inner_error0_ = NULL;
#line 150 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/chess-engine.vala"
	_tmp0_ = self->priv->started;
#line 150 "../src/chess-engine.vala"
	_tmp1_ = self->priv->stdout_channel;
#line 150 "../src/chess-engine.vala"
	_vala_return_if_fail ((!_tmp0_) || (_tmp1_ != NULL), "!started || stdout_channel != null");
#line 150 "../src/chess-engine.vala"
	_tmp2_ = self->priv->started;
#line 150 "../src/chess-engine.vala"
	_tmp3_ = self->priv->stdin_fd;
#line 150 "../src/chess-engine.vala"
	_vala_return_if_fail ((!_tmp2_) || (_tmp3_ != -1), "!started || stdin_fd != -1");
#line 150 "../src/chess-engine.vala"
	_tmp4_ = self->priv->started;
#line 150 "../src/chess-engine.vala"
	_tmp5_ = self->priv->stderr_fd;
#line 150 "../src/chess-engine.vala"
	_vala_return_if_fail ((!_tmp4_) || (_tmp5_ != -1), "!started || stderr_fd != -1");
#line 150 "../src/chess-engine.vala"
	_tmp6_ = self->priv->started;
#line 150 "../src/chess-engine.vala"
	_tmp7_ = self->priv->pid;
#line 150 "../src/chess-engine.vala"
	_vala_return_if_fail ((!_tmp6_) || (_tmp7_ != ((GPid) 0)), "!started || pid != 0");
#line 150 "../src/chess-engine.vala"
	_tmp8_ = self->priv->started;
#line 150 "../src/chess-engine.vala"
	_tmp9_ = self->priv->child_watch_id;
#line 150 "../src/chess-engine.vala"
	_vala_return_if_fail ((!_tmp8_) || (_tmp9_ != ((guint) 0)), "!started || child_watch_id != 0");
#line 157 "../src/chess-engine.vala"
	_tmp10_ = self->priv->started;
#line 157 "../src/chess-engine.vala"
	if (!_tmp10_) {
#line 158 "../src/chess-engine.vala"
		return;
#line 896 "chess-engine.c"
	}
#line 159 "../src/chess-engine.vala"
	self->priv->started = FALSE;
#line 162 "../src/chess-engine.vala"
	_tmp11_ = self->priv->stdout_watch_id;
#line 162 "../src/chess-engine.vala"
	if (_tmp11_ != ((guint) 0)) {
#line 904 "chess-engine.c"
		guint _tmp12_;
#line 163 "../src/chess-engine.vala"
		_tmp12_ = self->priv->stdout_watch_id;
#line 163 "../src/chess-engine.vala"
		g_source_remove (_tmp12_);
#line 164 "../src/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 912 "chess-engine.c"
	}
	{
		GIOChannel* _tmp13_;
#line 169 "../src/chess-engine.vala"
		_tmp13_ = self->priv->stdout_channel;
#line 169 "../src/chess-engine.vala"
		g_io_channel_shutdown (_tmp13_, FALSE, &_inner_error0_);
#line 169 "../src/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "../src/chess-engine.vala"
			if (_inner_error0_->domain == G_IO_CHANNEL_ERROR) {
#line 924 "chess-engine.c"
				goto __catch4_g_io_channel_error;
			}
#line 169 "../src/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 169 "../src/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 169 "../src/chess-engine.vala"
			return;
#line 933 "chess-engine.c"
		}
	}
	goto __finally4;
	__catch4_g_io_channel_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 167 "../src/chess-engine.vala"
		e = _inner_error0_;
#line 167 "../src/chess-engine.vala"
		_inner_error0_ = NULL;
#line 173 "../src/chess-engine.vala"
		_tmp14_ = e;
#line 173 "../src/chess-engine.vala"
		_tmp15_ = _tmp14_->message;
#line 173 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:173: Failed to close channel to engine's stdout: %s", _tmp15_);
#line 167 "../src/chess-engine.vala"
		_g_error_free0 (e);
#line 954 "chess-engine.c"
	}
	__finally4:
#line 167 "../src/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "../src/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 167 "../src/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 167 "../src/chess-engine.vala"
		return;
#line 965 "chess-engine.c"
	}
#line 175 "../src/chess-engine.vala"
	_g_io_channel_unref0 (self->priv->stdout_channel);
#line 175 "../src/chess-engine.vala"
	self->priv->stdout_channel = NULL;
#line 177 "../src/chess-engine.vala"
	_tmp16_ = self->priv->stdin_fd;
#line 177 "../src/chess-engine.vala"
	if (close (_tmp16_) == -1) {
#line 975 "chess-engine.c"
		gint _tmp17_;
		const gchar* _tmp18_;
#line 178 "../src/chess-engine.vala"
		_tmp17_ = errno;
#line 178 "../src/chess-engine.vala"
		_tmp18_ = g_strerror (_tmp17_);
#line 178 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:178: Failed to close pipe to engine's stdin: %s", _tmp18_);
#line 984 "chess-engine.c"
	}
#line 179 "../src/chess-engine.vala"
	self->priv->stdin_fd = -1;
#line 181 "../src/chess-engine.vala"
	_tmp19_ = self->priv->stderr_fd;
#line 181 "../src/chess-engine.vala"
	if (close (_tmp19_) == -1) {
#line 992 "chess-engine.c"
		gint _tmp20_;
		const gchar* _tmp21_;
#line 182 "../src/chess-engine.vala"
		_tmp20_ = errno;
#line 182 "../src/chess-engine.vala"
		_tmp21_ = g_strerror (_tmp20_);
#line 182 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:182: Failed to close pipe to engine's stderr: %s", _tmp21_);
#line 1001 "chess-engine.c"
	}
#line 183 "../src/chess-engine.vala"
	self->priv->stderr_fd = -1;
#line 185 "../src/chess-engine.vala"
	_tmp22_ = self->priv->child_watch_id;
#line 185 "../src/chess-engine.vala"
	g_source_remove (_tmp22_);
#line 186 "../src/chess-engine.vala"
	self->priv->child_watch_id = (guint) 0;
#line 188 "../src/chess-engine.vala"
	if (kill_engine) {
#line 1013 "chess-engine.c"
		GPid _tmp24_;
#line 188 "../src/chess-engine.vala"
		_tmp24_ = self->priv->pid;
#line 188 "../src/chess-engine.vala"
		_tmp23_ = kill ((pid_t) _tmp24_, (gint) SIGTERM) == -1;
#line 1019 "chess-engine.c"
	} else {
#line 188 "../src/chess-engine.vala"
		_tmp23_ = FALSE;
#line 1023 "chess-engine.c"
	}
#line 188 "../src/chess-engine.vala"
	if (_tmp23_) {
#line 1027 "chess-engine.c"
		gint _tmp25_;
		const gchar* _tmp26_;
#line 189 "../src/chess-engine.vala"
		_tmp25_ = errno;
#line 189 "../src/chess-engine.vala"
		_tmp26_ = g_strerror (_tmp25_);
#line 189 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:189: Failed to kill engine: %s", _tmp26_);
#line 1036 "chess-engine.c"
	}
#line 190 "../src/chess-engine.vala"
	_tmp27_ = self->priv->pid;
#line 190 "../src/chess-engine.vala"
	g_spawn_close_pid (_tmp27_);
#line 191 "../src/chess-engine.vala"
	self->priv->pid = (GPid) 0;
#line 1044 "chess-engine.c"
}


static gboolean
chess_engine_read_cb (ChessEngine* self,
                      GIOChannel* source,
                      GIOCondition condition)
{
	gboolean result = FALSE;
	guint _tmp0_;
	gchar* buf = NULL;
	gint buf_length1 = 0;
	gint _buf_size_ = 0;
	gsize n_read = 0UL;
	GIOStatus status = 0;
	gchar* _tmp1_;
	GIOStatus _tmp12_;
	GIOStatus _tmp13_;
	GError* _inner_error0_ = NULL;
#line 194 "../src/chess-engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 194 "../src/chess-engine.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 194 "../src/chess-engine.vala"
	_tmp0_ = self->priv->stdout_watch_id;
#line 194 "../src/chess-engine.vala"
	_vala_return_val_if_fail (_tmp0_ != ((guint) 0), "stdout_watch_id != 0", FALSE);
#line 201 "../src/chess-engine.vala"
	_tmp1_ = g_new0 (gchar, 1024);
#line 201 "../src/chess-engine.vala"
	buf = (g_free (buf), NULL);
#line 201 "../src/chess-engine.vala"
	buf = _tmp1_;
#line 201 "../src/chess-engine.vala"
	buf_length1 = 1024;
#line 201 "../src/chess-engine.vala"
	_buf_size_ = buf_length1;
#line 1082 "chess-engine.c"
	{
		GIOStatus _tmp2_ = 0;
		gchar* _tmp3_;
		gint _tmp3__length1;
		gsize _tmp4_ = 0UL;
		GIOStatus _tmp5_;
#line 204 "../src/chess-engine.vala"
		_tmp3_ = buf;
#line 204 "../src/chess-engine.vala"
		_tmp3__length1 = buf_length1;
#line 204 "../src/chess-engine.vala"
		_tmp5_ = g_io_channel_read_chars (source, _tmp3_, _tmp3__length1, &_tmp4_, &_inner_error0_);
#line 204 "../src/chess-engine.vala"
		n_read = _tmp4_;
#line 204 "../src/chess-engine.vala"
		_tmp2_ = _tmp5_;
#line 204 "../src/chess-engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1101 "chess-engine.c"
			gboolean _tmp6_ = FALSE;
#line 204 "../src/chess-engine.vala"
			if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 1105 "chess-engine.c"
				goto __catch5_g_convert_error;
			}
#line 204 "../src/chess-engine.vala"
			if (_inner_error0_->domain == G_IO_CHANNEL_ERROR) {
#line 1110 "chess-engine.c"
				goto __catch5_g_io_channel_error;
			}
#line 204 "../src/chess-engine.vala"
			buf = (g_free (buf), NULL);
#line 204 "../src/chess-engine.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 204 "../src/chess-engine.vala"
			g_clear_error (&_inner_error0_);
#line 204 "../src/chess-engine.vala"
			return _tmp6_;
#line 1121 "chess-engine.c"
		}
#line 204 "../src/chess-engine.vala"
		status = _tmp2_;
#line 1125 "chess-engine.c"
	}
	goto __finally5;
	__catch5_g_convert_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 202 "../src/chess-engine.vala"
		e = _inner_error0_;
#line 202 "../src/chess-engine.vala"
		_inner_error0_ = NULL;
#line 208 "../src/chess-engine.vala"
		_tmp7_ = e;
#line 208 "../src/chess-engine.vala"
		_tmp8_ = _tmp7_->message;
#line 208 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:208: Failed to read from engine: %s", _tmp8_);
#line 209 "../src/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 210 "../src/chess-engine.vala"
		result = FALSE;
#line 210 "../src/chess-engine.vala"
		_g_error_free0 (e);
#line 210 "../src/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 210 "../src/chess-engine.vala"
		return result;
#line 1153 "chess-engine.c"
	}
	goto __finally5;
	__catch5_g_io_channel_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 202 "../src/chess-engine.vala"
		e = _inner_error0_;
#line 202 "../src/chess-engine.vala"
		_inner_error0_ = NULL;
#line 214 "../src/chess-engine.vala"
		_tmp9_ = e;
#line 214 "../src/chess-engine.vala"
		_tmp10_ = _tmp9_->message;
#line 214 "../src/chess-engine.vala"
		g_warning ("chess-engine.vala:214: Failed to read from engine: %s", _tmp10_);
#line 215 "../src/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 216 "../src/chess-engine.vala"
		result = FALSE;
#line 216 "../src/chess-engine.vala"
		_g_error_free0 (e);
#line 216 "../src/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 216 "../src/chess-engine.vala"
		return result;
#line 1181 "chess-engine.c"
	}
	__finally5:
#line 202 "../src/chess-engine.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1186 "chess-engine.c"
		gboolean _tmp11_ = FALSE;
#line 202 "../src/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 202 "../src/chess-engine.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "../src/chess-engine.vala"
		g_clear_error (&_inner_error0_);
#line 202 "../src/chess-engine.vala"
		return _tmp11_;
#line 1196 "chess-engine.c"
	}
#line 219 "../src/chess-engine.vala"
	_tmp12_ = status;
#line 219 "../src/chess-engine.vala"
	if (_tmp12_ == G_IO_STATUS_EOF) {
#line 221 "../src/chess-engine.vala"
		g_debug ("chess-engine.vala:221: EOF");
#line 222 "../src/chess-engine.vala"
		self->priv->stdout_watch_id = (guint) 0;
#line 223 "../src/chess-engine.vala"
		result = FALSE;
#line 223 "../src/chess-engine.vala"
		buf = (g_free (buf), NULL);
#line 223 "../src/chess-engine.vala"
		return result;
#line 1212 "chess-engine.c"
	}
#line 225 "../src/chess-engine.vala"
	_tmp13_ = status;
#line 225 "../src/chess-engine.vala"
	if (_tmp13_ == G_IO_STATUS_NORMAL) {
#line 1218 "chess-engine.c"
		gsize _tmp14_;
		gint _tmp15_;
		gchar* _tmp16_;
		gint _tmp16__length1;
#line 227 "../src/chess-engine.vala"
		_tmp14_ = n_read;
#line 227 "../src/chess-engine.vala"
		_tmp15_ = (gint) _tmp14_;
#line 227 "../src/chess-engine.vala"
		buf = g_renew (gchar, buf, (gint) _tmp14_);
#line 227 "../src/chess-engine.vala"
		(_tmp15_ > buf_length1) ? memset (buf + buf_length1, 0, sizeof (gchar) * (_tmp15_ - buf_length1)) : NULL;
#line 227 "../src/chess-engine.vala"
		buf_length1 = _tmp15_;
#line 227 "../src/chess-engine.vala"
		_buf_size_ = _tmp15_;
#line 228 "../src/chess-engine.vala"
		_tmp16_ = buf;
#line 228 "../src/chess-engine.vala"
		_tmp16__length1 = buf_length1;
#line 228 "../src/chess-engine.vala"
		chess_engine_process_input (self, _tmp16_, _tmp16__length1);
#line 1241 "chess-engine.c"
	}
#line 231 "../src/chess-engine.vala"
	result = TRUE;
#line 231 "../src/chess-engine.vala"
	buf = (g_free (buf), NULL);
#line 231 "../src/chess-engine.vala"
	return result;
#line 1249 "chess-engine.c"
}


void
chess_engine_write (ChessEngine* self,
                    gchar* data,
                    int data_length1)
{
	gsize offset = 0UL;
	gsize n_written = 0UL;
#line 234 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/chess-engine.vala"
	offset = (gsize) 0;
#line 237 "../src/chess-engine.vala"
	n_written = (gsize) 0;
#line 1266 "chess-engine.c"
	{
		gboolean _tmp0_ = FALSE;
#line 239 "../src/chess-engine.vala"
		_tmp0_ = TRUE;
#line 239 "../src/chess-engine.vala"
		while (TRUE) {
#line 1273 "chess-engine.c"
			gint _tmp4_;
			gsize _tmp5_;
			gsize _tmp6_;
			gsize _tmp7_;
			gsize _tmp8_;
#line 239 "../src/chess-engine.vala"
			if (!_tmp0_) {
#line 1281 "chess-engine.c"
				gboolean _tmp1_ = FALSE;
				gsize _tmp2_;
#line 243 "../src/chess-engine.vala"
				_tmp2_ = n_written;
#line 243 "../src/chess-engine.vala"
				if (_tmp2_ > ((gsize) 0)) {
#line 1288 "chess-engine.c"
					gsize _tmp3_;
#line 243 "../src/chess-engine.vala"
					_tmp3_ = offset;
#line 243 "../src/chess-engine.vala"
					_tmp1_ = _tmp3_ < ((gsize) data_length1);
#line 1294 "chess-engine.c"
				} else {
#line 243 "../src/chess-engine.vala"
					_tmp1_ = FALSE;
#line 1298 "chess-engine.c"
				}
#line 243 "../src/chess-engine.vala"
				if (!_tmp1_) {
#line 243 "../src/chess-engine.vala"
					break;
#line 1304 "chess-engine.c"
				}
			}
#line 239 "../src/chess-engine.vala"
			_tmp0_ = FALSE;
#line 241 "../src/chess-engine.vala"
			_tmp4_ = self->priv->stdin_fd;
#line 241 "../src/chess-engine.vala"
			_tmp5_ = offset;
#line 241 "../src/chess-engine.vala"
			_tmp6_ = offset;
#line 241 "../src/chess-engine.vala"
			n_written = (gsize) write (_tmp4_, &data[_tmp5_], data_length1 - _tmp6_);
#line 242 "../src/chess-engine.vala"
			_tmp7_ = offset;
#line 242 "../src/chess-engine.vala"
			_tmp8_ = n_written;
#line 242 "../src/chess-engine.vala"
			offset = _tmp7_ + _tmp8_;
#line 1323 "chess-engine.c"
		}
	}
}


static gchar*
string_to_utf8 (const gchar* self,
                int* result_length1)
{
	gchar* result = NULL;
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gint _tmp2_;
	gchar* _tmp3_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp4_;
	gchar* _tmp5_;
	gint _tmp5__length1;
	gint _tmp6_;
	gchar* _tmp7_;
	gint _tmp7__length1;
#line 1505 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1506 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1506 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1506 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1507 "glib-2.0.vapi"
	_tmp2_ = string_length;
#line 1507 "glib-2.0.vapi"
	_tmp3_ = g_new0 (gchar, _tmp2_ + 1);
#line 1507 "glib-2.0.vapi"
	_result_ = _tmp3_;
#line 1507 "glib-2.0.vapi"
	_result__length1 = _tmp2_ + 1;
#line 1507 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1508 "glib-2.0.vapi"
	_tmp4_ = _result__length1;
#line 1508 "glib-2.0.vapi"
	_result__length1 = _tmp4_ - 1;
#line 1509 "glib-2.0.vapi"
	_tmp5_ = _result_;
#line 1509 "glib-2.0.vapi"
	_tmp5__length1 = _result__length1;
#line 1509 "glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1509 "glib-2.0.vapi"
	memcpy (_tmp5_, self, (gsize) _tmp6_);
#line 1510 "glib-2.0.vapi"
	_tmp7_ = _result_;
#line 1510 "glib-2.0.vapi"
	_tmp7__length1 = _result__length1;
#line 1510 "glib-2.0.vapi"
	if (result_length1) {
#line 1510 "glib-2.0.vapi"
		*result_length1 = _tmp7__length1;
#line 1386 "chess-engine.c"
	}
#line 1510 "glib-2.0.vapi"
	result = _tmp7_;
#line 1510 "glib-2.0.vapi"
	return result;
#line 1392 "chess-engine.c"
}


void
chess_engine_write_line (ChessEngine* self,
                         const gchar* line)
{
	gchar* l = NULL;
	gchar* _tmp0_;
	gchar* d = NULL;
	const gchar* _tmp1_;
	gint _tmp2_ = 0;
	gchar* _tmp3_;
	gint d_length1;
	gint _d_size_;
	gchar* _tmp4_;
	gint _tmp4__length1;
#line 246 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/chess-engine.vala"
	g_return_if_fail (line != NULL);
#line 248 "../src/chess-engine.vala"
	_tmp0_ = g_strconcat (line, "\n", NULL);
#line 248 "../src/chess-engine.vala"
	l = _tmp0_;
#line 249 "../src/chess-engine.vala"
	g_debug ("chess-engine.vala:249: Writing line to engine: '%s'", line);
#line 250 "../src/chess-engine.vala"
	_tmp1_ = l;
#line 250 "../src/chess-engine.vala"
	_tmp3_ = string_to_utf8 (_tmp1_, &_tmp2_);
#line 250 "../src/chess-engine.vala"
	d = _tmp3_;
#line 250 "../src/chess-engine.vala"
	d_length1 = _tmp2_;
#line 250 "../src/chess-engine.vala"
	_d_size_ = d_length1;
#line 251 "../src/chess-engine.vala"
	_tmp4_ = d;
#line 251 "../src/chess-engine.vala"
	_tmp4__length1 = d_length1;
#line 251 "../src/chess-engine.vala"
	if (_tmp4_ != NULL) {
#line 1436 "chess-engine.c"
		gchar* _tmp5_;
		gint _tmp5__length1;
#line 252 "../src/chess-engine.vala"
		_tmp5_ = d;
#line 252 "../src/chess-engine.vala"
		_tmp5__length1 = d_length1;
#line 252 "../src/chess-engine.vala"
		chess_engine_write (self, _tmp5_, _tmp5__length1);
#line 1445 "chess-engine.c"
	}
#line 246 "../src/chess-engine.vala"
	d = (g_free (d), NULL);
#line 246 "../src/chess-engine.vala"
	_g_free0 (l);
#line 1451 "chess-engine.c"
}


gboolean
chess_engine_get_ready (ChessEngine* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 49 "../src/chess-engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/chess-engine.vala"
	_tmp0_ = self->priv->_ready;
#line 51 "../src/chess-engine.vala"
	result = _tmp0_;
#line 51 "../src/chess-engine.vala"
	return result;
#line 1468 "chess-engine.c"
}


void
chess_engine_set_ready (ChessEngine* self,
                        gboolean value)
{
#line 44 "../src/chess-engine.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/chess-engine.vala"
	self->priv->_ready = value;
#line 47 "../src/chess-engine.vala"
	g_signal_emit (self, chess_engine_signals[CHESS_ENGINE_READY_CHANGED_SIGNAL], 0);
#line 44 "../src/chess-engine.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_engine_properties[CHESS_ENGINE_READY_PROPERTY]);
#line 1484 "chess-engine.c"
}


static void
chess_engine_class_init (ChessEngineClass * klass)
{
#line 14 "../src/chess-engine.vala"
	chess_engine_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/chess-engine.vala"
	g_type_class_adjust_private_offset (klass, &ChessEngine_private_offset);
#line 14 "../src/chess-engine.vala"
	((ChessEngineClass *) klass)->process_input = (void (*) (ChessEngine*, gchar*, int)) chess_engine_real_process_input;
#line 14 "../src/chess-engine.vala"
	((ChessEngineClass *) klass)->start_game = (void (*) (ChessEngine*)) chess_engine_real_start_game;
#line 14 "../src/chess-engine.vala"
	((ChessEngineClass *) klass)->report_move = (void (*) (ChessEngine*, ChessMove*)) chess_engine_real_report_move;
#line 14 "../src/chess-engine.vala"
	((ChessEngineClass *) klass)->do_undo = (void (*) (ChessEngine*)) chess_engine_real_do_undo;
#line 14 "../src/chess-engine.vala"
	((ChessEngineClass *) klass)->request_move = (void (*) (ChessEngine*)) chess_engine_real_request_move;
#line 14 "../src/chess-engine.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_engine_get_property;
#line 14 "../src/chess-engine.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_engine_set_property;
#line 14 "../src/chess-engine.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_engine_finalize;
#line 14 "../src/chess-engine.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_ENGINE_READY_PROPERTY, chess_engine_properties[CHESS_ENGINE_READY_PROPERTY] = g_param_spec_boolean ("ready", "ready", "ready", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_STARTING_SIGNAL] = g_signal_new ("starting", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_READY_CHANGED_SIGNAL] = g_signal_new ("ready-changed", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_RESIGNED_SIGNAL] = g_signal_new ("resigned", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_STOPPED_UNEXPECTEDLY_SIGNAL] = g_signal_new ("stopped-unexpectedly", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_ERROR_SIGNAL] = g_signal_new ("error", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_CLAIM_DRAW_SIGNAL] = g_signal_new ("claim-draw", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 14 "../src/chess-engine.vala"
	chess_engine_signals[CHESS_ENGINE_OFFER_DRAW_SIGNAL] = g_signal_new ("offer-draw", TYPE_CHESS_ENGINE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1529 "chess-engine.c"
}


static void
chess_engine_instance_init (ChessEngine * self)
{
#line 14 "../src/chess-engine.vala"
	self->priv = chess_engine_get_instance_private (self);
#line 22 "../src/chess-engine.vala"
	self->priv->pid = (GPid) 0;
#line 23 "../src/chess-engine.vala"
	self->priv->stdin_fd = -1;
#line 24 "../src/chess-engine.vala"
	self->priv->stderr_fd = -1;
#line 26 "../src/chess-engine.vala"
	self->priv->child_watch_id = (guint) 0;
#line 27 "../src/chess-engine.vala"
	self->priv->stdout_watch_id = (guint) 0;
#line 28 "../src/chess-engine.vala"
	self->priv->started = FALSE;
#line 41 "../src/chess-engine.vala"
	self->priv->_ready = FALSE;
#line 1552 "chess-engine.c"
}


static void
chess_engine_finalize (GObject * obj)
{
	ChessEngine * self;
	gboolean _tmp0_;
#line 14 "../src/chess-engine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_ENGINE, ChessEngine);
#line 64 "../src/chess-engine.vala"
	_tmp0_ = self->priv->started;
#line 64 "../src/chess-engine.vala"
	_vala_assert (!_tmp0_, "!started");
#line 16 "../src/chess-engine.vala"
	_g_free0 (self->priv->binary);
#line 17 "../src/chess-engine.vala"
	self->priv->args = (_vala_array_free (self->priv->args, self->priv->args_length1, (GDestroyNotify) g_free), NULL);
#line 25 "../src/chess-engine.vala"
	_g_io_channel_unref0 (self->priv->stdout_channel);
#line 14 "../src/chess-engine.vala"
	G_OBJECT_CLASS (chess_engine_parent_class)->finalize (obj);
#line 1575 "chess-engine.c"
}


GType
chess_engine_get_type (void)
{
	static volatile gsize chess_engine_type_id__volatile = 0;
	if (g_once_init_enter (&chess_engine_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessEngineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_engine_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessEngine), 0, (GInstanceInitFunc) chess_engine_instance_init, NULL };
		GType chess_engine_type_id;
		chess_engine_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessEngine", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		ChessEngine_private_offset = g_type_add_instance_private (chess_engine_type_id, sizeof (ChessEnginePrivate));
		g_once_init_leave (&chess_engine_type_id__volatile, chess_engine_type_id);
	}
	return chess_engine_type_id__volatile;
}


static void
_vala_chess_engine_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ChessEngine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_ENGINE, ChessEngine);
#line 14 "../src/chess-engine.vala"
	switch (property_id) {
#line 14 "../src/chess-engine.vala"
		case CHESS_ENGINE_READY_PROPERTY:
#line 14 "../src/chess-engine.vala"
		g_value_set_boolean (value, chess_engine_get_ready (self));
#line 14 "../src/chess-engine.vala"
		break;
#line 1610 "chess-engine.c"
		default:
#line 14 "../src/chess-engine.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/chess-engine.vala"
		break;
#line 1616 "chess-engine.c"
	}
}


static void
_vala_chess_engine_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ChessEngine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_ENGINE, ChessEngine);
#line 14 "../src/chess-engine.vala"
	switch (property_id) {
#line 14 "../src/chess-engine.vala"
		case CHESS_ENGINE_READY_PROPERTY:
#line 14 "../src/chess-engine.vala"
		chess_engine_set_ready (self, g_value_get_boolean (value));
#line 14 "../src/chess-engine.vala"
		break;
#line 1637 "chess-engine.c"
		default:
#line 14 "../src/chess-engine.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/chess-engine.vala"
		break;
#line 1643 "chess-engine.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



