/* chess-scene.c generated by valac 0.42.6, the Vala compiler
 * generated from chess-scene.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include "libchess.h"
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_CHESS_MODEL (chess_model_get_type ())
#define CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MODEL, ChessModel))
#define CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MODEL, ChessModelClass))
#define IS_CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MODEL))
#define IS_CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MODEL))
#define CHESS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MODEL, ChessModelClass))

typedef struct _ChessModel ChessModel;
typedef struct _ChessModelClass ChessModelClass;
typedef struct _ChessModelPrivate ChessModelPrivate;
enum  {
	CHESS_MODEL_0_PROPERTY,
	CHESS_MODEL_MOVING_PROPERTY,
	CHESS_MODEL_NUM_PROPERTIES
};
static GParamSpec* chess_model_properties[CHESS_MODEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
typedef struct _ChessScenePrivate ChessScenePrivate;
enum  {
	CHESS_SCENE_0_PROPERTY,
	CHESS_SCENE_GAME_PROPERTY,
	CHESS_SCENE_MOVE_NUMBER_PROPERTY,
	CHESS_SCENE_SHOW_NUMBERING_PROPERTY,
	CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY,
	CHESS_SCENE_THEME_NAME_PROPERTY,
	CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY,
	CHESS_SCENE_BOARD_SIDE_PROPERTY,
	CHESS_SCENE_BOARD_ANGLE_PROPERTY,
	CHESS_SCENE_MOVE_FORMAT_PROPERTY,
	CHESS_SCENE_NUM_PROPERTIES
};
static GParamSpec* chess_scene_properties[CHESS_SCENE_NUM_PROPERTIES];
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	CHESS_SCENE_IS_HUMAN_SIGNAL,
	CHESS_SCENE_CHOOSE_PROMOTION_TYPE_SIGNAL,
	CHESS_SCENE_CHANGED_SIGNAL,
	CHESS_SCENE_NUM_SIGNALS
};
static guint chess_scene_signals[CHESS_SCENE_NUM_SIGNALS] = {0};

struct _ChessModel {
	GObject parent_instance;
	ChessModelPrivate * priv;
	ChessPiece* piece;
	gdouble x;
	gdouble y;
	gdouble target_x;
	gdouble target_y;
	gboolean under_threat;
	gboolean is_selected;
};

struct _ChessModelClass {
	GObjectClass parent_class;
};

struct _ChessScene {
	GObject parent_instance;
	ChessScenePrivate * priv;
	GList* pieces;
	gboolean animating;
	gint selected_rank;
	gint selected_file;
};

struct _ChessSceneClass {
	GObjectClass parent_class;
};

struct _ChessScenePrivate {
	gboolean _can_move[64];
	GTimer* animation_timer;
	gdouble animation_time;
	guint animate_timeout_id;
	ChessGame* _game;
	gint _move_number;
	gboolean _show_numbering;
	gboolean _show_move_hints;
	gchar* _theme_name;
	gboolean _show_3d_smooth;
	gchar* _board_side;
	gchar* _move_format;
};


static gpointer chess_model_parent_class = NULL;
static gint ChessScene_private_offset;
static gpointer chess_scene_parent_class = NULL;

GType chess_model_get_type (void) G_GNUC_CONST;
ChessModel* chess_model_new (ChessPiece* piece,
                             gdouble x,
                             gdouble y);
ChessModel* chess_model_construct (GType object_type,
                                   ChessPiece* piece,
                                   gdouble x,
                                   gdouble y);
gboolean chess_model_move_to (ChessModel* self,
                              gdouble x,
                              gdouble y);
gboolean chess_model_animate (ChessModel* self,
                              gdouble timestep);
gboolean chess_model_get_moving (ChessModel* self);
static gdouble chess_model_update_position (ChessModel* self,
                                     gdouble timestep,
                                     gdouble value,
                                     gdouble target);
static void chess_model_finalize (GObject * obj);
static void _vala_chess_model_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
GType chess_scene_get_type (void) G_GNUC_CONST;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
ChessPiece* chess_scene_get_selected_piece (ChessScene* self);
ChessGame* chess_scene_get_game (ChessScene* self);
gint chess_scene_get_move_number (ChessScene* self);
ChessScene* chess_scene_new (void);
ChessScene* chess_scene_construct (GType object_type);
void chess_scene_select_square (ChessScene* self,
                                gint file,
                                gint rank);
static void chess_scene_update_board (ChessScene* self);
static void chess_scene_moved_cb (ChessScene* self,
                           ChessGame* game,
                           ChessMove* move);
static void chess_scene_paused_cb (ChessScene* self,
                            ChessGame* game);
static void chess_scene_unpaused_cb (ChessScene* self,
                              ChessGame* game);
static void chess_scene_undo_cb (ChessScene* self,
                          ChessGame* game);
static ChessModel* chess_scene_find_model (ChessScene* self,
                                    ChessPiece* piece);
static gboolean chess_scene_animate_cb (ChessScene* self);
static gboolean _chess_scene_animate_cb_gsource_func (gpointer self);
gboolean chess_scene_can_move (ChessScene* self,
                               gint rank,
                               gint file);
void chess_scene_set_game (ChessScene* self,
                           ChessGame* value);
static void _chess_scene_moved_cb_chess_game_moved (ChessGame* _sender,
                                             ChessMove* move,
                                             gpointer self);
static void _chess_scene_paused_cb_chess_game_paused (ChessGame* _sender,
                                               gpointer self);
static void _chess_scene_unpaused_cb_chess_game_unpaused (ChessGame* _sender,
                                                   gpointer self);
static void _chess_scene_undo_cb_chess_game_undo (ChessGame* _sender,
                                           gpointer self);
void chess_scene_set_move_number (ChessScene* self,
                                  gint value);
gboolean chess_scene_get_show_numbering (ChessScene* self);
void chess_scene_set_show_numbering (ChessScene* self,
                                     gboolean value);
gboolean chess_scene_get_show_move_hints (ChessScene* self);
void chess_scene_set_show_move_hints (ChessScene* self,
                                      gboolean value);
const gchar* chess_scene_get_theme_name (ChessScene* self);
void chess_scene_set_theme_name (ChessScene* self,
                                 const gchar* value);
gboolean chess_scene_get_show_3d_smooth (ChessScene* self);
void chess_scene_set_show_3d_smooth (ChessScene* self,
                                     gboolean value);
const gchar* chess_scene_get_board_side (ChessScene* self);
void chess_scene_set_board_side (ChessScene* self,
                                 const gchar* value);
gdouble chess_scene_get_board_angle (ChessScene* self);
const gchar* chess_scene_get_move_format (ChessScene* self);
void chess_scene_set_move_format (ChessScene* self,
                                  const gchar* value);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void g_cclosure_user_marshal_POINTER__VOID (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void chess_scene_finalize (GObject * obj);
static void _vala_chess_scene_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_chess_scene_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);


static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/chess-scene.vala"
	return self ? g_object_ref (self) : NULL;
#line 239 "chess-scene.c"
}


ChessModel*
chess_model_construct (GType object_type,
                       ChessPiece* piece,
                       gdouble x,
                       gdouble y)
{
	ChessModel * self = NULL;
	ChessPiece* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 28 "../src/chess-scene.vala"
	g_return_val_if_fail (piece != NULL, NULL);
#line 28 "../src/chess-scene.vala"
	self = (ChessModel*) g_object_new (object_type, NULL);
#line 30 "../src/chess-scene.vala"
	_tmp0_ = _g_object_ref0 (piece);
#line 30 "../src/chess-scene.vala"
	_g_object_unref0 (self->piece);
#line 30 "../src/chess-scene.vala"
	self->piece = _tmp0_;
#line 31 "../src/chess-scene.vala"
	self->target_x = x;
#line 31 "../src/chess-scene.vala"
	_tmp1_ = self->target_x;
#line 31 "../src/chess-scene.vala"
	self->x = _tmp1_;
#line 32 "../src/chess-scene.vala"
	self->target_y = y;
#line 32 "../src/chess-scene.vala"
	_tmp2_ = self->target_y;
#line 32 "../src/chess-scene.vala"
	self->y = _tmp2_;
#line 28 "../src/chess-scene.vala"
	return self;
#line 277 "chess-scene.c"
}


ChessModel*
chess_model_new (ChessPiece* piece,
                 gdouble x,
                 gdouble y)
{
#line 28 "../src/chess-scene.vala"
	return chess_model_construct (TYPE_CHESS_MODEL, piece, x, y);
#line 288 "chess-scene.c"
}


gboolean
chess_model_move_to (ChessModel* self,
                     gdouble x,
                     gdouble y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
#line 35 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "../src/chess-scene.vala"
	_tmp1_ = self->target_x;
#line 37 "../src/chess-scene.vala"
	if (_tmp1_ == x) {
#line 306 "chess-scene.c"
		gdouble _tmp2_;
#line 37 "../src/chess-scene.vala"
		_tmp2_ = self->target_y;
#line 37 "../src/chess-scene.vala"
		_tmp0_ = _tmp2_ == y;
#line 312 "chess-scene.c"
	} else {
#line 37 "../src/chess-scene.vala"
		_tmp0_ = FALSE;
#line 316 "chess-scene.c"
	}
#line 37 "../src/chess-scene.vala"
	if (_tmp0_) {
#line 38 "../src/chess-scene.vala"
		result = FALSE;
#line 38 "../src/chess-scene.vala"
		return result;
#line 324 "chess-scene.c"
	}
#line 40 "../src/chess-scene.vala"
	self->target_x = x;
#line 41 "../src/chess-scene.vala"
	self->target_y = y;
#line 43 "../src/chess-scene.vala"
	result = TRUE;
#line 43 "../src/chess-scene.vala"
	return result;
#line 334 "chess-scene.c"
}


gboolean
chess_model_animate (ChessModel* self,
                     gdouble timestep)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 46 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/chess-scene.vala"
	_tmp0_ = chess_model_get_moving (self);
#line 48 "../src/chess-scene.vala"
	_tmp1_ = _tmp0_;
#line 48 "../src/chess-scene.vala"
	if (!_tmp1_) {
#line 49 "../src/chess-scene.vala"
		result = FALSE;
#line 49 "../src/chess-scene.vala"
		return result;
#line 361 "chess-scene.c"
	}
#line 51 "../src/chess-scene.vala"
	_tmp2_ = self->x;
#line 51 "../src/chess-scene.vala"
	_tmp3_ = self->target_x;
#line 51 "../src/chess-scene.vala"
	self->x = chess_model_update_position (self, timestep, _tmp2_, _tmp3_);
#line 52 "../src/chess-scene.vala"
	_tmp4_ = self->y;
#line 52 "../src/chess-scene.vala"
	_tmp5_ = self->target_y;
#line 52 "../src/chess-scene.vala"
	self->y = chess_model_update_position (self, timestep, _tmp4_, _tmp5_);
#line 53 "../src/chess-scene.vala"
	result = TRUE;
#line 53 "../src/chess-scene.vala"
	return result;
#line 379 "chess-scene.c"
}


static gdouble
chess_model_update_position (ChessModel* self,
                             gdouble timestep,
                             gdouble value,
                             gdouble target)
{
	gdouble result = 0.0;
	gdouble distance = 0.0;
	gdouble step = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 56 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 58 "../src/chess-scene.vala"
	distance = fabs (target - value);
#line 59 "../src/chess-scene.vala"
	step = timestep * 4.0;
#line 61 "../src/chess-scene.vala"
	_tmp0_ = step;
#line 61 "../src/chess-scene.vala"
	_tmp1_ = distance;
#line 61 "../src/chess-scene.vala"
	if (_tmp0_ > _tmp1_) {
#line 406 "chess-scene.c"
		gdouble _tmp2_;
#line 62 "../src/chess-scene.vala"
		_tmp2_ = distance;
#line 62 "../src/chess-scene.vala"
		step = _tmp2_;
#line 412 "chess-scene.c"
	}
#line 64 "../src/chess-scene.vala"
	if (target > value) {
#line 416 "chess-scene.c"
		gdouble _tmp3_;
#line 65 "../src/chess-scene.vala"
		_tmp3_ = step;
#line 65 "../src/chess-scene.vala"
		result = value + _tmp3_;
#line 65 "../src/chess-scene.vala"
		return result;
#line 424 "chess-scene.c"
	} else {
		gdouble _tmp4_;
#line 67 "../src/chess-scene.vala"
		_tmp4_ = step;
#line 67 "../src/chess-scene.vala"
		result = value - _tmp4_;
#line 67 "../src/chess-scene.vala"
		return result;
#line 433 "chess-scene.c"
	}
}


gboolean
chess_model_get_moving (ChessModel* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 25 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/chess-scene.vala"
	_tmp1_ = self->x;
#line 25 "../src/chess-scene.vala"
	_tmp2_ = self->target_x;
#line 25 "../src/chess-scene.vala"
	if (_tmp1_ != _tmp2_) {
#line 25 "../src/chess-scene.vala"
		_tmp0_ = TRUE;
#line 455 "chess-scene.c"
	} else {
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 25 "../src/chess-scene.vala"
		_tmp3_ = self->y;
#line 25 "../src/chess-scene.vala"
		_tmp4_ = self->target_y;
#line 25 "../src/chess-scene.vala"
		_tmp0_ = _tmp3_ != _tmp4_;
#line 465 "chess-scene.c"
	}
#line 25 "../src/chess-scene.vala"
	result = _tmp0_;
#line 25 "../src/chess-scene.vala"
	return result;
#line 471 "chess-scene.c"
}


static void
chess_model_class_init (ChessModelClass * klass)
{
#line 13 "../src/chess-scene.vala"
	chess_model_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/chess-scene.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_model_get_property;
#line 13 "../src/chess-scene.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_model_finalize;
#line 13 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_MODEL_MOVING_PROPERTY, chess_model_properties[CHESS_MODEL_MOVING_PROPERTY] = g_param_spec_boolean ("moving", "moving", "moving", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 486 "chess-scene.c"
}


static void
chess_model_instance_init (ChessModel * self)
{
}


static void
chess_model_finalize (GObject * obj)
{
	ChessModel * self;
#line 13 "../src/chess-scene.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_MODEL, ChessModel);
#line 15 "../src/chess-scene.vala"
	_g_object_unref0 (self->piece);
#line 13 "../src/chess-scene.vala"
	G_OBJECT_CLASS (chess_model_parent_class)->finalize (obj);
#line 506 "chess-scene.c"
}


GType
chess_model_get_type (void)
{
	static volatile gsize chess_model_type_id__volatile = 0;
	if (g_once_init_enter (&chess_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessModel), 0, (GInstanceInitFunc) chess_model_instance_init, NULL };
		GType chess_model_type_id;
		chess_model_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessModel", &g_define_type_info, 0);
		g_once_init_leave (&chess_model_type_id__volatile, chess_model_type_id);
	}
	return chess_model_type_id__volatile;
}


static void
_vala_chess_model_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_MODEL, ChessModel);
#line 13 "../src/chess-scene.vala"
	switch (property_id) {
#line 13 "../src/chess-scene.vala"
		case CHESS_MODEL_MOVING_PROPERTY:
#line 13 "../src/chess-scene.vala"
		g_value_set_boolean (value, chess_model_get_moving (self));
#line 13 "../src/chess-scene.vala"
		break;
#line 540 "chess-scene.c"
		default:
#line 13 "../src/chess-scene.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/chess-scene.vala"
		break;
#line 546 "chess-scene.c"
	}
}


static inline gpointer
chess_scene_get_instance_private (ChessScene* self)
{
	return G_STRUCT_MEMBER_P (self, ChessScene_private_offset);
}


static void
_g_object_unref0_ (gpointer var)
{
#line 73 "../src/chess-scene.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 563 "chess-scene.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 73 "../src/chess-scene.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 572 "chess-scene.c"
}


ChessPiece*
chess_scene_get_selected_piece (ChessScene* self)
{
	ChessPiece* result = NULL;
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp4_;
	ChessGame* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	ChessPiece* _tmp10_;
#line 113 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "../src/chess-scene.vala"
	_tmp1_ = chess_scene_get_game (self);
#line 115 "../src/chess-scene.vala"
	_tmp2_ = _tmp1_;
#line 115 "../src/chess-scene.vala"
	if (_tmp2_ == NULL) {
#line 115 "../src/chess-scene.vala"
		_tmp0_ = TRUE;
#line 600 "chess-scene.c"
	} else {
		gint _tmp3_;
#line 115 "../src/chess-scene.vala"
		_tmp3_ = self->selected_rank;
#line 115 "../src/chess-scene.vala"
		_tmp0_ = _tmp3_ < 0;
#line 607 "chess-scene.c"
	}
#line 115 "../src/chess-scene.vala"
	if (_tmp0_) {
#line 116 "../src/chess-scene.vala"
		result = NULL;
#line 116 "../src/chess-scene.vala"
		return result;
#line 615 "chess-scene.c"
	}
#line 117 "../src/chess-scene.vala"
	_tmp4_ = chess_scene_get_game (self);
#line 117 "../src/chess-scene.vala"
	_tmp5_ = _tmp4_;
#line 117 "../src/chess-scene.vala"
	_tmp6_ = self->selected_rank;
#line 117 "../src/chess-scene.vala"
	_tmp7_ = self->selected_file;
#line 117 "../src/chess-scene.vala"
	_tmp8_ = chess_scene_get_move_number (self);
#line 117 "../src/chess-scene.vala"
	_tmp9_ = _tmp8_;
#line 117 "../src/chess-scene.vala"
	_tmp10_ = chess_game_get_piece (_tmp5_, _tmp6_, _tmp7_, _tmp9_);
#line 117 "../src/chess-scene.vala"
	result = _tmp10_;
#line 117 "../src/chess-scene.vala"
	return result;
#line 635 "chess-scene.c"
}


ChessScene*
chess_scene_construct (GType object_type)
{
	ChessScene * self = NULL;
	GTimer* _tmp0_;
#line 197 "../src/chess-scene.vala"
	self = (ChessScene*) g_object_new (object_type, NULL);
#line 199 "../src/chess-scene.vala"
	_tmp0_ = g_timer_new ();
#line 199 "../src/chess-scene.vala"
	_g_timer_destroy0 (self->priv->animation_timer);
#line 199 "../src/chess-scene.vala"
	self->priv->animation_timer = _tmp0_;
#line 197 "../src/chess-scene.vala"
	return self;
#line 654 "chess-scene.c"
}


ChessScene*
chess_scene_new (void)
{
#line 197 "../src/chess-scene.vala"
	return chess_scene_construct (TYPE_CHESS_SCENE);
#line 663 "chess-scene.c"
}


void
chess_scene_select_square (ChessScene* self,
                           gint file,
                           gint rank)
{
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	ChessGame* _tmp2_;
	gint _tmp9_;
	gint _tmp10_;
	ChessPiece* piece = NULL;
	ChessGame* _tmp11_;
	ChessGame* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	ChessPiece* _tmp15_;
	gboolean _tmp16_ = FALSE;
	gint _tmp17_;
#line 202 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/chess-scene.vala"
	_tmp1_ = chess_scene_get_game (self);
#line 204 "../src/chess-scene.vala"
	_tmp2_ = _tmp1_;
#line 204 "../src/chess-scene.vala"
	if (_tmp2_ == NULL) {
#line 204 "../src/chess-scene.vala"
		_tmp0_ = TRUE;
#line 695 "chess-scene.c"
	} else {
		ChessGame* _tmp3_;
		ChessGame* _tmp4_;
		ChessPlayer* _tmp5_;
		ChessPlayer* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 204 "../src/chess-scene.vala"
		_tmp3_ = chess_scene_get_game (self);
#line 204 "../src/chess-scene.vala"
		_tmp4_ = _tmp3_;
#line 204 "../src/chess-scene.vala"
		_tmp5_ = chess_game_get_current_player (_tmp4_);
#line 204 "../src/chess-scene.vala"
		_tmp6_ = _tmp5_;
#line 204 "../src/chess-scene.vala"
		_tmp7_ = chess_player_get_local_human (_tmp6_);
#line 204 "../src/chess-scene.vala"
		_tmp8_ = _tmp7_;
#line 204 "../src/chess-scene.vala"
		_tmp0_ = !_tmp8_;
#line 717 "chess-scene.c"
	}
#line 204 "../src/chess-scene.vala"
	if (_tmp0_) {
#line 205 "../src/chess-scene.vala"
		return;
#line 723 "chess-scene.c"
	}
#line 208 "../src/chess-scene.vala"
	_tmp9_ = chess_scene_get_move_number (self);
#line 208 "../src/chess-scene.vala"
	_tmp10_ = _tmp9_;
#line 208 "../src/chess-scene.vala"
	if (_tmp10_ != -1) {
#line 209 "../src/chess-scene.vala"
		return;
#line 733 "chess-scene.c"
	}
#line 211 "../src/chess-scene.vala"
	_tmp11_ = chess_scene_get_game (self);
#line 211 "../src/chess-scene.vala"
	_tmp12_ = _tmp11_;
#line 211 "../src/chess-scene.vala"
	_tmp13_ = chess_scene_get_move_number (self);
#line 211 "../src/chess-scene.vala"
	_tmp14_ = _tmp13_;
#line 211 "../src/chess-scene.vala"
	_tmp15_ = chess_game_get_piece (_tmp12_, rank, file, _tmp14_);
#line 211 "../src/chess-scene.vala"
	piece = _tmp15_;
#line 214 "../src/chess-scene.vala"
	_tmp17_ = self->selected_file;
#line 214 "../src/chess-scene.vala"
	if (file == _tmp17_) {
#line 751 "chess-scene.c"
		gint _tmp18_;
#line 214 "../src/chess-scene.vala"
		_tmp18_ = self->selected_rank;
#line 214 "../src/chess-scene.vala"
		_tmp16_ = rank == _tmp18_;
#line 757 "chess-scene.c"
	} else {
#line 214 "../src/chess-scene.vala"
		_tmp16_ = FALSE;
#line 761 "chess-scene.c"
	}
#line 214 "../src/chess-scene.vala"
	if (_tmp16_) {
#line 765 "chess-scene.c"
		gint _tmp19_;
#line 216 "../src/chess-scene.vala"
		self->selected_file = -1;
#line 216 "../src/chess-scene.vala"
		_tmp19_ = self->selected_file;
#line 216 "../src/chess-scene.vala"
		self->selected_rank = _tmp19_;
#line 773 "chess-scene.c"
	} else {
		gboolean _tmp20_ = FALSE;
		ChessPiece* _tmp21_;
#line 219 "../src/chess-scene.vala"
		_tmp21_ = piece;
#line 219 "../src/chess-scene.vala"
		if (_tmp21_ != NULL) {
#line 781 "chess-scene.c"
			ChessPiece* _tmp22_;
			ChessPlayer* _tmp23_;
			ChessGame* _tmp24_;
			ChessGame* _tmp25_;
			ChessPlayer* _tmp26_;
			ChessPlayer* _tmp27_;
#line 219 "../src/chess-scene.vala"
			_tmp22_ = piece;
#line 219 "../src/chess-scene.vala"
			_tmp23_ = _tmp22_->player;
#line 219 "../src/chess-scene.vala"
			_tmp24_ = chess_scene_get_game (self);
#line 219 "../src/chess-scene.vala"
			_tmp25_ = _tmp24_;
#line 219 "../src/chess-scene.vala"
			_tmp26_ = chess_game_get_current_player (_tmp25_);
#line 219 "../src/chess-scene.vala"
			_tmp27_ = _tmp26_;
#line 219 "../src/chess-scene.vala"
			_tmp20_ = _tmp23_ == _tmp27_;
#line 802 "chess-scene.c"
		} else {
#line 219 "../src/chess-scene.vala"
			_tmp20_ = FALSE;
#line 806 "chess-scene.c"
		}
#line 219 "../src/chess-scene.vala"
		if (_tmp20_) {
#line 221 "../src/chess-scene.vala"
			self->selected_rank = rank;
#line 222 "../src/chess-scene.vala"
			self->selected_file = file;
#line 814 "chess-scene.c"
		} else {
			gint _tmp28_;
#line 225 "../src/chess-scene.vala"
			_tmp28_ = self->selected_file;
#line 225 "../src/chess-scene.vala"
			if (_tmp28_ != -1) {
#line 821 "chess-scene.c"
				gboolean can_move = FALSE;
				ChessGame* _tmp29_;
				ChessGame* _tmp30_;
				ChessPlayer* _tmp31_;
				ChessPlayer* _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_ = FALSE;
				gboolean _tmp37_;
				gboolean _tmp52_ = FALSE;
				gint _tmp53_;
#line 227 "../src/chess-scene.vala"
				_tmp29_ = chess_scene_get_game (self);
#line 227 "../src/chess-scene.vala"
				_tmp30_ = _tmp29_;
#line 227 "../src/chess-scene.vala"
				_tmp31_ = chess_game_get_current_player (_tmp30_);
#line 227 "../src/chess-scene.vala"
				_tmp32_ = _tmp31_;
#line 227 "../src/chess-scene.vala"
				_tmp33_ = self->selected_rank;
#line 227 "../src/chess-scene.vala"
				_tmp34_ = self->selected_file;
#line 227 "../src/chess-scene.vala"
				can_move = chess_player_move_with_coords (_tmp32_, _tmp33_, _tmp34_, rank, file, FALSE, PIECE_TYPE_QUEEN);
#line 229 "../src/chess-scene.vala"
				_tmp37_ = can_move;
#line 229 "../src/chess-scene.vala"
				if (_tmp37_) {
#line 852 "chess-scene.c"
					ChessPiece* _tmp38_;
					ChessPiece* _tmp39_;
					PieceType _tmp40_;
#line 229 "../src/chess-scene.vala"
					_tmp38_ = chess_scene_get_selected_piece (self);
#line 229 "../src/chess-scene.vala"
					_tmp39_ = _tmp38_;
#line 229 "../src/chess-scene.vala"
					_tmp40_ = _tmp39_->type;
#line 229 "../src/chess-scene.vala"
					_tmp36_ = _tmp40_ == PIECE_TYPE_PAWN;
#line 229 "../src/chess-scene.vala"
					_g_object_unref0 (_tmp39_);
#line 866 "chess-scene.c"
				} else {
#line 229 "../src/chess-scene.vala"
					_tmp36_ = FALSE;
#line 870 "chess-scene.c"
				}
#line 229 "../src/chess-scene.vala"
				if (_tmp36_) {
#line 874 "chess-scene.c"
					gboolean _tmp41_ = FALSE;
#line 230 "../src/chess-scene.vala"
					if (rank == 0) {
#line 230 "../src/chess-scene.vala"
						_tmp41_ = TRUE;
#line 880 "chess-scene.c"
					} else {
#line 230 "../src/chess-scene.vala"
						_tmp41_ = rank == 7;
#line 884 "chess-scene.c"
					}
#line 230 "../src/chess-scene.vala"
					_tmp35_ = _tmp41_;
#line 888 "chess-scene.c"
				} else {
#line 229 "../src/chess-scene.vala"
					_tmp35_ = FALSE;
#line 892 "chess-scene.c"
				}
#line 229 "../src/chess-scene.vala"
				if (_tmp35_) {
#line 896 "chess-scene.c"
					PieceType* promotion_selection = NULL;
					PieceType* _tmp42_ = NULL;
					PieceType* _tmp43_;
					ChessGame* _tmp44_;
					ChessGame* _tmp45_;
					ChessPlayer* _tmp46_;
					ChessPlayer* _tmp47_;
					gint _tmp48_;
					gint _tmp49_;
					PieceType* _tmp50_;
					gint _tmp51_;
#line 233 "../src/chess-scene.vala"
					g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHOOSE_PROMOTION_TYPE_SIGNAL], 0, &_tmp42_);
#line 233 "../src/chess-scene.vala"
					promotion_selection = _tmp42_;
#line 236 "../src/chess-scene.vala"
					_tmp43_ = promotion_selection;
#line 236 "../src/chess-scene.vala"
					if (_tmp43_ == NULL) {
#line 237 "../src/chess-scene.vala"
						_g_free0 (promotion_selection);
#line 237 "../src/chess-scene.vala"
						_g_object_unref0 (piece);
#line 237 "../src/chess-scene.vala"
						return;
#line 922 "chess-scene.c"
					}
#line 239 "../src/chess-scene.vala"
					_tmp44_ = chess_scene_get_game (self);
#line 239 "../src/chess-scene.vala"
					_tmp45_ = _tmp44_;
#line 239 "../src/chess-scene.vala"
					_tmp46_ = chess_game_get_current_player (_tmp45_);
#line 239 "../src/chess-scene.vala"
					_tmp47_ = _tmp46_;
#line 239 "../src/chess-scene.vala"
					_tmp48_ = self->selected_rank;
#line 239 "../src/chess-scene.vala"
					_tmp49_ = self->selected_file;
#line 239 "../src/chess-scene.vala"
					_tmp50_ = promotion_selection;
#line 239 "../src/chess-scene.vala"
					chess_player_move_with_coords (_tmp47_, _tmp48_, _tmp49_, rank, file, TRUE, *_tmp50_);
#line 241 "../src/chess-scene.vala"
					self->selected_file = -1;
#line 241 "../src/chess-scene.vala"
					_tmp51_ = self->selected_file;
#line 241 "../src/chess-scene.vala"
					self->selected_rank = _tmp51_;
#line 229 "../src/chess-scene.vala"
					_g_free0 (promotion_selection);
#line 948 "chess-scene.c"
				}
#line 244 "../src/chess-scene.vala"
				_tmp53_ = self->selected_file;
#line 244 "../src/chess-scene.vala"
				if (_tmp53_ != -1) {
#line 954 "chess-scene.c"
					ChessGame* _tmp54_;
					ChessGame* _tmp55_;
					ChessPlayer* _tmp56_;
					ChessPlayer* _tmp57_;
					gint _tmp58_;
					gint _tmp59_;
#line 245 "../src/chess-scene.vala"
					_tmp54_ = chess_scene_get_game (self);
#line 245 "../src/chess-scene.vala"
					_tmp55_ = _tmp54_;
#line 245 "../src/chess-scene.vala"
					_tmp56_ = chess_game_get_current_player (_tmp55_);
#line 245 "../src/chess-scene.vala"
					_tmp57_ = _tmp56_;
#line 245 "../src/chess-scene.vala"
					_tmp58_ = self->selected_rank;
#line 245 "../src/chess-scene.vala"
					_tmp59_ = self->selected_file;
#line 245 "../src/chess-scene.vala"
					_tmp52_ = chess_player_move_with_coords (_tmp57_, _tmp58_, _tmp59_, rank, file, TRUE, PIECE_TYPE_QUEEN);
#line 975 "chess-scene.c"
				} else {
#line 244 "../src/chess-scene.vala"
					_tmp52_ = FALSE;
#line 979 "chess-scene.c"
				}
#line 244 "../src/chess-scene.vala"
				if (_tmp52_) {
#line 983 "chess-scene.c"
					gint _tmp60_;
#line 246 "../src/chess-scene.vala"
					self->selected_file = -1;
#line 246 "../src/chess-scene.vala"
					_tmp60_ = self->selected_file;
#line 246 "../src/chess-scene.vala"
					self->selected_rank = _tmp60_;
#line 991 "chess-scene.c"
				}
			}
		}
	}
#line 249 "../src/chess-scene.vala"
	chess_scene_update_board (self);
#line 250 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 202 "../src/chess-scene.vala"
	_g_object_unref0 (piece);
#line 1002 "chess-scene.c"
}


static void
chess_scene_moved_cb (ChessScene* self,
                      ChessGame* game,
                      ChessMove* move)
{
#line 253 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/chess-scene.vala"
	g_return_if_fail (game != NULL);
#line 253 "../src/chess-scene.vala"
	g_return_if_fail (move != NULL);
#line 255 "../src/chess-scene.vala"
	chess_scene_update_board (self);
#line 1019 "chess-scene.c"
}


static void
chess_scene_paused_cb (ChessScene* self,
                       ChessGame* game)
{
#line 258 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/chess-scene.vala"
	g_return_if_fail (game != NULL);
#line 260 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 1033 "chess-scene.c"
}


static void
chess_scene_unpaused_cb (ChessScene* self,
                         ChessGame* game)
{
#line 263 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/chess-scene.vala"
	g_return_if_fail (game != NULL);
#line 265 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 1047 "chess-scene.c"
}


static void
chess_scene_undo_cb (ChessScene* self,
                     ChessGame* game)
{
#line 268 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 268 "../src/chess-scene.vala"
	g_return_if_fail (game != NULL);
#line 270 "../src/chess-scene.vala"
	chess_scene_update_board (self);
#line 1061 "chess-scene.c"
}


static ChessModel*
chess_scene_find_model (ChessScene* self,
                        ChessPiece* piece)
{
	ChessModel* result = NULL;
	GList* _tmp0_;
#line 273 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 273 "../src/chess-scene.vala"
	g_return_val_if_fail (piece != NULL, NULL);
#line 275 "../src/chess-scene.vala"
	_tmp0_ = self->pieces;
#line 1077 "chess-scene.c"
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
#line 275 "../src/chess-scene.vala"
		model_collection = _tmp0_;
#line 275 "../src/chess-scene.vala"
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
#line 1085 "chess-scene.c"
			ChessModel* _tmp1_;
			ChessModel* model = NULL;
#line 275 "../src/chess-scene.vala"
			_tmp1_ = _g_object_ref0 ((ChessModel*) model_it->data);
#line 275 "../src/chess-scene.vala"
			model = _tmp1_;
#line 1092 "chess-scene.c"
			{
				ChessModel* _tmp2_;
				ChessPiece* _tmp3_;
#line 276 "../src/chess-scene.vala"
				_tmp2_ = model;
#line 276 "../src/chess-scene.vala"
				_tmp3_ = _tmp2_->piece;
#line 276 "../src/chess-scene.vala"
				if (_tmp3_ == piece) {
#line 277 "../src/chess-scene.vala"
					result = model;
#line 277 "../src/chess-scene.vala"
					return result;
#line 1106 "chess-scene.c"
				}
#line 275 "../src/chess-scene.vala"
				_g_object_unref0 (model);
#line 1110 "chess-scene.c"
			}
		}
	}
#line 278 "../src/chess-scene.vala"
	result = NULL;
#line 278 "../src/chess-scene.vala"
	return result;
#line 1118 "chess-scene.c"
}


static gboolean
_chess_scene_animate_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = chess_scene_animate_cb ((ChessScene*) self);
#line 345 "../src/chess-scene.vala"
	return result;
#line 1129 "chess-scene.c"
}


static void
chess_scene_update_board (ChessScene* self)
{
	ChessGame* _tmp0_;
	ChessGame* _tmp1_;
	gboolean board_changed = FALSE;
	gboolean need_animation = FALSE;
	GList* new_pieces = NULL;
	GList* _tmp56_;
	GList* _tmp57_;
	gboolean _tmp58_;
	GList* _tmp59_;
	gboolean _tmp63_ = FALSE;
	gboolean _tmp64_;
#line 281 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/chess-scene.vala"
	_tmp0_ = chess_scene_get_game (self);
#line 283 "../src/chess-scene.vala"
	_tmp1_ = _tmp0_;
#line 283 "../src/chess-scene.vala"
	if (_tmp1_ == NULL) {
#line 284 "../src/chess-scene.vala"
		return;
#line 1157 "chess-scene.c"
	}
#line 286 "../src/chess-scene.vala"
	board_changed = FALSE;
#line 287 "../src/chess-scene.vala"
	need_animation = FALSE;
#line 288 "../src/chess-scene.vala"
	new_pieces = NULL;
#line 1165 "chess-scene.c"
	{
		gint rank = 0;
#line 289 "../src/chess-scene.vala"
		rank = 0;
#line 1170 "chess-scene.c"
		{
			gboolean _tmp2_ = FALSE;
#line 289 "../src/chess-scene.vala"
			_tmp2_ = TRUE;
#line 289 "../src/chess-scene.vala"
			while (TRUE) {
#line 1177 "chess-scene.c"
				gint _tmp4_;
#line 289 "../src/chess-scene.vala"
				if (!_tmp2_) {
#line 1181 "chess-scene.c"
					gint _tmp3_;
#line 289 "../src/chess-scene.vala"
					_tmp3_ = rank;
#line 289 "../src/chess-scene.vala"
					rank = _tmp3_ + 1;
#line 1187 "chess-scene.c"
				}
#line 289 "../src/chess-scene.vala"
				_tmp2_ = FALSE;
#line 289 "../src/chess-scene.vala"
				_tmp4_ = rank;
#line 289 "../src/chess-scene.vala"
				if (!(_tmp4_ < 8)) {
#line 289 "../src/chess-scene.vala"
					break;
#line 1197 "chess-scene.c"
				}
				{
					gint file = 0;
#line 291 "../src/chess-scene.vala"
					file = 0;
#line 1203 "chess-scene.c"
					{
						gboolean _tmp5_ = FALSE;
#line 291 "../src/chess-scene.vala"
						_tmp5_ = TRUE;
#line 291 "../src/chess-scene.vala"
						while (TRUE) {
#line 1210 "chess-scene.c"
							gint _tmp7_;
							gboolean can_move = FALSE;
							gboolean _tmp8_ = FALSE;
							gboolean _tmp9_ = FALSE;
							gint _tmp10_;
							gint _tmp21_;
							gint _tmp22_;
							gboolean _tmp23_;
							ChessPiece* piece = NULL;
							ChessGame* _tmp24_;
							ChessGame* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							ChessPiece* _tmp30_;
							ChessPiece* _tmp31_;
							ChessModel* model = NULL;
							ChessPiece* _tmp32_;
							ChessModel* _tmp33_;
							ChessModel* _tmp34_;
							ChessModel* _tmp39_;
							gboolean _tmp40_;
							ChessModel* _tmp41_;
							gint _tmp42_;
							gint _tmp43_;
							gboolean _tmp44_ = FALSE;
							gboolean _tmp45_ = FALSE;
							gint _tmp46_;
							gint _tmp47_;
							ChessModel* _tmp54_;
							ChessModel* _tmp55_;
#line 291 "../src/chess-scene.vala"
							if (!_tmp5_) {
#line 1245 "chess-scene.c"
								gint _tmp6_;
#line 291 "../src/chess-scene.vala"
								_tmp6_ = file;
#line 291 "../src/chess-scene.vala"
								file = _tmp6_ + 1;
#line 1251 "chess-scene.c"
							}
#line 291 "../src/chess-scene.vala"
							_tmp5_ = FALSE;
#line 291 "../src/chess-scene.vala"
							_tmp7_ = file;
#line 291 "../src/chess-scene.vala"
							if (!(_tmp7_ < 8)) {
#line 291 "../src/chess-scene.vala"
								break;
#line 1261 "chess-scene.c"
							}
#line 293 "../src/chess-scene.vala"
							can_move = FALSE;
#line 294 "../src/chess-scene.vala"
							_tmp10_ = self->selected_rank;
#line 294 "../src/chess-scene.vala"
							if (_tmp10_ >= 0) {
#line 1269 "chess-scene.c"
								gint _tmp11_;
								gint _tmp12_;
#line 294 "../src/chess-scene.vala"
								_tmp11_ = chess_scene_get_move_number (self);
#line 294 "../src/chess-scene.vala"
								_tmp12_ = _tmp11_;
#line 294 "../src/chess-scene.vala"
								_tmp9_ = _tmp12_ == -1;
#line 1278 "chess-scene.c"
							} else {
#line 294 "../src/chess-scene.vala"
								_tmp9_ = FALSE;
#line 1282 "chess-scene.c"
							}
#line 294 "../src/chess-scene.vala"
							if (_tmp9_) {
#line 1286 "chess-scene.c"
								ChessGame* _tmp13_;
								ChessGame* _tmp14_;
								ChessPlayer* _tmp15_;
								ChessPlayer* _tmp16_;
								gint _tmp17_;
								gint _tmp18_;
								gint _tmp19_;
								gint _tmp20_;
#line 295 "../src/chess-scene.vala"
								_tmp13_ = chess_scene_get_game (self);
#line 295 "../src/chess-scene.vala"
								_tmp14_ = _tmp13_;
#line 295 "../src/chess-scene.vala"
								_tmp15_ = chess_game_get_current_player (_tmp14_);
#line 295 "../src/chess-scene.vala"
								_tmp16_ = _tmp15_;
#line 295 "../src/chess-scene.vala"
								_tmp17_ = self->selected_rank;
#line 295 "../src/chess-scene.vala"
								_tmp18_ = self->selected_file;
#line 295 "../src/chess-scene.vala"
								_tmp19_ = rank;
#line 295 "../src/chess-scene.vala"
								_tmp20_ = file;
#line 295 "../src/chess-scene.vala"
								_tmp8_ = chess_player_move_with_coords (_tmp16_, _tmp17_, _tmp18_, _tmp19_, _tmp20_, FALSE, PIECE_TYPE_QUEEN);
#line 1313 "chess-scene.c"
							} else {
#line 294 "../src/chess-scene.vala"
								_tmp8_ = FALSE;
#line 1317 "chess-scene.c"
							}
#line 294 "../src/chess-scene.vala"
							if (_tmp8_) {
#line 296 "../src/chess-scene.vala"
								can_move = TRUE;
#line 1323 "chess-scene.c"
							}
#line 297 "../src/chess-scene.vala"
							_tmp21_ = rank;
#line 297 "../src/chess-scene.vala"
							_tmp22_ = file;
#line 297 "../src/chess-scene.vala"
							_tmp23_ = can_move;
#line 297 "../src/chess-scene.vala"
							self->priv->_can_move[(_tmp21_ * 8) + _tmp22_] = _tmp23_;
#line 299 "../src/chess-scene.vala"
							_tmp24_ = chess_scene_get_game (self);
#line 299 "../src/chess-scene.vala"
							_tmp25_ = _tmp24_;
#line 299 "../src/chess-scene.vala"
							_tmp26_ = rank;
#line 299 "../src/chess-scene.vala"
							_tmp27_ = file;
#line 299 "../src/chess-scene.vala"
							_tmp28_ = chess_scene_get_move_number (self);
#line 299 "../src/chess-scene.vala"
							_tmp29_ = _tmp28_;
#line 299 "../src/chess-scene.vala"
							_tmp30_ = chess_game_get_piece (_tmp25_, _tmp26_, _tmp27_, _tmp29_);
#line 299 "../src/chess-scene.vala"
							piece = _tmp30_;
#line 300 "../src/chess-scene.vala"
							_tmp31_ = piece;
#line 300 "../src/chess-scene.vala"
							if (_tmp31_ == NULL) {
#line 301 "../src/chess-scene.vala"
								_g_object_unref0 (piece);
#line 301 "../src/chess-scene.vala"
								continue;
#line 1357 "chess-scene.c"
							}
#line 302 "../src/chess-scene.vala"
							_tmp32_ = piece;
#line 302 "../src/chess-scene.vala"
							_tmp33_ = chess_scene_find_model (self, _tmp32_);
#line 302 "../src/chess-scene.vala"
							model = _tmp33_;
#line 303 "../src/chess-scene.vala"
							_tmp34_ = model;
#line 303 "../src/chess-scene.vala"
							if (_tmp34_ == NULL) {
#line 1369 "chess-scene.c"
								ChessPiece* _tmp35_;
								gint _tmp36_;
								gint _tmp37_;
								ChessModel* _tmp38_;
#line 305 "../src/chess-scene.vala"
								_tmp35_ = piece;
#line 305 "../src/chess-scene.vala"
								_tmp36_ = file;
#line 305 "../src/chess-scene.vala"
								_tmp37_ = rank;
#line 305 "../src/chess-scene.vala"
								_tmp38_ = chess_model_new (_tmp35_, (gdouble) _tmp36_, (gdouble) _tmp37_);
#line 305 "../src/chess-scene.vala"
								_g_object_unref0 (model);
#line 305 "../src/chess-scene.vala"
								model = _tmp38_;
#line 306 "../src/chess-scene.vala"
								board_changed = TRUE;
#line 1388 "chess-scene.c"
							}
#line 308 "../src/chess-scene.vala"
							_tmp39_ = model;
#line 308 "../src/chess-scene.vala"
							_tmp40_ = can_move;
#line 308 "../src/chess-scene.vala"
							_tmp39_->under_threat = _tmp40_;
#line 310 "../src/chess-scene.vala"
							_tmp41_ = model;
#line 310 "../src/chess-scene.vala"
							_tmp42_ = file;
#line 310 "../src/chess-scene.vala"
							_tmp43_ = rank;
#line 310 "../src/chess-scene.vala"
							if (chess_model_move_to (_tmp41_, (gdouble) _tmp42_, (gdouble) _tmp43_)) {
#line 312 "../src/chess-scene.vala"
								board_changed = TRUE;
#line 313 "../src/chess-scene.vala"
								need_animation = TRUE;
#line 1408 "chess-scene.c"
							}
#line 316 "../src/chess-scene.vala"
							_tmp46_ = chess_scene_get_move_number (self);
#line 316 "../src/chess-scene.vala"
							_tmp47_ = _tmp46_;
#line 316 "../src/chess-scene.vala"
							if (_tmp47_ == -1) {
#line 1416 "chess-scene.c"
								gint _tmp48_;
								gint _tmp49_;
#line 316 "../src/chess-scene.vala"
								_tmp48_ = rank;
#line 316 "../src/chess-scene.vala"
								_tmp49_ = self->selected_rank;
#line 316 "../src/chess-scene.vala"
								_tmp45_ = _tmp48_ == _tmp49_;
#line 1425 "chess-scene.c"
							} else {
#line 316 "../src/chess-scene.vala"
								_tmp45_ = FALSE;
#line 1429 "chess-scene.c"
							}
#line 316 "../src/chess-scene.vala"
							if (_tmp45_) {
#line 1433 "chess-scene.c"
								gint _tmp50_;
								gint _tmp51_;
#line 316 "../src/chess-scene.vala"
								_tmp50_ = file;
#line 316 "../src/chess-scene.vala"
								_tmp51_ = self->selected_file;
#line 316 "../src/chess-scene.vala"
								_tmp44_ = _tmp50_ == _tmp51_;
#line 1442 "chess-scene.c"
							} else {
#line 316 "../src/chess-scene.vala"
								_tmp44_ = FALSE;
#line 1446 "chess-scene.c"
							}
#line 316 "../src/chess-scene.vala"
							if (_tmp44_) {
#line 1450 "chess-scene.c"
								ChessModel* _tmp52_;
#line 317 "../src/chess-scene.vala"
								_tmp52_ = model;
#line 317 "../src/chess-scene.vala"
								_tmp52_->is_selected = TRUE;
#line 1456 "chess-scene.c"
							} else {
								ChessModel* _tmp53_;
#line 319 "../src/chess-scene.vala"
								_tmp53_ = model;
#line 319 "../src/chess-scene.vala"
								_tmp53_->is_selected = FALSE;
#line 1463 "chess-scene.c"
							}
#line 321 "../src/chess-scene.vala"
							_tmp54_ = model;
#line 321 "../src/chess-scene.vala"
							_tmp55_ = _g_object_ref0 (_tmp54_);
#line 321 "../src/chess-scene.vala"
							new_pieces = g_list_append (new_pieces, _tmp55_);
#line 291 "../src/chess-scene.vala"
							_g_object_unref0 (model);
#line 291 "../src/chess-scene.vala"
							_g_object_unref0 (piece);
#line 1475 "chess-scene.c"
						}
					}
				}
			}
		}
	}
#line 325 "../src/chess-scene.vala"
	_tmp56_ = new_pieces;
#line 325 "../src/chess-scene.vala"
	_tmp57_ = self->pieces;
#line 325 "../src/chess-scene.vala"
	if (g_list_length (_tmp56_) != g_list_length (_tmp57_)) {
#line 326 "../src/chess-scene.vala"
		board_changed = TRUE;
#line 1490 "chess-scene.c"
	}
#line 328 "../src/chess-scene.vala"
	_tmp58_ = board_changed;
#line 328 "../src/chess-scene.vala"
	if (!_tmp58_) {
#line 329 "../src/chess-scene.vala"
		(new_pieces == NULL) ? NULL : (new_pieces = (_g_list_free__g_object_unref0_ (new_pieces), NULL));
#line 329 "../src/chess-scene.vala"
		return;
#line 1500 "chess-scene.c"
	}
#line 332 "../src/chess-scene.vala"
	(self->pieces == NULL) ? NULL : (self->pieces = (_g_list_free__g_object_unref0_ (self->pieces), NULL));
#line 332 "../src/chess-scene.vala"
	self->pieces = NULL;
#line 333 "../src/chess-scene.vala"
	_tmp59_ = new_pieces;
#line 1508 "chess-scene.c"
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
#line 333 "../src/chess-scene.vala"
		model_collection = _tmp59_;
#line 333 "../src/chess-scene.vala"
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
#line 1516 "chess-scene.c"
			ChessModel* _tmp60_;
			ChessModel* model = NULL;
#line 333 "../src/chess-scene.vala"
			_tmp60_ = _g_object_ref0 ((ChessModel*) model_it->data);
#line 333 "../src/chess-scene.vala"
			model = _tmp60_;
#line 1523 "chess-scene.c"
			{
				ChessModel* _tmp61_;
				ChessModel* _tmp62_;
#line 334 "../src/chess-scene.vala"
				_tmp61_ = model;
#line 334 "../src/chess-scene.vala"
				_tmp62_ = _g_object_ref0 (_tmp61_);
#line 334 "../src/chess-scene.vala"
				self->pieces = g_list_append (self->pieces, _tmp62_);
#line 333 "../src/chess-scene.vala"
				_g_object_unref0 (model);
#line 1535 "chess-scene.c"
			}
		}
	}
#line 335 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 337 "../src/chess-scene.vala"
	_tmp64_ = need_animation;
#line 337 "../src/chess-scene.vala"
	if (_tmp64_) {
#line 1545 "chess-scene.c"
		gboolean _tmp65_;
#line 337 "../src/chess-scene.vala"
		_tmp65_ = self->animating;
#line 337 "../src/chess-scene.vala"
		_tmp63_ = !_tmp65_;
#line 1551 "chess-scene.c"
	} else {
#line 337 "../src/chess-scene.vala"
		_tmp63_ = FALSE;
#line 1555 "chess-scene.c"
	}
#line 337 "../src/chess-scene.vala"
	if (_tmp63_) {
#line 1559 "chess-scene.c"
		GTimer* _tmp66_;
		ChessGame* _tmp67_;
		ChessGame* _tmp68_;
#line 339 "../src/chess-scene.vala"
		self->animating = TRUE;
#line 340 "../src/chess-scene.vala"
		_tmp66_ = self->priv->animation_timer;
#line 340 "../src/chess-scene.vala"
		g_timer_start (_tmp66_);
#line 341 "../src/chess-scene.vala"
		self->priv->animation_time = (gdouble) 0;
#line 342 "../src/chess-scene.vala"
		_tmp67_ = chess_scene_get_game (self);
#line 342 "../src/chess-scene.vala"
		_tmp68_ = _tmp67_;
#line 342 "../src/chess-scene.vala"
		chess_game_add_hold (_tmp68_);
#line 345 "../src/chess-scene.vala"
		self->priv->animate_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT_IDLE, (guint) 10, _chess_scene_animate_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1579 "chess-scene.c"
	}
#line 281 "../src/chess-scene.vala"
	(new_pieces == NULL) ? NULL : (new_pieces = (_g_list_free__g_object_unref0_ (new_pieces), NULL));
#line 1583 "chess-scene.c"
}


gboolean
chess_scene_can_move (ChessScene* self,
                      gint rank,
                      gint file)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 349 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 351 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_can_move[(rank * 8) + file];
#line 351 "../src/chess-scene.vala"
	result = _tmp0_;
#line 351 "../src/chess-scene.vala"
	return result;
#line 1602 "chess-scene.c"
}


static gboolean
chess_scene_animate_cb (ChessScene* self)
{
	gboolean result = FALSE;
	gdouble old_time = 0.0;
	gdouble _tmp0_;
	GTimer* _tmp1_;
	gdouble timestep = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gint animate_count = 0;
	GList* _tmp4_;
	gint _tmp9_;
	gboolean _tmp10_;
	ChessGame* _tmp11_;
	ChessGame* _tmp12_;
#line 354 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 357 "../src/chess-scene.vala"
	_tmp0_ = self->priv->animation_time;
#line 357 "../src/chess-scene.vala"
	old_time = _tmp0_;
#line 358 "../src/chess-scene.vala"
	_tmp1_ = self->priv->animation_timer;
#line 358 "../src/chess-scene.vala"
	self->priv->animation_time = g_timer_elapsed (_tmp1_, NULL);
#line 359 "../src/chess-scene.vala"
	_tmp2_ = self->priv->animation_time;
#line 359 "../src/chess-scene.vala"
	_tmp3_ = old_time;
#line 359 "../src/chess-scene.vala"
	timestep = _tmp2_ - _tmp3_;
#line 361 "../src/chess-scene.vala"
	animate_count = 0;
#line 362 "../src/chess-scene.vala"
	_tmp4_ = self->pieces;
#line 1642 "chess-scene.c"
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
#line 362 "../src/chess-scene.vala"
		model_collection = _tmp4_;
#line 362 "../src/chess-scene.vala"
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
#line 1650 "chess-scene.c"
			ChessModel* _tmp5_;
			ChessModel* model = NULL;
#line 362 "../src/chess-scene.vala"
			_tmp5_ = _g_object_ref0 ((ChessModel*) model_it->data);
#line 362 "../src/chess-scene.vala"
			model = _tmp5_;
#line 1657 "chess-scene.c"
			{
				ChessModel* _tmp6_;
				gdouble _tmp7_;
#line 364 "../src/chess-scene.vala"
				_tmp6_ = model;
#line 364 "../src/chess-scene.vala"
				_tmp7_ = timestep;
#line 364 "../src/chess-scene.vala"
				if (chess_model_animate (_tmp6_, _tmp7_)) {
#line 1667 "chess-scene.c"
					gint _tmp8_;
#line 365 "../src/chess-scene.vala"
					_tmp8_ = animate_count;
#line 365 "../src/chess-scene.vala"
					animate_count = _tmp8_ + 1;
#line 1673 "chess-scene.c"
				}
#line 362 "../src/chess-scene.vala"
				_g_object_unref0 (model);
#line 1677 "chess-scene.c"
			}
		}
	}
#line 367 "../src/chess-scene.vala"
	_tmp9_ = animate_count;
#line 367 "../src/chess-scene.vala"
	self->animating = _tmp9_ > 0;
#line 369 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 371 "../src/chess-scene.vala"
	_tmp10_ = self->animating;
#line 371 "../src/chess-scene.vala"
	if (_tmp10_) {
#line 372 "../src/chess-scene.vala"
		result = G_SOURCE_CONTINUE;
#line 372 "../src/chess-scene.vala"
		return result;
#line 1695 "chess-scene.c"
	}
#line 374 "../src/chess-scene.vala"
	_tmp11_ = chess_scene_get_game (self);
#line 374 "../src/chess-scene.vala"
	_tmp12_ = _tmp11_;
#line 374 "../src/chess-scene.vala"
	chess_game_remove_hold (_tmp12_);
#line 375 "../src/chess-scene.vala"
	result = G_SOURCE_REMOVE;
#line 375 "../src/chess-scene.vala"
	return result;
#line 1707 "chess-scene.c"
}


ChessGame*
chess_scene_get_game (ChessScene* self)
{
	ChessGame* result;
	ChessGame* _tmp0_;
#line 92 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 92 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_game;
#line 92 "../src/chess-scene.vala"
	result = _tmp0_;
#line 92 "../src/chess-scene.vala"
	return result;
#line 1724 "chess-scene.c"
}


static void
_chess_scene_moved_cb_chess_game_moved (ChessGame* _sender,
                                        ChessMove* move,
                                        gpointer self)
{
#line 105 "../src/chess-scene.vala"
	chess_scene_moved_cb ((ChessScene*) self, _sender, move);
#line 1735 "chess-scene.c"
}


static void
_chess_scene_paused_cb_chess_game_paused (ChessGame* _sender,
                                          gpointer self)
{
#line 106 "../src/chess-scene.vala"
	chess_scene_paused_cb ((ChessScene*) self, _sender);
#line 1745 "chess-scene.c"
}


static void
_chess_scene_unpaused_cb_chess_game_unpaused (ChessGame* _sender,
                                              gpointer self)
{
#line 107 "../src/chess-scene.vala"
	chess_scene_unpaused_cb ((ChessScene*) self, _sender);
#line 1755 "chess-scene.c"
}


static void
_chess_scene_undo_cb_chess_game_undo (ChessGame* _sender,
                                      gpointer self)
{
#line 108 "../src/chess-scene.vala"
	chess_scene_undo_cb ((ChessScene*) self, _sender);
#line 1765 "chess-scene.c"
}


void
chess_scene_set_game (ChessScene* self,
                      ChessGame* value)
{
	guint _tmp0_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessGame* _tmp4_;
	ChessGame* _tmp5_;
	ChessGame* _tmp6_;
#line 93 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/chess-scene.vala"
	_tmp0_ = self->priv->animate_timeout_id;
#line 95 "../src/chess-scene.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 1785 "chess-scene.c"
		guint _tmp1_;
#line 97 "../src/chess-scene.vala"
		_tmp1_ = self->priv->animate_timeout_id;
#line 97 "../src/chess-scene.vala"
		g_source_remove (_tmp1_);
#line 98 "../src/chess-scene.vala"
		self->priv->animate_timeout_id = (guint) 0;
#line 99 "../src/chess-scene.vala"
		self->animating = FALSE;
#line 1795 "chess-scene.c"
	}
#line 101 "../src/chess-scene.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 101 "../src/chess-scene.vala"
	_g_object_unref0 (self->priv->_game);
#line 101 "../src/chess-scene.vala"
	self->priv->_game = _tmp2_;
#line 102 "../src/chess-scene.vala"
	self->priv->_move_number = -1;
#line 103 "../src/chess-scene.vala"
	self->selected_rank = -1;
#line 104 "../src/chess-scene.vala"
	self->selected_file = -1;
#line 105 "../src/chess-scene.vala"
	_tmp3_ = self->priv->_game;
#line 105 "../src/chess-scene.vala"
	g_signal_connect_object (_tmp3_, "moved", (GCallback) _chess_scene_moved_cb_chess_game_moved, self, 0);
#line 106 "../src/chess-scene.vala"
	_tmp4_ = self->priv->_game;
#line 106 "../src/chess-scene.vala"
	g_signal_connect_object (_tmp4_, "paused", (GCallback) _chess_scene_paused_cb_chess_game_paused, self, 0);
#line 107 "../src/chess-scene.vala"
	_tmp5_ = self->priv->_game;
#line 107 "../src/chess-scene.vala"
	g_signal_connect_object (_tmp5_, "unpaused", (GCallback) _chess_scene_unpaused_cb_chess_game_unpaused, self, 0);
#line 108 "../src/chess-scene.vala"
	_tmp6_ = self->priv->_game;
#line 108 "../src/chess-scene.vala"
	g_signal_connect_object (_tmp6_, "undo", (GCallback) _chess_scene_undo_cb_chess_game_undo, self, 0);
#line 109 "../src/chess-scene.vala"
	chess_scene_update_board (self);
#line 93 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_GAME_PROPERTY]);
#line 1829 "chess-scene.c"
}


gint
chess_scene_get_move_number (ChessScene* self)
{
	gint result;
	gint _tmp0_;
#line 123 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 123 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_move_number;
#line 123 "../src/chess-scene.vala"
	result = _tmp0_;
#line 123 "../src/chess-scene.vala"
	return result;
#line 1846 "chess-scene.c"
}


void
chess_scene_set_move_number (ChessScene* self,
                             gint value)
{
	gint _tmp0_;
#line 124 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_move_number;
#line 126 "../src/chess-scene.vala"
	if (_tmp0_ == value) {
#line 127 "../src/chess-scene.vala"
		return;
#line 1863 "chess-scene.c"
	}
#line 128 "../src/chess-scene.vala"
	self->priv->_move_number = value;
#line 129 "../src/chess-scene.vala"
	chess_scene_update_board (self);
#line 124 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_MOVE_NUMBER_PROPERTY]);
#line 1871 "chess-scene.c"
}


gboolean
chess_scene_get_show_numbering (ChessScene* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 136 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_show_numbering;
#line 136 "../src/chess-scene.vala"
	result = _tmp0_;
#line 136 "../src/chess-scene.vala"
	return result;
#line 1888 "chess-scene.c"
}


void
chess_scene_set_show_numbering (ChessScene* self,
                                gboolean value)
{
#line 137 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/chess-scene.vala"
	self->priv->_show_numbering = value;
#line 137 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 137 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_SHOW_NUMBERING_PROPERTY]);
#line 1904 "chess-scene.c"
}


gboolean
chess_scene_get_show_move_hints (ChessScene* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 143 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 143 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_show_move_hints;
#line 143 "../src/chess-scene.vala"
	result = _tmp0_;
#line 143 "../src/chess-scene.vala"
	return result;
#line 1921 "chess-scene.c"
}


void
chess_scene_set_show_move_hints (ChessScene* self,
                                 gboolean value)
{
#line 144 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/chess-scene.vala"
	self->priv->_show_move_hints = value;
#line 144 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 144 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY]);
#line 1937 "chess-scene.c"
}


const gchar*
chess_scene_get_theme_name (ChessScene* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 150 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_theme_name;
#line 150 "../src/chess-scene.vala"
	result = _tmp0_;
#line 150 "../src/chess-scene.vala"
	return result;
#line 1954 "chess-scene.c"
}


void
chess_scene_set_theme_name (ChessScene* self,
                            const gchar* value)
{
	gchar* _tmp0_;
#line 151 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/chess-scene.vala"
	_tmp0_ = g_strdup (value);
#line 151 "../src/chess-scene.vala"
	_g_free0 (self->priv->_theme_name);
#line 151 "../src/chess-scene.vala"
	self->priv->_theme_name = _tmp0_;
#line 151 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 151 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_THEME_NAME_PROPERTY]);
#line 1975 "chess-scene.c"
}


gboolean
chess_scene_get_show_3d_smooth (ChessScene* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 157 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 157 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_show_3d_smooth;
#line 157 "../src/chess-scene.vala"
	result = _tmp0_;
#line 157 "../src/chess-scene.vala"
	return result;
#line 1992 "chess-scene.c"
}


void
chess_scene_set_show_3d_smooth (ChessScene* self,
                                gboolean value)
{
#line 158 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/chess-scene.vala"
	self->priv->_show_3d_smooth = value;
#line 158 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 158 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY]);
#line 2008 "chess-scene.c"
}


const gchar*
chess_scene_get_board_side (ChessScene* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 164 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_board_side;
#line 164 "../src/chess-scene.vala"
	result = _tmp0_;
#line 164 "../src/chess-scene.vala"
	return result;
#line 2025 "chess-scene.c"
}


void
chess_scene_set_board_side (ChessScene* self,
                            const gchar* value)
{
	gchar* _tmp0_;
#line 165 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/chess-scene.vala"
	_tmp0_ = g_strdup (value);
#line 165 "../src/chess-scene.vala"
	_g_free0 (self->priv->_board_side);
#line 165 "../src/chess-scene.vala"
	self->priv->_board_side = _tmp0_;
#line 165 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 165 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_BOARD_SIDE_PROPERTY]);
#line 2046 "chess-scene.c"
}


gdouble
chess_scene_get_board_angle (ChessScene* self)
{
	gdouble result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
#line 172 "../src/chess-scene.vala"
	static GQuark _tmp3_label0 = 0;
#line 172 "../src/chess-scene.vala"
	static GQuark _tmp3_label1 = 0;
#line 172 "../src/chess-scene.vala"
	static GQuark _tmp3_label2 = 0;
#line 170 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 172 "../src/chess-scene.vala"
	_tmp0_ = chess_scene_get_board_side (self);
#line 172 "../src/chess-scene.vala"
	_tmp1_ = _tmp0_;
#line 172 "../src/chess-scene.vala"
	_tmp2_ = _tmp1_;
#line 172 "../src/chess-scene.vala"
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 172 "../src/chess-scene.vala"
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("black")))) {
#line 172 "../src/chess-scene.vala"
		switch (0) {
#line 2078 "chess-scene.c"
			default:
			{
#line 178 "../src/chess-scene.vala"
				result = 180.0;
#line 178 "../src/chess-scene.vala"
				return result;
#line 2085 "chess-scene.c"
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("human")))) {
#line 172 "../src/chess-scene.vala"
		switch (0) {
#line 2091 "chess-scene.c"
			default:
			{
				ChessGame* _tmp5_;
				ChessGame* _tmp6_;
				ChessPlayer* _tmp7_;
				ChessPlayer* _tmp8_;
				gboolean _tmp9_ = FALSE;
#line 180 "../src/chess-scene.vala"
				_tmp5_ = chess_scene_get_game (self);
#line 180 "../src/chess-scene.vala"
				_tmp6_ = _tmp5_;
#line 180 "../src/chess-scene.vala"
				_tmp7_ = chess_game_get_black (_tmp6_);
#line 180 "../src/chess-scene.vala"
				_tmp8_ = _tmp7_;
#line 180 "../src/chess-scene.vala"
				g_signal_emit (self, chess_scene_signals[CHESS_SCENE_IS_HUMAN_SIGNAL], 0, _tmp8_, &_tmp9_);
#line 180 "../src/chess-scene.vala"
				if (_tmp9_) {
#line 181 "../src/chess-scene.vala"
					result = 180.0;
#line 181 "../src/chess-scene.vala"
					return result;
#line 2115 "chess-scene.c"
				} else {
#line 183 "../src/chess-scene.vala"
					result = 0.0;
#line 183 "../src/chess-scene.vala"
					return result;
#line 2121 "chess-scene.c"
				}
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("current")))) {
#line 172 "../src/chess-scene.vala"
		switch (0) {
#line 2128 "chess-scene.c"
			default:
			{
				gdouble _tmp10_ = 0.0;
				ChessGame* _tmp11_;
				ChessGame* _tmp12_;
				ChessPlayer* _tmp13_;
				ChessPlayer* _tmp14_;
				Color _tmp15_;
#line 185 "../src/chess-scene.vala"
				_tmp11_ = chess_scene_get_game (self);
#line 185 "../src/chess-scene.vala"
				_tmp12_ = _tmp11_;
#line 185 "../src/chess-scene.vala"
				_tmp13_ = chess_game_get_current_player (_tmp12_);
#line 185 "../src/chess-scene.vala"
				_tmp14_ = _tmp13_;
#line 185 "../src/chess-scene.vala"
				_tmp15_ = _tmp14_->color;
#line 185 "../src/chess-scene.vala"
				if (_tmp15_ == COLOR_WHITE) {
#line 185 "../src/chess-scene.vala"
					_tmp10_ = 0.0;
#line 2151 "chess-scene.c"
				} else {
#line 185 "../src/chess-scene.vala"
					_tmp10_ = 180.0;
#line 2155 "chess-scene.c"
				}
#line 185 "../src/chess-scene.vala"
				result = _tmp10_;
#line 185 "../src/chess-scene.vala"
				return result;
#line 2161 "chess-scene.c"
			}
		}
	} else {
#line 172 "../src/chess-scene.vala"
		switch (0) {
#line 2167 "chess-scene.c"
			default:
			{
#line 176 "../src/chess-scene.vala"
				result = 0.0;
#line 176 "../src/chess-scene.vala"
				return result;
#line 2174 "chess-scene.c"
			}
		}
	}
}


const gchar*
chess_scene_get_move_format (ChessScene* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 193 "../src/chess-scene.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 193 "../src/chess-scene.vala"
	_tmp0_ = self->priv->_move_format;
#line 193 "../src/chess-scene.vala"
	result = _tmp0_;
#line 193 "../src/chess-scene.vala"
	return result;
#line 2194 "chess-scene.c"
}


void
chess_scene_set_move_format (ChessScene* self,
                             const gchar* value)
{
	gchar* _tmp0_;
#line 194 "../src/chess-scene.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/chess-scene.vala"
	_tmp0_ = g_strdup (value);
#line 194 "../src/chess-scene.vala"
	_g_free0 (self->priv->_move_format);
#line 194 "../src/chess-scene.vala"
	self->priv->_move_format = _tmp0_;
#line 194 "../src/chess-scene.vala"
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
#line 194 "../src/chess-scene.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_MOVE_FORMAT_PROPERTY]);
#line 2215 "chess-scene.c"
}


static void
g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 71 "../src/chess-scene.vala"
	g_return_if_fail (return_value != NULL);
#line 71 "../src/chess-scene.vala"
	g_return_if_fail (n_param_values == 2);
#line 71 "../src/chess-scene.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 71 "../src/chess-scene.vala"
		data1 = closure->data;
#line 71 "../src/chess-scene.vala"
		data2 = param_values->data[0].v_pointer;
#line 2244 "chess-scene.c"
	} else {
#line 71 "../src/chess-scene.vala"
		data1 = param_values->data[0].v_pointer;
#line 71 "../src/chess-scene.vala"
		data2 = closure->data;
#line 2250 "chess-scene.c"
	}
#line 71 "../src/chess-scene.vala"
	callback = (GMarshalFunc_BOOLEAN__OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 71 "../src/chess-scene.vala"
	v_return = callback (data1, g_value_get_object (param_values + 1), data2);
#line 71 "../src/chess-scene.vala"
	g_value_set_boolean (return_value, v_return);
#line 2258 "chess-scene.c"
}


static void
g_cclosure_user_marshal_POINTER__VOID (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef gpointer (*GMarshalFunc_POINTER__VOID) (gpointer data1, gpointer data2);
	register GMarshalFunc_POINTER__VOID callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gpointer v_return;
	cc = (GCClosure *) closure;
#line 71 "../src/chess-scene.vala"
	g_return_if_fail (return_value != NULL);
#line 71 "../src/chess-scene.vala"
	g_return_if_fail (n_param_values == 1);
#line 71 "../src/chess-scene.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 71 "../src/chess-scene.vala"
		data1 = closure->data;
#line 71 "../src/chess-scene.vala"
		data2 = param_values->data[0].v_pointer;
#line 2287 "chess-scene.c"
	} else {
#line 71 "../src/chess-scene.vala"
		data1 = param_values->data[0].v_pointer;
#line 71 "../src/chess-scene.vala"
		data2 = closure->data;
#line 2293 "chess-scene.c"
	}
#line 71 "../src/chess-scene.vala"
	callback = (GMarshalFunc_POINTER__VOID) (marshal_data ? marshal_data : cc->callback);
#line 71 "../src/chess-scene.vala"
	v_return = callback (data1, data2);
#line 71 "../src/chess-scene.vala"
	g_value_set_pointer (return_value, v_return);
#line 2301 "chess-scene.c"
}


static void
chess_scene_class_init (ChessSceneClass * klass)
{
#line 71 "../src/chess-scene.vala"
	chess_scene_parent_class = g_type_class_peek_parent (klass);
#line 71 "../src/chess-scene.vala"
	g_type_class_adjust_private_offset (klass, &ChessScene_private_offset);
#line 71 "../src/chess-scene.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_scene_get_property;
#line 71 "../src/chess-scene.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_scene_set_property;
#line 71 "../src/chess-scene.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_scene_finalize;
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_GAME_PROPERTY, chess_scene_properties[CHESS_SCENE_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_CHESS_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_MOVE_NUMBER_PROPERTY, chess_scene_properties[CHESS_SCENE_MOVE_NUMBER_PROPERTY] = g_param_spec_int ("move-number", "move-number", "move-number", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_SHOW_NUMBERING_PROPERTY, chess_scene_properties[CHESS_SCENE_SHOW_NUMBERING_PROPERTY] = g_param_spec_boolean ("show-numbering", "show-numbering", "show-numbering", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY, chess_scene_properties[CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY] = g_param_spec_boolean ("show-move-hints", "show-move-hints", "show-move-hints", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_THEME_NAME_PROPERTY, chess_scene_properties[CHESS_SCENE_THEME_NAME_PROPERTY] = g_param_spec_string ("theme-name", "theme-name", "theme-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY, chess_scene_properties[CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY] = g_param_spec_boolean ("show-3d-smooth", "show-3d-smooth", "show-3d-smooth", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_BOARD_SIDE_PROPERTY, chess_scene_properties[CHESS_SCENE_BOARD_SIDE_PROPERTY] = g_param_spec_string ("board-side", "board-side", "board-side", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_BOARD_ANGLE_PROPERTY, chess_scene_properties[CHESS_SCENE_BOARD_ANGLE_PROPERTY] = g_param_spec_double ("board-angle", "board-angle", "board-angle", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 71 "../src/chess-scene.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_MOVE_FORMAT_PROPERTY, chess_scene_properties[CHESS_SCENE_MOVE_FORMAT_PROPERTY] = g_param_spec_string ("move-format", "move-format", "move-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 71 "../src/chess-scene.vala"
	chess_scene_signals[CHESS_SCENE_IS_HUMAN_SIGNAL] = g_signal_new ("is-human", TYPE_CHESS_SCENE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT, G_TYPE_BOOLEAN, 1, TYPE_CHESS_PLAYER);
#line 71 "../src/chess-scene.vala"
	chess_scene_signals[CHESS_SCENE_CHOOSE_PROMOTION_TYPE_SIGNAL] = g_signal_new ("choose-promotion-type", TYPE_CHESS_SCENE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_POINTER__VOID, G_TYPE_POINTER, 0);
#line 71 "../src/chess-scene.vala"
	chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_CHESS_SCENE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2342 "chess-scene.c"
}


static void
chess_scene_instance_init (ChessScene * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 71 "../src/chess-scene.vala"
	self->priv = chess_scene_get_instance_private (self);
#line 73 "../src/chess-scene.vala"
	self->pieces = NULL;
#line 76 "../src/chess-scene.vala"
	self->animating = FALSE;
#line 84 "../src/chess-scene.vala"
	self->selected_rank = -1;
#line 85 "../src/chess-scene.vala"
	self->selected_file = -1;
#line 87 "../src/chess-scene.vala"
	self->priv->animate_timeout_id = (guint) 0;
#line 89 "../src/chess-scene.vala"
	self->priv->_game = NULL;
#line 120 "../src/chess-scene.vala"
	self->priv->_move_number = -1;
#line 133 "../src/chess-scene.vala"
	self->priv->_show_numbering = TRUE;
#line 140 "../src/chess-scene.vala"
	self->priv->_show_move_hints = TRUE;
#line 147 "../src/chess-scene.vala"
	_tmp0_ = g_strdup ("simple");
#line 147 "../src/chess-scene.vala"
	self->priv->_theme_name = _tmp0_;
#line 154 "../src/chess-scene.vala"
	self->priv->_show_3d_smooth = FALSE;
#line 161 "../src/chess-scene.vala"
	_tmp1_ = g_strdup ("human");
#line 161 "../src/chess-scene.vala"
	self->priv->_board_side = _tmp1_;
#line 190 "../src/chess-scene.vala"
	_tmp2_ = g_strdup ("human");
#line 190 "../src/chess-scene.vala"
	self->priv->_move_format = _tmp2_;
#line 2386 "chess-scene.c"
}


static void
chess_scene_finalize (GObject * obj)
{
	ChessScene * self;
#line 71 "../src/chess-scene.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_SCENE, ChessScene);
#line 73 "../src/chess-scene.vala"
	(self->pieces == NULL) ? NULL : (self->pieces = (_g_list_free__g_object_unref0_ (self->pieces), NULL));
#line 77 "../src/chess-scene.vala"
	_g_timer_destroy0 (self->priv->animation_timer);
#line 89 "../src/chess-scene.vala"
	_g_object_unref0 (self->priv->_game);
#line 147 "../src/chess-scene.vala"
	_g_free0 (self->priv->_theme_name);
#line 161 "../src/chess-scene.vala"
	_g_free0 (self->priv->_board_side);
#line 190 "../src/chess-scene.vala"
	_g_free0 (self->priv->_move_format);
#line 71 "../src/chess-scene.vala"
	G_OBJECT_CLASS (chess_scene_parent_class)->finalize (obj);
#line 2410 "chess-scene.c"
}


GType
chess_scene_get_type (void)
{
	static volatile gsize chess_scene_type_id__volatile = 0;
	if (g_once_init_enter (&chess_scene_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessSceneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_scene_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessScene), 0, (GInstanceInitFunc) chess_scene_instance_init, NULL };
		GType chess_scene_type_id;
		chess_scene_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessScene", &g_define_type_info, 0);
		ChessScene_private_offset = g_type_add_instance_private (chess_scene_type_id, sizeof (ChessScenePrivate));
		g_once_init_leave (&chess_scene_type_id__volatile, chess_scene_type_id);
	}
	return chess_scene_type_id__volatile;
}


static void
_vala_chess_scene_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessScene * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_SCENE, ChessScene);
#line 71 "../src/chess-scene.vala"
	switch (property_id) {
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_GAME_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_object (value, chess_scene_get_game (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_MOVE_NUMBER_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_int (value, chess_scene_get_move_number (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_NUMBERING_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_boolean (value, chess_scene_get_show_numbering (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_boolean (value, chess_scene_get_show_move_hints (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_THEME_NAME_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_string (value, chess_scene_get_theme_name (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_boolean (value, chess_scene_get_show_3d_smooth (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_BOARD_SIDE_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_string (value, chess_scene_get_board_side (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_BOARD_ANGLE_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_double (value, chess_scene_get_board_angle (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_MOVE_FORMAT_PROPERTY:
#line 71 "../src/chess-scene.vala"
		g_value_set_string (value, chess_scene_get_move_format (self));
#line 71 "../src/chess-scene.vala"
		break;
#line 2493 "chess-scene.c"
		default:
#line 71 "../src/chess-scene.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 71 "../src/chess-scene.vala"
		break;
#line 2499 "chess-scene.c"
	}
}


static void
_vala_chess_scene_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ChessScene * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_SCENE, ChessScene);
#line 71 "../src/chess-scene.vala"
	switch (property_id) {
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_GAME_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_game (self, g_value_get_object (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_MOVE_NUMBER_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_move_number (self, g_value_get_int (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_NUMBERING_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_show_numbering (self, g_value_get_boolean (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_show_move_hints (self, g_value_get_boolean (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_THEME_NAME_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_theme_name (self, g_value_get_string (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_show_3d_smooth (self, g_value_get_boolean (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_BOARD_SIDE_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_board_side (self, g_value_get_string (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 71 "../src/chess-scene.vala"
		case CHESS_SCENE_MOVE_FORMAT_PROPERTY:
#line 71 "../src/chess-scene.vala"
		chess_scene_set_move_format (self, g_value_get_string (value));
#line 71 "../src/chess-scene.vala"
		break;
#line 2562 "chess-scene.c"
		default:
#line 71 "../src/chess-scene.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 71 "../src/chess-scene.vala"
		break;
#line 2568 "chess-scene.c"
	}
}



