/* chess-view.c generated by valac 0.42.6, the Vala compiler
 * generated from chess-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <math.h>
#include <float.h>
#include <librsvg/rsvg.h>
#include <stdio.h>
#include "libchess.h"
#include <glib/gi18n-lib.h>


#define TYPE_CHESS_VIEW (chess_view_get_type ())
#define CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_VIEW, ChessView))
#define CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_VIEW, ChessViewClass))
#define IS_CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_VIEW))
#define IS_CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_VIEW))
#define CHESS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_VIEW, ChessViewClass))

typedef struct _ChessView ChessView;
typedef struct _ChessViewClass ChessViewClass;
typedef struct _ChessViewPrivate ChessViewPrivate;

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
enum  {
	CHESS_VIEW_0_PROPERTY,
	CHESS_VIEW_SCENE_PROPERTY,
	CHESS_VIEW_NUM_PROPERTIES
};
static GParamSpec* chess_view_properties[CHESS_VIEW_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _ChessScenePrivate ChessScenePrivate;

#define TYPE_CHESS_MODEL (chess_model_get_type ())
#define CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MODEL, ChessModel))
#define CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MODEL, ChessModelClass))
#define IS_CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MODEL))
#define IS_CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MODEL))
#define CHESS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MODEL, ChessModelClass))

typedef struct _ChessModel ChessModel;
typedef struct _ChessModelClass ChessModelClass;
typedef struct _ChessModelPrivate ChessModelPrivate;

struct _ChessView {
	GtkDrawingArea parent_instance;
	ChessViewPrivate * priv;
};

struct _ChessViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _ChessViewPrivate {
	gint border;
	gint square_size;
	gint selected_square_size;
	cairo_surface_t* model_surface;
	cairo_surface_t* selected_model_surface;
	gchar* loaded_theme_name;
	ChessScene* _scene;
};

struct _ChessScene {
	GObject parent_instance;
	ChessScenePrivate * priv;
	GList* pieces;
	gboolean animating;
	gint selected_rank;
	gint selected_file;
};

struct _ChessSceneClass {
	GObjectClass parent_class;
};

struct _ChessModel {
	GObject parent_instance;
	ChessModelPrivate * priv;
	ChessPiece* piece;
	gdouble x;
	gdouble y;
	gdouble target_x;
	gdouble target_y;
	gboolean under_threat;
	gboolean is_selected;
};

struct _ChessModelClass {
	GObjectClass parent_class;
};


static gint ChessView_private_offset;
static gpointer chess_view_parent_class = NULL;

GType chess_view_get_type (void) G_GNUC_CONST;
GType chess_scene_get_type (void) G_GNUC_CONST;
ChessView* chess_view_new (void);
ChessView* chess_view_construct (GType object_type);
static gboolean chess_view_real_configure_event (GtkWidget* base,
                                          GdkEventConfigure* event);
static void chess_view_render_piece (ChessView* self,
                              cairo_t* c1,
                              cairo_t* c2,
                              const gchar* name,
                              gint offset);
ChessScene* chess_view_get_scene (ChessView* self);
const gchar* chess_scene_get_theme_name (ChessScene* self);
static void chess_view_load_theme (ChessView* self,
                            cairo_t* c);
static gboolean chess_view_real_draw (GtkWidget* base,
                               cairo_t* c);
gdouble chess_scene_get_board_angle (ChessScene* self);
static gdouble chess_view_get_border_size (ChessView* self);
gboolean chess_scene_get_show_numbering (ChessScene* self);
ChessGame* chess_scene_get_game (ChessScene* self);
void chess_view_draw_paused_overlay (ChessView* self,
                                     cairo_t* c);
GType chess_model_get_type (void) G_GNUC_CONST;
gboolean chess_scene_get_show_move_hints (ChessScene* self);
static void chess_view_draw_piece (ChessView* self,
                            cairo_t* c,
                            cairo_surface_t* surface,
                            gint size,
                            ChessPiece* piece,
                            gdouble alpha);
gboolean chess_scene_can_move (ChessScene* self,
                               gint rank,
                               gint file);
ChessPiece* chess_scene_get_selected_piece (ChessScene* self);
static gboolean chess_view_real_button_press_event (GtkWidget* base,
                                             GdkEventButton* event);
void chess_scene_select_square (ChessScene* self,
                                gint file,
                                gint rank);
static void chess_view_scene_changed_cb (ChessView* self,
                                  ChessScene* scene);
void chess_view_set_scene (ChessView* self,
                           ChessScene* value);
static void _chess_view_scene_changed_cb_chess_scene_changed (ChessScene* _sender,
                                                       gpointer self);
static void chess_view_finalize (GObject * obj);
static void _vala_chess_view_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_chess_view_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
chess_view_get_instance_private (ChessView* self)
{
	return G_STRUCT_MEMBER_P (self, ChessView_private_offset);
}


ChessView*
chess_view_construct (GType object_type)
{
	ChessView * self = NULL;
#line 39 "../src/chess-view.vala"
	self = (ChessView*) g_object_new (object_type, NULL);
#line 41 "../src/chess-view.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) (GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK));
#line 39 "../src/chess-view.vala"
	return self;
#line 209 "chess-view.c"
}


ChessView*
chess_view_new (void)
{
#line 39 "../src/chess-view.vala"
	return chess_view_construct (TYPE_CHESS_VIEW);
#line 218 "chess-view.c"
}


static gboolean
chess_view_real_configure_event (GtkWidget* base,
                                 GdkEventConfigure* event)
{
	ChessView * self;
	gboolean result = FALSE;
	gint short_edge = 0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble extra = 0.0;
	gint _tmp2_;
	gdouble _tmp3_;
	gint _tmp4_;
	gdouble _tmp5_;
#line 44 "../src/chess-view.vala"
	self = (ChessView*) base;
#line 44 "../src/chess-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 46 "../src/chess-view.vala"
	short_edge = MIN (gtk_widget_get_allocated_width ((GtkWidget*) self), gtk_widget_get_allocated_height ((GtkWidget*) self));
#line 48 "../src/chess-view.vala"
	_tmp0_ = short_edge;
#line 48 "../src/chess-view.vala"
	_tmp1_ = self->priv->border;
#line 48 "../src/chess-view.vala"
	self->priv->square_size = (gint) floor ((_tmp0_ - (2 * _tmp1_)) / 9.0);
#line 49 "../src/chess-view.vala"
	_tmp2_ = self->priv->square_size;
#line 49 "../src/chess-view.vala"
	extra = _tmp2_ * 0.1;
#line 50 "../src/chess-view.vala"
	_tmp3_ = extra;
#line 50 "../src/chess-view.vala"
	if (_tmp3_ < ((gdouble) 3)) {
#line 51 "../src/chess-view.vala"
		extra = (gdouble) 3;
#line 258 "chess-view.c"
	}
#line 52 "../src/chess-view.vala"
	_tmp4_ = self->priv->square_size;
#line 52 "../src/chess-view.vala"
	_tmp5_ = extra;
#line 52 "../src/chess-view.vala"
	self->priv->selected_square_size = _tmp4_ + (2 * ((gint) (_tmp5_ + 0.5)));
#line 54 "../src/chess-view.vala"
	result = TRUE;
#line 54 "../src/chess-view.vala"
	return result;
#line 270 "chess-view.c"
}


static void
chess_view_render_piece (ChessView* self,
                         cairo_t* c1,
                         cairo_t* c2,
                         const gchar* name,
                         gint offset)
{
	RsvgHandle* handle = NULL;
	gint _tmp15_;
	gint _tmp16_;
	RsvgHandle* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	RsvgHandle* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	RsvgHandle* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	RsvgHandle* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	RsvgHandle* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	RsvgHandle* _tmp34_;
	GError* _inner_error0_ = NULL;
#line 57 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/chess-view.vala"
	g_return_if_fail (c1 != NULL);
#line 57 "../src/chess-view.vala"
	g_return_if_fail (c2 != NULL);
#line 57 "../src/chess-view.vala"
	g_return_if_fail (name != NULL);
#line 311 "chess-view.c"
	{
		RsvgHandle* _tmp0_ = NULL;
		ChessScene* _tmp1_;
		ChessScene* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		RsvgHandle* _tmp9_;
		RsvgHandle* _tmp10_;
		RsvgHandle* _tmp11_;
#line 62 "../src/chess-view.vala"
		_tmp1_ = chess_view_get_scene (self);
#line 62 "../src/chess-view.vala"
		_tmp2_ = _tmp1_;
#line 62 "../src/chess-view.vala"
		_tmp3_ = chess_scene_get_theme_name (_tmp2_);
#line 62 "../src/chess-view.vala"
		_tmp4_ = _tmp3_;
#line 62 "../src/chess-view.vala"
		_tmp5_ = g_strconcat (name, ".svg", NULL);
#line 62 "../src/chess-view.vala"
		_tmp6_ = _tmp5_;
#line 62 "../src/chess-view.vala"
		_tmp7_ = g_build_filename (PKGDATADIR, "pieces", _tmp4_, _tmp6_, NULL, NULL);
#line 62 "../src/chess-view.vala"
		_tmp8_ = _tmp7_;
#line 62 "../src/chess-view.vala"
		_tmp9_ = rsvg_handle_new_from_file (_tmp8_, &_inner_error0_);
#line 62 "../src/chess-view.vala"
		_tmp10_ = _tmp9_;
#line 62 "../src/chess-view.vala"
		_g_free0 (_tmp8_);
#line 62 "../src/chess-view.vala"
		_g_free0 (_tmp6_);
#line 62 "../src/chess-view.vala"
		_tmp0_ = _tmp10_;
#line 62 "../src/chess-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 353 "chess-view.c"
			goto __catch6_g_error;
		}
#line 62 "../src/chess-view.vala"
		_tmp11_ = _tmp0_;
#line 62 "../src/chess-view.vala"
		_tmp0_ = NULL;
#line 62 "../src/chess-view.vala"
		_g_object_unref0 (handle);
#line 62 "../src/chess-view.vala"
		handle = _tmp11_;
#line 60 "../src/chess-view.vala"
		_g_object_unref0 (_tmp0_);
#line 366 "chess-view.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		FILE* _tmp12_;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 60 "../src/chess-view.vala"
		e = _inner_error0_;
#line 60 "../src/chess-view.vala"
		_inner_error0_ = NULL;
#line 66 "../src/chess-view.vala"
		_tmp12_ = stderr;
#line 66 "../src/chess-view.vala"
		_tmp13_ = e;
#line 66 "../src/chess-view.vala"
		_tmp14_ = _tmp13_->message;
#line 66 "../src/chess-view.vala"
		fprintf (_tmp12_, "Failed to load piece svg: %s\n", _tmp14_);
#line 67 "../src/chess-view.vala"
		_g_error_free0 (e);
#line 67 "../src/chess-view.vala"
		_g_object_unref0 (handle);
#line 67 "../src/chess-view.vala"
		return;
#line 393 "chess-view.c"
	}
	__finally6:
#line 60 "../src/chess-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "../src/chess-view.vala"
		_g_object_unref0 (handle);
#line 60 "../src/chess-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 60 "../src/chess-view.vala"
		g_clear_error (&_inner_error0_);
#line 60 "../src/chess-view.vala"
		return;
#line 406 "chess-view.c"
	}
#line 70 "../src/chess-view.vala"
	cairo_save (c1);
#line 71 "../src/chess-view.vala"
	_tmp15_ = self->priv->square_size;
#line 71 "../src/chess-view.vala"
	cairo_translate (c1, (gdouble) (_tmp15_ * offset), (gdouble) 0);
#line 72 "../src/chess-view.vala"
	_tmp16_ = self->priv->square_size;
#line 72 "../src/chess-view.vala"
	_tmp17_ = handle;
#line 72 "../src/chess-view.vala"
	g_object_get (_tmp17_, "width", &_tmp18_, NULL);
#line 72 "../src/chess-view.vala"
	_tmp19_ = _tmp18_;
#line 72 "../src/chess-view.vala"
	_tmp20_ = self->priv->square_size;
#line 72 "../src/chess-view.vala"
	_tmp21_ = handle;
#line 72 "../src/chess-view.vala"
	g_object_get (_tmp21_, "height", &_tmp22_, NULL);
#line 72 "../src/chess-view.vala"
	_tmp23_ = _tmp22_;
#line 72 "../src/chess-view.vala"
	cairo_scale (c1, ((gdouble) _tmp16_) / _tmp19_, ((gdouble) _tmp20_) / _tmp23_);
#line 73 "../src/chess-view.vala"
	_tmp24_ = handle;
#line 73 "../src/chess-view.vala"
	rsvg_handle_render_cairo (_tmp24_, c1);
#line 74 "../src/chess-view.vala"
	cairo_restore (c1);
#line 76 "../src/chess-view.vala"
	cairo_save (c2);
#line 77 "../src/chess-view.vala"
	_tmp25_ = self->priv->selected_square_size;
#line 77 "../src/chess-view.vala"
	cairo_translate (c2, (gdouble) (_tmp25_ * offset), (gdouble) 0);
#line 78 "../src/chess-view.vala"
	_tmp26_ = self->priv->selected_square_size;
#line 78 "../src/chess-view.vala"
	_tmp27_ = handle;
#line 78 "../src/chess-view.vala"
	g_object_get (_tmp27_, "width", &_tmp28_, NULL);
#line 78 "../src/chess-view.vala"
	_tmp29_ = _tmp28_;
#line 78 "../src/chess-view.vala"
	_tmp30_ = self->priv->selected_square_size;
#line 78 "../src/chess-view.vala"
	_tmp31_ = handle;
#line 78 "../src/chess-view.vala"
	g_object_get (_tmp31_, "height", &_tmp32_, NULL);
#line 78 "../src/chess-view.vala"
	_tmp33_ = _tmp32_;
#line 78 "../src/chess-view.vala"
	cairo_scale (c2, ((gdouble) _tmp26_) / _tmp29_, ((gdouble) _tmp30_) / _tmp33_);
#line 79 "../src/chess-view.vala"
	_tmp34_ = handle;
#line 79 "../src/chess-view.vala"
	rsvg_handle_render_cairo (_tmp34_, c2);
#line 80 "../src/chess-view.vala"
	cairo_restore (c2);
#line 57 "../src/chess-view.vala"
	_g_object_unref0 (handle);
#line 470 "chess-view.c"
}


static void
chess_view_load_theme (ChessView* self,
                       cairo_t* c)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gint _tmp10_;
	gint _tmp11_;
	cairo_surface_t* _tmp12_;
	cairo_surface_t* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	cairo_surface_t* _tmp16_;
	cairo_t* c1 = NULL;
	cairo_surface_t* _tmp17_;
	cairo_t* _tmp18_;
	cairo_t* c2 = NULL;
	cairo_surface_t* _tmp19_;
	cairo_t* _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
	cairo_t* _tmp23_;
	cairo_t* _tmp24_;
	cairo_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	cairo_t* _tmp28_;
	cairo_t* _tmp29_;
	cairo_t* _tmp30_;
	cairo_t* _tmp31_;
	cairo_t* _tmp32_;
	cairo_t* _tmp33_;
	cairo_t* _tmp34_;
	cairo_t* _tmp35_;
	cairo_t* _tmp36_;
	cairo_t* _tmp37_;
	cairo_t* _tmp38_;
	cairo_t* _tmp39_;
	cairo_t* _tmp40_;
	cairo_t* _tmp41_;
	cairo_t* _tmp42_;
	cairo_t* _tmp43_;
	cairo_t* _tmp44_;
	ChessScene* _tmp45_;
	ChessScene* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
#line 83 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/chess-view.vala"
	g_return_if_fail (c != NULL);
#line 86 "../src/chess-view.vala"
	_tmp2_ = chess_view_get_scene (self);
#line 86 "../src/chess-view.vala"
	_tmp3_ = _tmp2_;
#line 86 "../src/chess-view.vala"
	_tmp4_ = chess_scene_get_theme_name (_tmp3_);
#line 86 "../src/chess-view.vala"
	_tmp5_ = _tmp4_;
#line 86 "../src/chess-view.vala"
	_tmp6_ = self->priv->loaded_theme_name;
#line 86 "../src/chess-view.vala"
	if (g_strcmp0 (_tmp5_, _tmp6_) == 0) {
#line 543 "chess-view.c"
		cairo_surface_t* _tmp7_;
#line 86 "../src/chess-view.vala"
		_tmp7_ = self->priv->model_surface;
#line 86 "../src/chess-view.vala"
		_tmp1_ = _tmp7_ != NULL;
#line 549 "chess-view.c"
	} else {
#line 86 "../src/chess-view.vala"
		_tmp1_ = FALSE;
#line 553 "chess-view.c"
	}
#line 86 "../src/chess-view.vala"
	if (_tmp1_) {
#line 557 "chess-view.c"
		gint _tmp8_;
		cairo_surface_t* _tmp9_;
#line 86 "../src/chess-view.vala"
		_tmp8_ = self->priv->square_size;
#line 86 "../src/chess-view.vala"
		_tmp9_ = self->priv->model_surface;
#line 86 "../src/chess-view.vala"
		_tmp0_ = _tmp8_ == cairo_image_surface_get_height (_tmp9_);
#line 566 "chess-view.c"
	} else {
#line 86 "../src/chess-view.vala"
		_tmp0_ = FALSE;
#line 570 "chess-view.c"
	}
#line 86 "../src/chess-view.vala"
	if (_tmp0_) {
#line 87 "../src/chess-view.vala"
		return;
#line 576 "chess-view.c"
	}
#line 89 "../src/chess-view.vala"
	_tmp10_ = self->priv->square_size;
#line 89 "../src/chess-view.vala"
	_tmp11_ = self->priv->square_size;
#line 89 "../src/chess-view.vala"
	_tmp12_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 12 * _tmp10_, _tmp11_);
#line 89 "../src/chess-view.vala"
	_cairo_surface_destroy0 (self->priv->model_surface);
#line 89 "../src/chess-view.vala"
	self->priv->model_surface = _tmp12_;
#line 90 "../src/chess-view.vala"
	_tmp13_ = cairo_get_target (c);
#line 90 "../src/chess-view.vala"
	_tmp14_ = self->priv->selected_square_size;
#line 90 "../src/chess-view.vala"
	_tmp15_ = self->priv->selected_square_size;
#line 90 "../src/chess-view.vala"
	_tmp16_ = cairo_surface_create_similar (_tmp13_, CAIRO_CONTENT_COLOR_ALPHA, 12 * _tmp14_, _tmp15_);
#line 90 "../src/chess-view.vala"
	_cairo_surface_destroy0 (self->priv->selected_model_surface);
#line 90 "../src/chess-view.vala"
	self->priv->selected_model_surface = _tmp16_;
#line 92 "../src/chess-view.vala"
	_tmp17_ = self->priv->model_surface;
#line 92 "../src/chess-view.vala"
	_tmp18_ = cairo_create (_tmp17_);
#line 92 "../src/chess-view.vala"
	c1 = _tmp18_;
#line 93 "../src/chess-view.vala"
	_tmp19_ = self->priv->selected_model_surface;
#line 93 "../src/chess-view.vala"
	_tmp20_ = cairo_create (_tmp19_);
#line 93 "../src/chess-view.vala"
	c2 = _tmp20_;
#line 94 "../src/chess-view.vala"
	_tmp21_ = c1;
#line 94 "../src/chess-view.vala"
	_tmp22_ = c2;
#line 94 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp21_, _tmp22_, "whitePawn", 0);
#line 95 "../src/chess-view.vala"
	_tmp23_ = c1;
#line 95 "../src/chess-view.vala"
	_tmp24_ = c2;
#line 95 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp23_, _tmp24_, "whiteRook", 1);
#line 96 "../src/chess-view.vala"
	_tmp25_ = c1;
#line 96 "../src/chess-view.vala"
	_tmp26_ = c2;
#line 96 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp25_, _tmp26_, "whiteKnight", 2);
#line 97 "../src/chess-view.vala"
	_tmp27_ = c1;
#line 97 "../src/chess-view.vala"
	_tmp28_ = c2;
#line 97 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp27_, _tmp28_, "whiteBishop", 3);
#line 98 "../src/chess-view.vala"
	_tmp29_ = c1;
#line 98 "../src/chess-view.vala"
	_tmp30_ = c2;
#line 98 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp29_, _tmp30_, "whiteQueen", 4);
#line 99 "../src/chess-view.vala"
	_tmp31_ = c1;
#line 99 "../src/chess-view.vala"
	_tmp32_ = c2;
#line 99 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp31_, _tmp32_, "whiteKing", 5);
#line 100 "../src/chess-view.vala"
	_tmp33_ = c1;
#line 100 "../src/chess-view.vala"
	_tmp34_ = c2;
#line 100 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp33_, _tmp34_, "blackPawn", 6);
#line 101 "../src/chess-view.vala"
	_tmp35_ = c1;
#line 101 "../src/chess-view.vala"
	_tmp36_ = c2;
#line 101 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp35_, _tmp36_, "blackRook", 7);
#line 102 "../src/chess-view.vala"
	_tmp37_ = c1;
#line 102 "../src/chess-view.vala"
	_tmp38_ = c2;
#line 102 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp37_, _tmp38_, "blackKnight", 8);
#line 103 "../src/chess-view.vala"
	_tmp39_ = c1;
#line 103 "../src/chess-view.vala"
	_tmp40_ = c2;
#line 103 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp39_, _tmp40_, "blackBishop", 9);
#line 104 "../src/chess-view.vala"
	_tmp41_ = c1;
#line 104 "../src/chess-view.vala"
	_tmp42_ = c2;
#line 104 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp41_, _tmp42_, "blackQueen", 10);
#line 105 "../src/chess-view.vala"
	_tmp43_ = c1;
#line 105 "../src/chess-view.vala"
	_tmp44_ = c2;
#line 105 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp43_, _tmp44_, "blackKing", 11);
#line 107 "../src/chess-view.vala"
	_tmp45_ = chess_view_get_scene (self);
#line 107 "../src/chess-view.vala"
	_tmp46_ = _tmp45_;
#line 107 "../src/chess-view.vala"
	_tmp47_ = chess_scene_get_theme_name (_tmp46_);
#line 107 "../src/chess-view.vala"
	_tmp48_ = _tmp47_;
#line 107 "../src/chess-view.vala"
	_tmp49_ = g_strdup (_tmp48_);
#line 107 "../src/chess-view.vala"
	_g_free0 (self->priv->loaded_theme_name);
#line 107 "../src/chess-view.vala"
	self->priv->loaded_theme_name = _tmp49_;
#line 83 "../src/chess-view.vala"
	_cairo_destroy0 (c2);
#line 83 "../src/chess-view.vala"
	_cairo_destroy0 (c1);
#line 702 "chess-view.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 225 "../src/chess-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 711 "chess-view.c"
}


static gboolean
chess_view_real_draw (GtkWidget* base,
                      cairo_t* c)
{
	ChessView * self;
	gboolean result = FALSE;
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gint board_size = 0;
	gint _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	ChessScene* _tmp27_;
	ChessScene* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	ChessScene* _tmp146_;
	ChessScene* _tmp147_;
	ChessGame* _tmp148_;
	ChessGame* _tmp149_;
	gboolean _tmp150_;
	gboolean _tmp151_;
	ChessScene* _tmp156_;
	ChessScene* _tmp157_;
	GList* _tmp158_;
#line 110 "../src/chess-view.vala"
	self = (ChessView*) base;
#line 110 "../src/chess-view.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 112 "../src/chess-view.vala"
	chess_view_load_theme (self, c);
#line 114 "../src/chess-view.vala"
	cairo_translate (c, (gdouble) (gtk_widget_get_allocated_width ((GtkWidget*) self) / 2), (gdouble) (gtk_widget_get_allocated_height ((GtkWidget*) self) / 2));
#line 116 "../src/chess-view.vala"
	_tmp0_ = chess_view_get_scene (self);
#line 116 "../src/chess-view.vala"
	_tmp1_ = _tmp0_;
#line 116 "../src/chess-view.vala"
	_tmp2_ = chess_scene_get_board_angle (_tmp1_);
#line 116 "../src/chess-view.vala"
	_tmp3_ = _tmp2_;
#line 116 "../src/chess-view.vala"
	cairo_rotate (c, (G_PI * _tmp3_) / 180.0);
#line 118 "../src/chess-view.vala"
	_tmp4_ = self->priv->square_size;
#line 118 "../src/chess-view.vala"
	_tmp5_ = chess_view_get_border_size (self);
#line 118 "../src/chess-view.vala"
	_tmp6_ = _tmp5_;
#line 118 "../src/chess-view.vala"
	board_size = (gint) ceil ((_tmp4_ * 4) + _tmp6_);
#line 119 "../src/chess-view.vala"
	cairo_set_source_rgb (c, 0x2e / 255.0, 0x34 / 255.0, 0x36 / 255.0);
#line 120 "../src/chess-view.vala"
	_tmp7_ = board_size;
#line 120 "../src/chess-view.vala"
	_tmp8_ = board_size;
#line 120 "../src/chess-view.vala"
	_tmp9_ = board_size;
#line 120 "../src/chess-view.vala"
	_tmp10_ = board_size;
#line 120 "../src/chess-view.vala"
	cairo_rectangle (c, (gdouble) (-_tmp7_), (gdouble) (-_tmp8_), (gdouble) (_tmp9_ * 2), (gdouble) (_tmp10_ * 2));
#line 121 "../src/chess-view.vala"
	cairo_fill (c);
#line 786 "chess-view.c"
	{
		gint file = 0;
#line 123 "../src/chess-view.vala"
		file = 0;
#line 791 "chess-view.c"
		{
			gboolean _tmp11_ = FALSE;
#line 123 "../src/chess-view.vala"
			_tmp11_ = TRUE;
#line 123 "../src/chess-view.vala"
			while (TRUE) {
#line 798 "chess-view.c"
				gint _tmp13_;
#line 123 "../src/chess-view.vala"
				if (!_tmp11_) {
#line 802 "chess-view.c"
					gint _tmp12_;
#line 123 "../src/chess-view.vala"
					_tmp12_ = file;
#line 123 "../src/chess-view.vala"
					file = _tmp12_ + 1;
#line 808 "chess-view.c"
				}
#line 123 "../src/chess-view.vala"
				_tmp11_ = FALSE;
#line 123 "../src/chess-view.vala"
				_tmp13_ = file;
#line 123 "../src/chess-view.vala"
				if (!(_tmp13_ < 8)) {
#line 123 "../src/chess-view.vala"
					break;
#line 818 "chess-view.c"
				}
				{
					gint rank = 0;
#line 125 "../src/chess-view.vala"
					rank = 0;
#line 824 "chess-view.c"
					{
						gboolean _tmp14_ = FALSE;
#line 125 "../src/chess-view.vala"
						_tmp14_ = TRUE;
#line 125 "../src/chess-view.vala"
						while (TRUE) {
#line 831 "chess-view.c"
							gint _tmp16_;
							gint x = 0;
							gint _tmp17_;
							gint _tmp18_;
							gint y = 0;
							gint _tmp19_;
							gint _tmp20_;
							gint _tmp21_;
							gint _tmp22_;
							gint _tmp23_;
							gint _tmp24_;
							gint _tmp25_;
							gint _tmp26_;
#line 125 "../src/chess-view.vala"
							if (!_tmp14_) {
#line 847 "chess-view.c"
								gint _tmp15_;
#line 125 "../src/chess-view.vala"
								_tmp15_ = rank;
#line 125 "../src/chess-view.vala"
								rank = _tmp15_ + 1;
#line 853 "chess-view.c"
							}
#line 125 "../src/chess-view.vala"
							_tmp14_ = FALSE;
#line 125 "../src/chess-view.vala"
							_tmp16_ = rank;
#line 125 "../src/chess-view.vala"
							if (!(_tmp16_ < 8)) {
#line 125 "../src/chess-view.vala"
								break;
#line 863 "chess-view.c"
							}
#line 127 "../src/chess-view.vala"
							_tmp17_ = file;
#line 127 "../src/chess-view.vala"
							_tmp18_ = self->priv->square_size;
#line 127 "../src/chess-view.vala"
							x = (gint) ((_tmp17_ - 4) * _tmp18_);
#line 128 "../src/chess-view.vala"
							_tmp19_ = rank;
#line 128 "../src/chess-view.vala"
							_tmp20_ = self->priv->square_size;
#line 128 "../src/chess-view.vala"
							y = (gint) ((3 - _tmp19_) * _tmp20_);
#line 130 "../src/chess-view.vala"
							_tmp21_ = x;
#line 130 "../src/chess-view.vala"
							_tmp22_ = y;
#line 130 "../src/chess-view.vala"
							_tmp23_ = self->priv->square_size;
#line 130 "../src/chess-view.vala"
							_tmp24_ = self->priv->square_size;
#line 130 "../src/chess-view.vala"
							cairo_rectangle (c, (gdouble) _tmp21_, (gdouble) _tmp22_, (gdouble) _tmp23_, (gdouble) _tmp24_);
#line 131 "../src/chess-view.vala"
							_tmp25_ = file;
#line 131 "../src/chess-view.vala"
							_tmp26_ = rank;
#line 131 "../src/chess-view.vala"
							if (((_tmp25_ + _tmp26_) % 2) == 0) {
#line 132 "../src/chess-view.vala"
								cairo_set_source_rgb (c, 0xba / 255.0, 0xbd / 255.0, 0xb6 / 255.0);
#line 895 "chess-view.c"
							} else {
#line 134 "../src/chess-view.vala"
								cairo_set_source_rgb (c, 0xee / 255.0, 0xee / 255.0, 0xec / 255.0);
#line 899 "chess-view.c"
							}
#line 135 "../src/chess-view.vala"
							cairo_fill (c);
#line 903 "chess-view.c"
						}
					}
				}
			}
		}
	}
#line 139 "../src/chess-view.vala"
	_tmp27_ = chess_view_get_scene (self);
#line 139 "../src/chess-view.vala"
	_tmp28_ = _tmp27_;
#line 139 "../src/chess-view.vala"
	_tmp29_ = chess_scene_get_show_numbering (_tmp28_);
#line 139 "../src/chess-view.vala"
	_tmp30_ = _tmp29_;
#line 139 "../src/chess-view.vala"
	if (_tmp30_) {
#line 920 "chess-view.c"
		gdouble _tmp31_;
		gdouble _tmp32_;
		cairo_text_extents_t extents = {0};
		cairo_text_extents_t _tmp33_ = {0};
		gdouble y_offset = 0.0;
		gint _tmp34_;
		cairo_text_extents_t _tmp35_;
		gdouble _tmp36_;
		cairo_text_extents_t _tmp37_;
		gdouble _tmp38_;
		cairo_text_extents_t _tmp39_;
		gdouble _tmp40_;
		gdouble top = 0.0;
		gint _tmp41_;
		gdouble _tmp42_;
		gdouble bottom = 0.0;
		gint _tmp43_;
		gdouble _tmp44_;
		gdouble _tmp45_;
		gdouble _tmp46_;
		gdouble file_offset = 0.0;
		gint _tmp47_;
		gdouble rank_offset = 0.0;
		gint _tmp48_;
		gchar** files = NULL;
		gint files_length1 = 0;
		gint _files_size_ = 0;
		gchar** ranks = NULL;
		gint ranks_length1 = 0;
		gint _ranks_size_ = 0;
		cairo_matrix_t matrix = {0};
		cairo_matrix_t _tmp49_ = {0};
		ChessScene* _tmp50_;
		ChessScene* _tmp51_;
		gdouble _tmp52_;
		gdouble _tmp53_;
		cairo_matrix_t _tmp90_;
#line 144 "../src/chess-view.vala"
		cairo_set_source_rgb (c, 0x88 / 255.0, 0x8a / 255.0, 0x85 / 255.0);
#line 145 "../src/chess-view.vala"
		_tmp31_ = chess_view_get_border_size (self);
#line 145 "../src/chess-view.vala"
		_tmp32_ = _tmp31_;
#line 145 "../src/chess-view.vala"
		cairo_set_font_size (c, _tmp32_ * 0.6);
#line 146 "../src/chess-view.vala"
		cairo_select_font_face (c, "sans-serif", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 149 "../src/chess-view.vala"
		cairo_text_extents (c, "abcdefgh", &_tmp33_);
#line 149 "../src/chess-view.vala"
		extents = _tmp33_;
#line 150 "../src/chess-view.vala"
		_tmp34_ = self->priv->square_size;
#line 150 "../src/chess-view.vala"
		_tmp35_ = extents;
#line 150 "../src/chess-view.vala"
		_tmp36_ = _tmp35_.height;
#line 150 "../src/chess-view.vala"
		_tmp37_ = extents;
#line 150 "../src/chess-view.vala"
		_tmp38_ = _tmp37_.height;
#line 150 "../src/chess-view.vala"
		_tmp39_ = extents;
#line 150 "../src/chess-view.vala"
		_tmp40_ = _tmp39_.y_bearing;
#line 150 "../src/chess-view.vala"
		y_offset = ((((_tmp34_ / 2) - _tmp36_) / 2) + _tmp38_) + _tmp40_;
#line 151 "../src/chess-view.vala"
		_tmp41_ = self->priv->square_size;
#line 151 "../src/chess-view.vala"
		_tmp42_ = y_offset;
#line 151 "../src/chess-view.vala"
		top = -((_tmp41_ * 4) + _tmp42_);
#line 152 "../src/chess-view.vala"
		_tmp43_ = self->priv->square_size;
#line 152 "../src/chess-view.vala"
		_tmp44_ = chess_view_get_border_size (self);
#line 152 "../src/chess-view.vala"
		_tmp45_ = _tmp44_;
#line 152 "../src/chess-view.vala"
		_tmp46_ = y_offset;
#line 152 "../src/chess-view.vala"
		bottom = ((_tmp43_ * 4) + _tmp45_) - _tmp46_;
#line 154 "../src/chess-view.vala"
		_tmp47_ = self->priv->square_size;
#line 154 "../src/chess-view.vala"
		file_offset = -(_tmp47_ * 3.5);
#line 155 "../src/chess-view.vala"
		_tmp48_ = self->priv->square_size;
#line 155 "../src/chess-view.vala"
		rank_offset = -(_tmp48_ * 3.5);
#line 160 "../src/chess-view.vala"
		cairo_get_matrix (c, &_tmp49_);
#line 160 "../src/chess-view.vala"
		matrix = _tmp49_;
#line 162 "../src/chess-view.vala"
		_tmp50_ = chess_view_get_scene (self);
#line 162 "../src/chess-view.vala"
		_tmp51_ = _tmp50_;
#line 162 "../src/chess-view.vala"
		_tmp52_ = chess_scene_get_board_angle (_tmp51_);
#line 162 "../src/chess-view.vala"
		_tmp53_ = _tmp52_;
#line 162 "../src/chess-view.vala"
		if (_tmp53_ == 180.0) {
#line 1026 "chess-view.c"
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
			gchar* _tmp60_;
			gchar* _tmp61_;
			gchar** _tmp62_;
			gchar* _tmp63_;
			gchar* _tmp64_;
			gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
			gchar* _tmp70_;
			gchar** _tmp71_;
#line 164 "../src/chess-view.vala"
			_tmp54_ = g_strdup ("h");
#line 164 "../src/chess-view.vala"
			_tmp55_ = g_strdup ("g");
#line 164 "../src/chess-view.vala"
			_tmp56_ = g_strdup ("f");
#line 164 "../src/chess-view.vala"
			_tmp57_ = g_strdup ("e");
#line 164 "../src/chess-view.vala"
			_tmp58_ = g_strdup ("d");
#line 164 "../src/chess-view.vala"
			_tmp59_ = g_strdup ("c");
#line 164 "../src/chess-view.vala"
			_tmp60_ = g_strdup ("b");
#line 164 "../src/chess-view.vala"
			_tmp61_ = g_strdup ("a");
#line 164 "../src/chess-view.vala"
			_tmp62_ = g_new0 (gchar*, 8 + 1);
#line 164 "../src/chess-view.vala"
			_tmp62_[0] = _tmp54_;
#line 164 "../src/chess-view.vala"
			_tmp62_[1] = _tmp55_;
#line 164 "../src/chess-view.vala"
			_tmp62_[2] = _tmp56_;
#line 164 "../src/chess-view.vala"
			_tmp62_[3] = _tmp57_;
#line 164 "../src/chess-view.vala"
			_tmp62_[4] = _tmp58_;
#line 164 "../src/chess-view.vala"
			_tmp62_[5] = _tmp59_;
#line 164 "../src/chess-view.vala"
			_tmp62_[6] = _tmp60_;
#line 164 "../src/chess-view.vala"
			_tmp62_[7] = _tmp61_;
#line 164 "../src/chess-view.vala"
			files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
#line 164 "../src/chess-view.vala"
			files = _tmp62_;
#line 164 "../src/chess-view.vala"
			files_length1 = 8;
#line 164 "../src/chess-view.vala"
			_files_size_ = files_length1;
#line 165 "../src/chess-view.vala"
			_tmp63_ = g_strdup ("1");
#line 165 "../src/chess-view.vala"
			_tmp64_ = g_strdup ("2");
#line 165 "../src/chess-view.vala"
			_tmp65_ = g_strdup ("3");
#line 165 "../src/chess-view.vala"
			_tmp66_ = g_strdup ("4");
#line 165 "../src/chess-view.vala"
			_tmp67_ = g_strdup ("5");
#line 165 "../src/chess-view.vala"
			_tmp68_ = g_strdup ("6");
#line 165 "../src/chess-view.vala"
			_tmp69_ = g_strdup ("7");
#line 165 "../src/chess-view.vala"
			_tmp70_ = g_strdup ("8");
#line 165 "../src/chess-view.vala"
			_tmp71_ = g_new0 (gchar*, 8 + 1);
#line 165 "../src/chess-view.vala"
			_tmp71_[0] = _tmp63_;
#line 165 "../src/chess-view.vala"
			_tmp71_[1] = _tmp64_;
#line 165 "../src/chess-view.vala"
			_tmp71_[2] = _tmp65_;
#line 165 "../src/chess-view.vala"
			_tmp71_[3] = _tmp66_;
#line 165 "../src/chess-view.vala"
			_tmp71_[4] = _tmp67_;
#line 165 "../src/chess-view.vala"
			_tmp71_[5] = _tmp68_;
#line 165 "../src/chess-view.vala"
			_tmp71_[6] = _tmp69_;
#line 165 "../src/chess-view.vala"
			_tmp71_[7] = _tmp70_;
#line 165 "../src/chess-view.vala"
			ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 165 "../src/chess-view.vala"
			ranks = _tmp71_;
#line 165 "../src/chess-view.vala"
			ranks_length1 = 8;
#line 165 "../src/chess-view.vala"
			_ranks_size_ = ranks_length1;
#line 167 "../src/chess-view.vala"
			cairo_matrix_scale (&matrix, (gdouble) -1, (gdouble) -1);
#line 1131 "chess-view.c"
		} else {
			gchar* _tmp72_;
			gchar* _tmp73_;
			gchar* _tmp74_;
			gchar* _tmp75_;
			gchar* _tmp76_;
			gchar* _tmp77_;
			gchar* _tmp78_;
			gchar* _tmp79_;
			gchar** _tmp80_;
			gchar* _tmp81_;
			gchar* _tmp82_;
			gchar* _tmp83_;
			gchar* _tmp84_;
			gchar* _tmp85_;
			gchar* _tmp86_;
			gchar* _tmp87_;
			gchar* _tmp88_;
			gchar** _tmp89_;
#line 171 "../src/chess-view.vala"
			_tmp72_ = g_strdup ("a");
#line 171 "../src/chess-view.vala"
			_tmp73_ = g_strdup ("b");
#line 171 "../src/chess-view.vala"
			_tmp74_ = g_strdup ("c");
#line 171 "../src/chess-view.vala"
			_tmp75_ = g_strdup ("d");
#line 171 "../src/chess-view.vala"
			_tmp76_ = g_strdup ("e");
#line 171 "../src/chess-view.vala"
			_tmp77_ = g_strdup ("f");
#line 171 "../src/chess-view.vala"
			_tmp78_ = g_strdup ("g");
#line 171 "../src/chess-view.vala"
			_tmp79_ = g_strdup ("h");
#line 171 "../src/chess-view.vala"
			_tmp80_ = g_new0 (gchar*, 8 + 1);
#line 171 "../src/chess-view.vala"
			_tmp80_[0] = _tmp72_;
#line 171 "../src/chess-view.vala"
			_tmp80_[1] = _tmp73_;
#line 171 "../src/chess-view.vala"
			_tmp80_[2] = _tmp74_;
#line 171 "../src/chess-view.vala"
			_tmp80_[3] = _tmp75_;
#line 171 "../src/chess-view.vala"
			_tmp80_[4] = _tmp76_;
#line 171 "../src/chess-view.vala"
			_tmp80_[5] = _tmp77_;
#line 171 "../src/chess-view.vala"
			_tmp80_[6] = _tmp78_;
#line 171 "../src/chess-view.vala"
			_tmp80_[7] = _tmp79_;
#line 171 "../src/chess-view.vala"
			files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
#line 171 "../src/chess-view.vala"
			files = _tmp80_;
#line 171 "../src/chess-view.vala"
			files_length1 = 8;
#line 171 "../src/chess-view.vala"
			_files_size_ = files_length1;
#line 172 "../src/chess-view.vala"
			_tmp81_ = g_strdup ("8");
#line 172 "../src/chess-view.vala"
			_tmp82_ = g_strdup ("7");
#line 172 "../src/chess-view.vala"
			_tmp83_ = g_strdup ("6");
#line 172 "../src/chess-view.vala"
			_tmp84_ = g_strdup ("5");
#line 172 "../src/chess-view.vala"
			_tmp85_ = g_strdup ("4");
#line 172 "../src/chess-view.vala"
			_tmp86_ = g_strdup ("3");
#line 172 "../src/chess-view.vala"
			_tmp87_ = g_strdup ("2");
#line 172 "../src/chess-view.vala"
			_tmp88_ = g_strdup ("1");
#line 172 "../src/chess-view.vala"
			_tmp89_ = g_new0 (gchar*, 8 + 1);
#line 172 "../src/chess-view.vala"
			_tmp89_[0] = _tmp81_;
#line 172 "../src/chess-view.vala"
			_tmp89_[1] = _tmp82_;
#line 172 "../src/chess-view.vala"
			_tmp89_[2] = _tmp83_;
#line 172 "../src/chess-view.vala"
			_tmp89_[3] = _tmp84_;
#line 172 "../src/chess-view.vala"
			_tmp89_[4] = _tmp85_;
#line 172 "../src/chess-view.vala"
			_tmp89_[5] = _tmp86_;
#line 172 "../src/chess-view.vala"
			_tmp89_[6] = _tmp87_;
#line 172 "../src/chess-view.vala"
			_tmp89_[7] = _tmp88_;
#line 172 "../src/chess-view.vala"
			ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 172 "../src/chess-view.vala"
			ranks = _tmp89_;
#line 172 "../src/chess-view.vala"
			ranks_length1 = 8;
#line 172 "../src/chess-view.vala"
			_ranks_size_ = ranks_length1;
#line 1235 "chess-view.c"
		}
#line 175 "../src/chess-view.vala"
		cairo_save (c);
#line 176 "../src/chess-view.vala"
		_tmp90_ = matrix;
#line 176 "../src/chess-view.vala"
		cairo_set_matrix (c, &_tmp90_);
#line 1243 "chess-view.c"
		{
			gint i = 0;
#line 178 "../src/chess-view.vala"
			i = 0;
#line 1248 "chess-view.c"
			{
				gboolean _tmp91_ = FALSE;
#line 178 "../src/chess-view.vala"
				_tmp91_ = TRUE;
#line 178 "../src/chess-view.vala"
				while (TRUE) {
#line 1255 "chess-view.c"
					gint _tmp93_;
					gchar** _tmp94_;
					gint _tmp94__length1;
					gint _tmp95_;
					const gchar* _tmp96_;
					cairo_text_extents_t _tmp97_ = {0};
					gdouble _tmp98_;
					cairo_text_extents_t _tmp99_;
					gdouble _tmp100_;
					gdouble _tmp101_;
					gchar** _tmp102_;
					gint _tmp102__length1;
					gint _tmp103_;
					const gchar* _tmp104_;
					gdouble _tmp105_;
					cairo_text_extents_t _tmp106_;
					gdouble _tmp107_;
					gdouble _tmp108_;
					gchar** _tmp109_;
					gint _tmp109__length1;
					gint _tmp110_;
					const gchar* _tmp111_;
					gchar** _tmp112_;
					gint _tmp112__length1;
					gint _tmp113_;
					const gchar* _tmp114_;
					cairo_text_extents_t _tmp115_ = {0};
					cairo_text_extents_t _tmp116_;
					gdouble _tmp117_;
					cairo_text_extents_t _tmp118_;
					gdouble _tmp119_;
					gint _tmp120_;
					gdouble _tmp121_;
					gdouble _tmp122_;
					gdouble _tmp123_;
					gdouble _tmp124_;
					cairo_text_extents_t _tmp125_;
					gdouble _tmp126_;
					gdouble _tmp127_;
					gdouble _tmp128_;
					gchar** _tmp129_;
					gint _tmp129__length1;
					gint _tmp130_;
					const gchar* _tmp131_;
					gint _tmp132_;
					gdouble _tmp133_;
					gdouble _tmp134_;
					cairo_text_extents_t _tmp135_;
					gdouble _tmp136_;
					gdouble _tmp137_;
					gdouble _tmp138_;
					gchar** _tmp139_;
					gint _tmp139__length1;
					gint _tmp140_;
					const gchar* _tmp141_;
					gdouble _tmp142_;
					gint _tmp143_;
					gdouble _tmp144_;
					gint _tmp145_;
#line 178 "../src/chess-view.vala"
					if (!_tmp91_) {
#line 1317 "chess-view.c"
						gint _tmp92_;
#line 178 "../src/chess-view.vala"
						_tmp92_ = i;
#line 178 "../src/chess-view.vala"
						i = _tmp92_ + 1;
#line 1323 "chess-view.c"
					}
#line 178 "../src/chess-view.vala"
					_tmp91_ = FALSE;
#line 178 "../src/chess-view.vala"
					_tmp93_ = i;
#line 178 "../src/chess-view.vala"
					if (!(_tmp93_ < 8)) {
#line 178 "../src/chess-view.vala"
						break;
#line 1333 "chess-view.c"
					}
#line 180 "../src/chess-view.vala"
					_tmp94_ = ranks;
#line 180 "../src/chess-view.vala"
					_tmp94__length1 = ranks_length1;
#line 180 "../src/chess-view.vala"
					_tmp95_ = i;
#line 180 "../src/chess-view.vala"
					_tmp96_ = _tmp94_[_tmp95_];
#line 180 "../src/chess-view.vala"
					cairo_text_extents (c, _tmp96_, &_tmp97_);
#line 180 "../src/chess-view.vala"
					extents = _tmp97_;
#line 183 "../src/chess-view.vala"
					cairo_save (c);
#line 184 "../src/chess-view.vala"
					_tmp98_ = file_offset;
#line 184 "../src/chess-view.vala"
					_tmp99_ = extents;
#line 184 "../src/chess-view.vala"
					_tmp100_ = _tmp99_.width;
#line 184 "../src/chess-view.vala"
					_tmp101_ = top;
#line 184 "../src/chess-view.vala"
					cairo_move_to (c, _tmp98_ - (_tmp100_ / 2), _tmp101_);
#line 185 "../src/chess-view.vala"
					_tmp102_ = files;
#line 185 "../src/chess-view.vala"
					_tmp102__length1 = files_length1;
#line 185 "../src/chess-view.vala"
					_tmp103_ = i;
#line 185 "../src/chess-view.vala"
					_tmp104_ = _tmp102_[_tmp103_];
#line 185 "../src/chess-view.vala"
					cairo_show_text (c, _tmp104_);
#line 186 "../src/chess-view.vala"
					cairo_restore (c);
#line 189 "../src/chess-view.vala"
					cairo_save (c);
#line 190 "../src/chess-view.vala"
					_tmp105_ = file_offset;
#line 190 "../src/chess-view.vala"
					_tmp106_ = extents;
#line 190 "../src/chess-view.vala"
					_tmp107_ = _tmp106_.width;
#line 190 "../src/chess-view.vala"
					_tmp108_ = bottom;
#line 190 "../src/chess-view.vala"
					cairo_move_to (c, _tmp105_ - (_tmp107_ / 2), _tmp108_);
#line 191 "../src/chess-view.vala"
					_tmp109_ = files;
#line 191 "../src/chess-view.vala"
					_tmp109__length1 = files_length1;
#line 191 "../src/chess-view.vala"
					_tmp110_ = i;
#line 191 "../src/chess-view.vala"
					_tmp111_ = _tmp109_[_tmp110_];
#line 191 "../src/chess-view.vala"
					cairo_show_text (c, _tmp111_);
#line 192 "../src/chess-view.vala"
					cairo_restore (c);
#line 194 "../src/chess-view.vala"
					_tmp112_ = ranks;
#line 194 "../src/chess-view.vala"
					_tmp112__length1 = ranks_length1;
#line 194 "../src/chess-view.vala"
					_tmp113_ = i;
#line 194 "../src/chess-view.vala"
					_tmp114_ = _tmp112_[_tmp113_];
#line 194 "../src/chess-view.vala"
					cairo_text_extents (c, _tmp114_, &_tmp115_);
#line 194 "../src/chess-view.vala"
					extents = _tmp115_;
#line 195 "../src/chess-view.vala"
					_tmp116_ = extents;
#line 195 "../src/chess-view.vala"
					_tmp117_ = _tmp116_.y_bearing;
#line 195 "../src/chess-view.vala"
					_tmp118_ = extents;
#line 195 "../src/chess-view.vala"
					_tmp119_ = _tmp118_.height;
#line 195 "../src/chess-view.vala"
					y_offset = -(_tmp117_ + (_tmp119_ / 2));
#line 198 "../src/chess-view.vala"
					cairo_save (c);
#line 199 "../src/chess-view.vala"
					_tmp120_ = self->priv->square_size;
#line 199 "../src/chess-view.vala"
					_tmp121_ = chess_view_get_border_size (self);
#line 199 "../src/chess-view.vala"
					_tmp122_ = _tmp121_;
#line 199 "../src/chess-view.vala"
					_tmp123_ = chess_view_get_border_size (self);
#line 199 "../src/chess-view.vala"
					_tmp124_ = _tmp123_;
#line 199 "../src/chess-view.vala"
					_tmp125_ = extents;
#line 199 "../src/chess-view.vala"
					_tmp126_ = _tmp125_.width;
#line 199 "../src/chess-view.vala"
					_tmp127_ = rank_offset;
#line 199 "../src/chess-view.vala"
					_tmp128_ = y_offset;
#line 199 "../src/chess-view.vala"
					cairo_move_to (c, -(((((gdouble) _tmp120_) * 4) + _tmp122_) - ((_tmp124_ - _tmp126_) / 2)), _tmp127_ + _tmp128_);
#line 200 "../src/chess-view.vala"
					_tmp129_ = ranks;
#line 200 "../src/chess-view.vala"
					_tmp129__length1 = ranks_length1;
#line 200 "../src/chess-view.vala"
					_tmp130_ = i;
#line 200 "../src/chess-view.vala"
					_tmp131_ = _tmp129_[_tmp130_];
#line 200 "../src/chess-view.vala"
					cairo_show_text (c, _tmp131_);
#line 201 "../src/chess-view.vala"
					cairo_restore (c);
#line 204 "../src/chess-view.vala"
					cairo_save (c);
#line 205 "../src/chess-view.vala"
					_tmp132_ = self->priv->square_size;
#line 205 "../src/chess-view.vala"
					_tmp133_ = chess_view_get_border_size (self);
#line 205 "../src/chess-view.vala"
					_tmp134_ = _tmp133_;
#line 205 "../src/chess-view.vala"
					_tmp135_ = extents;
#line 205 "../src/chess-view.vala"
					_tmp136_ = _tmp135_.width;
#line 205 "../src/chess-view.vala"
					_tmp137_ = rank_offset;
#line 205 "../src/chess-view.vala"
					_tmp138_ = y_offset;
#line 205 "../src/chess-view.vala"
					cairo_move_to (c, (((gdouble) _tmp132_) * 4) + ((_tmp134_ - _tmp136_) / 2), _tmp137_ + _tmp138_);
#line 206 "../src/chess-view.vala"
					_tmp139_ = ranks;
#line 206 "../src/chess-view.vala"
					_tmp139__length1 = ranks_length1;
#line 206 "../src/chess-view.vala"
					_tmp140_ = i;
#line 206 "../src/chess-view.vala"
					_tmp141_ = _tmp139_[_tmp140_];
#line 206 "../src/chess-view.vala"
					cairo_show_text (c, _tmp141_);
#line 207 "../src/chess-view.vala"
					cairo_restore (c);
#line 209 "../src/chess-view.vala"
					_tmp142_ = file_offset;
#line 209 "../src/chess-view.vala"
					_tmp143_ = self->priv->square_size;
#line 209 "../src/chess-view.vala"
					file_offset = _tmp142_ + _tmp143_;
#line 210 "../src/chess-view.vala"
					_tmp144_ = rank_offset;
#line 210 "../src/chess-view.vala"
					_tmp145_ = self->priv->square_size;
#line 210 "../src/chess-view.vala"
					rank_offset = _tmp144_ + _tmp145_;
#line 1493 "chess-view.c"
				}
			}
		}
#line 213 "../src/chess-view.vala"
		cairo_restore (c);
#line 139 "../src/chess-view.vala"
		ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 139 "../src/chess-view.vala"
		files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
#line 1503 "chess-view.c"
	}
#line 217 "../src/chess-view.vala"
	_tmp146_ = chess_view_get_scene (self);
#line 217 "../src/chess-view.vala"
	_tmp147_ = _tmp146_;
#line 217 "../src/chess-view.vala"
	_tmp148_ = chess_scene_get_game (_tmp147_);
#line 217 "../src/chess-view.vala"
	_tmp149_ = _tmp148_;
#line 217 "../src/chess-view.vala"
	_tmp150_ = chess_game_get_should_show_paused_overlay (_tmp149_);
#line 217 "../src/chess-view.vala"
	_tmp151_ = _tmp150_;
#line 217 "../src/chess-view.vala"
	if (_tmp151_) {
#line 1519 "chess-view.c"
		ChessScene* _tmp152_;
		ChessScene* _tmp153_;
		gdouble _tmp154_;
		gdouble _tmp155_;
#line 219 "../src/chess-view.vala"
		_tmp152_ = chess_view_get_scene (self);
#line 219 "../src/chess-view.vala"
		_tmp153_ = _tmp152_;
#line 219 "../src/chess-view.vala"
		_tmp154_ = chess_scene_get_board_angle (_tmp153_);
#line 219 "../src/chess-view.vala"
		_tmp155_ = _tmp154_;
#line 219 "../src/chess-view.vala"
		cairo_rotate (c, (G_PI * _tmp155_) / 180.0);
#line 220 "../src/chess-view.vala"
		chess_view_draw_paused_overlay (self, c);
#line 221 "../src/chess-view.vala"
		result = TRUE;
#line 221 "../src/chess-view.vala"
		return result;
#line 1540 "chess-view.c"
	}
#line 225 "../src/chess-view.vala"
	_tmp156_ = chess_view_get_scene (self);
#line 225 "../src/chess-view.vala"
	_tmp157_ = _tmp156_;
#line 225 "../src/chess-view.vala"
	_tmp158_ = _tmp157_->pieces;
#line 1548 "chess-view.c"
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
#line 225 "../src/chess-view.vala"
		model_collection = _tmp158_;
#line 225 "../src/chess-view.vala"
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
#line 1556 "chess-view.c"
			ChessModel* _tmp159_;
			ChessModel* model = NULL;
#line 225 "../src/chess-view.vala"
			_tmp159_ = _g_object_ref0 ((ChessModel*) model_it->data);
#line 225 "../src/chess-view.vala"
			model = _tmp159_;
#line 1563 "chess-view.c"
			{
				ChessModel* _tmp160_;
				gdouble _tmp161_;
				gint _tmp162_;
				ChessModel* _tmp163_;
				gdouble _tmp164_;
				gint _tmp165_;
				gint _tmp166_;
				gint _tmp167_;
				ChessScene* _tmp168_;
				ChessScene* _tmp169_;
				gdouble _tmp170_;
				gdouble _tmp171_;
				cairo_surface_t* _tmp172_ = NULL;
				ChessModel* _tmp173_;
				gboolean _tmp174_;
				gint _tmp177_ = 0;
				ChessModel* _tmp178_;
				gboolean _tmp179_;
				gdouble _tmp182_ = 0.0;
				gboolean _tmp183_ = FALSE;
				ChessModel* _tmp184_;
				gboolean _tmp185_;
				ChessModel* _tmp190_;
				ChessPiece* _tmp191_;
#line 227 "../src/chess-view.vala"
				cairo_save (c);
#line 228 "../src/chess-view.vala"
				_tmp160_ = model;
#line 228 "../src/chess-view.vala"
				_tmp161_ = _tmp160_->x;
#line 228 "../src/chess-view.vala"
				_tmp162_ = self->priv->square_size;
#line 228 "../src/chess-view.vala"
				_tmp163_ = model;
#line 228 "../src/chess-view.vala"
				_tmp164_ = _tmp163_->y;
#line 228 "../src/chess-view.vala"
				_tmp165_ = self->priv->square_size;
#line 228 "../src/chess-view.vala"
				cairo_translate (c, (_tmp161_ - 4) * _tmp162_, (3 - _tmp164_) * _tmp165_);
#line 229 "../src/chess-view.vala"
				_tmp166_ = self->priv->square_size;
#line 229 "../src/chess-view.vala"
				_tmp167_ = self->priv->square_size;
#line 229 "../src/chess-view.vala"
				cairo_translate (c, (gdouble) (_tmp166_ / 2), (gdouble) (_tmp167_ / 2));
#line 230 "../src/chess-view.vala"
				_tmp168_ = chess_view_get_scene (self);
#line 230 "../src/chess-view.vala"
				_tmp169_ = _tmp168_;
#line 230 "../src/chess-view.vala"
				_tmp170_ = chess_scene_get_board_angle (_tmp169_);
#line 230 "../src/chess-view.vala"
				_tmp171_ = _tmp170_;
#line 230 "../src/chess-view.vala"
				cairo_rotate (c, ((-G_PI) * _tmp171_) / 180.0);
#line 233 "../src/chess-view.vala"
				_tmp173_ = model;
#line 233 "../src/chess-view.vala"
				_tmp174_ = _tmp173_->is_selected;
#line 233 "../src/chess-view.vala"
				if (_tmp174_) {
#line 1627 "chess-view.c"
					cairo_surface_t* _tmp175_;
#line 233 "../src/chess-view.vala"
					_tmp175_ = self->priv->selected_model_surface;
#line 233 "../src/chess-view.vala"
					_tmp172_ = _tmp175_;
#line 1633 "chess-view.c"
				} else {
					cairo_surface_t* _tmp176_;
#line 233 "../src/chess-view.vala"
					_tmp176_ = self->priv->model_surface;
#line 233 "../src/chess-view.vala"
					_tmp172_ = _tmp176_;
#line 1640 "chess-view.c"
				}
#line 234 "../src/chess-view.vala"
				_tmp178_ = model;
#line 234 "../src/chess-view.vala"
				_tmp179_ = _tmp178_->is_selected;
#line 234 "../src/chess-view.vala"
				if (_tmp179_) {
#line 1648 "chess-view.c"
					gint _tmp180_;
#line 234 "../src/chess-view.vala"
					_tmp180_ = self->priv->selected_square_size;
#line 234 "../src/chess-view.vala"
					_tmp177_ = _tmp180_;
#line 1654 "chess-view.c"
				} else {
					gint _tmp181_;
#line 234 "../src/chess-view.vala"
					_tmp181_ = self->priv->square_size;
#line 234 "../src/chess-view.vala"
					_tmp177_ = _tmp181_;
#line 1661 "chess-view.c"
				}
#line 235 "../src/chess-view.vala"
				_tmp184_ = model;
#line 235 "../src/chess-view.vala"
				_tmp185_ = _tmp184_->under_threat;
#line 235 "../src/chess-view.vala"
				if (_tmp185_) {
#line 1669 "chess-view.c"
					ChessScene* _tmp186_;
					ChessScene* _tmp187_;
					gboolean _tmp188_;
					gboolean _tmp189_;
#line 235 "../src/chess-view.vala"
					_tmp186_ = chess_view_get_scene (self);
#line 235 "../src/chess-view.vala"
					_tmp187_ = _tmp186_;
#line 235 "../src/chess-view.vala"
					_tmp188_ = chess_scene_get_show_move_hints (_tmp187_);
#line 235 "../src/chess-view.vala"
					_tmp189_ = _tmp188_;
#line 235 "../src/chess-view.vala"
					_tmp183_ = _tmp189_;
#line 1684 "chess-view.c"
				} else {
#line 235 "../src/chess-view.vala"
					_tmp183_ = FALSE;
#line 1688 "chess-view.c"
				}
#line 235 "../src/chess-view.vala"
				if (_tmp183_) {
#line 235 "../src/chess-view.vala"
					_tmp182_ = 0.8;
#line 1694 "chess-view.c"
				} else {
#line 235 "../src/chess-view.vala"
					_tmp182_ = 1.0;
#line 1698 "chess-view.c"
				}
#line 232 "../src/chess-view.vala"
				_tmp190_ = model;
#line 232 "../src/chess-view.vala"
				_tmp191_ = _tmp190_->piece;
#line 232 "../src/chess-view.vala"
				chess_view_draw_piece (self, c, _tmp172_, _tmp177_, _tmp191_, _tmp182_);
#line 237 "../src/chess-view.vala"
				cairo_restore (c);
#line 225 "../src/chess-view.vala"
				_g_object_unref0 (model);
#line 1710 "chess-view.c"
			}
		}
	}
	{
		gint rank = 0;
#line 241 "../src/chess-view.vala"
		rank = 0;
#line 1718 "chess-view.c"
		{
			gboolean _tmp192_ = FALSE;
#line 241 "../src/chess-view.vala"
			_tmp192_ = TRUE;
#line 241 "../src/chess-view.vala"
			while (TRUE) {
#line 1725 "chess-view.c"
				gint _tmp194_;
#line 241 "../src/chess-view.vala"
				if (!_tmp192_) {
#line 1729 "chess-view.c"
					gint _tmp193_;
#line 241 "../src/chess-view.vala"
					_tmp193_ = rank;
#line 241 "../src/chess-view.vala"
					rank = _tmp193_ + 1;
#line 1735 "chess-view.c"
				}
#line 241 "../src/chess-view.vala"
				_tmp192_ = FALSE;
#line 241 "../src/chess-view.vala"
				_tmp194_ = rank;
#line 241 "../src/chess-view.vala"
				if (!(_tmp194_ < 8)) {
#line 241 "../src/chess-view.vala"
					break;
#line 1745 "chess-view.c"
				}
				{
					gint file = 0;
#line 243 "../src/chess-view.vala"
					file = 0;
#line 1751 "chess-view.c"
					{
						gboolean _tmp195_ = FALSE;
#line 243 "../src/chess-view.vala"
						_tmp195_ = TRUE;
#line 243 "../src/chess-view.vala"
						while (TRUE) {
#line 1758 "chess-view.c"
							gint _tmp197_;
							gboolean _tmp198_ = FALSE;
							ChessScene* _tmp199_;
							ChessScene* _tmp200_;
							gboolean _tmp201_;
							gboolean _tmp202_;
#line 243 "../src/chess-view.vala"
							if (!_tmp195_) {
#line 1767 "chess-view.c"
								gint _tmp196_;
#line 243 "../src/chess-view.vala"
								_tmp196_ = file;
#line 243 "../src/chess-view.vala"
								file = _tmp196_ + 1;
#line 1773 "chess-view.c"
							}
#line 243 "../src/chess-view.vala"
							_tmp195_ = FALSE;
#line 243 "../src/chess-view.vala"
							_tmp197_ = file;
#line 243 "../src/chess-view.vala"
							if (!(_tmp197_ < 8)) {
#line 243 "../src/chess-view.vala"
								break;
#line 1783 "chess-view.c"
							}
#line 245 "../src/chess-view.vala"
							_tmp199_ = chess_view_get_scene (self);
#line 245 "../src/chess-view.vala"
							_tmp200_ = _tmp199_;
#line 245 "../src/chess-view.vala"
							_tmp201_ = chess_scene_get_show_move_hints (_tmp200_);
#line 245 "../src/chess-view.vala"
							_tmp202_ = _tmp201_;
#line 245 "../src/chess-view.vala"
							if (_tmp202_) {
#line 1795 "chess-view.c"
								ChessScene* _tmp203_;
								ChessScene* _tmp204_;
								gint _tmp205_;
								gint _tmp206_;
#line 245 "../src/chess-view.vala"
								_tmp203_ = chess_view_get_scene (self);
#line 245 "../src/chess-view.vala"
								_tmp204_ = _tmp203_;
#line 245 "../src/chess-view.vala"
								_tmp205_ = rank;
#line 245 "../src/chess-view.vala"
								_tmp206_ = file;
#line 245 "../src/chess-view.vala"
								_tmp198_ = chess_scene_can_move (_tmp204_, _tmp205_, _tmp206_);
#line 1810 "chess-view.c"
							} else {
#line 245 "../src/chess-view.vala"
								_tmp198_ = FALSE;
#line 1814 "chess-view.c"
							}
#line 245 "../src/chess-view.vala"
							if (_tmp198_) {
#line 1818 "chess-view.c"
								gint _tmp207_;
								gint _tmp208_;
								gint _tmp209_;
								gint _tmp210_;
								gint _tmp211_;
								gint _tmp212_;
								ChessScene* _tmp213_;
								ChessScene* _tmp214_;
								gdouble _tmp215_;
								gdouble _tmp216_;
								cairo_surface_t* _tmp217_;
								gint _tmp218_;
								ChessScene* _tmp219_;
								ChessScene* _tmp220_;
								ChessPiece* _tmp221_;
								ChessPiece* _tmp222_;
#line 247 "../src/chess-view.vala"
								cairo_save (c);
#line 248 "../src/chess-view.vala"
								_tmp207_ = file;
#line 248 "../src/chess-view.vala"
								_tmp208_ = self->priv->square_size;
#line 248 "../src/chess-view.vala"
								_tmp209_ = rank;
#line 248 "../src/chess-view.vala"
								_tmp210_ = self->priv->square_size;
#line 248 "../src/chess-view.vala"
								cairo_translate (c, (gdouble) ((_tmp207_ - 4) * _tmp208_), (gdouble) ((3 - _tmp209_) * _tmp210_));
#line 249 "../src/chess-view.vala"
								_tmp211_ = self->priv->square_size;
#line 249 "../src/chess-view.vala"
								_tmp212_ = self->priv->square_size;
#line 249 "../src/chess-view.vala"
								cairo_translate (c, (gdouble) (_tmp211_ / 2), (gdouble) (_tmp212_ / 2));
#line 250 "../src/chess-view.vala"
								_tmp213_ = chess_view_get_scene (self);
#line 250 "../src/chess-view.vala"
								_tmp214_ = _tmp213_;
#line 250 "../src/chess-view.vala"
								_tmp215_ = chess_scene_get_board_angle (_tmp214_);
#line 250 "../src/chess-view.vala"
								_tmp216_ = _tmp215_;
#line 250 "../src/chess-view.vala"
								cairo_rotate (c, ((-G_PI) * _tmp216_) / 180.0);
#line 252 "../src/chess-view.vala"
								_tmp217_ = self->priv->model_surface;
#line 252 "../src/chess-view.vala"
								_tmp218_ = self->priv->square_size;
#line 252 "../src/chess-view.vala"
								_tmp219_ = chess_view_get_scene (self);
#line 252 "../src/chess-view.vala"
								_tmp220_ = _tmp219_;
#line 252 "../src/chess-view.vala"
								_tmp221_ = chess_scene_get_selected_piece (_tmp220_);
#line 252 "../src/chess-view.vala"
								_tmp222_ = _tmp221_;
#line 252 "../src/chess-view.vala"
								chess_view_draw_piece (self, c, _tmp217_, _tmp218_, _tmp222_, 0.1);
#line 252 "../src/chess-view.vala"
								_g_object_unref0 (_tmp222_);
#line 254 "../src/chess-view.vala"
								cairo_restore (c);
#line 1881 "chess-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 259 "../src/chess-view.vala"
	result = TRUE;
#line 259 "../src/chess-view.vala"
	return result;
#line 1893 "chess-view.c"
}


static void
chess_view_draw_piece (ChessView* self,
                       cairo_t* c,
                       cairo_surface_t* surface,
                       gint size,
                       ChessPiece* piece,
                       gdouble alpha)
{
	gint offset = 0;
	PieceType _tmp0_;
	Color _tmp1_;
	Color _tmp2_;
	gint _tmp4_;
#line 262 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/chess-view.vala"
	g_return_if_fail (c != NULL);
#line 262 "../src/chess-view.vala"
	g_return_if_fail (surface != NULL);
#line 262 "../src/chess-view.vala"
	g_return_if_fail (piece != NULL);
#line 264 "../src/chess-view.vala"
	cairo_translate (c, (gdouble) ((-size) / 2), (gdouble) ((-size) / 2));
#line 266 "../src/chess-view.vala"
	_tmp0_ = piece->type;
#line 266 "../src/chess-view.vala"
	offset = (gint) _tmp0_;
#line 267 "../src/chess-view.vala"
	_tmp1_ = chess_piece_get_color (piece);
#line 267 "../src/chess-view.vala"
	_tmp2_ = _tmp1_;
#line 267 "../src/chess-view.vala"
	if (_tmp2_ == COLOR_BLACK) {
#line 1930 "chess-view.c"
		gint _tmp3_;
#line 268 "../src/chess-view.vala"
		_tmp3_ = offset;
#line 268 "../src/chess-view.vala"
		offset = _tmp3_ + 6;
#line 1936 "chess-view.c"
	}
#line 269 "../src/chess-view.vala"
	_tmp4_ = offset;
#line 269 "../src/chess-view.vala"
	cairo_set_source_surface (c, surface, (gdouble) ((-_tmp4_) * size), (gdouble) 0);
#line 270 "../src/chess-view.vala"
	cairo_rectangle (c, (gdouble) 0, (gdouble) 0, (gdouble) size, (gdouble) size);
#line 271 "../src/chess-view.vala"
	cairo_clip (c);
#line 272 "../src/chess-view.vala"
	cairo_paint_with_alpha (c, alpha);
#line 1948 "chess-view.c"
}


static gboolean
chess_view_real_button_press_event (GtkWidget* base,
                                    GdkEventButton* event)
{
	ChessView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
	ChessGame* _tmp4_;
	ChessGame* _tmp5_;
	ChessScene* _tmp13_;
	ChessScene* _tmp14_;
	ChessGame* _tmp15_;
	ChessGame* _tmp16_;
	ChessResult _tmp17_;
	gint file = 0;
	gdouble _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint rank = 0;
	gdouble _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	ChessScene* _tmp24_;
	ChessScene* _tmp25_;
	gdouble _tmp26_;
	gdouble _tmp27_;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gint _tmp33_;
	ChessScene* _tmp37_;
	ChessScene* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
#line 275 "../src/chess-view.vala"
	self = (ChessView*) base;
#line 275 "../src/chess-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 277 "../src/chess-view.vala"
	_tmp2_ = chess_view_get_scene (self);
#line 277 "../src/chess-view.vala"
	_tmp3_ = _tmp2_;
#line 277 "../src/chess-view.vala"
	_tmp4_ = chess_scene_get_game (_tmp3_);
#line 277 "../src/chess-view.vala"
	_tmp5_ = _tmp4_;
#line 277 "../src/chess-view.vala"
	if (_tmp5_ == NULL) {
#line 277 "../src/chess-view.vala"
		_tmp1_ = TRUE;
#line 2005 "chess-view.c"
	} else {
		guint _tmp6_;
#line 277 "../src/chess-view.vala"
		_tmp6_ = event->button;
#line 277 "../src/chess-view.vala"
		_tmp1_ = _tmp6_ != ((guint) 1);
#line 2012 "chess-view.c"
	}
#line 277 "../src/chess-view.vala"
	if (_tmp1_) {
#line 277 "../src/chess-view.vala"
		_tmp0_ = TRUE;
#line 2018 "chess-view.c"
	} else {
		ChessScene* _tmp7_;
		ChessScene* _tmp8_;
		ChessGame* _tmp9_;
		ChessGame* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 277 "../src/chess-view.vala"
		_tmp7_ = chess_view_get_scene (self);
#line 277 "../src/chess-view.vala"
		_tmp8_ = _tmp7_;
#line 277 "../src/chess-view.vala"
		_tmp9_ = chess_scene_get_game (_tmp8_);
#line 277 "../src/chess-view.vala"
		_tmp10_ = _tmp9_;
#line 277 "../src/chess-view.vala"
		_tmp11_ = chess_game_get_should_show_paused_overlay (_tmp10_);
#line 277 "../src/chess-view.vala"
		_tmp12_ = _tmp11_;
#line 277 "../src/chess-view.vala"
		_tmp0_ = _tmp12_;
#line 2040 "chess-view.c"
	}
#line 277 "../src/chess-view.vala"
	if (_tmp0_) {
#line 278 "../src/chess-view.vala"
		result = FALSE;
#line 278 "../src/chess-view.vala"
		return result;
#line 2048 "chess-view.c"
	}
#line 281 "../src/chess-view.vala"
	_tmp13_ = chess_view_get_scene (self);
#line 281 "../src/chess-view.vala"
	_tmp14_ = _tmp13_;
#line 281 "../src/chess-view.vala"
	_tmp15_ = chess_scene_get_game (_tmp14_);
#line 281 "../src/chess-view.vala"
	_tmp16_ = _tmp15_;
#line 281 "../src/chess-view.vala"
	_tmp17_ = _tmp16_->result;
#line 281 "../src/chess-view.vala"
	if (_tmp17_ != CHESS_RESULT_IN_PROGRESS) {
#line 282 "../src/chess-view.vala"
		result = FALSE;
#line 282 "../src/chess-view.vala"
		return result;
#line 2066 "chess-view.c"
	}
#line 284 "../src/chess-view.vala"
	_tmp18_ = event->x;
#line 284 "../src/chess-view.vala"
	_tmp19_ = self->priv->square_size;
#line 284 "../src/chess-view.vala"
	_tmp20_ = self->priv->square_size;
#line 284 "../src/chess-view.vala"
	file = (gint) floor (((_tmp18_ - (0.5 * gtk_widget_get_allocated_width ((GtkWidget*) self))) + (_tmp19_ * 4)) / _tmp20_);
#line 285 "../src/chess-view.vala"
	_tmp21_ = event->y;
#line 285 "../src/chess-view.vala"
	_tmp22_ = self->priv->square_size;
#line 285 "../src/chess-view.vala"
	_tmp23_ = self->priv->square_size;
#line 285 "../src/chess-view.vala"
	rank = 7 - ((gint) floor (((_tmp21_ - (0.5 * gtk_widget_get_allocated_height ((GtkWidget*) self))) + (_tmp22_ * 4)) / _tmp23_));
#line 288 "../src/chess-view.vala"
	_tmp24_ = chess_view_get_scene (self);
#line 288 "../src/chess-view.vala"
	_tmp25_ = _tmp24_;
#line 288 "../src/chess-view.vala"
	_tmp26_ = chess_scene_get_board_angle (_tmp25_);
#line 288 "../src/chess-view.vala"
	_tmp27_ = _tmp26_;
#line 288 "../src/chess-view.vala"
	if (_tmp27_ == 180.0) {
#line 2094 "chess-view.c"
		gint _tmp28_;
		gint _tmp29_;
#line 290 "../src/chess-view.vala"
		_tmp28_ = rank;
#line 290 "../src/chess-view.vala"
		rank = 7 - _tmp28_;
#line 291 "../src/chess-view.vala"
		_tmp29_ = file;
#line 291 "../src/chess-view.vala"
		file = 7 - _tmp29_;
#line 2105 "chess-view.c"
	}
#line 294 "../src/chess-view.vala"
	_tmp33_ = file;
#line 294 "../src/chess-view.vala"
	if (_tmp33_ < 0) {
#line 294 "../src/chess-view.vala"
		_tmp32_ = TRUE;
#line 2113 "chess-view.c"
	} else {
		gint _tmp34_;
#line 294 "../src/chess-view.vala"
		_tmp34_ = file;
#line 294 "../src/chess-view.vala"
		_tmp32_ = _tmp34_ >= 8;
#line 2120 "chess-view.c"
	}
#line 294 "../src/chess-view.vala"
	if (_tmp32_) {
#line 294 "../src/chess-view.vala"
		_tmp31_ = TRUE;
#line 2126 "chess-view.c"
	} else {
		gint _tmp35_;
#line 294 "../src/chess-view.vala"
		_tmp35_ = rank;
#line 294 "../src/chess-view.vala"
		_tmp31_ = _tmp35_ < 0;
#line 2133 "chess-view.c"
	}
#line 294 "../src/chess-view.vala"
	if (_tmp31_) {
#line 294 "../src/chess-view.vala"
		_tmp30_ = TRUE;
#line 2139 "chess-view.c"
	} else {
		gint _tmp36_;
#line 294 "../src/chess-view.vala"
		_tmp36_ = rank;
#line 294 "../src/chess-view.vala"
		_tmp30_ = _tmp36_ >= 8;
#line 2146 "chess-view.c"
	}
#line 294 "../src/chess-view.vala"
	if (_tmp30_) {
#line 295 "../src/chess-view.vala"
		result = FALSE;
#line 295 "../src/chess-view.vala"
		return result;
#line 2154 "chess-view.c"
	}
#line 297 "../src/chess-view.vala"
	_tmp37_ = chess_view_get_scene (self);
#line 297 "../src/chess-view.vala"
	_tmp38_ = _tmp37_;
#line 297 "../src/chess-view.vala"
	_tmp39_ = file;
#line 297 "../src/chess-view.vala"
	_tmp40_ = rank;
#line 297 "../src/chess-view.vala"
	chess_scene_select_square (_tmp38_, _tmp39_, _tmp40_);
#line 299 "../src/chess-view.vala"
	result = TRUE;
#line 299 "../src/chess-view.vala"
	return result;
#line 2170 "chess-view.c"
}


static void
chess_view_scene_changed_cb (ChessView* self,
                             ChessScene* scene)
{
#line 302 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 302 "../src/chess-view.vala"
	g_return_if_fail (scene != NULL);
#line 304 "../src/chess-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 2184 "chess-view.c"
}


void
chess_view_draw_paused_overlay (ChessView* self,
                                cairo_t* c)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	gdouble _tmp3_;
	cairo_text_extents_t _tmp4_;
	gdouble _tmp5_;
#line 307 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/chess-view.vala"
	g_return_if_fail (c != NULL);
#line 309 "../src/chess-view.vala"
	cairo_save (c);
#line 311 "../src/chess-view.vala"
	cairo_set_source_rgba (c, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.75);
#line 312 "../src/chess-view.vala"
	cairo_paint (c);
#line 314 "../src/chess-view.vala"
	cairo_select_font_face (c, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 315 "../src/chess-view.vala"
	cairo_set_font_size (c, gtk_widget_get_allocated_width ((GtkWidget*) self) * 0.125);
#line 317 "../src/chess-view.vala"
	_tmp0_ = g_strdup (_ ("Paused"));
#line 317 "../src/chess-view.vala"
	text = _tmp0_;
#line 319 "../src/chess-view.vala"
	cairo_text_extents (c, text, &_tmp1_);
#line 319 "../src/chess-view.vala"
	extents = _tmp1_;
#line 320 "../src/chess-view.vala"
	_tmp2_ = extents;
#line 320 "../src/chess-view.vala"
	_tmp3_ = _tmp2_.width;
#line 320 "../src/chess-view.vala"
	_tmp4_ = extents;
#line 320 "../src/chess-view.vala"
	_tmp5_ = _tmp4_.height;
#line 320 "../src/chess-view.vala"
	cairo_move_to (c, (-_tmp3_) / 2.0, _tmp5_ / 2.0);
#line 321 "../src/chess-view.vala"
	cairo_set_source_rgb (c, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 322 "../src/chess-view.vala"
	cairo_show_text (c, text);
#line 324 "../src/chess-view.vala"
	cairo_restore (c);
#line 307 "../src/chess-view.vala"
	_g_free0 (text);
#line 2240 "chess-view.c"
}


ChessScene*
chess_view_get_scene (ChessView* self)
{
	ChessScene* result;
	ChessScene* _tmp0_;
#line 25 "../src/chess-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/chess-view.vala"
	_tmp0_ = self->priv->_scene;
#line 25 "../src/chess-view.vala"
	result = _tmp0_;
#line 25 "../src/chess-view.vala"
	return result;
#line 2257 "chess-view.c"
}


static void
_chess_view_scene_changed_cb_chess_scene_changed (ChessScene* _sender,
                                                  gpointer self)
{
#line 29 "../src/chess-view.vala"
	chess_view_scene_changed_cb ((ChessView*) self, _sender);
#line 2267 "chess-view.c"
}


void
chess_view_set_scene (ChessView* self,
                      ChessScene* value)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
#line 26 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/chess-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/chess-view.vala"
	_g_object_unref0 (self->priv->_scene);
#line 28 "../src/chess-view.vala"
	self->priv->_scene = _tmp0_;
#line 29 "../src/chess-view.vala"
	_tmp1_ = self->priv->_scene;
#line 29 "../src/chess-view.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _chess_view_scene_changed_cb_chess_scene_changed, self, 0);
#line 30 "../src/chess-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 26 "../src/chess-view.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_view_properties[CHESS_VIEW_SCENE_PROPERTY]);
#line 2293 "chess-view.c"
}


static gdouble
chess_view_get_border_size (ChessView* self)
{
	gdouble result;
	gint _tmp0_;
#line 36 "../src/chess-view.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 36 "../src/chess-view.vala"
	_tmp0_ = self->priv->square_size;
#line 36 "../src/chess-view.vala"
	result = (gdouble) (_tmp0_ / 2);
#line 36 "../src/chess-view.vala"
	return result;
#line 2310 "chess-view.c"
}


static void
chess_view_class_init (ChessViewClass * klass)
{
#line 13 "../src/chess-view.vala"
	chess_view_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/chess-view.vala"
	g_type_class_adjust_private_offset (klass, &ChessView_private_offset);
#line 13 "../src/chess-view.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) chess_view_real_configure_event;
#line 13 "../src/chess-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) chess_view_real_draw;
#line 13 "../src/chess-view.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) chess_view_real_button_press_event;
#line 13 "../src/chess-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_view_get_property;
#line 13 "../src/chess-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_view_set_property;
#line 13 "../src/chess-view.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_view_finalize;
#line 13 "../src/chess-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_VIEW_SCENE_PROPERTY, chess_view_properties[CHESS_VIEW_SCENE_PROPERTY] = g_param_spec_object ("scene", "scene", "scene", TYPE_CHESS_SCENE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2335 "chess-view.c"
}


static void
chess_view_instance_init (ChessView * self)
{
	gchar* _tmp0_;
#line 13 "../src/chess-view.vala"
	self->priv = chess_view_get_instance_private (self);
#line 15 "../src/chess-view.vala"
	self->priv->border = 6;
#line 20 "../src/chess-view.vala"
	_tmp0_ = g_strdup ("");
#line 20 "../src/chess-view.vala"
	self->priv->loaded_theme_name = _tmp0_;
#line 2351 "chess-view.c"
}


static void
chess_view_finalize (GObject * obj)
{
	ChessView * self;
#line 13 "../src/chess-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_VIEW, ChessView);
#line 18 "../src/chess-view.vala"
	_cairo_surface_destroy0 (self->priv->model_surface);
#line 19 "../src/chess-view.vala"
	_cairo_surface_destroy0 (self->priv->selected_model_surface);
#line 20 "../src/chess-view.vala"
	_g_free0 (self->priv->loaded_theme_name);
#line 22 "../src/chess-view.vala"
	_g_object_unref0 (self->priv->_scene);
#line 13 "../src/chess-view.vala"
	G_OBJECT_CLASS (chess_view_parent_class)->finalize (obj);
#line 2371 "chess-view.c"
}


GType
chess_view_get_type (void)
{
	static volatile gsize chess_view_type_id__volatile = 0;
	if (g_once_init_enter (&chess_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessView), 0, (GInstanceInitFunc) chess_view_instance_init, NULL };
		GType chess_view_type_id;
		chess_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "ChessView", &g_define_type_info, 0);
		ChessView_private_offset = g_type_add_instance_private (chess_view_type_id, sizeof (ChessViewPrivate));
		g_once_init_leave (&chess_view_type_id__volatile, chess_view_type_id);
	}
	return chess_view_type_id__volatile;
}


static void
_vala_chess_view_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	ChessView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_VIEW, ChessView);
#line 13 "../src/chess-view.vala"
	switch (property_id) {
#line 13 "../src/chess-view.vala"
		case CHESS_VIEW_SCENE_PROPERTY:
#line 13 "../src/chess-view.vala"
		g_value_set_object (value, chess_view_get_scene (self));
#line 13 "../src/chess-view.vala"
		break;
#line 2406 "chess-view.c"
		default:
#line 13 "../src/chess-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/chess-view.vala"
		break;
#line 2412 "chess-view.c"
	}
}


static void
_vala_chess_view_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	ChessView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_VIEW, ChessView);
#line 13 "../src/chess-view.vala"
	switch (property_id) {
#line 13 "../src/chess-view.vala"
		case CHESS_VIEW_SCENE_PROPERTY:
#line 13 "../src/chess-view.vala"
		chess_view_set_scene (self, g_value_get_object (value));
#line 13 "../src/chess-view.vala"
		break;
#line 2433 "chess-view.c"
		default:
#line 13 "../src/chess-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/chess-view.vala"
		break;
#line 2439 "chess-view.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



