/* chess-state.c generated by valac 0.42.6, the Vala compiler
 * generated from chess-state.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	CHECK_STATE_NONE,
	CHECK_STATE_CHECK,
	CHECK_STATE_CHECKMATE
} CheckState;


#define TYPE_CHECK_STATE (check_state_get_type ())

#define TYPE_CHESS_STATE (chess_state_get_type ())
#define CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_STATE, ChessState))
#define CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_STATE, ChessStateClass))
#define IS_CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_STATE))
#define IS_CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_STATE))
#define CHESS_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_STATE, ChessStateClass))

typedef struct _ChessState ChessState;
typedef struct _ChessStateClass ChessStateClass;
typedef struct _ChessStatePrivate ChessStatePrivate;

#define TYPE_CHESS_PLAYER (chess_player_get_type ())
#define CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PLAYER, ChessPlayer))
#define CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PLAYER, ChessPlayerClass))
#define IS_CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PLAYER))
#define IS_CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PLAYER))
#define CHESS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PLAYER, ChessPlayerClass))

typedef struct _ChessPlayer ChessPlayer;
typedef struct _ChessPlayerClass ChessPlayerClass;

#define TYPE_CHESS_PIECE (chess_piece_get_type ())
#define CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PIECE, ChessPiece))
#define CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PIECE, ChessPieceClass))
#define IS_CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PIECE))
#define IS_CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PIECE))
#define CHESS_PIECE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PIECE, ChessPieceClass))

typedef struct _ChessPiece ChessPiece;
typedef struct _ChessPieceClass ChessPieceClass;

#define TYPE_CHESS_MOVE (chess_move_get_type ())
#define CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MOVE, ChessMove))
#define CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MOVE, ChessMoveClass))
#define IS_CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MOVE))
#define IS_CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MOVE))
#define CHESS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MOVE, ChessMoveClass))

typedef struct _ChessMove ChessMove;
typedef struct _ChessMoveClass ChessMoveClass;
enum  {
	CHESS_STATE_0_PROPERTY,
	CHESS_STATE_OPPONENT_PROPERTY,
	CHESS_STATE_NUM_PROPERTIES
};
static GParamSpec* chess_state_properties[CHESS_STATE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	COLOR_WHITE,
	COLOR_BLACK
} Color;


#define TYPE_COLOR (color_get_type ())
typedef enum  {
	PIECE_TYPE_PAWN,
	PIECE_TYPE_ROOK,
	PIECE_TYPE_KNIGHT,
	PIECE_TYPE_BISHOP,
	PIECE_TYPE_QUEEN,
	PIECE_TYPE_KING
} PieceType;


#define TYPE_PIECE_TYPE (piece_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ChessPlayerPrivate ChessPlayerPrivate;
typedef struct _ChessPiecePrivate ChessPiecePrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ChessMovePrivate ChessMovePrivate;
typedef enum  {
	CHESS_RULE_UNKNOWN,
	CHESS_RULE_CHECKMATE,
	CHESS_RULE_STALEMATE,
	CHESS_RULE_FIFTY_MOVES,
	CHESS_RULE_SEVENTY_FIVE_MOVES,
	CHESS_RULE_TIMEOUT,
	CHESS_RULE_THREE_FOLD_REPETITION,
	CHESS_RULE_FIVE_FOLD_REPETITION,
	CHESS_RULE_INSUFFICIENT_MATERIAL,
	CHESS_RULE_RESIGN,
	CHESS_RULE_ABANDONMENT,
	CHESS_RULE_DEATH,
	CHESS_RULE_BUG
} ChessRule;


#define TYPE_CHESS_RULE (chess_rule_get_type ())
typedef enum  {
	CHESS_RESULT_IN_PROGRESS,
	CHESS_RESULT_WHITE_WON,
	CHESS_RESULT_BLACK_WON,
	CHESS_RESULT_DRAW,
	CHESS_RESULT_BUG
} ChessResult;


#define TYPE_CHESS_RESULT (chess_result_get_type ())

struct _ChessState {
	GObject parent_instance;
	ChessStatePrivate * priv;
	gint number;
	ChessPlayer* players[2];
	ChessPlayer* current_player;
	gboolean can_castle_kingside[2];
	gboolean can_castle_queenside[2];
	gint en_passant_index;
	CheckState check_state;
	gint halfmove_clock;
	ChessPiece* board[64];
	ChessMove* last_move;
};

struct _ChessStateClass {
	GObjectClass parent_class;
};

struct _ChessStatePrivate {
	gint64 piece_masks[2];
};

struct _ChessPlayer {
	GObject parent_instance;
	ChessPlayerPrivate * priv;
	Color color;
};

struct _ChessPlayerClass {
	GObjectClass parent_class;
};

struct _ChessPiece {
	GObject parent_instance;
	ChessPiecePrivate * priv;
	ChessPlayer* player;
	PieceType type;
};

struct _ChessPieceClass {
	GObjectClass parent_class;
};

struct _ChessMove {
	GObject parent_instance;
	ChessMovePrivate * priv;
	gint number;
	ChessPiece* piece;
	ChessPiece* promotion_piece;
	ChessPiece* castling_rook;
	ChessPiece* victim;
	gint r0;
	gint f0;
	gint r1;
	gint f1;
	gboolean ambiguous_rank;
	gboolean ambiguous_file;
	gboolean en_passant;
	CheckState check_state;
};

struct _ChessMoveClass {
	GObjectClass parent_class;
};


static gint ChessState_private_offset;
static gpointer chess_state_parent_class = NULL;

GType check_state_get_type (void) G_GNUC_CONST;
GType chess_state_get_type (void) G_GNUC_CONST;
GType chess_player_get_type (void) G_GNUC_CONST;
GType chess_piece_get_type (void) G_GNUC_CONST;
GType chess_move_get_type (void) G_GNUC_CONST;
static ChessState* chess_state_new_empty (void);
static ChessState* chess_state_construct_empty (GType object_type);
ChessState* chess_state_new (const gchar* fen);
ChessState* chess_state_construct (GType object_type,
                                   const gchar* fen);
GType color_get_type (void) G_GNUC_CONST;
ChessPlayer* chess_player_new (Color color);
ChessPlayer* chess_player_construct (GType object_type,
                                     Color color);
GType piece_type_get_type (void) G_GNUC_CONST;
static gboolean chess_state_decode_piece_type (ChessState* self,
                                        gunichar c,
                                        PieceType* type);
gint chess_state_get_index (ChessState* self,
                            gint rank,
                            gint file);
ChessPiece* chess_piece_new (ChessPlayer* player,
                             PieceType type);
ChessPiece* chess_piece_construct (GType object_type,
                                   ChessPlayer* player,
                                   PieceType type);
static CheckState chess_state_get_check_state (ChessState* self,
                                        ChessPlayer* player);
ChessState* chess_state_copy (ChessState* self);
ChessMove* chess_move_copy (ChessMove* self);
gboolean chess_state_equals (ChessState* self,
                             ChessState* state);
gchar* chess_state_get_fen (ChessState* self);
gunichar chess_piece_get_symbol (ChessPiece* self);
gint chess_state_get_file (ChessState* self,
                           gint index);
gint chess_state_get_rank (ChessState* self,
                           gint index);
gboolean chess_state_move (ChessState* self,
                           const gchar* move,
                           gboolean apply);
static gboolean chess_state_decode_move (ChessState* self,
                                  ChessPlayer* player,
                                  const gchar* move,
                                  gint* r0,
                                  gint* f0,
                                  gint* r1,
                                  gint* f1,
                                  PieceType* promotion_type);
gboolean chess_state_move_with_coords (ChessState* self,
                                       ChessPlayer* player,
                                       gint r0,
                                       gint f0,
                                       gint r1,
                                       gint f1,
                                       PieceType promotion_type,
                                       gboolean apply,
                                       gboolean test_check);
Color chess_piece_get_color (ChessPiece* self);
gboolean chess_state_is_in_check (ChessState* self,
                                  ChessPlayer* player);
ChessMove* chess_move_new (void);
ChessMove* chess_move_construct (GType object_type);
GType chess_rule_get_type (void) G_GNUC_CONST;
GType chess_result_get_type (void) G_GNUC_CONST;
ChessResult chess_state_get_result (ChessState* self,
                                    ChessRule* rule);
static gboolean chess_state_can_move (ChessState* self,
                               ChessPlayer* player);
gboolean chess_state_have_sufficient_material (ChessState* self);
static gboolean chess_state_is_in_checkmate (ChessState* self,
                                      ChessPlayer* player);
ChessPlayer* chess_state_get_opponent (ChessState* self);
static void chess_state_finalize (GObject * obj);
static void _vala_chess_state_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

extern const gint64 BIT_BOARD_set_location_masks[64];
extern const gint64 BIT_BOARD_move_masks[768];
extern const gint64 BIT_BOARD_over_masks[4096];
extern const gint64 BIT_BOARD_clear_location_masks[64];

GType
check_state_get_type (void)
{
	static volatile gsize check_state_type_id__volatile = 0;
	if (g_once_init_enter (&check_state_type_id__volatile)) {
		static const GEnumValue values[] = {{CHECK_STATE_NONE, "CHECK_STATE_NONE", "none"}, {CHECK_STATE_CHECK, "CHECK_STATE_CHECK", "check"}, {CHECK_STATE_CHECKMATE, "CHECK_STATE_CHECKMATE", "checkmate"}, {0, NULL, NULL}};
		GType check_state_type_id;
		check_state_type_id = g_enum_register_static ("CheckState", values);
		g_once_init_leave (&check_state_type_id__volatile, check_state_type_id);
	}
	return check_state_type_id__volatile;
}


static inline gpointer
chess_state_get_instance_private (ChessState* self)
{
	return G_STRUCT_MEMBER_P (self, ChessState_private_offset);
}


static ChessState*
chess_state_construct_empty (GType object_type)
{
	ChessState * self = NULL;
#line 41 "../lib/chess-state.vala"
	self = (ChessState*) g_object_new (object_type, NULL);
#line 41 "../lib/chess-state.vala"
	return self;
#line 321 "chess-state.c"
}


static ChessState*
chess_state_new_empty (void)
{
#line 41 "../lib/chess-state.vala"
	return chess_state_construct_empty (TYPE_CHESS_STATE);
#line 330 "chess-state.c"
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 348 "chess-state.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 80 "../lib/chess-state.vala"
	return self ? g_object_ref (self) : NULL;
#line 357 "chess-state.c"
}


ChessState*
chess_state_construct (GType object_type,
                       const gchar* fen)
{
	ChessState * self = NULL;
	ChessPlayer* _tmp0_;
	ChessPlayer* _tmp1_;
	gchar** fields = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint fields_length1;
	gint _fields_size_;
	gchar** ranks = NULL;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint ranks_length1;
	gint _ranks_size_;
	gchar** _tmp52_;
	gint _tmp52__length1;
	const gchar* _tmp53_;
	gchar** _tmp60_;
	gint _tmp60__length1;
	const gchar* _tmp61_;
	gchar** _tmp76_;
	gint _tmp76__length1;
	const gchar* _tmp77_;
	gchar** _tmp82_;
	gint _tmp82__length1;
	const gchar* _tmp83_;
	gchar** _tmp84_;
	gint _tmp84__length1;
	const gchar* _tmp85_;
	ChessPlayer* _tmp86_;
	Color _tmp87_;
	ChessPlayer* _tmp89_;
#line 46 "../lib/chess-state.vala"
	g_return_val_if_fail (fen != NULL, NULL);
#line 46 "../lib/chess-state.vala"
	self = (ChessState*) g_object_new (object_type, NULL);
#line 48 "../lib/chess-state.vala"
	_tmp0_ = chess_player_new (COLOR_WHITE);
#line 48 "../lib/chess-state.vala"
	_g_object_unref0 (self->players[COLOR_WHITE]);
#line 48 "../lib/chess-state.vala"
	self->players[COLOR_WHITE] = _tmp0_;
#line 49 "../lib/chess-state.vala"
	_tmp1_ = chess_player_new (COLOR_BLACK);
#line 49 "../lib/chess-state.vala"
	_g_object_unref0 (self->players[COLOR_BLACK]);
#line 49 "../lib/chess-state.vala"
	self->players[COLOR_BLACK] = _tmp1_;
#line 415 "chess-state.c"
	{
		gint i = 0;
#line 50 "../lib/chess-state.vala"
		i = 0;
#line 420 "chess-state.c"
		{
			gboolean _tmp2_ = FALSE;
#line 50 "../lib/chess-state.vala"
			_tmp2_ = TRUE;
#line 50 "../lib/chess-state.vala"
			while (TRUE) {
#line 427 "chess-state.c"
				gint _tmp4_;
				gint _tmp5_;
#line 50 "../lib/chess-state.vala"
				if (!_tmp2_) {
#line 432 "chess-state.c"
					gint _tmp3_;
#line 50 "../lib/chess-state.vala"
					_tmp3_ = i;
#line 50 "../lib/chess-state.vala"
					i = _tmp3_ + 1;
#line 438 "chess-state.c"
				}
#line 50 "../lib/chess-state.vala"
				_tmp2_ = FALSE;
#line 50 "../lib/chess-state.vala"
				_tmp4_ = i;
#line 50 "../lib/chess-state.vala"
				if (!(_tmp4_ < 64)) {
#line 50 "../lib/chess-state.vala"
					break;
#line 448 "chess-state.c"
				}
#line 51 "../lib/chess-state.vala"
				_tmp5_ = i;
#line 51 "../lib/chess-state.vala"
				_g_object_unref0 (self->board[_tmp5_]);
#line 51 "../lib/chess-state.vala"
				self->board[_tmp5_] = NULL;
#line 456 "chess-state.c"
			}
		}
	}
#line 53 "../lib/chess-state.vala"
	_tmp7_ = _tmp6_ = g_strsplit (fen, " ", 0);
#line 53 "../lib/chess-state.vala"
	fields = _tmp7_;
#line 53 "../lib/chess-state.vala"
	fields_length1 = _vala_array_length (_tmp6_);
#line 53 "../lib/chess-state.vala"
	_fields_size_ = fields_length1;
#line 58 "../lib/chess-state.vala"
	_tmp8_ = fields;
#line 58 "../lib/chess-state.vala"
	_tmp8__length1 = fields_length1;
#line 58 "../lib/chess-state.vala"
	_tmp9_ = _tmp8_[0];
#line 58 "../lib/chess-state.vala"
	_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, "/", 0);
#line 58 "../lib/chess-state.vala"
	ranks = _tmp11_;
#line 58 "../lib/chess-state.vala"
	ranks_length1 = _vala_array_length (_tmp10_);
#line 58 "../lib/chess-state.vala"
	_ranks_size_ = ranks_length1;
#line 482 "chess-state.c"
	{
		gint rank = 0;
#line 61 "../lib/chess-state.vala"
		rank = 0;
#line 487 "chess-state.c"
		{
			gboolean _tmp12_ = FALSE;
#line 61 "../lib/chess-state.vala"
			_tmp12_ = TRUE;
#line 61 "../lib/chess-state.vala"
			while (TRUE) {
#line 494 "chess-state.c"
				gint _tmp14_;
				gchar* rank_string = NULL;
				gchar** _tmp15_;
				gint _tmp15__length1;
				gint _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
#line 61 "../lib/chess-state.vala"
				if (!_tmp12_) {
#line 504 "chess-state.c"
					gint _tmp13_;
#line 61 "../lib/chess-state.vala"
					_tmp13_ = rank;
#line 61 "../lib/chess-state.vala"
					rank = _tmp13_ + 1;
#line 510 "chess-state.c"
				}
#line 61 "../lib/chess-state.vala"
				_tmp12_ = FALSE;
#line 61 "../lib/chess-state.vala"
				_tmp14_ = rank;
#line 61 "../lib/chess-state.vala"
				if (!(_tmp14_ < 8)) {
#line 61 "../lib/chess-state.vala"
					break;
#line 520 "chess-state.c"
				}
#line 63 "../lib/chess-state.vala"
				_tmp15_ = ranks;
#line 63 "../lib/chess-state.vala"
				_tmp15__length1 = ranks_length1;
#line 63 "../lib/chess-state.vala"
				_tmp16_ = rank;
#line 63 "../lib/chess-state.vala"
				_tmp17_ = _tmp15_[7 - _tmp16_];
#line 63 "../lib/chess-state.vala"
				_tmp18_ = g_strdup (_tmp17_);
#line 63 "../lib/chess-state.vala"
				rank_string = _tmp18_;
#line 534 "chess-state.c"
				{
					gint file = 0;
					gint offset = 0;
#line 64 "../lib/chess-state.vala"
					file = 0;
#line 64 "../lib/chess-state.vala"
					offset = 0;
#line 542 "chess-state.c"
					{
						gboolean _tmp19_ = FALSE;
#line 64 "../lib/chess-state.vala"
						_tmp19_ = TRUE;
#line 64 "../lib/chess-state.vala"
						while (TRUE) {
#line 549 "chess-state.c"
							gboolean _tmp21_ = FALSE;
							gint _tmp22_;
							gchar c = '\0';
							const gchar* _tmp27_;
							gint _tmp28_;
							gboolean _tmp29_ = FALSE;
							gchar _tmp30_;
							PieceType type = 0;
							Color _tmp34_ = 0;
							gchar _tmp35_;
							Color color = 0;
							gchar _tmp36_;
							PieceType _tmp37_ = 0;
							gint index = 0;
							gint _tmp38_;
							gint _tmp39_;
							ChessPiece* piece = NULL;
							Color _tmp40_;
							ChessPlayer* _tmp41_;
							PieceType _tmp42_;
							ChessPiece* _tmp43_;
							gint _tmp44_;
							ChessPiece* _tmp45_;
							ChessPiece* _tmp46_;
							gint64 mask = 0LL;
							gint _tmp47_;
							gint64 _tmp48_;
							Color _tmp49_;
							gint64 _tmp50_;
							gint _tmp51_;
#line 64 "../lib/chess-state.vala"
							if (!_tmp19_) {
#line 582 "chess-state.c"
								gint _tmp20_;
#line 64 "../lib/chess-state.vala"
								_tmp20_ = offset;
#line 64 "../lib/chess-state.vala"
								offset = _tmp20_ + 1;
#line 588 "chess-state.c"
							}
#line 64 "../lib/chess-state.vala"
							_tmp19_ = FALSE;
#line 64 "../lib/chess-state.vala"
							_tmp22_ = file;
#line 64 "../lib/chess-state.vala"
							if (_tmp22_ < 8) {
#line 596 "chess-state.c"
								gint _tmp23_;
								const gchar* _tmp24_;
								gint _tmp25_;
								gint _tmp26_;
#line 64 "../lib/chess-state.vala"
								_tmp23_ = offset;
#line 64 "../lib/chess-state.vala"
								_tmp24_ = rank_string;
#line 64 "../lib/chess-state.vala"
								_tmp25_ = strlen (_tmp24_);
#line 64 "../lib/chess-state.vala"
								_tmp26_ = _tmp25_;
#line 64 "../lib/chess-state.vala"
								_tmp21_ = _tmp23_ < _tmp26_;
#line 611 "chess-state.c"
							} else {
#line 64 "../lib/chess-state.vala"
								_tmp21_ = FALSE;
#line 615 "chess-state.c"
							}
#line 64 "../lib/chess-state.vala"
							if (!_tmp21_) {
#line 64 "../lib/chess-state.vala"
								break;
#line 621 "chess-state.c"
							}
#line 66 "../lib/chess-state.vala"
							_tmp27_ = rank_string;
#line 66 "../lib/chess-state.vala"
							_tmp28_ = offset;
#line 66 "../lib/chess-state.vala"
							c = string_get (_tmp27_, (glong) _tmp28_);
#line 67 "../lib/chess-state.vala"
							_tmp30_ = c;
#line 67 "../lib/chess-state.vala"
							if (_tmp30_ >= '1') {
#line 633 "chess-state.c"
								gchar _tmp31_;
#line 67 "../lib/chess-state.vala"
								_tmp31_ = c;
#line 67 "../lib/chess-state.vala"
								_tmp29_ = _tmp31_ <= '8';
#line 639 "chess-state.c"
							} else {
#line 67 "../lib/chess-state.vala"
								_tmp29_ = FALSE;
#line 643 "chess-state.c"
							}
#line 67 "../lib/chess-state.vala"
							if (_tmp29_) {
#line 647 "chess-state.c"
								gint _tmp32_;
								gchar _tmp33_;
#line 69 "../lib/chess-state.vala"
								_tmp32_ = file;
#line 69 "../lib/chess-state.vala"
								_tmp33_ = c;
#line 69 "../lib/chess-state.vala"
								file = _tmp32_ + (_tmp33_ - '0');
#line 70 "../lib/chess-state.vala"
								continue;
#line 658 "chess-state.c"
							}
#line 74 "../lib/chess-state.vala"
							_tmp35_ = c;
#line 74 "../lib/chess-state.vala"
							if (g_ascii_isupper (_tmp35_)) {
#line 74 "../lib/chess-state.vala"
								_tmp34_ = COLOR_WHITE;
#line 666 "chess-state.c"
							} else {
#line 74 "../lib/chess-state.vala"
								_tmp34_ = COLOR_BLACK;
#line 670 "chess-state.c"
							}
#line 74 "../lib/chess-state.vala"
							color = _tmp34_;
#line 75 "../lib/chess-state.vala"
							_tmp36_ = c;
#line 75 "../lib/chess-state.vala"
							chess_state_decode_piece_type (self, (gunichar) g_ascii_toupper (_tmp36_), &_tmp37_);
#line 75 "../lib/chess-state.vala"
							type = _tmp37_;
#line 78 "../lib/chess-state.vala"
							_tmp38_ = rank;
#line 78 "../lib/chess-state.vala"
							_tmp39_ = file;
#line 78 "../lib/chess-state.vala"
							index = chess_state_get_index (self, _tmp38_, _tmp39_);
#line 79 "../lib/chess-state.vala"
							_tmp40_ = color;
#line 79 "../lib/chess-state.vala"
							_tmp41_ = self->players[_tmp40_];
#line 79 "../lib/chess-state.vala"
							_tmp42_ = type;
#line 79 "../lib/chess-state.vala"
							_tmp43_ = chess_piece_new (_tmp41_, _tmp42_);
#line 79 "../lib/chess-state.vala"
							piece = _tmp43_;
#line 80 "../lib/chess-state.vala"
							_tmp44_ = index;
#line 80 "../lib/chess-state.vala"
							_tmp45_ = piece;
#line 80 "../lib/chess-state.vala"
							_tmp46_ = _g_object_ref0 (_tmp45_);
#line 80 "../lib/chess-state.vala"
							_g_object_unref0 (self->board[_tmp44_]);
#line 80 "../lib/chess-state.vala"
							self->board[_tmp44_] = _tmp46_;
#line 81 "../lib/chess-state.vala"
							_tmp47_ = index;
#line 81 "../lib/chess-state.vala"
							_tmp48_ = BIT_BOARD_set_location_masks[_tmp47_];
#line 81 "../lib/chess-state.vala"
							mask = _tmp48_;
#line 82 "../lib/chess-state.vala"
							_tmp49_ = color;
#line 82 "../lib/chess-state.vala"
							_tmp50_ = mask;
#line 82 "../lib/chess-state.vala"
							self->priv->piece_masks[_tmp49_] |= _tmp50_;
#line 83 "../lib/chess-state.vala"
							_tmp51_ = file;
#line 83 "../lib/chess-state.vala"
							file = _tmp51_ + 1;
#line 64 "../lib/chess-state.vala"
							_g_object_unref0 (piece);
#line 724 "chess-state.c"
						}
					}
				}
#line 61 "../lib/chess-state.vala"
				_g_free0 (rank_string);
#line 730 "chess-state.c"
			}
		}
	}
#line 88 "../lib/chess-state.vala"
	_tmp52_ = fields;
#line 88 "../lib/chess-state.vala"
	_tmp52__length1 = fields_length1;
#line 88 "../lib/chess-state.vala"
	_tmp53_ = _tmp52_[1];
#line 88 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp53_, "w") == 0) {
#line 742 "chess-state.c"
		ChessPlayer* _tmp54_;
		ChessPlayer* _tmp55_;
#line 89 "../lib/chess-state.vala"
		_tmp54_ = self->players[COLOR_WHITE];
#line 89 "../lib/chess-state.vala"
		_tmp55_ = _g_object_ref0 (_tmp54_);
#line 89 "../lib/chess-state.vala"
		_g_object_unref0 (self->current_player);
#line 89 "../lib/chess-state.vala"
		self->current_player = _tmp55_;
#line 753 "chess-state.c"
	} else {
		gchar** _tmp56_;
		gint _tmp56__length1;
		const gchar* _tmp57_;
#line 90 "../lib/chess-state.vala"
		_tmp56_ = fields;
#line 90 "../lib/chess-state.vala"
		_tmp56__length1 = fields_length1;
#line 90 "../lib/chess-state.vala"
		_tmp57_ = _tmp56_[1];
#line 90 "../lib/chess-state.vala"
		if (g_strcmp0 (_tmp57_, "b") == 0) {
#line 766 "chess-state.c"
			ChessPlayer* _tmp58_;
			ChessPlayer* _tmp59_;
#line 91 "../lib/chess-state.vala"
			_tmp58_ = self->players[COLOR_BLACK];
#line 91 "../lib/chess-state.vala"
			_tmp59_ = _g_object_ref0 (_tmp58_);
#line 91 "../lib/chess-state.vala"
			_g_object_unref0 (self->current_player);
#line 91 "../lib/chess-state.vala"
			self->current_player = _tmp59_;
#line 777 "chess-state.c"
		}
	}
#line 96 "../lib/chess-state.vala"
	_tmp60_ = fields;
#line 96 "../lib/chess-state.vala"
	_tmp60__length1 = fields_length1;
#line 96 "../lib/chess-state.vala"
	_tmp61_ = _tmp60_[2];
#line 96 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp61_, "-") != 0) {
#line 788 "chess-state.c"
		{
			gint i = 0;
#line 98 "../lib/chess-state.vala"
			i = 0;
#line 793 "chess-state.c"
			{
				gboolean _tmp62_ = FALSE;
#line 98 "../lib/chess-state.vala"
				_tmp62_ = TRUE;
#line 98 "../lib/chess-state.vala"
				while (TRUE) {
#line 800 "chess-state.c"
					gint _tmp64_;
					gchar** _tmp65_;
					gint _tmp65__length1;
					const gchar* _tmp66_;
					gint _tmp67_;
					gint _tmp68_;
					gchar c = '\0';
					gchar** _tmp69_;
					gint _tmp69__length1;
					const gchar* _tmp70_;
					gint _tmp71_;
					gchar _tmp72_;
#line 98 "../lib/chess-state.vala"
					if (!_tmp62_) {
#line 815 "chess-state.c"
						gint _tmp63_;
#line 98 "../lib/chess-state.vala"
						_tmp63_ = i;
#line 98 "../lib/chess-state.vala"
						i = _tmp63_ + 1;
#line 821 "chess-state.c"
					}
#line 98 "../lib/chess-state.vala"
					_tmp62_ = FALSE;
#line 98 "../lib/chess-state.vala"
					_tmp64_ = i;
#line 98 "../lib/chess-state.vala"
					_tmp65_ = fields;
#line 98 "../lib/chess-state.vala"
					_tmp65__length1 = fields_length1;
#line 98 "../lib/chess-state.vala"
					_tmp66_ = _tmp65_[2];
#line 98 "../lib/chess-state.vala"
					_tmp67_ = strlen (_tmp66_);
#line 98 "../lib/chess-state.vala"
					_tmp68_ = _tmp67_;
#line 98 "../lib/chess-state.vala"
					if (!(_tmp64_ < _tmp68_)) {
#line 98 "../lib/chess-state.vala"
						break;
#line 841 "chess-state.c"
					}
#line 100 "../lib/chess-state.vala"
					_tmp69_ = fields;
#line 100 "../lib/chess-state.vala"
					_tmp69__length1 = fields_length1;
#line 100 "../lib/chess-state.vala"
					_tmp70_ = _tmp69_[2];
#line 100 "../lib/chess-state.vala"
					_tmp71_ = i;
#line 100 "../lib/chess-state.vala"
					c = string_get (_tmp70_, (glong) _tmp71_);
#line 101 "../lib/chess-state.vala"
					_tmp72_ = c;
#line 101 "../lib/chess-state.vala"
					if (_tmp72_ == 'K') {
#line 102 "../lib/chess-state.vala"
						self->can_castle_kingside[COLOR_WHITE] = TRUE;
#line 859 "chess-state.c"
					} else {
						gchar _tmp73_;
#line 103 "../lib/chess-state.vala"
						_tmp73_ = c;
#line 103 "../lib/chess-state.vala"
						if (_tmp73_ == 'Q') {
#line 104 "../lib/chess-state.vala"
							self->can_castle_queenside[COLOR_WHITE] = TRUE;
#line 868 "chess-state.c"
						} else {
							gchar _tmp74_;
#line 105 "../lib/chess-state.vala"
							_tmp74_ = c;
#line 105 "../lib/chess-state.vala"
							if (_tmp74_ == 'k') {
#line 106 "../lib/chess-state.vala"
								self->can_castle_kingside[COLOR_BLACK] = TRUE;
#line 877 "chess-state.c"
							} else {
								gchar _tmp75_;
#line 107 "../lib/chess-state.vala"
								_tmp75_ = c;
#line 107 "../lib/chess-state.vala"
								if (_tmp75_ == 'q') {
#line 108 "../lib/chess-state.vala"
									self->can_castle_queenside[COLOR_BLACK] = TRUE;
#line 886 "chess-state.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 115 "../lib/chess-state.vala"
	_tmp76_ = fields;
#line 115 "../lib/chess-state.vala"
	_tmp76__length1 = fields_length1;
#line 115 "../lib/chess-state.vala"
	_tmp77_ = _tmp76_[3];
#line 115 "../lib/chess-state.vala"
	if (g_strcmp0 (_tmp77_, "-") != 0) {
#line 903 "chess-state.c"
		gchar** _tmp78_;
		gint _tmp78__length1;
		const gchar* _tmp79_;
		gchar** _tmp80_;
		gint _tmp80__length1;
		const gchar* _tmp81_;
#line 119 "../lib/chess-state.vala"
		_tmp78_ = fields;
#line 119 "../lib/chess-state.vala"
		_tmp78__length1 = fields_length1;
#line 119 "../lib/chess-state.vala"
		_tmp79_ = _tmp78_[3];
#line 119 "../lib/chess-state.vala"
		_tmp80_ = fields;
#line 119 "../lib/chess-state.vala"
		_tmp80__length1 = fields_length1;
#line 119 "../lib/chess-state.vala"
		_tmp81_ = _tmp80_[3];
#line 119 "../lib/chess-state.vala"
		self->en_passant_index = chess_state_get_index (self, (gint) (string_get (_tmp79_, (glong) 1) - '1'), (gint) (string_get (_tmp81_, (glong) 0) - 'a'));
#line 924 "chess-state.c"
	}
#line 123 "../lib/chess-state.vala"
	_tmp82_ = fields;
#line 123 "../lib/chess-state.vala"
	_tmp82__length1 = fields_length1;
#line 123 "../lib/chess-state.vala"
	_tmp83_ = _tmp82_[4];
#line 123 "../lib/chess-state.vala"
	self->halfmove_clock = atoi (_tmp83_);
#line 126 "../lib/chess-state.vala"
	_tmp84_ = fields;
#line 126 "../lib/chess-state.vala"
	_tmp84__length1 = fields_length1;
#line 126 "../lib/chess-state.vala"
	_tmp85_ = _tmp84_[5];
#line 126 "../lib/chess-state.vala"
	self->number = (atoi (_tmp85_) - 1) * 2;
#line 127 "../lib/chess-state.vala"
	_tmp86_ = self->current_player;
#line 127 "../lib/chess-state.vala"
	_tmp87_ = _tmp86_->color;
#line 127 "../lib/chess-state.vala"
	if (_tmp87_ == COLOR_BLACK) {
#line 948 "chess-state.c"
		gint _tmp88_;
#line 128 "../lib/chess-state.vala"
		_tmp88_ = self->number;
#line 128 "../lib/chess-state.vala"
		self->number = _tmp88_ + 1;
#line 954 "chess-state.c"
	}
#line 130 "../lib/chess-state.vala"
	_tmp89_ = self->current_player;
#line 130 "../lib/chess-state.vala"
	self->check_state = chess_state_get_check_state (self, _tmp89_);
#line 46 "../lib/chess-state.vala"
	ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../lib/chess-state.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 46 "../lib/chess-state.vala"
	return self;
#line 966 "chess-state.c"
}


ChessState*
chess_state_new (const gchar* fen)
{
#line 46 "../lib/chess-state.vala"
	return chess_state_construct (TYPE_CHESS_STATE, fen);
#line 975 "chess-state.c"
}


ChessState*
chess_state_copy (ChessState* self)
{
	ChessState* result = NULL;
	ChessState* state = NULL;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	gint _tmp2_;
	ChessState* _tmp3_;
	ChessPlayer* _tmp4_;
	ChessPlayer* _tmp5_;
	ChessState* _tmp6_;
	ChessPlayer* _tmp7_;
	ChessPlayer* _tmp8_;
	ChessState* _tmp9_;
	ChessPlayer* _tmp10_;
	ChessPlayer* _tmp11_;
	ChessState* _tmp12_;
	gboolean _tmp13_;
	ChessState* _tmp14_;
	gboolean _tmp15_;
	ChessState* _tmp16_;
	gboolean _tmp17_;
	ChessState* _tmp18_;
	gboolean _tmp19_;
	ChessState* _tmp20_;
	gint _tmp21_;
	ChessState* _tmp22_;
	CheckState _tmp23_;
	ChessMove* _tmp24_;
	ChessState* _tmp36_;
	gint64 _tmp37_;
	ChessState* _tmp38_;
	gint64 _tmp39_;
	ChessState* _tmp40_;
	gint _tmp41_;
#line 133 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "../lib/chess-state.vala"
	_tmp0_ = chess_state_new_empty ();
#line 135 "../lib/chess-state.vala"
	state = _tmp0_;
#line 137 "../lib/chess-state.vala"
	_tmp1_ = state;
#line 137 "../lib/chess-state.vala"
	_tmp2_ = self->number;
#line 137 "../lib/chess-state.vala"
	_tmp1_->number = _tmp2_;
#line 138 "../lib/chess-state.vala"
	_tmp3_ = state;
#line 138 "../lib/chess-state.vala"
	_tmp4_ = self->players[COLOR_WHITE];
#line 138 "../lib/chess-state.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 138 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp3_->players[COLOR_WHITE]);
#line 138 "../lib/chess-state.vala"
	_tmp3_->players[COLOR_WHITE] = _tmp5_;
#line 139 "../lib/chess-state.vala"
	_tmp6_ = state;
#line 139 "../lib/chess-state.vala"
	_tmp7_ = self->players[COLOR_BLACK];
#line 139 "../lib/chess-state.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 139 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp6_->players[COLOR_BLACK]);
#line 139 "../lib/chess-state.vala"
	_tmp6_->players[COLOR_BLACK] = _tmp8_;
#line 140 "../lib/chess-state.vala"
	_tmp9_ = state;
#line 140 "../lib/chess-state.vala"
	_tmp10_ = self->current_player;
#line 140 "../lib/chess-state.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 140 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp9_->current_player);
#line 140 "../lib/chess-state.vala"
	_tmp9_->current_player = _tmp11_;
#line 141 "../lib/chess-state.vala"
	_tmp12_ = state;
#line 141 "../lib/chess-state.vala"
	_tmp13_ = self->can_castle_kingside[COLOR_WHITE];
#line 141 "../lib/chess-state.vala"
	_tmp12_->can_castle_kingside[COLOR_WHITE] = _tmp13_;
#line 142 "../lib/chess-state.vala"
	_tmp14_ = state;
#line 142 "../lib/chess-state.vala"
	_tmp15_ = self->can_castle_queenside[COLOR_WHITE];
#line 142 "../lib/chess-state.vala"
	_tmp14_->can_castle_queenside[COLOR_WHITE] = _tmp15_;
#line 143 "../lib/chess-state.vala"
	_tmp16_ = state;
#line 143 "../lib/chess-state.vala"
	_tmp17_ = self->can_castle_kingside[COLOR_BLACK];
#line 143 "../lib/chess-state.vala"
	_tmp16_->can_castle_kingside[COLOR_BLACK] = _tmp17_;
#line 144 "../lib/chess-state.vala"
	_tmp18_ = state;
#line 144 "../lib/chess-state.vala"
	_tmp19_ = self->can_castle_queenside[COLOR_BLACK];
#line 144 "../lib/chess-state.vala"
	_tmp18_->can_castle_queenside[COLOR_BLACK] = _tmp19_;
#line 145 "../lib/chess-state.vala"
	_tmp20_ = state;
#line 145 "../lib/chess-state.vala"
	_tmp21_ = self->en_passant_index;
#line 145 "../lib/chess-state.vala"
	_tmp20_->en_passant_index = _tmp21_;
#line 146 "../lib/chess-state.vala"
	_tmp22_ = state;
#line 146 "../lib/chess-state.vala"
	_tmp23_ = self->check_state;
#line 146 "../lib/chess-state.vala"
	_tmp22_->check_state = _tmp23_;
#line 147 "../lib/chess-state.vala"
	_tmp24_ = self->last_move;
#line 147 "../lib/chess-state.vala"
	if (_tmp24_ != NULL) {
#line 1097 "chess-state.c"
		ChessState* _tmp25_;
		ChessMove* _tmp26_;
		ChessMove* _tmp27_;
#line 148 "../lib/chess-state.vala"
		_tmp25_ = state;
#line 148 "../lib/chess-state.vala"
		_tmp26_ = self->last_move;
#line 148 "../lib/chess-state.vala"
		_tmp27_ = chess_move_copy (_tmp26_);
#line 148 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp25_->last_move);
#line 148 "../lib/chess-state.vala"
		_tmp25_->last_move = _tmp27_;
#line 1111 "chess-state.c"
	}
	{
		gint i = 0;
#line 149 "../lib/chess-state.vala"
		i = 0;
#line 1117 "chess-state.c"
		{
			gboolean _tmp28_ = FALSE;
#line 149 "../lib/chess-state.vala"
			_tmp28_ = TRUE;
#line 149 "../lib/chess-state.vala"
			while (TRUE) {
#line 1124 "chess-state.c"
				gint _tmp30_;
				ChessState* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				ChessPiece* _tmp34_;
				ChessPiece* _tmp35_;
#line 149 "../lib/chess-state.vala"
				if (!_tmp28_) {
#line 1133 "chess-state.c"
					gint _tmp29_;
#line 149 "../lib/chess-state.vala"
					_tmp29_ = i;
#line 149 "../lib/chess-state.vala"
					i = _tmp29_ + 1;
#line 1139 "chess-state.c"
				}
#line 149 "../lib/chess-state.vala"
				_tmp28_ = FALSE;
#line 149 "../lib/chess-state.vala"
				_tmp30_ = i;
#line 149 "../lib/chess-state.vala"
				if (!(_tmp30_ < 64)) {
#line 149 "../lib/chess-state.vala"
					break;
#line 1149 "chess-state.c"
				}
#line 150 "../lib/chess-state.vala"
				_tmp31_ = state;
#line 150 "../lib/chess-state.vala"
				_tmp32_ = i;
#line 150 "../lib/chess-state.vala"
				_tmp33_ = i;
#line 150 "../lib/chess-state.vala"
				_tmp34_ = self->board[_tmp33_];
#line 150 "../lib/chess-state.vala"
				_tmp35_ = _g_object_ref0 (_tmp34_);
#line 150 "../lib/chess-state.vala"
				_g_object_unref0 (_tmp31_->board[_tmp32_]);
#line 150 "../lib/chess-state.vala"
				_tmp31_->board[_tmp32_] = _tmp35_;
#line 1165 "chess-state.c"
			}
		}
	}
#line 151 "../lib/chess-state.vala"
	_tmp36_ = state;
#line 151 "../lib/chess-state.vala"
	_tmp37_ = self->priv->piece_masks[COLOR_WHITE];
#line 151 "../lib/chess-state.vala"
	_tmp36_->priv->piece_masks[COLOR_WHITE] = _tmp37_;
#line 152 "../lib/chess-state.vala"
	_tmp38_ = state;
#line 152 "../lib/chess-state.vala"
	_tmp39_ = self->priv->piece_masks[COLOR_BLACK];
#line 152 "../lib/chess-state.vala"
	_tmp38_->priv->piece_masks[COLOR_BLACK] = _tmp39_;
#line 153 "../lib/chess-state.vala"
	_tmp40_ = state;
#line 153 "../lib/chess-state.vala"
	_tmp41_ = self->halfmove_clock;
#line 153 "../lib/chess-state.vala"
	_tmp40_->halfmove_clock = _tmp41_;
#line 155 "../lib/chess-state.vala"
	result = state;
#line 155 "../lib/chess-state.vala"
	return result;
#line 1191 "chess-state.c"
}


gboolean
chess_state_equals (ChessState* self,
                    ChessState* state)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gint64 _tmp7_;
	gint64 _tmp8_;
#line 158 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../lib/chess-state.vala"
	g_return_val_if_fail (state != NULL, FALSE);
#line 168 "../lib/chess-state.vala"
	_tmp7_ = self->priv->piece_masks[COLOR_WHITE];
#line 168 "../lib/chess-state.vala"
	_tmp8_ = state->priv->piece_masks[COLOR_WHITE];
#line 168 "../lib/chess-state.vala"
	if (_tmp7_ != _tmp8_) {
#line 168 "../lib/chess-state.vala"
		_tmp6_ = TRUE;
#line 1221 "chess-state.c"
	} else {
		gint64 _tmp9_;
		gint64 _tmp10_;
#line 169 "../lib/chess-state.vala"
		_tmp9_ = self->priv->piece_masks[COLOR_BLACK];
#line 169 "../lib/chess-state.vala"
		_tmp10_ = state->priv->piece_masks[COLOR_BLACK];
#line 169 "../lib/chess-state.vala"
		_tmp6_ = _tmp9_ != _tmp10_;
#line 1231 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp6_) {
#line 168 "../lib/chess-state.vala"
		_tmp5_ = TRUE;
#line 1237 "chess-state.c"
	} else {
		ChessPlayer* _tmp11_;
		Color _tmp12_;
		ChessPlayer* _tmp13_;
		Color _tmp14_;
#line 170 "../lib/chess-state.vala"
		_tmp11_ = self->current_player;
#line 170 "../lib/chess-state.vala"
		_tmp12_ = _tmp11_->color;
#line 170 "../lib/chess-state.vala"
		_tmp13_ = state->current_player;
#line 170 "../lib/chess-state.vala"
		_tmp14_ = _tmp13_->color;
#line 170 "../lib/chess-state.vala"
		_tmp5_ = _tmp12_ != _tmp14_;
#line 1253 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp5_) {
#line 168 "../lib/chess-state.vala"
		_tmp4_ = TRUE;
#line 1259 "chess-state.c"
	} else {
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 171 "../lib/chess-state.vala"
		_tmp15_ = self->can_castle_kingside[COLOR_WHITE];
#line 171 "../lib/chess-state.vala"
		_tmp16_ = state->can_castle_kingside[COLOR_WHITE];
#line 171 "../lib/chess-state.vala"
		_tmp4_ = _tmp15_ != _tmp16_;
#line 1269 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp4_) {
#line 168 "../lib/chess-state.vala"
		_tmp3_ = TRUE;
#line 1275 "chess-state.c"
	} else {
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 172 "../lib/chess-state.vala"
		_tmp17_ = self->can_castle_queenside[COLOR_WHITE];
#line 172 "../lib/chess-state.vala"
		_tmp18_ = state->can_castle_queenside[COLOR_WHITE];
#line 172 "../lib/chess-state.vala"
		_tmp3_ = _tmp17_ != _tmp18_;
#line 1285 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp3_) {
#line 168 "../lib/chess-state.vala"
		_tmp2_ = TRUE;
#line 1291 "chess-state.c"
	} else {
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 173 "../lib/chess-state.vala"
		_tmp19_ = self->can_castle_kingside[COLOR_BLACK];
#line 173 "../lib/chess-state.vala"
		_tmp20_ = state->can_castle_kingside[COLOR_BLACK];
#line 173 "../lib/chess-state.vala"
		_tmp2_ = _tmp19_ != _tmp20_;
#line 1301 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp2_) {
#line 168 "../lib/chess-state.vala"
		_tmp1_ = TRUE;
#line 1307 "chess-state.c"
	} else {
		gboolean _tmp21_;
		gboolean _tmp22_;
#line 174 "../lib/chess-state.vala"
		_tmp21_ = self->can_castle_queenside[COLOR_BLACK];
#line 174 "../lib/chess-state.vala"
		_tmp22_ = state->can_castle_queenside[COLOR_BLACK];
#line 174 "../lib/chess-state.vala"
		_tmp1_ = _tmp21_ != _tmp22_;
#line 1317 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp1_) {
#line 168 "../lib/chess-state.vala"
		_tmp0_ = TRUE;
#line 1323 "chess-state.c"
	} else {
		gint _tmp23_;
		gint _tmp24_;
#line 175 "../lib/chess-state.vala"
		_tmp23_ = self->en_passant_index;
#line 175 "../lib/chess-state.vala"
		_tmp24_ = state->en_passant_index;
#line 175 "../lib/chess-state.vala"
		_tmp0_ = _tmp23_ != _tmp24_;
#line 1333 "chess-state.c"
	}
#line 168 "../lib/chess-state.vala"
	if (_tmp0_) {
#line 176 "../lib/chess-state.vala"
		result = FALSE;
#line 176 "../lib/chess-state.vala"
		return result;
#line 1341 "chess-state.c"
	}
	{
		gint i = 0;
#line 179 "../lib/chess-state.vala"
		i = 0;
#line 1347 "chess-state.c"
		{
			gboolean _tmp25_ = FALSE;
#line 179 "../lib/chess-state.vala"
			_tmp25_ = TRUE;
#line 179 "../lib/chess-state.vala"
			while (TRUE) {
#line 1354 "chess-state.c"
				gint _tmp27_;
				gboolean _tmp28_ = FALSE;
				gint _tmp29_;
				ChessPiece* _tmp30_;
#line 179 "../lib/chess-state.vala"
				if (!_tmp25_) {
#line 1361 "chess-state.c"
					gint _tmp26_;
#line 179 "../lib/chess-state.vala"
					_tmp26_ = i;
#line 179 "../lib/chess-state.vala"
					i = _tmp26_ + 1;
#line 1367 "chess-state.c"
				}
#line 179 "../lib/chess-state.vala"
				_tmp25_ = FALSE;
#line 179 "../lib/chess-state.vala"
				_tmp27_ = i;
#line 179 "../lib/chess-state.vala"
				if (!(_tmp27_ < 64)) {
#line 179 "../lib/chess-state.vala"
					break;
#line 1377 "chess-state.c"
				}
#line 181 "../lib/chess-state.vala"
				_tmp29_ = i;
#line 181 "../lib/chess-state.vala"
				_tmp30_ = self->board[_tmp29_];
#line 181 "../lib/chess-state.vala"
				if (_tmp30_ != NULL) {
#line 1385 "chess-state.c"
					gint _tmp31_;
					ChessPiece* _tmp32_;
					PieceType _tmp33_;
					gint _tmp34_;
					ChessPiece* _tmp35_;
					PieceType _tmp36_;
#line 181 "../lib/chess-state.vala"
					_tmp31_ = i;
#line 181 "../lib/chess-state.vala"
					_tmp32_ = self->board[_tmp31_];
#line 181 "../lib/chess-state.vala"
					_tmp33_ = _tmp32_->type;
#line 181 "../lib/chess-state.vala"
					_tmp34_ = i;
#line 181 "../lib/chess-state.vala"
					_tmp35_ = state->board[_tmp34_];
#line 181 "../lib/chess-state.vala"
					_tmp36_ = _tmp35_->type;
#line 181 "../lib/chess-state.vala"
					_tmp28_ = _tmp33_ != _tmp36_;
#line 1406 "chess-state.c"
				} else {
#line 181 "../lib/chess-state.vala"
					_tmp28_ = FALSE;
#line 1410 "chess-state.c"
				}
#line 181 "../lib/chess-state.vala"
				if (_tmp28_) {
#line 182 "../lib/chess-state.vala"
					result = FALSE;
#line 182 "../lib/chess-state.vala"
					return result;
#line 1418 "chess-state.c"
				}
			}
		}
	}
#line 185 "../lib/chess-state.vala"
	result = TRUE;
#line 185 "../lib/chess-state.vala"
	return result;
#line 1427 "chess-state.c"
}


gchar*
chess_state_get_fen (ChessState* self)
{
	gchar* result = NULL;
	GString* value = NULL;
	GString* _tmp0_;
	GString* _tmp25_;
	ChessPlayer* _tmp26_;
	Color _tmp27_;
	GString* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp33_;
	gboolean _tmp35_;
	gboolean _tmp37_;
	gboolean _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	GString* _tmp44_;
	gint _tmp45_;
	GString* _tmp50_;
	GString* _tmp51_;
	gint _tmp52_;
	GString* _tmp53_;
	ChessPlayer* _tmp54_;
	Color _tmp55_;
	GString* _tmp60_;
	const gchar* _tmp61_;
	gchar* _tmp62_;
#line 188 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../lib/chess-state.vala"
	_tmp0_ = g_string_new ("");
#line 190 "../lib/chess-state.vala"
	value = _tmp0_;
#line 1466 "chess-state.c"
	{
		gint rank = 0;
#line 192 "../lib/chess-state.vala"
		rank = 7;
#line 1471 "chess-state.c"
		{
			gboolean _tmp1_ = FALSE;
#line 192 "../lib/chess-state.vala"
			_tmp1_ = TRUE;
#line 192 "../lib/chess-state.vala"
			while (TRUE) {
#line 1478 "chess-state.c"
				gint _tmp3_;
				gint skip_count = 0;
				gint _tmp20_;
				gint _tmp23_;
#line 192 "../lib/chess-state.vala"
				if (!_tmp1_) {
#line 1485 "chess-state.c"
					gint _tmp2_;
#line 192 "../lib/chess-state.vala"
					_tmp2_ = rank;
#line 192 "../lib/chess-state.vala"
					rank = _tmp2_ - 1;
#line 1491 "chess-state.c"
				}
#line 192 "../lib/chess-state.vala"
				_tmp1_ = FALSE;
#line 192 "../lib/chess-state.vala"
				_tmp3_ = rank;
#line 192 "../lib/chess-state.vala"
				if (!(_tmp3_ >= 0)) {
#line 192 "../lib/chess-state.vala"
					break;
#line 1501 "chess-state.c"
				}
#line 194 "../lib/chess-state.vala"
				skip_count = 0;
#line 1505 "chess-state.c"
				{
					gint file = 0;
#line 195 "../lib/chess-state.vala"
					file = 0;
#line 1510 "chess-state.c"
					{
						gboolean _tmp4_ = FALSE;
#line 195 "../lib/chess-state.vala"
						_tmp4_ = TRUE;
#line 195 "../lib/chess-state.vala"
						while (TRUE) {
#line 1517 "chess-state.c"
							gint _tmp6_;
							ChessPiece* p = NULL;
							gint _tmp7_;
							gint _tmp8_;
							ChessPiece* _tmp9_;
							ChessPiece* _tmp10_;
							ChessPiece* _tmp11_;
#line 195 "../lib/chess-state.vala"
							if (!_tmp4_) {
#line 1527 "chess-state.c"
								gint _tmp5_;
#line 195 "../lib/chess-state.vala"
								_tmp5_ = file;
#line 195 "../lib/chess-state.vala"
								file = _tmp5_ + 1;
#line 1533 "chess-state.c"
							}
#line 195 "../lib/chess-state.vala"
							_tmp4_ = FALSE;
#line 195 "../lib/chess-state.vala"
							_tmp6_ = file;
#line 195 "../lib/chess-state.vala"
							if (!(_tmp6_ < 8)) {
#line 195 "../lib/chess-state.vala"
								break;
#line 1543 "chess-state.c"
							}
#line 197 "../lib/chess-state.vala"
							_tmp7_ = rank;
#line 197 "../lib/chess-state.vala"
							_tmp8_ = file;
#line 197 "../lib/chess-state.vala"
							_tmp9_ = self->board[chess_state_get_index (self, _tmp7_, _tmp8_)];
#line 197 "../lib/chess-state.vala"
							_tmp10_ = _g_object_ref0 (_tmp9_);
#line 197 "../lib/chess-state.vala"
							p = _tmp10_;
#line 198 "../lib/chess-state.vala"
							_tmp11_ = p;
#line 198 "../lib/chess-state.vala"
							if (_tmp11_ == NULL) {
#line 1559 "chess-state.c"
								gint _tmp12_;
#line 199 "../lib/chess-state.vala"
								_tmp12_ = skip_count;
#line 199 "../lib/chess-state.vala"
								skip_count = _tmp12_ + 1;
#line 1565 "chess-state.c"
							} else {
								gint _tmp13_;
								GString* _tmp16_;
								ChessPiece* _tmp17_;
								gunichar _tmp18_;
								gunichar _tmp19_;
#line 202 "../lib/chess-state.vala"
								_tmp13_ = skip_count;
#line 202 "../lib/chess-state.vala"
								if (_tmp13_ > 0) {
#line 1576 "chess-state.c"
									GString* _tmp14_;
									gint _tmp15_;
#line 204 "../lib/chess-state.vala"
									_tmp14_ = value;
#line 204 "../lib/chess-state.vala"
									_tmp15_ = skip_count;
#line 204 "../lib/chess-state.vala"
									g_string_append_printf (_tmp14_, "%d", _tmp15_);
#line 205 "../lib/chess-state.vala"
									skip_count = 0;
#line 1587 "chess-state.c"
								}
#line 207 "../lib/chess-state.vala"
								_tmp16_ = value;
#line 207 "../lib/chess-state.vala"
								_tmp17_ = p;
#line 207 "../lib/chess-state.vala"
								_tmp18_ = chess_piece_get_symbol (_tmp17_);
#line 207 "../lib/chess-state.vala"
								_tmp19_ = _tmp18_;
#line 207 "../lib/chess-state.vala"
								g_string_append_printf (_tmp16_, "%c", (gint) _tmp19_);
#line 1599 "chess-state.c"
							}
#line 195 "../lib/chess-state.vala"
							_g_object_unref0 (p);
#line 1603 "chess-state.c"
						}
					}
				}
#line 210 "../lib/chess-state.vala"
				_tmp20_ = skip_count;
#line 210 "../lib/chess-state.vala"
				if (_tmp20_ > 0) {
#line 1611 "chess-state.c"
					GString* _tmp21_;
					gint _tmp22_;
#line 211 "../lib/chess-state.vala"
					_tmp21_ = value;
#line 211 "../lib/chess-state.vala"
					_tmp22_ = skip_count;
#line 211 "../lib/chess-state.vala"
					g_string_append_printf (_tmp21_, "%d", _tmp22_);
#line 1620 "chess-state.c"
				}
#line 212 "../lib/chess-state.vala"
				_tmp23_ = rank;
#line 212 "../lib/chess-state.vala"
				if (_tmp23_ != 0) {
#line 1626 "chess-state.c"
					GString* _tmp24_;
#line 213 "../lib/chess-state.vala"
					_tmp24_ = value;
#line 213 "../lib/chess-state.vala"
					g_string_append_c (_tmp24_, '/');
#line 1632 "chess-state.c"
				}
			}
		}
	}
#line 216 "../lib/chess-state.vala"
	_tmp25_ = value;
#line 216 "../lib/chess-state.vala"
	g_string_append_c (_tmp25_, ' ');
#line 217 "../lib/chess-state.vala"
	_tmp26_ = self->current_player;
#line 217 "../lib/chess-state.vala"
	_tmp27_ = _tmp26_->color;
#line 217 "../lib/chess-state.vala"
	if (_tmp27_ == COLOR_WHITE) {
#line 1647 "chess-state.c"
		GString* _tmp28_;
#line 218 "../lib/chess-state.vala"
		_tmp28_ = value;
#line 218 "../lib/chess-state.vala"
		g_string_append_c (_tmp28_, 'w');
#line 1653 "chess-state.c"
	} else {
		GString* _tmp29_;
#line 220 "../lib/chess-state.vala"
		_tmp29_ = value;
#line 220 "../lib/chess-state.vala"
		g_string_append_c (_tmp29_, 'b');
#line 1660 "chess-state.c"
	}
#line 222 "../lib/chess-state.vala"
	_tmp30_ = value;
#line 222 "../lib/chess-state.vala"
	g_string_append_c (_tmp30_, ' ');
#line 223 "../lib/chess-state.vala"
	_tmp31_ = self->can_castle_kingside[COLOR_WHITE];
#line 223 "../lib/chess-state.vala"
	if (_tmp31_) {
#line 1670 "chess-state.c"
		GString* _tmp32_;
#line 224 "../lib/chess-state.vala"
		_tmp32_ = value;
#line 224 "../lib/chess-state.vala"
		g_string_append_c (_tmp32_, 'K');
#line 1676 "chess-state.c"
	}
#line 225 "../lib/chess-state.vala"
	_tmp33_ = self->can_castle_queenside[COLOR_WHITE];
#line 225 "../lib/chess-state.vala"
	if (_tmp33_) {
#line 1682 "chess-state.c"
		GString* _tmp34_;
#line 226 "../lib/chess-state.vala"
		_tmp34_ = value;
#line 226 "../lib/chess-state.vala"
		g_string_append_c (_tmp34_, 'Q');
#line 1688 "chess-state.c"
	}
#line 227 "../lib/chess-state.vala"
	_tmp35_ = self->can_castle_kingside[COLOR_BLACK];
#line 227 "../lib/chess-state.vala"
	if (_tmp35_) {
#line 1694 "chess-state.c"
		GString* _tmp36_;
#line 228 "../lib/chess-state.vala"
		_tmp36_ = value;
#line 228 "../lib/chess-state.vala"
		g_string_append_c (_tmp36_, 'k');
#line 1700 "chess-state.c"
	}
#line 229 "../lib/chess-state.vala"
	_tmp37_ = self->can_castle_queenside[COLOR_BLACK];
#line 229 "../lib/chess-state.vala"
	if (_tmp37_) {
#line 1706 "chess-state.c"
		GString* _tmp38_;
#line 230 "../lib/chess-state.vala"
		_tmp38_ = value;
#line 230 "../lib/chess-state.vala"
		g_string_append_c (_tmp38_, 'q');
#line 1712 "chess-state.c"
	}
#line 231 "../lib/chess-state.vala"
	_tmp39_ = self->can_castle_kingside[COLOR_WHITE];
#line 231 "../lib/chess-state.vala"
	_tmp40_ = self->can_castle_queenside[COLOR_WHITE];
#line 231 "../lib/chess-state.vala"
	_tmp41_ = self->can_castle_kingside[COLOR_BLACK];
#line 231 "../lib/chess-state.vala"
	_tmp42_ = self->can_castle_queenside[COLOR_BLACK];
#line 231 "../lib/chess-state.vala"
	if (!(((_tmp39_ | _tmp40_) | _tmp41_) | _tmp42_)) {
#line 1724 "chess-state.c"
		GString* _tmp43_;
#line 232 "../lib/chess-state.vala"
		_tmp43_ = value;
#line 232 "../lib/chess-state.vala"
		g_string_append_c (_tmp43_, '-');
#line 1730 "chess-state.c"
	}
#line 234 "../lib/chess-state.vala"
	_tmp44_ = value;
#line 234 "../lib/chess-state.vala"
	g_string_append_c (_tmp44_, ' ');
#line 235 "../lib/chess-state.vala"
	_tmp45_ = self->en_passant_index;
#line 235 "../lib/chess-state.vala"
	if (_tmp45_ >= 0) {
#line 1740 "chess-state.c"
		GString* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
#line 236 "../lib/chess-state.vala"
		_tmp46_ = value;
#line 236 "../lib/chess-state.vala"
		_tmp47_ = self->en_passant_index;
#line 236 "../lib/chess-state.vala"
		_tmp48_ = self->en_passant_index;
#line 236 "../lib/chess-state.vala"
		g_string_append_printf (_tmp46_, "%c%d", 'a' + chess_state_get_file (self, _tmp47_), chess_state_get_rank (self, _tmp48_) + 1);
#line 1752 "chess-state.c"
	} else {
		GString* _tmp49_;
#line 238 "../lib/chess-state.vala"
		_tmp49_ = value;
#line 238 "../lib/chess-state.vala"
		g_string_append_c (_tmp49_, '-');
#line 1759 "chess-state.c"
	}
#line 240 "../lib/chess-state.vala"
	_tmp50_ = value;
#line 240 "../lib/chess-state.vala"
	g_string_append_c (_tmp50_, ' ');
#line 241 "../lib/chess-state.vala"
	_tmp51_ = value;
#line 241 "../lib/chess-state.vala"
	_tmp52_ = self->halfmove_clock;
#line 241 "../lib/chess-state.vala"
	g_string_append_printf (_tmp51_, "%d", _tmp52_);
#line 243 "../lib/chess-state.vala"
	_tmp53_ = value;
#line 243 "../lib/chess-state.vala"
	g_string_append_c (_tmp53_, ' ');
#line 244 "../lib/chess-state.vala"
	_tmp54_ = self->current_player;
#line 244 "../lib/chess-state.vala"
	_tmp55_ = _tmp54_->color;
#line 244 "../lib/chess-state.vala"
	if (_tmp55_ == COLOR_WHITE) {
#line 1781 "chess-state.c"
		GString* _tmp56_;
		gint _tmp57_;
#line 245 "../lib/chess-state.vala"
		_tmp56_ = value;
#line 245 "../lib/chess-state.vala"
		_tmp57_ = self->number;
#line 245 "../lib/chess-state.vala"
		g_string_append_printf (_tmp56_, "%d", _tmp57_ / 2);
#line 1790 "chess-state.c"
	} else {
		GString* _tmp58_;
		gint _tmp59_;
#line 247 "../lib/chess-state.vala"
		_tmp58_ = value;
#line 247 "../lib/chess-state.vala"
		_tmp59_ = self->number;
#line 247 "../lib/chess-state.vala"
		g_string_append_printf (_tmp58_, "%d", (_tmp59_ / 2) + 1);
#line 1800 "chess-state.c"
	}
#line 249 "../lib/chess-state.vala"
	_tmp60_ = value;
#line 249 "../lib/chess-state.vala"
	_tmp61_ = _tmp60_->str;
#line 249 "../lib/chess-state.vala"
	_tmp62_ = g_strdup (_tmp61_);
#line 249 "../lib/chess-state.vala"
	result = _tmp62_;
#line 249 "../lib/chess-state.vala"
	_g_string_free0 (value);
#line 249 "../lib/chess-state.vala"
	return result;
#line 1814 "chess-state.c"
}


gint
chess_state_get_index (ChessState* self,
                       gint rank,
                       gint file)
{
	gint result = 0;
#line 252 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 254 "../lib/chess-state.vala"
	result = (rank * 8) + file;
#line 254 "../lib/chess-state.vala"
	return result;
#line 1830 "chess-state.c"
}


gint
chess_state_get_rank (ChessState* self,
                      gint index)
{
	gint result = 0;
#line 257 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 259 "../lib/chess-state.vala"
	result = index / 8;
#line 259 "../lib/chess-state.vala"
	return result;
#line 1845 "chess-state.c"
}


gint
chess_state_get_file (ChessState* self,
                      gint index)
{
	gint result = 0;
#line 262 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 264 "../lib/chess-state.vala"
	result = index % 8;
#line 264 "../lib/chess-state.vala"
	return result;
#line 1860 "chess-state.c"
}


gboolean
chess_state_move (ChessState* self,
                  const gchar* move,
                  gboolean apply)
{
	gboolean result = FALSE;
	gint r0 = 0;
	gint f0 = 0;
	gint r1 = 0;
	gint f1 = 0;
	PieceType promotion_type = 0;
	ChessPlayer* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	PieceType _tmp5_ = 0;
	gboolean _tmp6_;
	ChessPlayer* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	PieceType _tmp12_;
#line 267 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 267 "../lib/chess-state.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 272 "../lib/chess-state.vala"
	_tmp0_ = self->current_player;
#line 272 "../lib/chess-state.vala"
	_tmp6_ = chess_state_decode_move (self, _tmp0_, move, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 272 "../lib/chess-state.vala"
	r0 = _tmp1_;
#line 272 "../lib/chess-state.vala"
	f0 = _tmp2_;
#line 272 "../lib/chess-state.vala"
	r1 = _tmp3_;
#line 272 "../lib/chess-state.vala"
	f1 = _tmp4_;
#line 272 "../lib/chess-state.vala"
	promotion_type = _tmp5_;
#line 272 "../lib/chess-state.vala"
	if (!_tmp6_) {
#line 273 "../lib/chess-state.vala"
		result = FALSE;
#line 273 "../lib/chess-state.vala"
		return result;
#line 1912 "chess-state.c"
	}
#line 275 "../lib/chess-state.vala"
	_tmp7_ = self->current_player;
#line 275 "../lib/chess-state.vala"
	_tmp8_ = r0;
#line 275 "../lib/chess-state.vala"
	_tmp9_ = f0;
#line 275 "../lib/chess-state.vala"
	_tmp10_ = r1;
#line 275 "../lib/chess-state.vala"
	_tmp11_ = f1;
#line 275 "../lib/chess-state.vala"
	_tmp12_ = promotion_type;
#line 275 "../lib/chess-state.vala"
	if (!chess_state_move_with_coords (self, _tmp7_, _tmp8_, _tmp9_, _tmp10_, _tmp11_, _tmp12_, apply, TRUE)) {
#line 276 "../lib/chess-state.vala"
		result = FALSE;
#line 276 "../lib/chess-state.vala"
		return result;
#line 1932 "chess-state.c"
	}
#line 278 "../lib/chess-state.vala"
	result = TRUE;
#line 278 "../lib/chess-state.vala"
	return result;
#line 1938 "chess-state.c"
}


gboolean
chess_state_move_with_coords (ChessState* self,
                              ChessPlayer* player,
                              gint r0,
                              gint f0,
                              gint r1,
                              gint f1,
                              PieceType promotion_type,
                              gboolean apply,
                              gboolean test_check)
{
	gboolean result = FALSE;
	gint start = 0;
	gint end = 0;
	Color color = 0;
	Color _tmp0_;
	Color _tmp1_ = 0;
	Color _tmp2_;
	Color opponent_color = 0;
	ChessPiece* piece = NULL;
	gint _tmp3_;
	ChessPiece* _tmp4_;
	ChessPiece* _tmp5_;
	gboolean _tmp6_ = FALSE;
	ChessPiece* _tmp7_;
	gint64 end_mask = 0LL;
	gint _tmp10_;
	gint64 _tmp11_;
	gint64 move_mask = 0LL;
	Color _tmp12_;
	ChessPiece* _tmp13_;
	PieceType _tmp14_;
	gint _tmp15_;
	gint64 _tmp16_;
	gint64 _tmp17_;
	gint64 _tmp18_;
	gint64 over_mask = 0LL;
	gint _tmp19_;
	gint _tmp20_;
	gint64 _tmp21_;
	gint64 _tmp22_;
	gint64 _tmp23_;
	gint64 _tmp24_;
	ChessPiece* victim = NULL;
	gint _tmp25_;
	ChessPiece* _tmp26_;
	ChessPiece* _tmp27_;
	gint victim_index = 0;
	gint _tmp28_;
	gboolean _tmp29_ = FALSE;
	ChessPiece* _tmp30_;
	gint rook_start = 0;
	gint rook_end = 0;
	gboolean is_promotion = FALSE;
	gboolean en_passant = FALSE;
	gboolean ambiguous_rank = FALSE;
	gboolean ambiguous_file = FALSE;
	ChessPiece* _tmp33_;
	PieceType _tmp34_;
	gboolean _tmp74_ = FALSE;
	gint64 old_white_mask = 0LL;
	gint64 _tmp98_;
	gint64 old_black_mask = 0LL;
	gint64 _tmp99_;
	gboolean old_white_can_castle_kingside = FALSE;
	gboolean _tmp100_;
	gboolean old_white_can_castle_queenside = FALSE;
	gboolean _tmp101_;
	gboolean old_black_can_castle_kingside = FALSE;
	gboolean _tmp102_;
	gboolean old_black_can_castle_queenside = FALSE;
	gboolean _tmp103_;
	gint old_en_passant_index = 0;
	gint _tmp104_;
	gint old_halfmove_clock = 0;
	gint _tmp105_;
	gint _tmp106_;
	gint _tmp107_;
	gint64 _tmp108_;
	gint _tmp109_;
	gint64 _tmp110_;
	ChessPiece* _tmp111_;
	gboolean _tmp117_;
	Color _tmp123_;
	gint64 _tmp124_;
	Color _tmp125_;
	gint _tmp126_;
	gint64 _tmp127_;
	gint _tmp128_;
	ChessPiece* _tmp142_;
	PieceType _tmp143_;
	gboolean _tmp162_ = FALSE;
	ChessPiece* _tmp163_;
	PieceType _tmp164_;
	gboolean _tmp166_ = FALSE;
	ChessPiece* _tmp167_;
	PieceType _tmp168_;
	gboolean _result_ = FALSE;
	gboolean _tmp171_ = FALSE;
	gboolean _tmp172_ = FALSE;
	ChessPlayer* _tmp198_ = NULL;
	Color _tmp199_;
	ChessPlayer* _tmp202_;
	ChessPlayer* _tmp203_;
	ChessMove* _tmp204_;
	ChessMove* _tmp205_;
	gint _tmp206_;
	ChessMove* _tmp207_;
	ChessPiece* _tmp208_;
	ChessPiece* _tmp209_;
	gboolean _tmp210_;
	ChessMove* _tmp215_;
	ChessPiece* _tmp216_;
	ChessPiece* _tmp217_;
	gint _tmp218_;
	ChessMove* _tmp223_;
	ChessMove* _tmp224_;
	ChessMove* _tmp225_;
	ChessMove* _tmp226_;
	ChessMove* _tmp227_;
	gboolean _tmp228_;
	ChessMove* _tmp229_;
	gboolean _tmp230_;
	ChessMove* _tmp231_;
	gboolean _tmp232_;
	ChessMove* _tmp233_;
	CheckState _tmp234_;
#line 281 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 281 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 287 "../lib/chess-state.vala"
	start = chess_state_get_index (self, r0, f0);
#line 288 "../lib/chess-state.vala"
	end = chess_state_get_index (self, r1, f1);
#line 290 "../lib/chess-state.vala"
	_tmp0_ = player->color;
#line 290 "../lib/chess-state.vala"
	color = _tmp0_;
#line 291 "../lib/chess-state.vala"
	_tmp2_ = color;
#line 291 "../lib/chess-state.vala"
	if (_tmp2_ == COLOR_WHITE) {
#line 291 "../lib/chess-state.vala"
		_tmp1_ = COLOR_BLACK;
#line 2087 "chess-state.c"
	} else {
#line 291 "../lib/chess-state.vala"
		_tmp1_ = COLOR_WHITE;
#line 2091 "chess-state.c"
	}
#line 291 "../lib/chess-state.vala"
	opponent_color = _tmp1_;
#line 294 "../lib/chess-state.vala"
	_tmp3_ = start;
#line 294 "../lib/chess-state.vala"
	_tmp4_ = self->board[_tmp3_];
#line 294 "../lib/chess-state.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 294 "../lib/chess-state.vala"
	piece = _tmp5_;
#line 295 "../lib/chess-state.vala"
	_tmp7_ = piece;
#line 295 "../lib/chess-state.vala"
	if (_tmp7_ == NULL) {
#line 295 "../lib/chess-state.vala"
		_tmp6_ = TRUE;
#line 2109 "chess-state.c"
	} else {
		ChessPiece* _tmp8_;
		ChessPlayer* _tmp9_;
#line 295 "../lib/chess-state.vala"
		_tmp8_ = piece;
#line 295 "../lib/chess-state.vala"
		_tmp9_ = _tmp8_->player;
#line 295 "../lib/chess-state.vala"
		_tmp6_ = _tmp9_ != player;
#line 2119 "chess-state.c"
	}
#line 295 "../lib/chess-state.vala"
	if (_tmp6_) {
#line 296 "../lib/chess-state.vala"
		result = FALSE;
#line 296 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 296 "../lib/chess-state.vala"
		return result;
#line 2129 "chess-state.c"
	}
#line 299 "../lib/chess-state.vala"
	_tmp10_ = end;
#line 299 "../lib/chess-state.vala"
	_tmp11_ = BIT_BOARD_set_location_masks[_tmp10_];
#line 299 "../lib/chess-state.vala"
	end_mask = _tmp11_;
#line 300 "../lib/chess-state.vala"
	_tmp12_ = color;
#line 300 "../lib/chess-state.vala"
	_tmp13_ = piece;
#line 300 "../lib/chess-state.vala"
	_tmp14_ = _tmp13_->type;
#line 300 "../lib/chess-state.vala"
	_tmp15_ = start;
#line 300 "../lib/chess-state.vala"
	_tmp16_ = BIT_BOARD_move_masks[(((_tmp12_ * 64) * 6) + (_tmp14_ * 64)) + _tmp15_];
#line 300 "../lib/chess-state.vala"
	move_mask = _tmp16_;
#line 301 "../lib/chess-state.vala"
	_tmp17_ = end_mask;
#line 301 "../lib/chess-state.vala"
	_tmp18_ = move_mask;
#line 301 "../lib/chess-state.vala"
	if ((_tmp17_ & _tmp18_) == ((gint64) 0)) {
#line 302 "../lib/chess-state.vala"
		result = FALSE;
#line 302 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 302 "../lib/chess-state.vala"
		return result;
#line 2161 "chess-state.c"
	}
#line 305 "../lib/chess-state.vala"
	_tmp19_ = start;
#line 305 "../lib/chess-state.vala"
	_tmp20_ = end;
#line 305 "../lib/chess-state.vala"
	_tmp21_ = BIT_BOARD_over_masks[(_tmp19_ * 64) + _tmp20_];
#line 305 "../lib/chess-state.vala"
	over_mask = _tmp21_;
#line 306 "../lib/chess-state.vala"
	_tmp22_ = over_mask;
#line 306 "../lib/chess-state.vala"
	_tmp23_ = self->priv->piece_masks[COLOR_WHITE];
#line 306 "../lib/chess-state.vala"
	_tmp24_ = self->priv->piece_masks[COLOR_BLACK];
#line 306 "../lib/chess-state.vala"
	if ((_tmp22_ & (_tmp23_ | _tmp24_)) != ((gint64) 0)) {
#line 307 "../lib/chess-state.vala"
		result = FALSE;
#line 307 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 307 "../lib/chess-state.vala"
		return result;
#line 2185 "chess-state.c"
	}
#line 310 "../lib/chess-state.vala"
	_tmp25_ = end;
#line 310 "../lib/chess-state.vala"
	_tmp26_ = self->board[_tmp25_];
#line 310 "../lib/chess-state.vala"
	_tmp27_ = _g_object_ref0 (_tmp26_);
#line 310 "../lib/chess-state.vala"
	victim = _tmp27_;
#line 311 "../lib/chess-state.vala"
	_tmp28_ = end;
#line 311 "../lib/chess-state.vala"
	victim_index = _tmp28_;
#line 314 "../lib/chess-state.vala"
	_tmp30_ = victim;
#line 314 "../lib/chess-state.vala"
	if (_tmp30_ != NULL) {
#line 2203 "chess-state.c"
		ChessPiece* _tmp31_;
		ChessPlayer* _tmp32_;
#line 314 "../lib/chess-state.vala"
		_tmp31_ = victim;
#line 314 "../lib/chess-state.vala"
		_tmp32_ = _tmp31_->player;
#line 314 "../lib/chess-state.vala"
		_tmp29_ = _tmp32_ == player;
#line 2212 "chess-state.c"
	} else {
#line 314 "../lib/chess-state.vala"
		_tmp29_ = FALSE;
#line 2216 "chess-state.c"
	}
#line 314 "../lib/chess-state.vala"
	if (_tmp29_) {
#line 315 "../lib/chess-state.vala"
		result = FALSE;
#line 315 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 315 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 315 "../lib/chess-state.vala"
		return result;
#line 2228 "chess-state.c"
	}
#line 318 "../lib/chess-state.vala"
	rook_start = -1;
#line 318 "../lib/chess-state.vala"
	rook_end = -1;
#line 319 "../lib/chess-state.vala"
	is_promotion = FALSE;
#line 320 "../lib/chess-state.vala"
	en_passant = FALSE;
#line 321 "../lib/chess-state.vala"
	ambiguous_rank = FALSE;
#line 322 "../lib/chess-state.vala"
	ambiguous_file = FALSE;
#line 323 "../lib/chess-state.vala"
	_tmp33_ = piece;
#line 323 "../lib/chess-state.vala"
	_tmp34_ = _tmp33_->type;
#line 323 "../lib/chess-state.vala"
	switch (_tmp34_) {
#line 323 "../lib/chess-state.vala"
		case PIECE_TYPE_PAWN:
#line 2250 "chess-state.c"
		{
			gboolean _tmp35_ = FALSE;
			ChessPiece* _tmp36_;
			gboolean _tmp45_ = FALSE;
			ChessPiece* _tmp46_;
#line 327 "../lib/chess-state.vala"
			_tmp36_ = victim;
#line 327 "../lib/chess-state.vala"
			if (_tmp36_ == NULL) {
#line 2260 "chess-state.c"
				gint _tmp37_;
				gint _tmp38_;
#line 327 "../lib/chess-state.vala"
				_tmp37_ = end;
#line 327 "../lib/chess-state.vala"
				_tmp38_ = self->en_passant_index;
#line 327 "../lib/chess-state.vala"
				_tmp35_ = _tmp37_ == _tmp38_;
#line 2269 "chess-state.c"
			} else {
#line 327 "../lib/chess-state.vala"
				_tmp35_ = FALSE;
#line 2273 "chess-state.c"
			}
#line 327 "../lib/chess-state.vala"
			if (_tmp35_) {
#line 2277 "chess-state.c"
				gint _tmp39_ = 0;
				gint _tmp40_;
				ChessPiece* _tmp41_;
				ChessPiece* _tmp42_;
#line 329 "../lib/chess-state.vala"
				en_passant = TRUE;
#line 330 "../lib/chess-state.vala"
				if (r1 == 2) {
#line 330 "../lib/chess-state.vala"
					_tmp39_ = 3;
#line 2288 "chess-state.c"
				} else {
#line 330 "../lib/chess-state.vala"
					_tmp39_ = 4;
#line 2292 "chess-state.c"
				}
#line 330 "../lib/chess-state.vala"
				victim_index = chess_state_get_index (self, _tmp39_, f1);
#line 331 "../lib/chess-state.vala"
				_tmp40_ = victim_index;
#line 331 "../lib/chess-state.vala"
				_tmp41_ = self->board[_tmp40_];
#line 331 "../lib/chess-state.vala"
				_tmp42_ = _g_object_ref0 (_tmp41_);
#line 331 "../lib/chess-state.vala"
				_g_object_unref0 (victim);
#line 331 "../lib/chess-state.vala"
				victim = _tmp42_;
#line 2306 "chess-state.c"
			}
#line 335 "../lib/chess-state.vala"
			if (f0 != f1) {
#line 2310 "chess-state.c"
				ChessPiece* _tmp43_;
#line 337 "../lib/chess-state.vala"
				_tmp43_ = victim;
#line 337 "../lib/chess-state.vala"
				if (_tmp43_ == NULL) {
#line 338 "../lib/chess-state.vala"
					result = FALSE;
#line 338 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 338 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 338 "../lib/chess-state.vala"
					return result;
#line 2324 "chess-state.c"
				}
			} else {
				ChessPiece* _tmp44_;
#line 343 "../lib/chess-state.vala"
				_tmp44_ = victim;
#line 343 "../lib/chess-state.vala"
				if (_tmp44_ != NULL) {
#line 344 "../lib/chess-state.vala"
					result = FALSE;
#line 344 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 344 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 344 "../lib/chess-state.vala"
					return result;
#line 2340 "chess-state.c"
				}
			}
#line 346 "../lib/chess-state.vala"
			if (r1 == 0) {
#line 346 "../lib/chess-state.vala"
				_tmp45_ = TRUE;
#line 2347 "chess-state.c"
			} else {
#line 346 "../lib/chess-state.vala"
				_tmp45_ = r1 == 7;
#line 2351 "chess-state.c"
			}
#line 346 "../lib/chess-state.vala"
			is_promotion = _tmp45_;
#line 349 "../lib/chess-state.vala"
			_tmp46_ = victim;
#line 349 "../lib/chess-state.vala"
			if (_tmp46_ != NULL) {
#line 350 "../lib/chess-state.vala"
				ambiguous_file = TRUE;
#line 2361 "chess-state.c"
			}
#line 351 "../lib/chess-state.vala"
			break;
#line 2365 "chess-state.c"
		}
#line 323 "../lib/chess-state.vala"
		case PIECE_TYPE_KING:
#line 2369 "chess-state.c"
		{
#line 354 "../lib/chess-state.vala"
			if (abs (f0 - f1) > 1) {
#line 2373 "chess-state.c"
				gint _tmp47_ = 0;
				gint _tmp48_ = 0;
				ChessPiece* rook = NULL;
				gint _tmp53_;
				ChessPiece* _tmp54_;
				ChessPiece* _tmp55_;
				gboolean _tmp56_ = FALSE;
				gboolean _tmp57_ = FALSE;
				ChessPiece* _tmp58_;
				gint64 rook_over_mask = 0LL;
				gint _tmp65_;
				gint _tmp66_;
				gint64 _tmp67_;
				gint64 _tmp68_;
				gint64 _tmp69_;
				gint64 _tmp70_;
				CheckState _tmp71_;
				gint _tmp72_;
				gint _tmp73_;
#line 357 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 357 "../lib/chess-state.vala"
					_tmp47_ = 7;
#line 2397 "chess-state.c"
				} else {
#line 357 "../lib/chess-state.vala"
					_tmp47_ = 0;
#line 2401 "chess-state.c"
				}
#line 357 "../lib/chess-state.vala"
				rook_start = chess_state_get_index (self, r0, _tmp47_);
#line 358 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 358 "../lib/chess-state.vala"
					_tmp48_ = f1 - 1;
#line 2409 "chess-state.c"
				} else {
#line 358 "../lib/chess-state.vala"
					_tmp48_ = f1 + 1;
#line 2413 "chess-state.c"
				}
#line 358 "../lib/chess-state.vala"
				rook_end = chess_state_get_index (self, r0, _tmp48_);
#line 361 "../lib/chess-state.vala"
				if (f1 > f0) {
#line 2419 "chess-state.c"
					Color _tmp49_;
					gboolean _tmp50_;
#line 363 "../lib/chess-state.vala"
					_tmp49_ = color;
#line 363 "../lib/chess-state.vala"
					_tmp50_ = self->can_castle_kingside[_tmp49_];
#line 363 "../lib/chess-state.vala"
					if (!_tmp50_) {
#line 364 "../lib/chess-state.vala"
						result = FALSE;
#line 364 "../lib/chess-state.vala"
						_g_object_unref0 (victim);
#line 364 "../lib/chess-state.vala"
						_g_object_unref0 (piece);
#line 364 "../lib/chess-state.vala"
						return result;
#line 2436 "chess-state.c"
					}
				} else {
					Color _tmp51_;
					gboolean _tmp52_;
#line 368 "../lib/chess-state.vala"
					_tmp51_ = color;
#line 368 "../lib/chess-state.vala"
					_tmp52_ = self->can_castle_queenside[_tmp51_];
#line 368 "../lib/chess-state.vala"
					if (!_tmp52_) {
#line 369 "../lib/chess-state.vala"
						result = FALSE;
#line 369 "../lib/chess-state.vala"
						_g_object_unref0 (victim);
#line 369 "../lib/chess-state.vala"
						_g_object_unref0 (piece);
#line 369 "../lib/chess-state.vala"
						return result;
#line 2455 "chess-state.c"
					}
				}
#line 372 "../lib/chess-state.vala"
				_tmp53_ = rook_start;
#line 372 "../lib/chess-state.vala"
				_tmp54_ = self->board[_tmp53_];
#line 372 "../lib/chess-state.vala"
				_tmp55_ = _g_object_ref0 (_tmp54_);
#line 372 "../lib/chess-state.vala"
				rook = _tmp55_;
#line 373 "../lib/chess-state.vala"
				_tmp58_ = rook;
#line 373 "../lib/chess-state.vala"
				if (_tmp58_ == NULL) {
#line 373 "../lib/chess-state.vala"
					_tmp57_ = TRUE;
#line 2472 "chess-state.c"
				} else {
					ChessPiece* _tmp59_;
					PieceType _tmp60_;
#line 373 "../lib/chess-state.vala"
					_tmp59_ = rook;
#line 373 "../lib/chess-state.vala"
					_tmp60_ = _tmp59_->type;
#line 373 "../lib/chess-state.vala"
					_tmp57_ = _tmp60_ != PIECE_TYPE_ROOK;
#line 2482 "chess-state.c"
				}
#line 373 "../lib/chess-state.vala"
				if (_tmp57_) {
#line 373 "../lib/chess-state.vala"
					_tmp56_ = TRUE;
#line 2488 "chess-state.c"
				} else {
					ChessPiece* _tmp61_;
					Color _tmp62_;
					Color _tmp63_;
					Color _tmp64_;
#line 373 "../lib/chess-state.vala"
					_tmp61_ = rook;
#line 373 "../lib/chess-state.vala"
					_tmp62_ = chess_piece_get_color (_tmp61_);
#line 373 "../lib/chess-state.vala"
					_tmp63_ = _tmp62_;
#line 373 "../lib/chess-state.vala"
					_tmp64_ = color;
#line 373 "../lib/chess-state.vala"
					_tmp56_ = _tmp63_ != _tmp64_;
#line 2504 "chess-state.c"
				}
#line 373 "../lib/chess-state.vala"
				if (_tmp56_) {
#line 374 "../lib/chess-state.vala"
					result = FALSE;
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 374 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 374 "../lib/chess-state.vala"
					return result;
#line 2518 "chess-state.c"
				}
#line 377 "../lib/chess-state.vala"
				_tmp65_ = rook_start;
#line 377 "../lib/chess-state.vala"
				_tmp66_ = rook_end;
#line 377 "../lib/chess-state.vala"
				_tmp67_ = BIT_BOARD_over_masks[(_tmp65_ * 64) + _tmp66_];
#line 377 "../lib/chess-state.vala"
				rook_over_mask = _tmp67_;
#line 378 "../lib/chess-state.vala"
				_tmp68_ = rook_over_mask;
#line 378 "../lib/chess-state.vala"
				_tmp69_ = self->priv->piece_masks[COLOR_WHITE];
#line 378 "../lib/chess-state.vala"
				_tmp70_ = self->priv->piece_masks[COLOR_BLACK];
#line 378 "../lib/chess-state.vala"
				if ((_tmp68_ & (_tmp69_ | _tmp70_)) != ((gint64) 0)) {
#line 379 "../lib/chess-state.vala"
					result = FALSE;
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 379 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 379 "../lib/chess-state.vala"
					return result;
#line 2546 "chess-state.c"
				}
#line 382 "../lib/chess-state.vala"
				_tmp71_ = self->check_state;
#line 382 "../lib/chess-state.vala"
				if (_tmp71_ == CHECK_STATE_CHECK) {
#line 383 "../lib/chess-state.vala"
					result = FALSE;
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 383 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 383 "../lib/chess-state.vala"
					return result;
#line 2562 "chess-state.c"
				}
#line 386 "../lib/chess-state.vala"
				_tmp72_ = rook_end;
#line 386 "../lib/chess-state.vala"
				_tmp73_ = rook_end;
#line 386 "../lib/chess-state.vala"
				if (!chess_state_move_with_coords (self, player, r0, f0, chess_state_get_rank (self, _tmp72_), chess_state_get_file (self, _tmp73_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 387 "../lib/chess-state.vala"
					result = FALSE;
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (rook);
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (victim);
#line 387 "../lib/chess-state.vala"
					_g_object_unref0 (piece);
#line 387 "../lib/chess-state.vala"
					return result;
#line 2580 "chess-state.c"
				}
#line 354 "../lib/chess-state.vala"
				_g_object_unref0 (rook);
#line 2584 "chess-state.c"
			}
#line 389 "../lib/chess-state.vala"
			break;
#line 2588 "chess-state.c"
		}
		default:
		{
#line 391 "../lib/chess-state.vala"
			break;
#line 2594 "chess-state.c"
		}
	}
#line 394 "../lib/chess-state.vala"
	if (!apply) {
#line 394 "../lib/chess-state.vala"
		_tmp74_ = !test_check;
#line 2601 "chess-state.c"
	} else {
#line 394 "../lib/chess-state.vala"
		_tmp74_ = FALSE;
#line 2605 "chess-state.c"
	}
#line 394 "../lib/chess-state.vala"
	if (_tmp74_) {
#line 395 "../lib/chess-state.vala"
		result = TRUE;
#line 395 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 395 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 395 "../lib/chess-state.vala"
		return result;
#line 2617 "chess-state.c"
	}
#line 398 "../lib/chess-state.vala"
	if (apply) {
#line 2621 "chess-state.c"
		{
			gint i = 0;
#line 400 "../lib/chess-state.vala"
			i = 0;
#line 2626 "chess-state.c"
			{
				gboolean _tmp75_ = FALSE;
#line 400 "../lib/chess-state.vala"
				_tmp75_ = TRUE;
#line 400 "../lib/chess-state.vala"
				while (TRUE) {
#line 2633 "chess-state.c"
					gint _tmp77_;
					gint _tmp78_;
					gint _tmp79_;
					ChessPiece* p = NULL;
					gint _tmp80_;
					ChessPiece* _tmp81_;
					ChessPiece* _tmp82_;
					gboolean _tmp83_ = FALSE;
					gboolean _tmp84_ = FALSE;
					ChessPiece* _tmp85_;
					gint r = 0;
					gint _tmp92_;
					gint f = 0;
					gint _tmp93_;
					gint _tmp94_;
					gint _tmp95_;
#line 400 "../lib/chess-state.vala"
					if (!_tmp75_) {
#line 2652 "chess-state.c"
						gint _tmp76_;
#line 400 "../lib/chess-state.vala"
						_tmp76_ = i;
#line 400 "../lib/chess-state.vala"
						i = _tmp76_ + 1;
#line 2658 "chess-state.c"
					}
#line 400 "../lib/chess-state.vala"
					_tmp75_ = FALSE;
#line 400 "../lib/chess-state.vala"
					_tmp77_ = i;
#line 400 "../lib/chess-state.vala"
					if (!(_tmp77_ < 64)) {
#line 400 "../lib/chess-state.vala"
						break;
#line 2668 "chess-state.c"
					}
#line 403 "../lib/chess-state.vala"
					_tmp78_ = i;
#line 403 "../lib/chess-state.vala"
					_tmp79_ = start;
#line 403 "../lib/chess-state.vala"
					if (_tmp78_ == _tmp79_) {
#line 404 "../lib/chess-state.vala"
						continue;
#line 2678 "chess-state.c"
					}
#line 407 "../lib/chess-state.vala"
					_tmp80_ = i;
#line 407 "../lib/chess-state.vala"
					_tmp81_ = self->board[_tmp80_];
#line 407 "../lib/chess-state.vala"
					_tmp82_ = _g_object_ref0 (_tmp81_);
#line 407 "../lib/chess-state.vala"
					p = _tmp82_;
#line 408 "../lib/chess-state.vala"
					_tmp85_ = p;
#line 408 "../lib/chess-state.vala"
					if (_tmp85_ == NULL) {
#line 408 "../lib/chess-state.vala"
						_tmp84_ = TRUE;
#line 2694 "chess-state.c"
					} else {
						ChessPiece* _tmp86_;
						ChessPlayer* _tmp87_;
#line 408 "../lib/chess-state.vala"
						_tmp86_ = p;
#line 408 "../lib/chess-state.vala"
						_tmp87_ = _tmp86_->player;
#line 408 "../lib/chess-state.vala"
						_tmp84_ = _tmp87_ != player;
#line 2704 "chess-state.c"
					}
#line 408 "../lib/chess-state.vala"
					if (_tmp84_) {
#line 408 "../lib/chess-state.vala"
						_tmp83_ = TRUE;
#line 2710 "chess-state.c"
					} else {
						ChessPiece* _tmp88_;
						PieceType _tmp89_;
						ChessPiece* _tmp90_;
						PieceType _tmp91_;
#line 408 "../lib/chess-state.vala"
						_tmp88_ = p;
#line 408 "../lib/chess-state.vala"
						_tmp89_ = _tmp88_->type;
#line 408 "../lib/chess-state.vala"
						_tmp90_ = piece;
#line 408 "../lib/chess-state.vala"
						_tmp91_ = _tmp90_->type;
#line 408 "../lib/chess-state.vala"
						_tmp83_ = _tmp89_ != _tmp91_;
#line 2726 "chess-state.c"
					}
#line 408 "../lib/chess-state.vala"
					if (_tmp83_) {
#line 409 "../lib/chess-state.vala"
						_g_object_unref0 (p);
#line 409 "../lib/chess-state.vala"
						continue;
#line 2734 "chess-state.c"
					}
#line 412 "../lib/chess-state.vala"
					_tmp92_ = i;
#line 412 "../lib/chess-state.vala"
					r = chess_state_get_rank (self, _tmp92_);
#line 413 "../lib/chess-state.vala"
					_tmp93_ = i;
#line 413 "../lib/chess-state.vala"
					f = chess_state_get_file (self, _tmp93_);
#line 414 "../lib/chess-state.vala"
					_tmp94_ = r;
#line 414 "../lib/chess-state.vala"
					_tmp95_ = f;
#line 414 "../lib/chess-state.vala"
					if (chess_state_move_with_coords (self, player, _tmp94_, _tmp95_, r1, f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 2750 "chess-state.c"
						gint _tmp96_;
						gint _tmp97_;
#line 416 "../lib/chess-state.vala"
						_tmp96_ = r;
#line 416 "../lib/chess-state.vala"
						if (_tmp96_ != r0) {
#line 417 "../lib/chess-state.vala"
							ambiguous_rank = TRUE;
#line 2759 "chess-state.c"
						}
#line 418 "../lib/chess-state.vala"
						_tmp97_ = f;
#line 418 "../lib/chess-state.vala"
						if (_tmp97_ != f0) {
#line 419 "../lib/chess-state.vala"
							ambiguous_file = TRUE;
#line 2767 "chess-state.c"
						}
					}
#line 400 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 2772 "chess-state.c"
				}
			}
		}
	}
#line 424 "../lib/chess-state.vala"
	_tmp98_ = self->priv->piece_masks[COLOR_WHITE];
#line 424 "../lib/chess-state.vala"
	old_white_mask = _tmp98_;
#line 425 "../lib/chess-state.vala"
	_tmp99_ = self->priv->piece_masks[COLOR_BLACK];
#line 425 "../lib/chess-state.vala"
	old_black_mask = _tmp99_;
#line 426 "../lib/chess-state.vala"
	_tmp100_ = self->can_castle_kingside[COLOR_WHITE];
#line 426 "../lib/chess-state.vala"
	old_white_can_castle_kingside = _tmp100_;
#line 427 "../lib/chess-state.vala"
	_tmp101_ = self->can_castle_queenside[COLOR_WHITE];
#line 427 "../lib/chess-state.vala"
	old_white_can_castle_queenside = _tmp101_;
#line 428 "../lib/chess-state.vala"
	_tmp102_ = self->can_castle_kingside[COLOR_BLACK];
#line 428 "../lib/chess-state.vala"
	old_black_can_castle_kingside = _tmp102_;
#line 429 "../lib/chess-state.vala"
	_tmp103_ = self->can_castle_queenside[COLOR_BLACK];
#line 429 "../lib/chess-state.vala"
	old_black_can_castle_queenside = _tmp103_;
#line 430 "../lib/chess-state.vala"
	_tmp104_ = self->en_passant_index;
#line 430 "../lib/chess-state.vala"
	old_en_passant_index = _tmp104_;
#line 431 "../lib/chess-state.vala"
	_tmp105_ = self->halfmove_clock;
#line 431 "../lib/chess-state.vala"
	old_halfmove_clock = _tmp105_;
#line 434 "../lib/chess-state.vala"
	_tmp106_ = start;
#line 434 "../lib/chess-state.vala"
	_g_object_unref0 (self->board[_tmp106_]);
#line 434 "../lib/chess-state.vala"
	self->board[_tmp106_] = NULL;
#line 435 "../lib/chess-state.vala"
	_tmp107_ = start;
#line 435 "../lib/chess-state.vala"
	_tmp108_ = BIT_BOARD_clear_location_masks[_tmp107_];
#line 435 "../lib/chess-state.vala"
	self->priv->piece_masks[COLOR_WHITE] &= _tmp108_;
#line 436 "../lib/chess-state.vala"
	_tmp109_ = start;
#line 436 "../lib/chess-state.vala"
	_tmp110_ = BIT_BOARD_clear_location_masks[_tmp109_];
#line 436 "../lib/chess-state.vala"
	self->priv->piece_masks[COLOR_BLACK] &= _tmp110_;
#line 437 "../lib/chess-state.vala"
	_tmp111_ = victim;
#line 437 "../lib/chess-state.vala"
	if (_tmp111_ != NULL) {
#line 2831 "chess-state.c"
		gint _tmp112_;
		gint _tmp113_;
		gint64 _tmp114_;
		gint _tmp115_;
		gint64 _tmp116_;
#line 439 "../lib/chess-state.vala"
		_tmp112_ = victim_index;
#line 439 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp112_]);
#line 439 "../lib/chess-state.vala"
		self->board[_tmp112_] = NULL;
#line 440 "../lib/chess-state.vala"
		_tmp113_ = victim_index;
#line 440 "../lib/chess-state.vala"
		_tmp114_ = BIT_BOARD_clear_location_masks[_tmp113_];
#line 440 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_WHITE] &= _tmp114_;
#line 441 "../lib/chess-state.vala"
		_tmp115_ = victim_index;
#line 441 "../lib/chess-state.vala"
		_tmp116_ = BIT_BOARD_clear_location_masks[_tmp115_];
#line 441 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_BLACK] &= _tmp116_;
#line 2855 "chess-state.c"
	}
#line 443 "../lib/chess-state.vala"
	_tmp117_ = is_promotion;
#line 443 "../lib/chess-state.vala"
	if (_tmp117_) {
#line 2861 "chess-state.c"
		gint _tmp118_;
		ChessPiece* _tmp119_;
#line 444 "../lib/chess-state.vala"
		_tmp118_ = end;
#line 444 "../lib/chess-state.vala"
		_tmp119_ = chess_piece_new (player, promotion_type);
#line 444 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp118_]);
#line 444 "../lib/chess-state.vala"
		self->board[_tmp118_] = _tmp119_;
#line 2872 "chess-state.c"
	} else {
		gint _tmp120_;
		ChessPiece* _tmp121_;
		ChessPiece* _tmp122_;
#line 446 "../lib/chess-state.vala"
		_tmp120_ = end;
#line 446 "../lib/chess-state.vala"
		_tmp121_ = piece;
#line 446 "../lib/chess-state.vala"
		_tmp122_ = _g_object_ref0 (_tmp121_);
#line 446 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp120_]);
#line 446 "../lib/chess-state.vala"
		self->board[_tmp120_] = _tmp122_;
#line 2887 "chess-state.c"
	}
#line 447 "../lib/chess-state.vala"
	_tmp123_ = color;
#line 447 "../lib/chess-state.vala"
	_tmp124_ = end_mask;
#line 447 "../lib/chess-state.vala"
	self->priv->piece_masks[_tmp123_] |= _tmp124_;
#line 448 "../lib/chess-state.vala"
	_tmp125_ = opponent_color;
#line 448 "../lib/chess-state.vala"
	_tmp126_ = end;
#line 448 "../lib/chess-state.vala"
	_tmp127_ = BIT_BOARD_clear_location_masks[_tmp126_];
#line 448 "../lib/chess-state.vala"
	self->priv->piece_masks[_tmp125_] &= _tmp127_;
#line 449 "../lib/chess-state.vala"
	_tmp128_ = rook_start;
#line 449 "../lib/chess-state.vala"
	if (_tmp128_ >= 0) {
#line 2907 "chess-state.c"
		ChessPiece* rook = NULL;
		gint _tmp129_;
		ChessPiece* _tmp130_;
		ChessPiece* _tmp131_;
		gint _tmp132_;
		Color _tmp133_;
		gint _tmp134_;
		gint64 _tmp135_;
		gint _tmp136_;
		ChessPiece* _tmp137_;
		ChessPiece* _tmp138_;
		Color _tmp139_;
		gint _tmp140_;
		gint64 _tmp141_;
#line 451 "../lib/chess-state.vala"
		_tmp129_ = rook_start;
#line 451 "../lib/chess-state.vala"
		_tmp130_ = self->board[_tmp129_];
#line 451 "../lib/chess-state.vala"
		_tmp131_ = _g_object_ref0 (_tmp130_);
#line 451 "../lib/chess-state.vala"
		rook = _tmp131_;
#line 452 "../lib/chess-state.vala"
		_tmp132_ = rook_start;
#line 452 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp132_]);
#line 452 "../lib/chess-state.vala"
		self->board[_tmp132_] = NULL;
#line 453 "../lib/chess-state.vala"
		_tmp133_ = color;
#line 453 "../lib/chess-state.vala"
		_tmp134_ = rook_start;
#line 453 "../lib/chess-state.vala"
		_tmp135_ = BIT_BOARD_clear_location_masks[_tmp134_];
#line 453 "../lib/chess-state.vala"
		self->priv->piece_masks[_tmp133_] &= _tmp135_;
#line 454 "../lib/chess-state.vala"
		_tmp136_ = rook_end;
#line 454 "../lib/chess-state.vala"
		_tmp137_ = rook;
#line 454 "../lib/chess-state.vala"
		_tmp138_ = _g_object_ref0 (_tmp137_);
#line 454 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp136_]);
#line 454 "../lib/chess-state.vala"
		self->board[_tmp136_] = _tmp138_;
#line 455 "../lib/chess-state.vala"
		_tmp139_ = color;
#line 455 "../lib/chess-state.vala"
		_tmp140_ = rook_end;
#line 455 "../lib/chess-state.vala"
		_tmp141_ = BIT_BOARD_set_location_masks[_tmp140_];
#line 455 "../lib/chess-state.vala"
		self->priv->piece_masks[_tmp139_] |= _tmp141_;
#line 449 "../lib/chess-state.vala"
		_g_object_unref0 (rook);
#line 2964 "chess-state.c"
	}
#line 459 "../lib/chess-state.vala"
	_tmp142_ = piece;
#line 459 "../lib/chess-state.vala"
	_tmp143_ = _tmp142_->type;
#line 459 "../lib/chess-state.vala"
	if (_tmp143_ == PIECE_TYPE_KING) {
#line 2972 "chess-state.c"
		Color _tmp144_;
		Color _tmp145_;
#line 461 "../lib/chess-state.vala"
		_tmp144_ = color;
#line 461 "../lib/chess-state.vala"
		self->can_castle_kingside[_tmp144_] = FALSE;
#line 462 "../lib/chess-state.vala"
		_tmp145_ = color;
#line 462 "../lib/chess-state.vala"
		self->can_castle_queenside[_tmp145_] = FALSE;
#line 2983 "chess-state.c"
	} else {
		ChessPiece* _tmp146_;
		PieceType _tmp147_;
#line 465 "../lib/chess-state.vala"
		_tmp146_ = piece;
#line 465 "../lib/chess-state.vala"
		_tmp147_ = _tmp146_->type;
#line 465 "../lib/chess-state.vala"
		if (_tmp147_ == PIECE_TYPE_ROOK) {
#line 2993 "chess-state.c"
			gint _tmp148_ = 0;
			Color _tmp149_;
			gint base_rank = 0;
			gint _tmp150_;
#line 467 "../lib/chess-state.vala"
			_tmp149_ = color;
#line 467 "../lib/chess-state.vala"
			if (_tmp149_ == COLOR_WHITE) {
#line 467 "../lib/chess-state.vala"
				_tmp148_ = 0;
#line 3004 "chess-state.c"
			} else {
#line 467 "../lib/chess-state.vala"
				_tmp148_ = 7;
#line 3008 "chess-state.c"
			}
#line 467 "../lib/chess-state.vala"
			base_rank = _tmp148_;
#line 468 "../lib/chess-state.vala"
			_tmp150_ = base_rank;
#line 468 "../lib/chess-state.vala"
			if (r0 == _tmp150_) {
#line 470 "../lib/chess-state.vala"
				if (f0 == 0) {
#line 3018 "chess-state.c"
					Color _tmp151_;
#line 471 "../lib/chess-state.vala"
					_tmp151_ = color;
#line 471 "../lib/chess-state.vala"
					self->can_castle_queenside[_tmp151_] = FALSE;
#line 3024 "chess-state.c"
				} else {
#line 472 "../lib/chess-state.vala"
					if (f0 == 7) {
#line 3028 "chess-state.c"
						Color _tmp152_;
#line 473 "../lib/chess-state.vala"
						_tmp152_ = color;
#line 473 "../lib/chess-state.vala"
						self->can_castle_kingside[_tmp152_] = FALSE;
#line 3034 "chess-state.c"
					}
				}
			}
		} else {
			gboolean _tmp153_ = FALSE;
			ChessPiece* _tmp154_;
#line 477 "../lib/chess-state.vala"
			_tmp154_ = victim;
#line 477 "../lib/chess-state.vala"
			if (_tmp154_ != NULL) {
#line 3045 "chess-state.c"
				ChessPiece* _tmp155_;
				PieceType _tmp156_;
#line 477 "../lib/chess-state.vala"
				_tmp155_ = victim;
#line 477 "../lib/chess-state.vala"
				_tmp156_ = _tmp155_->type;
#line 477 "../lib/chess-state.vala"
				_tmp153_ = _tmp156_ == PIECE_TYPE_ROOK;
#line 3054 "chess-state.c"
			} else {
#line 477 "../lib/chess-state.vala"
				_tmp153_ = FALSE;
#line 3058 "chess-state.c"
			}
#line 477 "../lib/chess-state.vala"
			if (_tmp153_) {
#line 3062 "chess-state.c"
				gint _tmp157_ = 0;
				Color _tmp158_;
				gint base_rank = 0;
				gint _tmp159_;
#line 479 "../lib/chess-state.vala"
				_tmp158_ = opponent_color;
#line 479 "../lib/chess-state.vala"
				if (_tmp158_ == COLOR_WHITE) {
#line 479 "../lib/chess-state.vala"
					_tmp157_ = 0;
#line 3073 "chess-state.c"
				} else {
#line 479 "../lib/chess-state.vala"
					_tmp157_ = 7;
#line 3077 "chess-state.c"
				}
#line 479 "../lib/chess-state.vala"
				base_rank = _tmp157_;
#line 480 "../lib/chess-state.vala"
				_tmp159_ = base_rank;
#line 480 "../lib/chess-state.vala"
				if (r1 == _tmp159_) {
#line 482 "../lib/chess-state.vala"
					if (f1 == 0) {
#line 3087 "chess-state.c"
						Color _tmp160_;
#line 483 "../lib/chess-state.vala"
						_tmp160_ = opponent_color;
#line 483 "../lib/chess-state.vala"
						self->can_castle_queenside[_tmp160_] = FALSE;
#line 3093 "chess-state.c"
					} else {
#line 484 "../lib/chess-state.vala"
						if (f1 == 7) {
#line 3097 "chess-state.c"
							Color _tmp161_;
#line 485 "../lib/chess-state.vala"
							_tmp161_ = opponent_color;
#line 485 "../lib/chess-state.vala"
							self->can_castle_kingside[_tmp161_] = FALSE;
#line 3103 "chess-state.c"
						}
					}
				}
			}
		}
	}
#line 490 "../lib/chess-state.vala"
	_tmp163_ = piece;
#line 490 "../lib/chess-state.vala"
	_tmp164_ = _tmp163_->type;
#line 490 "../lib/chess-state.vala"
	if (_tmp164_ == PIECE_TYPE_PAWN) {
#line 3116 "chess-state.c"
		gint64 _tmp165_;
#line 490 "../lib/chess-state.vala"
		_tmp165_ = over_mask;
#line 490 "../lib/chess-state.vala"
		_tmp162_ = _tmp165_ != ((gint64) 0);
#line 3122 "chess-state.c"
	} else {
#line 490 "../lib/chess-state.vala"
		_tmp162_ = FALSE;
#line 3126 "chess-state.c"
	}
#line 490 "../lib/chess-state.vala"
	if (_tmp162_) {
#line 491 "../lib/chess-state.vala"
		self->en_passant_index = chess_state_get_index (self, (r0 + r1) / 2, f0);
#line 3132 "chess-state.c"
	} else {
#line 493 "../lib/chess-state.vala"
		self->en_passant_index = -1;
#line 3136 "chess-state.c"
	}
#line 496 "../lib/chess-state.vala"
	_tmp167_ = piece;
#line 496 "../lib/chess-state.vala"
	_tmp168_ = _tmp167_->type;
#line 496 "../lib/chess-state.vala"
	if (_tmp168_ == PIECE_TYPE_PAWN) {
#line 496 "../lib/chess-state.vala"
		_tmp166_ = TRUE;
#line 3146 "chess-state.c"
	} else {
		ChessPiece* _tmp169_;
#line 496 "../lib/chess-state.vala"
		_tmp169_ = victim;
#line 496 "../lib/chess-state.vala"
		_tmp166_ = _tmp169_ != NULL;
#line 3153 "chess-state.c"
	}
#line 496 "../lib/chess-state.vala"
	if (_tmp166_) {
#line 497 "../lib/chess-state.vala"
		self->halfmove_clock = 0;
#line 3159 "chess-state.c"
	} else {
		gint _tmp170_;
#line 499 "../lib/chess-state.vala"
		_tmp170_ = self->halfmove_clock;
#line 499 "../lib/chess-state.vala"
		self->halfmove_clock = _tmp170_ + 1;
#line 3166 "chess-state.c"
	}
#line 502 "../lib/chess-state.vala"
	_result_ = TRUE;
#line 503 "../lib/chess-state.vala"
	if (test_check) {
#line 503 "../lib/chess-state.vala"
		_tmp171_ = chess_state_is_in_check (self, player);
#line 3174 "chess-state.c"
	} else {
#line 503 "../lib/chess-state.vala"
		_tmp171_ = FALSE;
#line 3178 "chess-state.c"
	}
#line 503 "../lib/chess-state.vala"
	if (_tmp171_) {
#line 504 "../lib/chess-state.vala"
		_result_ = FALSE;
#line 3184 "chess-state.c"
	}
#line 507 "../lib/chess-state.vala"
	if (!apply) {
#line 507 "../lib/chess-state.vala"
		_tmp172_ = TRUE;
#line 3190 "chess-state.c"
	} else {
		gboolean _tmp173_;
#line 507 "../lib/chess-state.vala"
		_tmp173_ = _result_;
#line 507 "../lib/chess-state.vala"
		_tmp172_ = !_tmp173_;
#line 3197 "chess-state.c"
	}
#line 507 "../lib/chess-state.vala"
	if (_tmp172_) {
#line 3201 "chess-state.c"
		gint _tmp174_;
		ChessPiece* _tmp175_;
		ChessPiece* _tmp176_;
		gint _tmp177_;
		ChessPiece* _tmp178_;
		gint _tmp182_;
		gint64 _tmp190_;
		gint64 _tmp191_;
		gboolean _tmp192_;
		gboolean _tmp193_;
		gboolean _tmp194_;
		gboolean _tmp195_;
		gint _tmp196_;
		gint _tmp197_;
#line 509 "../lib/chess-state.vala"
		_tmp174_ = start;
#line 509 "../lib/chess-state.vala"
		_tmp175_ = piece;
#line 509 "../lib/chess-state.vala"
		_tmp176_ = _g_object_ref0 (_tmp175_);
#line 509 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp174_]);
#line 509 "../lib/chess-state.vala"
		self->board[_tmp174_] = _tmp176_;
#line 510 "../lib/chess-state.vala"
		_tmp177_ = end;
#line 510 "../lib/chess-state.vala"
		_g_object_unref0 (self->board[_tmp177_]);
#line 510 "../lib/chess-state.vala"
		self->board[_tmp177_] = NULL;
#line 511 "../lib/chess-state.vala"
		_tmp178_ = victim;
#line 511 "../lib/chess-state.vala"
		if (_tmp178_ != NULL) {
#line 3236 "chess-state.c"
			gint _tmp179_;
			ChessPiece* _tmp180_;
			ChessPiece* _tmp181_;
#line 512 "../lib/chess-state.vala"
			_tmp179_ = victim_index;
#line 512 "../lib/chess-state.vala"
			_tmp180_ = victim;
#line 512 "../lib/chess-state.vala"
			_tmp181_ = _g_object_ref0 (_tmp180_);
#line 512 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[_tmp179_]);
#line 512 "../lib/chess-state.vala"
			self->board[_tmp179_] = _tmp181_;
#line 3250 "chess-state.c"
		}
#line 513 "../lib/chess-state.vala"
		_tmp182_ = rook_start;
#line 513 "../lib/chess-state.vala"
		if (_tmp182_ >= 0) {
#line 3256 "chess-state.c"
			ChessPiece* rook = NULL;
			gint _tmp183_;
			ChessPiece* _tmp184_;
			ChessPiece* _tmp185_;
			gint _tmp186_;
			ChessPiece* _tmp187_;
			ChessPiece* _tmp188_;
			gint _tmp189_;
#line 515 "../lib/chess-state.vala"
			_tmp183_ = rook_end;
#line 515 "../lib/chess-state.vala"
			_tmp184_ = self->board[_tmp183_];
#line 515 "../lib/chess-state.vala"
			_tmp185_ = _g_object_ref0 (_tmp184_);
#line 515 "../lib/chess-state.vala"
			rook = _tmp185_;
#line 516 "../lib/chess-state.vala"
			_tmp186_ = rook_start;
#line 516 "../lib/chess-state.vala"
			_tmp187_ = rook;
#line 516 "../lib/chess-state.vala"
			_tmp188_ = _g_object_ref0 (_tmp187_);
#line 516 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[_tmp186_]);
#line 516 "../lib/chess-state.vala"
			self->board[_tmp186_] = _tmp188_;
#line 517 "../lib/chess-state.vala"
			_tmp189_ = rook_end;
#line 517 "../lib/chess-state.vala"
			_g_object_unref0 (self->board[_tmp189_]);
#line 517 "../lib/chess-state.vala"
			self->board[_tmp189_] = NULL;
#line 513 "../lib/chess-state.vala"
			_g_object_unref0 (rook);
#line 3291 "chess-state.c"
		}
#line 519 "../lib/chess-state.vala"
		_tmp190_ = old_white_mask;
#line 519 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_WHITE] = _tmp190_;
#line 520 "../lib/chess-state.vala"
		_tmp191_ = old_black_mask;
#line 520 "../lib/chess-state.vala"
		self->priv->piece_masks[COLOR_BLACK] = _tmp191_;
#line 521 "../lib/chess-state.vala"
		_tmp192_ = old_white_can_castle_kingside;
#line 521 "../lib/chess-state.vala"
		self->can_castle_kingside[COLOR_WHITE] = _tmp192_;
#line 522 "../lib/chess-state.vala"
		_tmp193_ = old_white_can_castle_queenside;
#line 522 "../lib/chess-state.vala"
		self->can_castle_queenside[COLOR_WHITE] = _tmp193_;
#line 523 "../lib/chess-state.vala"
		_tmp194_ = old_black_can_castle_kingside;
#line 523 "../lib/chess-state.vala"
		self->can_castle_kingside[COLOR_BLACK] = _tmp194_;
#line 524 "../lib/chess-state.vala"
		_tmp195_ = old_black_can_castle_queenside;
#line 524 "../lib/chess-state.vala"
		self->can_castle_queenside[COLOR_BLACK] = _tmp195_;
#line 525 "../lib/chess-state.vala"
		_tmp196_ = old_en_passant_index;
#line 525 "../lib/chess-state.vala"
		self->en_passant_index = _tmp196_;
#line 526 "../lib/chess-state.vala"
		_tmp197_ = old_halfmove_clock;
#line 526 "../lib/chess-state.vala"
		self->halfmove_clock = _tmp197_;
#line 528 "../lib/chess-state.vala"
		result = _result_;
#line 528 "../lib/chess-state.vala"
		_g_object_unref0 (victim);
#line 528 "../lib/chess-state.vala"
		_g_object_unref0 (piece);
#line 528 "../lib/chess-state.vala"
		return result;
#line 3333 "chess-state.c"
	}
#line 531 "../lib/chess-state.vala"
	_tmp199_ = color;
#line 531 "../lib/chess-state.vala"
	if (_tmp199_ == COLOR_WHITE) {
#line 3339 "chess-state.c"
		ChessPlayer* _tmp200_;
#line 531 "../lib/chess-state.vala"
		_tmp200_ = self->players[COLOR_BLACK];
#line 531 "../lib/chess-state.vala"
		_tmp198_ = _tmp200_;
#line 3345 "chess-state.c"
	} else {
		ChessPlayer* _tmp201_;
#line 531 "../lib/chess-state.vala"
		_tmp201_ = self->players[COLOR_WHITE];
#line 531 "../lib/chess-state.vala"
		_tmp198_ = _tmp201_;
#line 3352 "chess-state.c"
	}
#line 531 "../lib/chess-state.vala"
	_tmp202_ = _g_object_ref0 (_tmp198_);
#line 531 "../lib/chess-state.vala"
	_g_object_unref0 (self->current_player);
#line 531 "../lib/chess-state.vala"
	self->current_player = _tmp202_;
#line 532 "../lib/chess-state.vala"
	_tmp203_ = self->current_player;
#line 532 "../lib/chess-state.vala"
	self->check_state = chess_state_get_check_state (self, _tmp203_);
#line 534 "../lib/chess-state.vala"
	_tmp204_ = chess_move_new ();
#line 534 "../lib/chess-state.vala"
	_g_object_unref0 (self->last_move);
#line 534 "../lib/chess-state.vala"
	self->last_move = _tmp204_;
#line 535 "../lib/chess-state.vala"
	_tmp205_ = self->last_move;
#line 535 "../lib/chess-state.vala"
	_tmp206_ = self->number;
#line 535 "../lib/chess-state.vala"
	_tmp205_->number = _tmp206_;
#line 536 "../lib/chess-state.vala"
	_tmp207_ = self->last_move;
#line 536 "../lib/chess-state.vala"
	_tmp208_ = piece;
#line 536 "../lib/chess-state.vala"
	_tmp209_ = _g_object_ref0 (_tmp208_);
#line 536 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp207_->piece);
#line 536 "../lib/chess-state.vala"
	_tmp207_->piece = _tmp209_;
#line 537 "../lib/chess-state.vala"
	_tmp210_ = is_promotion;
#line 537 "../lib/chess-state.vala"
	if (_tmp210_) {
#line 3390 "chess-state.c"
		ChessMove* _tmp211_;
		gint _tmp212_;
		ChessPiece* _tmp213_;
		ChessPiece* _tmp214_;
#line 538 "../lib/chess-state.vala"
		_tmp211_ = self->last_move;
#line 538 "../lib/chess-state.vala"
		_tmp212_ = end;
#line 538 "../lib/chess-state.vala"
		_tmp213_ = self->board[_tmp212_];
#line 538 "../lib/chess-state.vala"
		_tmp214_ = _g_object_ref0 (_tmp213_);
#line 538 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp211_->promotion_piece);
#line 538 "../lib/chess-state.vala"
		_tmp211_->promotion_piece = _tmp214_;
#line 3407 "chess-state.c"
	}
#line 539 "../lib/chess-state.vala"
	_tmp215_ = self->last_move;
#line 539 "../lib/chess-state.vala"
	_tmp216_ = victim;
#line 539 "../lib/chess-state.vala"
	_tmp217_ = _g_object_ref0 (_tmp216_);
#line 539 "../lib/chess-state.vala"
	_g_object_unref0 (_tmp215_->victim);
#line 539 "../lib/chess-state.vala"
	_tmp215_->victim = _tmp217_;
#line 540 "../lib/chess-state.vala"
	_tmp218_ = rook_end;
#line 540 "../lib/chess-state.vala"
	if (_tmp218_ >= 0) {
#line 3423 "chess-state.c"
		ChessMove* _tmp219_;
		gint _tmp220_;
		ChessPiece* _tmp221_;
		ChessPiece* _tmp222_;
#line 541 "../lib/chess-state.vala"
		_tmp219_ = self->last_move;
#line 541 "../lib/chess-state.vala"
		_tmp220_ = rook_end;
#line 541 "../lib/chess-state.vala"
		_tmp221_ = self->board[_tmp220_];
#line 541 "../lib/chess-state.vala"
		_tmp222_ = _g_object_ref0 (_tmp221_);
#line 541 "../lib/chess-state.vala"
		_g_object_unref0 (_tmp219_->castling_rook);
#line 541 "../lib/chess-state.vala"
		_tmp219_->castling_rook = _tmp222_;
#line 3440 "chess-state.c"
	}
#line 542 "../lib/chess-state.vala"
	_tmp223_ = self->last_move;
#line 542 "../lib/chess-state.vala"
	_tmp223_->r0 = r0;
#line 543 "../lib/chess-state.vala"
	_tmp224_ = self->last_move;
#line 543 "../lib/chess-state.vala"
	_tmp224_->f0 = f0;
#line 544 "../lib/chess-state.vala"
	_tmp225_ = self->last_move;
#line 544 "../lib/chess-state.vala"
	_tmp225_->r1 = r1;
#line 545 "../lib/chess-state.vala"
	_tmp226_ = self->last_move;
#line 545 "../lib/chess-state.vala"
	_tmp226_->f1 = f1;
#line 546 "../lib/chess-state.vala"
	_tmp227_ = self->last_move;
#line 546 "../lib/chess-state.vala"
	_tmp228_ = ambiguous_rank;
#line 546 "../lib/chess-state.vala"
	_tmp227_->ambiguous_rank = _tmp228_;
#line 547 "../lib/chess-state.vala"
	_tmp229_ = self->last_move;
#line 547 "../lib/chess-state.vala"
	_tmp230_ = ambiguous_file;
#line 547 "../lib/chess-state.vala"
	_tmp229_->ambiguous_file = _tmp230_;
#line 548 "../lib/chess-state.vala"
	_tmp231_ = self->last_move;
#line 548 "../lib/chess-state.vala"
	_tmp232_ = en_passant;
#line 548 "../lib/chess-state.vala"
	_tmp231_->en_passant = _tmp232_;
#line 549 "../lib/chess-state.vala"
	_tmp233_ = self->last_move;
#line 549 "../lib/chess-state.vala"
	_tmp234_ = self->check_state;
#line 549 "../lib/chess-state.vala"
	_tmp233_->check_state = _tmp234_;
#line 551 "../lib/chess-state.vala"
	result = TRUE;
#line 551 "../lib/chess-state.vala"
	_g_object_unref0 (victim);
#line 551 "../lib/chess-state.vala"
	_g_object_unref0 (piece);
#line 551 "../lib/chess-state.vala"
	return result;
#line 3490 "chess-state.c"
}


ChessResult
chess_state_get_result (ChessState* self,
                        ChessRule* rule)
{
	ChessRule _vala_rule = 0;
	ChessResult result = 0;
	CheckState _tmp0_;
	ChessPlayer* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	ChessMove* _tmp6_;
#line 554 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 556 "../lib/chess-state.vala"
	_vala_rule = CHESS_RULE_CHECKMATE;
#line 557 "../lib/chess-state.vala"
	_tmp0_ = self->check_state;
#line 557 "../lib/chess-state.vala"
	if (_tmp0_ == CHECK_STATE_CHECKMATE) {
#line 3513 "chess-state.c"
		ChessPlayer* _tmp1_;
		Color _tmp2_;
#line 559 "../lib/chess-state.vala"
		_tmp1_ = self->current_player;
#line 559 "../lib/chess-state.vala"
		_tmp2_ = _tmp1_->color;
#line 559 "../lib/chess-state.vala"
		if (_tmp2_ == COLOR_WHITE) {
#line 561 "../lib/chess-state.vala"
			_vala_rule = CHESS_RULE_CHECKMATE;
#line 562 "../lib/chess-state.vala"
			result = CHESS_RESULT_BLACK_WON;
#line 562 "../lib/chess-state.vala"
			if (rule) {
#line 562 "../lib/chess-state.vala"
				*rule = _vala_rule;
#line 3530 "chess-state.c"
			}
#line 562 "../lib/chess-state.vala"
			return result;
#line 3534 "chess-state.c"
		} else {
#line 566 "../lib/chess-state.vala"
			_vala_rule = CHESS_RULE_CHECKMATE;
#line 567 "../lib/chess-state.vala"
			result = CHESS_RESULT_WHITE_WON;
#line 567 "../lib/chess-state.vala"
			if (rule) {
#line 567 "../lib/chess-state.vala"
				*rule = _vala_rule;
#line 3544 "chess-state.c"
			}
#line 567 "../lib/chess-state.vala"
			return result;
#line 3548 "chess-state.c"
		}
	}
#line 571 "../lib/chess-state.vala"
	_tmp3_ = self->current_player;
#line 571 "../lib/chess-state.vala"
	if (!chess_state_can_move (self, _tmp3_)) {
#line 573 "../lib/chess-state.vala"
		_vala_rule = CHESS_RULE_STALEMATE;
#line 574 "../lib/chess-state.vala"
		result = CHESS_RESULT_DRAW;
#line 574 "../lib/chess-state.vala"
		if (rule) {
#line 574 "../lib/chess-state.vala"
			*rule = _vala_rule;
#line 3563 "chess-state.c"
		}
#line 574 "../lib/chess-state.vala"
		return result;
#line 3567 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	_tmp6_ = self->last_move;
#line 577 "../lib/chess-state.vala"
	if (_tmp6_ != NULL) {
#line 3573 "chess-state.c"
		ChessMove* _tmp7_;
		ChessPiece* _tmp8_;
#line 577 "../lib/chess-state.vala"
		_tmp7_ = self->last_move;
#line 577 "../lib/chess-state.vala"
		_tmp8_ = _tmp7_->victim;
#line 577 "../lib/chess-state.vala"
		_tmp5_ = _tmp8_ != NULL;
#line 3582 "chess-state.c"
	} else {
#line 577 "../lib/chess-state.vala"
		_tmp5_ = FALSE;
#line 3586 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	if (_tmp5_) {
#line 577 "../lib/chess-state.vala"
		_tmp4_ = !chess_state_have_sufficient_material (self);
#line 3592 "chess-state.c"
	} else {
#line 577 "../lib/chess-state.vala"
		_tmp4_ = FALSE;
#line 3596 "chess-state.c"
	}
#line 577 "../lib/chess-state.vala"
	if (_tmp4_) {
#line 579 "../lib/chess-state.vala"
		_vala_rule = CHESS_RULE_INSUFFICIENT_MATERIAL;
#line 580 "../lib/chess-state.vala"
		result = CHESS_RESULT_DRAW;
#line 580 "../lib/chess-state.vala"
		if (rule) {
#line 580 "../lib/chess-state.vala"
			*rule = _vala_rule;
#line 3608 "chess-state.c"
		}
#line 580 "../lib/chess-state.vala"
		return result;
#line 3612 "chess-state.c"
	}
#line 583 "../lib/chess-state.vala"
	result = CHESS_RESULT_IN_PROGRESS;
#line 583 "../lib/chess-state.vala"
	if (rule) {
#line 583 "../lib/chess-state.vala"
		*rule = _vala_rule;
#line 3620 "chess-state.c"
	}
#line 583 "../lib/chess-state.vala"
	return result;
#line 3624 "chess-state.c"
}


static CheckState
chess_state_get_check_state (ChessState* self,
                             ChessPlayer* player)
{
	CheckState result = 0;
#line 586 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 586 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, 0);
#line 588 "../lib/chess-state.vala"
	if (chess_state_is_in_check (self, player)) {
#line 590 "../lib/chess-state.vala"
		if (chess_state_is_in_checkmate (self, player)) {
#line 591 "../lib/chess-state.vala"
			result = CHECK_STATE_CHECKMATE;
#line 591 "../lib/chess-state.vala"
			return result;
#line 3645 "chess-state.c"
		} else {
#line 593 "../lib/chess-state.vala"
			result = CHECK_STATE_CHECK;
#line 593 "../lib/chess-state.vala"
			return result;
#line 3651 "chess-state.c"
		}
	}
#line 595 "../lib/chess-state.vala"
	result = CHECK_STATE_NONE;
#line 595 "../lib/chess-state.vala"
	return result;
#line 3658 "chess-state.c"
}


gboolean
chess_state_is_in_check (ChessState* self,
                         ChessPlayer* player)
{
	gboolean result = FALSE;
	ChessPlayer* _tmp0_ = NULL;
	Color _tmp1_;
	ChessPlayer* opponent = NULL;
	ChessPlayer* _tmp4_;
#line 598 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 598 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 600 "../lib/chess-state.vala"
	_tmp1_ = player->color;
#line 600 "../lib/chess-state.vala"
	if (_tmp1_ == COLOR_WHITE) {
#line 3679 "chess-state.c"
		ChessPlayer* _tmp2_;
#line 600 "../lib/chess-state.vala"
		_tmp2_ = self->players[COLOR_BLACK];
#line 600 "../lib/chess-state.vala"
		_tmp0_ = _tmp2_;
#line 3685 "chess-state.c"
	} else {
		ChessPlayer* _tmp3_;
#line 600 "../lib/chess-state.vala"
		_tmp3_ = self->players[COLOR_WHITE];
#line 600 "../lib/chess-state.vala"
		_tmp0_ = _tmp3_;
#line 3692 "chess-state.c"
	}
#line 600 "../lib/chess-state.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 600 "../lib/chess-state.vala"
	opponent = _tmp4_;
#line 3698 "chess-state.c"
	{
		gint king_index = 0;
#line 603 "../lib/chess-state.vala"
		king_index = 0;
#line 3703 "chess-state.c"
		{
			gboolean _tmp5_ = FALSE;
#line 603 "../lib/chess-state.vala"
			_tmp5_ = TRUE;
#line 603 "../lib/chess-state.vala"
			while (TRUE) {
#line 3710 "chess-state.c"
				gint _tmp7_;
				ChessPiece* p = NULL;
				gint _tmp8_;
				ChessPiece* _tmp9_;
				ChessPiece* _tmp10_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				ChessPiece* _tmp13_;
#line 603 "../lib/chess-state.vala"
				if (!_tmp5_) {
#line 3721 "chess-state.c"
					gint _tmp6_;
#line 603 "../lib/chess-state.vala"
					_tmp6_ = king_index;
#line 603 "../lib/chess-state.vala"
					king_index = _tmp6_ + 1;
#line 3727 "chess-state.c"
				}
#line 603 "../lib/chess-state.vala"
				_tmp5_ = FALSE;
#line 603 "../lib/chess-state.vala"
				_tmp7_ = king_index;
#line 603 "../lib/chess-state.vala"
				if (!(_tmp7_ < 64)) {
#line 603 "../lib/chess-state.vala"
					break;
#line 3737 "chess-state.c"
				}
#line 605 "../lib/chess-state.vala"
				_tmp8_ = king_index;
#line 605 "../lib/chess-state.vala"
				_tmp9_ = self->board[_tmp8_];
#line 605 "../lib/chess-state.vala"
				_tmp10_ = _g_object_ref0 (_tmp9_);
#line 605 "../lib/chess-state.vala"
				p = _tmp10_;
#line 606 "../lib/chess-state.vala"
				_tmp13_ = p;
#line 606 "../lib/chess-state.vala"
				if (_tmp13_ != NULL) {
#line 3751 "chess-state.c"
					ChessPiece* _tmp14_;
					ChessPlayer* _tmp15_;
#line 606 "../lib/chess-state.vala"
					_tmp14_ = p;
#line 606 "../lib/chess-state.vala"
					_tmp15_ = _tmp14_->player;
#line 606 "../lib/chess-state.vala"
					_tmp12_ = _tmp15_ == player;
#line 3760 "chess-state.c"
				} else {
#line 606 "../lib/chess-state.vala"
					_tmp12_ = FALSE;
#line 3764 "chess-state.c"
				}
#line 606 "../lib/chess-state.vala"
				if (_tmp12_) {
#line 3768 "chess-state.c"
					ChessPiece* _tmp16_;
					PieceType _tmp17_;
#line 606 "../lib/chess-state.vala"
					_tmp16_ = p;
#line 606 "../lib/chess-state.vala"
					_tmp17_ = _tmp16_->type;
#line 606 "../lib/chess-state.vala"
					_tmp11_ = _tmp17_ == PIECE_TYPE_KING;
#line 3777 "chess-state.c"
				} else {
#line 606 "../lib/chess-state.vala"
					_tmp11_ = FALSE;
#line 3781 "chess-state.c"
				}
#line 606 "../lib/chess-state.vala"
				if (_tmp11_) {
#line 3785 "chess-state.c"
					{
						gint start = 0;
#line 609 "../lib/chess-state.vala"
						start = 0;
#line 3790 "chess-state.c"
						{
							gboolean _tmp18_ = FALSE;
#line 609 "../lib/chess-state.vala"
							_tmp18_ = TRUE;
#line 609 "../lib/chess-state.vala"
							while (TRUE) {
#line 3797 "chess-state.c"
								gint _tmp20_;
								ChessPlayer* _tmp21_;
								gint _tmp22_;
								gint _tmp23_;
								gint _tmp24_;
								gint _tmp25_;
#line 609 "../lib/chess-state.vala"
								if (!_tmp18_) {
#line 3806 "chess-state.c"
									gint _tmp19_;
#line 609 "../lib/chess-state.vala"
									_tmp19_ = start;
#line 609 "../lib/chess-state.vala"
									start = _tmp19_ + 1;
#line 3812 "chess-state.c"
								}
#line 609 "../lib/chess-state.vala"
								_tmp18_ = FALSE;
#line 609 "../lib/chess-state.vala"
								_tmp20_ = start;
#line 609 "../lib/chess-state.vala"
								if (!(_tmp20_ < 64)) {
#line 609 "../lib/chess-state.vala"
									break;
#line 3822 "chess-state.c"
								}
#line 611 "../lib/chess-state.vala"
								_tmp21_ = opponent;
#line 611 "../lib/chess-state.vala"
								_tmp22_ = start;
#line 611 "../lib/chess-state.vala"
								_tmp23_ = start;
#line 611 "../lib/chess-state.vala"
								_tmp24_ = king_index;
#line 611 "../lib/chess-state.vala"
								_tmp25_ = king_index;
#line 611 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, _tmp21_, chess_state_get_rank (self, _tmp22_), chess_state_get_file (self, _tmp23_), chess_state_get_rank (self, _tmp24_), chess_state_get_file (self, _tmp25_), PIECE_TYPE_QUEEN, FALSE, FALSE)) {
#line 615 "../lib/chess-state.vala"
									result = TRUE;
#line 615 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 615 "../lib/chess-state.vala"
									_g_object_unref0 (opponent);
#line 615 "../lib/chess-state.vala"
									return result;
#line 3844 "chess-state.c"
								}
							}
						}
					}
				}
#line 603 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 3852 "chess-state.c"
			}
		}
	}
#line 620 "../lib/chess-state.vala"
	result = FALSE;
#line 620 "../lib/chess-state.vala"
	_g_object_unref0 (opponent);
#line 620 "../lib/chess-state.vala"
	return result;
#line 3862 "chess-state.c"
}


static gboolean
chess_state_is_in_checkmate (ChessState* self,
                             ChessPlayer* player)
{
	gboolean result = FALSE;
#line 623 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 623 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 3875 "chess-state.c"
	{
		gint piece_index = 0;
#line 626 "../lib/chess-state.vala"
		piece_index = 0;
#line 3880 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 626 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 626 "../lib/chess-state.vala"
			while (TRUE) {
#line 3887 "chess-state.c"
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
#line 626 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 3897 "chess-state.c"
					gint _tmp1_;
#line 626 "../lib/chess-state.vala"
					_tmp1_ = piece_index;
#line 626 "../lib/chess-state.vala"
					piece_index = _tmp1_ + 1;
#line 3903 "chess-state.c"
				}
#line 626 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 626 "../lib/chess-state.vala"
				_tmp2_ = piece_index;
#line 626 "../lib/chess-state.vala"
				if (!(_tmp2_ < 64)) {
#line 626 "../lib/chess-state.vala"
					break;
#line 3913 "chess-state.c"
				}
#line 628 "../lib/chess-state.vala"
				_tmp3_ = piece_index;
#line 628 "../lib/chess-state.vala"
				_tmp4_ = self->board[_tmp3_];
#line 628 "../lib/chess-state.vala"
				_tmp5_ = _g_object_ref0 (_tmp4_);
#line 628 "../lib/chess-state.vala"
				p = _tmp5_;
#line 629 "../lib/chess-state.vala"
				_tmp7_ = p;
#line 629 "../lib/chess-state.vala"
				if (_tmp7_ != NULL) {
#line 3927 "chess-state.c"
					ChessPiece* _tmp8_;
					ChessPlayer* _tmp9_;
#line 629 "../lib/chess-state.vala"
					_tmp8_ = p;
#line 629 "../lib/chess-state.vala"
					_tmp9_ = _tmp8_->player;
#line 629 "../lib/chess-state.vala"
					_tmp6_ = _tmp9_ == player;
#line 3936 "chess-state.c"
				} else {
#line 629 "../lib/chess-state.vala"
					_tmp6_ = FALSE;
#line 3940 "chess-state.c"
				}
#line 629 "../lib/chess-state.vala"
				if (_tmp6_) {
#line 3944 "chess-state.c"
					{
						gint end = 0;
#line 631 "../lib/chess-state.vala"
						end = 0;
#line 3949 "chess-state.c"
						{
							gboolean _tmp10_ = FALSE;
#line 631 "../lib/chess-state.vala"
							_tmp10_ = TRUE;
#line 631 "../lib/chess-state.vala"
							while (TRUE) {
#line 3956 "chess-state.c"
								gint _tmp12_;
								gint _tmp13_;
								gint _tmp14_;
								gint _tmp15_;
								gint _tmp16_;
#line 631 "../lib/chess-state.vala"
								if (!_tmp10_) {
#line 3964 "chess-state.c"
									gint _tmp11_;
#line 631 "../lib/chess-state.vala"
									_tmp11_ = end;
#line 631 "../lib/chess-state.vala"
									end = _tmp11_ + 1;
#line 3970 "chess-state.c"
								}
#line 631 "../lib/chess-state.vala"
								_tmp10_ = FALSE;
#line 631 "../lib/chess-state.vala"
								_tmp12_ = end;
#line 631 "../lib/chess-state.vala"
								if (!(_tmp12_ < 64)) {
#line 631 "../lib/chess-state.vala"
									break;
#line 3980 "chess-state.c"
								}
#line 633 "../lib/chess-state.vala"
								_tmp13_ = piece_index;
#line 633 "../lib/chess-state.vala"
								_tmp14_ = piece_index;
#line 633 "../lib/chess-state.vala"
								_tmp15_ = end;
#line 633 "../lib/chess-state.vala"
								_tmp16_ = end;
#line 633 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, _tmp13_), chess_state_get_file (self, _tmp14_), chess_state_get_rank (self, _tmp15_), chess_state_get_file (self, _tmp16_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 637 "../lib/chess-state.vala"
									result = FALSE;
#line 637 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 637 "../lib/chess-state.vala"
									return result;
#line 3998 "chess-state.c"
								}
							}
						}
					}
				}
#line 626 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 4006 "chess-state.c"
			}
		}
	}
#line 642 "../lib/chess-state.vala"
	result = TRUE;
#line 642 "../lib/chess-state.vala"
	return result;
#line 4014 "chess-state.c"
}


static gboolean
chess_state_can_move (ChessState* self,
                      ChessPlayer* player)
{
	gboolean result = FALSE;
	gboolean have_pieces = FALSE;
	gboolean _tmp17_;
#line 645 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 645 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 647 "../lib/chess-state.vala"
	have_pieces = FALSE;
#line 4031 "chess-state.c"
	{
		gint start = 0;
#line 649 "../lib/chess-state.vala"
		start = 0;
#line 4036 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 649 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 649 "../lib/chess-state.vala"
			while (TRUE) {
#line 4043 "chess-state.c"
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
#line 649 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 4053 "chess-state.c"
					gint _tmp1_;
#line 649 "../lib/chess-state.vala"
					_tmp1_ = start;
#line 649 "../lib/chess-state.vala"
					start = _tmp1_ + 1;
#line 4059 "chess-state.c"
				}
#line 649 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 649 "../lib/chess-state.vala"
				_tmp2_ = start;
#line 649 "../lib/chess-state.vala"
				if (!(_tmp2_ < 64)) {
#line 649 "../lib/chess-state.vala"
					break;
#line 4069 "chess-state.c"
				}
#line 651 "../lib/chess-state.vala"
				_tmp3_ = start;
#line 651 "../lib/chess-state.vala"
				_tmp4_ = self->board[_tmp3_];
#line 651 "../lib/chess-state.vala"
				_tmp5_ = _g_object_ref0 (_tmp4_);
#line 651 "../lib/chess-state.vala"
				p = _tmp5_;
#line 652 "../lib/chess-state.vala"
				_tmp7_ = p;
#line 652 "../lib/chess-state.vala"
				if (_tmp7_ != NULL) {
#line 4083 "chess-state.c"
					ChessPiece* _tmp8_;
					ChessPlayer* _tmp9_;
#line 652 "../lib/chess-state.vala"
					_tmp8_ = p;
#line 652 "../lib/chess-state.vala"
					_tmp9_ = _tmp8_->player;
#line 652 "../lib/chess-state.vala"
					_tmp6_ = _tmp9_ == player;
#line 4092 "chess-state.c"
				} else {
#line 652 "../lib/chess-state.vala"
					_tmp6_ = FALSE;
#line 4096 "chess-state.c"
				}
#line 652 "../lib/chess-state.vala"
				if (_tmp6_) {
#line 654 "../lib/chess-state.vala"
					have_pieces = TRUE;
#line 4102 "chess-state.c"
					{
						gint end = 0;
#line 657 "../lib/chess-state.vala"
						end = 0;
#line 4107 "chess-state.c"
						{
							gboolean _tmp10_ = FALSE;
#line 657 "../lib/chess-state.vala"
							_tmp10_ = TRUE;
#line 657 "../lib/chess-state.vala"
							while (TRUE) {
#line 4114 "chess-state.c"
								gint _tmp12_;
								gint _tmp13_;
								gint _tmp14_;
								gint _tmp15_;
								gint _tmp16_;
#line 657 "../lib/chess-state.vala"
								if (!_tmp10_) {
#line 4122 "chess-state.c"
									gint _tmp11_;
#line 657 "../lib/chess-state.vala"
									_tmp11_ = end;
#line 657 "../lib/chess-state.vala"
									end = _tmp11_ + 1;
#line 4128 "chess-state.c"
								}
#line 657 "../lib/chess-state.vala"
								_tmp10_ = FALSE;
#line 657 "../lib/chess-state.vala"
								_tmp12_ = end;
#line 657 "../lib/chess-state.vala"
								if (!(_tmp12_ < 64)) {
#line 657 "../lib/chess-state.vala"
									break;
#line 4138 "chess-state.c"
								}
#line 659 "../lib/chess-state.vala"
								_tmp13_ = start;
#line 659 "../lib/chess-state.vala"
								_tmp14_ = start;
#line 659 "../lib/chess-state.vala"
								_tmp15_ = end;
#line 659 "../lib/chess-state.vala"
								_tmp16_ = end;
#line 659 "../lib/chess-state.vala"
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, _tmp13_), chess_state_get_file (self, _tmp14_), chess_state_get_rank (self, _tmp15_), chess_state_get_file (self, _tmp16_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 663 "../lib/chess-state.vala"
									result = TRUE;
#line 663 "../lib/chess-state.vala"
									_g_object_unref0 (p);
#line 663 "../lib/chess-state.vala"
									return result;
#line 4156 "chess-state.c"
								}
							}
						}
					}
				}
#line 649 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 4164 "chess-state.c"
			}
		}
	}
#line 669 "../lib/chess-state.vala"
	_tmp17_ = have_pieces;
#line 669 "../lib/chess-state.vala"
	if (_tmp17_) {
#line 670 "../lib/chess-state.vala"
		result = FALSE;
#line 670 "../lib/chess-state.vala"
		return result;
#line 4176 "chess-state.c"
	} else {
#line 672 "../lib/chess-state.vala"
		result = TRUE;
#line 672 "../lib/chess-state.vala"
		return result;
#line 4182 "chess-state.c"
	}
}


gboolean
chess_state_have_sufficient_material (ChessState* self)
{
	gboolean result = FALSE;
	gint white_knight_count = 0;
	gint white_bishop_count = 0;
	gboolean white_bishop_on_white_square = FALSE;
	gboolean white_bishop_on_black_square = FALSE;
	gint black_knight_count = 0;
	gint black_bishop_count = 0;
	gboolean black_bishop_on_white_square = FALSE;
	gboolean black_bishop_on_black_square = FALSE;
#line 675 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 677 "../lib/chess-state.vala"
	white_knight_count = 0;
#line 678 "../lib/chess-state.vala"
	white_bishop_count = 0;
#line 679 "../lib/chess-state.vala"
	white_bishop_on_white_square = FALSE;
#line 680 "../lib/chess-state.vala"
	white_bishop_on_black_square = FALSE;
#line 681 "../lib/chess-state.vala"
	black_knight_count = 0;
#line 682 "../lib/chess-state.vala"
	black_bishop_count = 0;
#line 683 "../lib/chess-state.vala"
	black_bishop_on_white_square = FALSE;
#line 684 "../lib/chess-state.vala"
	black_bishop_on_black_square = FALSE;
#line 4217 "chess-state.c"
	{
		gint i = 0;
#line 686 "../lib/chess-state.vala"
		i = 0;
#line 4222 "chess-state.c"
		{
			gboolean _tmp0_ = FALSE;
#line 686 "../lib/chess-state.vala"
			_tmp0_ = TRUE;
#line 686 "../lib/chess-state.vala"
			while (TRUE) {
#line 4229 "chess-state.c"
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				ChessPiece* _tmp6_;
				gboolean _tmp7_ = FALSE;
				gboolean _tmp8_ = FALSE;
				ChessPiece* _tmp9_;
				PieceType _tmp10_;
				ChessPiece* _tmp15_;
				PieceType _tmp16_;
				ChessPiece* _tmp22_;
				PieceType _tmp23_;
				gboolean _tmp33_ = FALSE;
				gint _tmp34_;
				gboolean _tmp36_ = FALSE;
				gint _tmp37_;
				gboolean _tmp39_ = FALSE;
				gint _tmp40_;
				gboolean _tmp42_ = FALSE;
				gboolean _tmp43_;
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_;
				gboolean _tmp48_ = FALSE;
				gboolean _tmp49_ = FALSE;
				gint _tmp50_;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_ = FALSE;
				gint _tmp55_;
				gboolean _tmp58_ = FALSE;
				gint _tmp59_;
#line 686 "../lib/chess-state.vala"
				if (!_tmp0_) {
#line 4264 "chess-state.c"
					gint _tmp1_;
#line 686 "../lib/chess-state.vala"
					_tmp1_ = i;
#line 686 "../lib/chess-state.vala"
					i = _tmp1_ + 1;
#line 4270 "chess-state.c"
				}
#line 686 "../lib/chess-state.vala"
				_tmp0_ = FALSE;
#line 686 "../lib/chess-state.vala"
				_tmp2_ = i;
#line 686 "../lib/chess-state.vala"
				if (!(_tmp2_ < 64)) {
#line 686 "../lib/chess-state.vala"
					break;
#line 4280 "chess-state.c"
				}
#line 688 "../lib/chess-state.vala"
				_tmp3_ = i;
#line 688 "../lib/chess-state.vala"
				_tmp4_ = self->board[_tmp3_];
#line 688 "../lib/chess-state.vala"
				_tmp5_ = _g_object_ref0 (_tmp4_);
#line 688 "../lib/chess-state.vala"
				p = _tmp5_;
#line 689 "../lib/chess-state.vala"
				_tmp6_ = p;
#line 689 "../lib/chess-state.vala"
				if (_tmp6_ == NULL) {
#line 690 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 690 "../lib/chess-state.vala"
					continue;
#line 4298 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				_tmp9_ = p;
#line 693 "../lib/chess-state.vala"
				_tmp10_ = _tmp9_->type;
#line 693 "../lib/chess-state.vala"
				if (_tmp10_ == PIECE_TYPE_PAWN) {
#line 693 "../lib/chess-state.vala"
					_tmp8_ = TRUE;
#line 4308 "chess-state.c"
				} else {
					ChessPiece* _tmp11_;
					PieceType _tmp12_;
#line 693 "../lib/chess-state.vala"
					_tmp11_ = p;
#line 693 "../lib/chess-state.vala"
					_tmp12_ = _tmp11_->type;
#line 693 "../lib/chess-state.vala"
					_tmp8_ = _tmp12_ == PIECE_TYPE_ROOK;
#line 4318 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				if (_tmp8_) {
#line 693 "../lib/chess-state.vala"
					_tmp7_ = TRUE;
#line 4324 "chess-state.c"
				} else {
					ChessPiece* _tmp13_;
					PieceType _tmp14_;
#line 693 "../lib/chess-state.vala"
					_tmp13_ = p;
#line 693 "../lib/chess-state.vala"
					_tmp14_ = _tmp13_->type;
#line 693 "../lib/chess-state.vala"
					_tmp7_ = _tmp14_ == PIECE_TYPE_QUEEN;
#line 4334 "chess-state.c"
				}
#line 693 "../lib/chess-state.vala"
				if (_tmp7_) {
#line 694 "../lib/chess-state.vala"
					result = TRUE;
#line 694 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 694 "../lib/chess-state.vala"
					return result;
#line 4344 "chess-state.c"
				}
#line 697 "../lib/chess-state.vala"
				_tmp15_ = p;
#line 697 "../lib/chess-state.vala"
				_tmp16_ = _tmp15_->type;
#line 697 "../lib/chess-state.vala"
				if (_tmp16_ == PIECE_TYPE_KNIGHT) {
#line 4352 "chess-state.c"
					ChessPiece* _tmp17_;
					Color _tmp18_;
					Color _tmp19_;
#line 699 "../lib/chess-state.vala"
					_tmp17_ = p;
#line 699 "../lib/chess-state.vala"
					_tmp18_ = chess_piece_get_color (_tmp17_);
#line 699 "../lib/chess-state.vala"
					_tmp19_ = _tmp18_;
#line 699 "../lib/chess-state.vala"
					if (_tmp19_ == COLOR_WHITE) {
#line 4364 "chess-state.c"
						gint _tmp20_;
#line 700 "../lib/chess-state.vala"
						_tmp20_ = white_knight_count;
#line 700 "../lib/chess-state.vala"
						white_knight_count = _tmp20_ + 1;
#line 4370 "chess-state.c"
					} else {
						gint _tmp21_;
#line 702 "../lib/chess-state.vala"
						_tmp21_ = black_knight_count;
#line 702 "../lib/chess-state.vala"
						black_knight_count = _tmp21_ + 1;
#line 4377 "chess-state.c"
					}
				}
#line 705 "../lib/chess-state.vala"
				_tmp22_ = p;
#line 705 "../lib/chess-state.vala"
				_tmp23_ = _tmp22_->type;
#line 705 "../lib/chess-state.vala"
				if (_tmp23_ == PIECE_TYPE_BISHOP) {
#line 4386 "chess-state.c"
					Color color = 0;
					gint _tmp24_;
					gint _tmp25_;
					ChessPiece* _tmp26_;
					Color _tmp27_;
					Color _tmp28_;
#line 707 "../lib/chess-state.vala"
					color = COLOR_BLACK;
#line 708 "../lib/chess-state.vala"
					_tmp24_ = i;
#line 708 "../lib/chess-state.vala"
					_tmp25_ = i;
#line 708 "../lib/chess-state.vala"
					if (((_tmp24_ + (_tmp25_ / 8)) % 2) != 0) {
#line 709 "../lib/chess-state.vala"
						color = COLOR_WHITE;
#line 4403 "chess-state.c"
					}
#line 711 "../lib/chess-state.vala"
					_tmp26_ = p;
#line 711 "../lib/chess-state.vala"
					_tmp27_ = chess_piece_get_color (_tmp26_);
#line 711 "../lib/chess-state.vala"
					_tmp28_ = _tmp27_;
#line 711 "../lib/chess-state.vala"
					if (_tmp28_ == COLOR_WHITE) {
#line 4413 "chess-state.c"
						Color _tmp29_;
						gint _tmp30_;
#line 713 "../lib/chess-state.vala"
						_tmp29_ = color;
#line 713 "../lib/chess-state.vala"
						if (_tmp29_ == COLOR_WHITE) {
#line 714 "../lib/chess-state.vala"
							white_bishop_on_white_square = TRUE;
#line 4422 "chess-state.c"
						} else {
#line 716 "../lib/chess-state.vala"
							white_bishop_on_black_square = TRUE;
#line 4426 "chess-state.c"
						}
#line 717 "../lib/chess-state.vala"
						_tmp30_ = white_bishop_count;
#line 717 "../lib/chess-state.vala"
						white_bishop_count = _tmp30_ + 1;
#line 4432 "chess-state.c"
					} else {
						Color _tmp31_;
						gint _tmp32_;
#line 721 "../lib/chess-state.vala"
						_tmp31_ = color;
#line 721 "../lib/chess-state.vala"
						if (_tmp31_ == COLOR_WHITE) {
#line 722 "../lib/chess-state.vala"
							black_bishop_on_white_square = TRUE;
#line 4442 "chess-state.c"
						} else {
#line 724 "../lib/chess-state.vala"
							black_bishop_on_black_square = TRUE;
#line 4446 "chess-state.c"
						}
#line 725 "../lib/chess-state.vala"
						_tmp32_ = black_bishop_count;
#line 725 "../lib/chess-state.vala"
						black_bishop_count = _tmp32_ + 1;
#line 4452 "chess-state.c"
					}
				}
#line 759 "../lib/chess-state.vala"
				_tmp34_ = white_knight_count;
#line 759 "../lib/chess-state.vala"
				if (_tmp34_ > 1) {
#line 759 "../lib/chess-state.vala"
					_tmp33_ = TRUE;
#line 4461 "chess-state.c"
				} else {
					gint _tmp35_;
#line 759 "../lib/chess-state.vala"
					_tmp35_ = black_knight_count;
#line 759 "../lib/chess-state.vala"
					_tmp33_ = _tmp35_ > 1;
#line 4468 "chess-state.c"
				}
#line 759 "../lib/chess-state.vala"
				if (_tmp33_) {
#line 760 "../lib/chess-state.vala"
					result = TRUE;
#line 760 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 760 "../lib/chess-state.vala"
					return result;
#line 4478 "chess-state.c"
				}
#line 763 "../lib/chess-state.vala"
				_tmp37_ = white_bishop_count;
#line 763 "../lib/chess-state.vala"
				if (_tmp37_ > 0) {
#line 4484 "chess-state.c"
					gint _tmp38_;
#line 763 "../lib/chess-state.vala"
					_tmp38_ = white_knight_count;
#line 763 "../lib/chess-state.vala"
					_tmp36_ = _tmp38_ > 0;
#line 4490 "chess-state.c"
				} else {
#line 763 "../lib/chess-state.vala"
					_tmp36_ = FALSE;
#line 4494 "chess-state.c"
				}
#line 763 "../lib/chess-state.vala"
				if (_tmp36_) {
#line 764 "../lib/chess-state.vala"
					result = TRUE;
#line 764 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 764 "../lib/chess-state.vala"
					return result;
#line 4504 "chess-state.c"
				}
#line 765 "../lib/chess-state.vala"
				_tmp40_ = black_bishop_count;
#line 765 "../lib/chess-state.vala"
				if (_tmp40_ > 0) {
#line 4510 "chess-state.c"
					gint _tmp41_;
#line 765 "../lib/chess-state.vala"
					_tmp41_ = black_knight_count;
#line 765 "../lib/chess-state.vala"
					_tmp39_ = _tmp41_ > 0;
#line 4516 "chess-state.c"
				} else {
#line 765 "../lib/chess-state.vala"
					_tmp39_ = FALSE;
#line 4520 "chess-state.c"
				}
#line 765 "../lib/chess-state.vala"
				if (_tmp39_) {
#line 766 "../lib/chess-state.vala"
					result = TRUE;
#line 766 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 766 "../lib/chess-state.vala"
					return result;
#line 4530 "chess-state.c"
				}
#line 769 "../lib/chess-state.vala"
				_tmp43_ = white_bishop_on_white_square;
#line 769 "../lib/chess-state.vala"
				if (_tmp43_) {
#line 4536 "chess-state.c"
					gboolean _tmp44_;
#line 769 "../lib/chess-state.vala"
					_tmp44_ = white_bishop_on_black_square;
#line 769 "../lib/chess-state.vala"
					_tmp42_ = _tmp44_;
#line 4542 "chess-state.c"
				} else {
#line 769 "../lib/chess-state.vala"
					_tmp42_ = FALSE;
#line 4546 "chess-state.c"
				}
#line 769 "../lib/chess-state.vala"
				if (_tmp42_) {
#line 770 "../lib/chess-state.vala"
					result = TRUE;
#line 770 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 770 "../lib/chess-state.vala"
					return result;
#line 4556 "chess-state.c"
				}
#line 771 "../lib/chess-state.vala"
				_tmp46_ = black_bishop_on_white_square;
#line 771 "../lib/chess-state.vala"
				if (_tmp46_) {
#line 4562 "chess-state.c"
					gboolean _tmp47_;
#line 771 "../lib/chess-state.vala"
					_tmp47_ = black_bishop_on_black_square;
#line 771 "../lib/chess-state.vala"
					_tmp45_ = _tmp47_;
#line 4568 "chess-state.c"
				} else {
#line 771 "../lib/chess-state.vala"
					_tmp45_ = FALSE;
#line 4572 "chess-state.c"
				}
#line 771 "../lib/chess-state.vala"
				if (_tmp45_) {
#line 772 "../lib/chess-state.vala"
					result = TRUE;
#line 772 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 772 "../lib/chess-state.vala"
					return result;
#line 4582 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				_tmp50_ = white_bishop_count;
#line 775 "../lib/chess-state.vala"
				if (_tmp50_ > 0) {
#line 775 "../lib/chess-state.vala"
					_tmp49_ = TRUE;
#line 4590 "chess-state.c"
				} else {
					gint _tmp51_;
#line 775 "../lib/chess-state.vala"
					_tmp51_ = white_knight_count;
#line 775 "../lib/chess-state.vala"
					_tmp49_ = _tmp51_ > 0;
#line 4597 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				if (_tmp49_) {
#line 4601 "chess-state.c"
					gint _tmp52_;
#line 775 "../lib/chess-state.vala"
					_tmp52_ = black_knight_count;
#line 775 "../lib/chess-state.vala"
					_tmp48_ = _tmp52_ > 0;
#line 4607 "chess-state.c"
				} else {
#line 775 "../lib/chess-state.vala"
					_tmp48_ = FALSE;
#line 4611 "chess-state.c"
				}
#line 775 "../lib/chess-state.vala"
				if (_tmp48_) {
#line 776 "../lib/chess-state.vala"
					result = TRUE;
#line 776 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 776 "../lib/chess-state.vala"
					return result;
#line 4621 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				_tmp55_ = black_bishop_count;
#line 777 "../lib/chess-state.vala"
				if (_tmp55_ > 0) {
#line 777 "../lib/chess-state.vala"
					_tmp54_ = TRUE;
#line 4629 "chess-state.c"
				} else {
					gint _tmp56_;
#line 777 "../lib/chess-state.vala"
					_tmp56_ = black_knight_count;
#line 777 "../lib/chess-state.vala"
					_tmp54_ = _tmp56_ > 0;
#line 4636 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				if (_tmp54_) {
#line 4640 "chess-state.c"
					gint _tmp57_;
#line 777 "../lib/chess-state.vala"
					_tmp57_ = white_knight_count;
#line 777 "../lib/chess-state.vala"
					_tmp53_ = _tmp57_ > 0;
#line 4646 "chess-state.c"
				} else {
#line 777 "../lib/chess-state.vala"
					_tmp53_ = FALSE;
#line 4650 "chess-state.c"
				}
#line 777 "../lib/chess-state.vala"
				if (_tmp53_) {
#line 778 "../lib/chess-state.vala"
					result = TRUE;
#line 778 "../lib/chess-state.vala"
					_g_object_unref0 (p);
#line 778 "../lib/chess-state.vala"
					return result;
#line 4660 "chess-state.c"
				}
#line 781 "../lib/chess-state.vala"
				_tmp59_ = white_bishop_count;
#line 781 "../lib/chess-state.vala"
				if (_tmp59_ > 0) {
#line 4666 "chess-state.c"
					gint _tmp60_;
#line 781 "../lib/chess-state.vala"
					_tmp60_ = black_bishop_count;
#line 781 "../lib/chess-state.vala"
					_tmp58_ = _tmp60_ > 0;
#line 4672 "chess-state.c"
				} else {
#line 781 "../lib/chess-state.vala"
					_tmp58_ = FALSE;
#line 4676 "chess-state.c"
				}
#line 781 "../lib/chess-state.vala"
				if (_tmp58_) {
#line 4680 "chess-state.c"
					gboolean _tmp61_ = FALSE;
					gboolean _tmp62_;
#line 783 "../lib/chess-state.vala"
					_tmp62_ = white_bishop_on_white_square;
#line 783 "../lib/chess-state.vala"
					if (_tmp62_) {
#line 4687 "chess-state.c"
						gboolean _tmp63_;
#line 783 "../lib/chess-state.vala"
						_tmp63_ = black_bishop_on_black_square;
#line 783 "../lib/chess-state.vala"
						_tmp61_ = _tmp63_;
#line 4693 "chess-state.c"
					} else {
#line 783 "../lib/chess-state.vala"
						_tmp61_ = FALSE;
#line 4697 "chess-state.c"
					}
#line 783 "../lib/chess-state.vala"
					if (_tmp61_) {
#line 784 "../lib/chess-state.vala"
						result = TRUE;
#line 784 "../lib/chess-state.vala"
						_g_object_unref0 (p);
#line 784 "../lib/chess-state.vala"
						return result;
#line 4707 "chess-state.c"
					} else {
						gboolean _tmp64_ = FALSE;
						gboolean _tmp65_;
#line 785 "../lib/chess-state.vala"
						_tmp65_ = white_bishop_on_black_square;
#line 785 "../lib/chess-state.vala"
						if (_tmp65_) {
#line 4715 "chess-state.c"
							gboolean _tmp66_;
#line 785 "../lib/chess-state.vala"
							_tmp66_ = black_bishop_on_white_square;
#line 785 "../lib/chess-state.vala"
							_tmp64_ = _tmp66_;
#line 4721 "chess-state.c"
						} else {
#line 785 "../lib/chess-state.vala"
							_tmp64_ = FALSE;
#line 4725 "chess-state.c"
						}
#line 785 "../lib/chess-state.vala"
						if (_tmp64_) {
#line 786 "../lib/chess-state.vala"
							result = TRUE;
#line 786 "../lib/chess-state.vala"
							_g_object_unref0 (p);
#line 786 "../lib/chess-state.vala"
							return result;
#line 4735 "chess-state.c"
						}
					}
				}
#line 686 "../lib/chess-state.vala"
				_g_object_unref0 (p);
#line 4741 "chess-state.c"
			}
		}
	}
#line 790 "../lib/chess-state.vala"
	result = FALSE;
#line 790 "../lib/chess-state.vala"
	return result;
#line 4749 "chess-state.c"
}


static gboolean
chess_state_decode_piece_type (ChessState* self,
                               gunichar c,
                               PieceType* type)
{
	PieceType _vala_type = 0;
	gboolean result = FALSE;
#line 793 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 795 "../lib/chess-state.vala"
	_vala_type = PIECE_TYPE_PAWN;
#line 796 "../lib/chess-state.vala"
	switch (c) {
#line 796 "../lib/chess-state.vala"
		case 'P':
#line 4768 "chess-state.c"
		{
#line 799 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_PAWN;
#line 800 "../lib/chess-state.vala"
			result = TRUE;
#line 800 "../lib/chess-state.vala"
			if (type) {
#line 800 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4778 "chess-state.c"
			}
#line 800 "../lib/chess-state.vala"
			return result;
#line 4782 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'R':
#line 4786 "chess-state.c"
		{
#line 802 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_ROOK;
#line 803 "../lib/chess-state.vala"
			result = TRUE;
#line 803 "../lib/chess-state.vala"
			if (type) {
#line 803 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4796 "chess-state.c"
			}
#line 803 "../lib/chess-state.vala"
			return result;
#line 4800 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'N':
#line 4804 "chess-state.c"
		{
#line 805 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_KNIGHT;
#line 806 "../lib/chess-state.vala"
			result = TRUE;
#line 806 "../lib/chess-state.vala"
			if (type) {
#line 806 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4814 "chess-state.c"
			}
#line 806 "../lib/chess-state.vala"
			return result;
#line 4818 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'B':
#line 4822 "chess-state.c"
		{
#line 808 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_BISHOP;
#line 809 "../lib/chess-state.vala"
			result = TRUE;
#line 809 "../lib/chess-state.vala"
			if (type) {
#line 809 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4832 "chess-state.c"
			}
#line 809 "../lib/chess-state.vala"
			return result;
#line 4836 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'Q':
#line 4840 "chess-state.c"
		{
#line 811 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_QUEEN;
#line 812 "../lib/chess-state.vala"
			result = TRUE;
#line 812 "../lib/chess-state.vala"
			if (type) {
#line 812 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4850 "chess-state.c"
			}
#line 812 "../lib/chess-state.vala"
			return result;
#line 4854 "chess-state.c"
		}
#line 796 "../lib/chess-state.vala"
		case 'K':
#line 4858 "chess-state.c"
		{
#line 814 "../lib/chess-state.vala"
			_vala_type = PIECE_TYPE_KING;
#line 815 "../lib/chess-state.vala"
			result = TRUE;
#line 815 "../lib/chess-state.vala"
			if (type) {
#line 815 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4868 "chess-state.c"
			}
#line 815 "../lib/chess-state.vala"
			return result;
#line 4872 "chess-state.c"
		}
		default:
		{
#line 817 "../lib/chess-state.vala"
			result = FALSE;
#line 817 "../lib/chess-state.vala"
			if (type) {
#line 817 "../lib/chess-state.vala"
				*type = _vala_type;
#line 4882 "chess-state.c"
			}
#line 817 "../lib/chess-state.vala"
			return result;
#line 4886 "chess-state.c"
		}
	}
#line 793 "../lib/chess-state.vala"
	if (type) {
#line 793 "../lib/chess-state.vala"
		*type = _vala_type;
#line 4893 "chess-state.c"
	}
}


static gboolean
chess_state_decode_move (ChessState* self,
                         ChessPlayer* player,
                         const gchar* move,
                         gint* r0,
                         gint* f0,
                         gint* r1,
                         gint* f1,
                         PieceType* promotion_type)
{
	gint _vala_r0 = 0;
	gint _vala_f0 = 0;
	gint _vala_r1 = 0;
	gint _vala_f1 = 0;
	PieceType _vala_promotion_type = 0;
	gboolean result = FALSE;
	gint i = 0;
	gint _tmp99_;
	gint _tmp103_;
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (player != NULL, FALSE);
#line 821 "../lib/chess-state.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 823 "../lib/chess-state.vala"
	i = 0;
#line 825 "../lib/chess-state.vala"
	_vala_promotion_type = PIECE_TYPE_QUEEN;
#line 826 "../lib/chess-state.vala"
	if (g_str_has_prefix (move, "O-O-O")) {
#line 4929 "chess-state.c"
		Color _tmp0_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 828 "../lib/chess-state.vala"
		_tmp0_ = player->color;
#line 828 "../lib/chess-state.vala"
		if (_tmp0_ == COLOR_WHITE) {
#line 4938 "chess-state.c"
			gint _tmp1_;
#line 829 "../lib/chess-state.vala"
			_vala_r1 = 0;
#line 829 "../lib/chess-state.vala"
			_tmp1_ = _vala_r1;
#line 829 "../lib/chess-state.vala"
			_vala_r0 = _tmp1_;
#line 4946 "chess-state.c"
		} else {
			gint _tmp2_;
#line 831 "../lib/chess-state.vala"
			_vala_r1 = 7;
#line 831 "../lib/chess-state.vala"
			_tmp2_ = _vala_r1;
#line 831 "../lib/chess-state.vala"
			_vala_r0 = _tmp2_;
#line 4955 "chess-state.c"
		}
#line 832 "../lib/chess-state.vala"
		_vala_f0 = 4;
#line 833 "../lib/chess-state.vala"
		_vala_f1 = 2;
#line 834 "../lib/chess-state.vala"
		_tmp3_ = i;
#line 834 "../lib/chess-state.vala"
		_tmp4_ = strlen ("O-O-O");
#line 834 "../lib/chess-state.vala"
		_tmp5_ = _tmp4_;
#line 834 "../lib/chess-state.vala"
		i = _tmp3_ + ((gint) _tmp5_);
#line 4969 "chess-state.c"
	} else {
#line 836 "../lib/chess-state.vala"
		if (g_str_has_prefix (move, "O-O")) {
#line 4973 "chess-state.c"
			Color _tmp6_;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 838 "../lib/chess-state.vala"
			_tmp6_ = player->color;
#line 838 "../lib/chess-state.vala"
			if (_tmp6_ == COLOR_WHITE) {
#line 4982 "chess-state.c"
				gint _tmp7_;
#line 839 "../lib/chess-state.vala"
				_vala_r1 = 0;
#line 839 "../lib/chess-state.vala"
				_tmp7_ = _vala_r1;
#line 839 "../lib/chess-state.vala"
				_vala_r0 = _tmp7_;
#line 4990 "chess-state.c"
			} else {
				gint _tmp8_;
#line 841 "../lib/chess-state.vala"
				_vala_r1 = 7;
#line 841 "../lib/chess-state.vala"
				_tmp8_ = _vala_r1;
#line 841 "../lib/chess-state.vala"
				_vala_r0 = _tmp8_;
#line 4999 "chess-state.c"
			}
#line 842 "../lib/chess-state.vala"
			_vala_f0 = 4;
#line 843 "../lib/chess-state.vala"
			_vala_f1 = 6;
#line 844 "../lib/chess-state.vala"
			_tmp9_ = i;
#line 844 "../lib/chess-state.vala"
			_tmp10_ = strlen ("O-O");
#line 844 "../lib/chess-state.vala"
			_tmp11_ = _tmp10_;
#line 844 "../lib/chess-state.vala"
			i = _tmp9_ + ((gint) _tmp11_);
#line 5013 "chess-state.c"
		} else {
			PieceType type = 0;
			gint _tmp12_;
			PieceType _tmp13_ = 0;
			gboolean _tmp14_;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gboolean _tmp19_ = FALSE;
			gint _tmp20_;
			gboolean _tmp24_ = FALSE;
			gint _tmp25_;
			gboolean _tmp29_ = FALSE;
			gint _tmp30_;
			gboolean _tmp33_ = FALSE;
			gint _tmp34_;
			gboolean _tmp39_ = FALSE;
			gint _tmp40_;
			gint _tmp45_;
			gboolean _tmp57_ = FALSE;
			gint _tmp58_;
			gboolean _tmp60_ = FALSE;
			gint _tmp61_;
#line 848 "../lib/chess-state.vala"
			type = PIECE_TYPE_PAWN;
#line 849 "../lib/chess-state.vala"
			_tmp12_ = i;
#line 849 "../lib/chess-state.vala"
			_tmp14_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) _tmp12_), &_tmp13_);
#line 849 "../lib/chess-state.vala"
			type = _tmp13_;
#line 849 "../lib/chess-state.vala"
			if (_tmp14_) {
#line 5047 "chess-state.c"
				gint _tmp15_;
#line 850 "../lib/chess-state.vala"
				_tmp15_ = i;
#line 850 "../lib/chess-state.vala"
				i = _tmp15_ + 1;
#line 5053 "chess-state.c"
			}
#line 852 "../lib/chess-state.vala"
			_vala_f1 = -1;
#line 852 "../lib/chess-state.vala"
			_tmp16_ = _vala_f1;
#line 852 "../lib/chess-state.vala"
			_vala_r1 = _tmp16_;
#line 852 "../lib/chess-state.vala"
			_tmp17_ = _vala_r1;
#line 852 "../lib/chess-state.vala"
			_vala_f0 = _tmp17_;
#line 852 "../lib/chess-state.vala"
			_tmp18_ = _vala_f0;
#line 852 "../lib/chess-state.vala"
			_vala_r0 = _tmp18_;
#line 853 "../lib/chess-state.vala"
			_tmp20_ = i;
#line 853 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp20_) >= 'a') {
#line 5073 "chess-state.c"
				gint _tmp21_;
#line 853 "../lib/chess-state.vala"
				_tmp21_ = i;
#line 853 "../lib/chess-state.vala"
				_tmp19_ = string_get (move, (glong) _tmp21_) <= 'h';
#line 5079 "chess-state.c"
			} else {
#line 853 "../lib/chess-state.vala"
				_tmp19_ = FALSE;
#line 5083 "chess-state.c"
			}
#line 853 "../lib/chess-state.vala"
			if (_tmp19_) {
#line 5087 "chess-state.c"
				gint _tmp22_;
				gint _tmp23_;
#line 855 "../lib/chess-state.vala"
				_tmp22_ = i;
#line 855 "../lib/chess-state.vala"
				_vala_f1 = (gint) (string_get (move, (glong) _tmp22_) - 'a');
#line 856 "../lib/chess-state.vala"
				_tmp23_ = i;
#line 856 "../lib/chess-state.vala"
				i = _tmp23_ + 1;
#line 5098 "chess-state.c"
			}
#line 858 "../lib/chess-state.vala"
			_tmp25_ = i;
#line 858 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp25_) >= '1') {
#line 5104 "chess-state.c"
				gint _tmp26_;
#line 858 "../lib/chess-state.vala"
				_tmp26_ = i;
#line 858 "../lib/chess-state.vala"
				_tmp24_ = string_get (move, (glong) _tmp26_) <= '8';
#line 5110 "chess-state.c"
			} else {
#line 858 "../lib/chess-state.vala"
				_tmp24_ = FALSE;
#line 5114 "chess-state.c"
			}
#line 858 "../lib/chess-state.vala"
			if (_tmp24_) {
#line 5118 "chess-state.c"
				gint _tmp27_;
				gint _tmp28_;
#line 860 "../lib/chess-state.vala"
				_tmp27_ = i;
#line 860 "../lib/chess-state.vala"
				_vala_r1 = (gint) (string_get (move, (glong) _tmp27_) - '1');
#line 861 "../lib/chess-state.vala"
				_tmp28_ = i;
#line 861 "../lib/chess-state.vala"
				i = _tmp28_ + 1;
#line 5129 "chess-state.c"
			}
#line 863 "../lib/chess-state.vala"
			_tmp30_ = i;
#line 863 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp30_) == 'x') {
#line 863 "../lib/chess-state.vala"
				_tmp29_ = TRUE;
#line 5137 "chess-state.c"
			} else {
				gint _tmp31_;
#line 863 "../lib/chess-state.vala"
				_tmp31_ = i;
#line 863 "../lib/chess-state.vala"
				_tmp29_ = string_get (move, (glong) _tmp31_) == '-';
#line 5144 "chess-state.c"
			}
#line 863 "../lib/chess-state.vala"
			if (_tmp29_) {
#line 5148 "chess-state.c"
				gint _tmp32_;
#line 864 "../lib/chess-state.vala"
				_tmp32_ = i;
#line 864 "../lib/chess-state.vala"
				i = _tmp32_ + 1;
#line 5154 "chess-state.c"
			}
#line 865 "../lib/chess-state.vala"
			_tmp34_ = i;
#line 865 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp34_) >= 'a') {
#line 5160 "chess-state.c"
				gint _tmp35_;
#line 865 "../lib/chess-state.vala"
				_tmp35_ = i;
#line 865 "../lib/chess-state.vala"
				_tmp33_ = string_get (move, (glong) _tmp35_) <= 'h';
#line 5166 "chess-state.c"
			} else {
#line 865 "../lib/chess-state.vala"
				_tmp33_ = FALSE;
#line 5170 "chess-state.c"
			}
#line 865 "../lib/chess-state.vala"
			if (_tmp33_) {
#line 5174 "chess-state.c"
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
#line 867 "../lib/chess-state.vala"
				_tmp36_ = _vala_f1;
#line 867 "../lib/chess-state.vala"
				_vala_f0 = _tmp36_;
#line 868 "../lib/chess-state.vala"
				_tmp37_ = i;
#line 868 "../lib/chess-state.vala"
				_vala_f1 = (gint) (string_get (move, (glong) _tmp37_) - 'a');
#line 869 "../lib/chess-state.vala"
				_tmp38_ = i;
#line 869 "../lib/chess-state.vala"
				i = _tmp38_ + 1;
#line 5190 "chess-state.c"
			}
#line 871 "../lib/chess-state.vala"
			_tmp40_ = i;
#line 871 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp40_) >= '1') {
#line 5196 "chess-state.c"
				gint _tmp41_;
#line 871 "../lib/chess-state.vala"
				_tmp41_ = i;
#line 871 "../lib/chess-state.vala"
				_tmp39_ = string_get (move, (glong) _tmp41_) <= '8';
#line 5202 "chess-state.c"
			} else {
#line 871 "../lib/chess-state.vala"
				_tmp39_ = FALSE;
#line 5206 "chess-state.c"
			}
#line 871 "../lib/chess-state.vala"
			if (_tmp39_) {
#line 5210 "chess-state.c"
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
#line 873 "../lib/chess-state.vala"
				_tmp42_ = _vala_r1;
#line 873 "../lib/chess-state.vala"
				_vala_r0 = _tmp42_;
#line 874 "../lib/chess-state.vala"
				_tmp43_ = i;
#line 874 "../lib/chess-state.vala"
				_vala_r1 = (gint) (string_get (move, (glong) _tmp43_) - '1');
#line 875 "../lib/chess-state.vala"
				_tmp44_ = i;
#line 875 "../lib/chess-state.vala"
				i = _tmp44_ + 1;
#line 5226 "chess-state.c"
			}
#line 877 "../lib/chess-state.vala"
			_tmp45_ = i;
#line 877 "../lib/chess-state.vala"
			if (string_get (move, (glong) _tmp45_) == '=') {
#line 5232 "chess-state.c"
				gint _tmp46_;
				gint _tmp47_;
				PieceType _tmp48_ = 0;
				gboolean _tmp49_;
#line 879 "../lib/chess-state.vala"
				_tmp46_ = i;
#line 879 "../lib/chess-state.vala"
				i = _tmp46_ + 1;
#line 880 "../lib/chess-state.vala"
				_tmp47_ = i;
#line 880 "../lib/chess-state.vala"
				_tmp49_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) _tmp47_), &_tmp48_);
#line 880 "../lib/chess-state.vala"
				_vala_promotion_type = _tmp48_;
#line 880 "../lib/chess-state.vala"
				if (_tmp49_) {
#line 5249 "chess-state.c"
					gint _tmp50_;
#line 881 "../lib/chess-state.vala"
					_tmp50_ = i;
#line 881 "../lib/chess-state.vala"
					i = _tmp50_ + 1;
#line 5255 "chess-state.c"
				}
			} else {
				gint _tmp51_;
#line 883 "../lib/chess-state.vala"
				_tmp51_ = i;
#line 883 "../lib/chess-state.vala"
				if (string_get (move, (glong) _tmp51_) != '\0') {
#line 5263 "chess-state.c"
					gint _tmp52_;
#line 885 "../lib/chess-state.vala"
					_tmp52_ = i;
#line 885 "../lib/chess-state.vala"
					switch (string_get (move, (glong) _tmp52_)) {
#line 885 "../lib/chess-state.vala"
						case 'q':
#line 885 "../lib/chess-state.vala"
						case 'Q':
#line 5273 "chess-state.c"
						{
							gint _tmp53_;
#line 889 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_QUEEN;
#line 890 "../lib/chess-state.vala"
							_tmp53_ = i;
#line 890 "../lib/chess-state.vala"
							i = _tmp53_ + 1;
#line 891 "../lib/chess-state.vala"
							break;
#line 5284 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'n':
#line 885 "../lib/chess-state.vala"
						case 'N':
#line 5290 "chess-state.c"
						{
							gint _tmp54_;
#line 894 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_KNIGHT;
#line 895 "../lib/chess-state.vala"
							_tmp54_ = i;
#line 895 "../lib/chess-state.vala"
							i = _tmp54_ + 1;
#line 896 "../lib/chess-state.vala"
							break;
#line 5301 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'r':
#line 885 "../lib/chess-state.vala"
						case 'R':
#line 5307 "chess-state.c"
						{
							gint _tmp55_;
#line 899 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_ROOK;
#line 900 "../lib/chess-state.vala"
							_tmp55_ = i;
#line 900 "../lib/chess-state.vala"
							i = _tmp55_ + 1;
#line 901 "../lib/chess-state.vala"
							break;
#line 5318 "chess-state.c"
						}
#line 885 "../lib/chess-state.vala"
						case 'b':
#line 885 "../lib/chess-state.vala"
						case 'B':
#line 5324 "chess-state.c"
						{
							gint _tmp56_;
#line 904 "../lib/chess-state.vala"
							_vala_promotion_type = PIECE_TYPE_BISHOP;
#line 905 "../lib/chess-state.vala"
							_tmp56_ = i;
#line 905 "../lib/chess-state.vala"
							i = _tmp56_ + 1;
#line 906 "../lib/chess-state.vala"
							break;
#line 5335 "chess-state.c"
						}
						default:
#line 885 "../lib/chess-state.vala"
						break;
#line 5340 "chess-state.c"
					}
				}
			}
#line 911 "../lib/chess-state.vala"
			_tmp58_ = _vala_r1;
#line 911 "../lib/chess-state.vala"
			if (_tmp58_ < 0) {
#line 911 "../lib/chess-state.vala"
				_tmp57_ = TRUE;
#line 5350 "chess-state.c"
			} else {
				gint _tmp59_;
#line 911 "../lib/chess-state.vala"
				_tmp59_ = _vala_f1;
#line 911 "../lib/chess-state.vala"
				_tmp57_ = _tmp59_ < 0;
#line 5357 "chess-state.c"
			}
#line 911 "../lib/chess-state.vala"
			if (_tmp57_) {
#line 913 "../lib/chess-state.vala"
				g_debug ("chess-state.vala:913: Move %s missing destination", move);
#line 914 "../lib/chess-state.vala"
				result = FALSE;
#line 914 "../lib/chess-state.vala"
				if (r0) {
#line 914 "../lib/chess-state.vala"
					*r0 = _vala_r0;
#line 5369 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (f0) {
#line 914 "../lib/chess-state.vala"
					*f0 = _vala_f0;
#line 5375 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (r1) {
#line 914 "../lib/chess-state.vala"
					*r1 = _vala_r1;
#line 5381 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (f1) {
#line 914 "../lib/chess-state.vala"
					*f1 = _vala_f1;
#line 5387 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				if (promotion_type) {
#line 914 "../lib/chess-state.vala"
					*promotion_type = _vala_promotion_type;
#line 5393 "chess-state.c"
				}
#line 914 "../lib/chess-state.vala"
				return result;
#line 5397 "chess-state.c"
			}
#line 918 "../lib/chess-state.vala"
			_tmp61_ = _vala_r0;
#line 918 "../lib/chess-state.vala"
			if (_tmp61_ < 0) {
#line 918 "../lib/chess-state.vala"
				_tmp60_ = TRUE;
#line 5405 "chess-state.c"
			} else {
				gint _tmp62_;
#line 918 "../lib/chess-state.vala"
				_tmp62_ = _vala_f0;
#line 918 "../lib/chess-state.vala"
				_tmp60_ = _tmp62_ < 0;
#line 5412 "chess-state.c"
			}
#line 918 "../lib/chess-state.vala"
			if (_tmp60_) {
#line 5416 "chess-state.c"
				gint match_rank = 0;
				gint match_file = 0;
				gint _tmp96_;
				gint _tmp97_;
				gint _tmp98_;
#line 920 "../lib/chess-state.vala"
				match_rank = -1;
#line 920 "../lib/chess-state.vala"
				match_file = -1;
#line 5426 "chess-state.c"
				{
					gint file = 0;
#line 922 "../lib/chess-state.vala"
					file = 0;
#line 5431 "chess-state.c"
					{
						gboolean _tmp63_ = FALSE;
#line 922 "../lib/chess-state.vala"
						_tmp63_ = TRUE;
#line 922 "../lib/chess-state.vala"
						while (TRUE) {
#line 5438 "chess-state.c"
							gint _tmp65_;
							gboolean _tmp66_ = FALSE;
							gint _tmp67_;
#line 922 "../lib/chess-state.vala"
							if (!_tmp63_) {
#line 5444 "chess-state.c"
								gint _tmp64_;
#line 922 "../lib/chess-state.vala"
								_tmp64_ = file;
#line 922 "../lib/chess-state.vala"
								file = _tmp64_ + 1;
#line 5450 "chess-state.c"
							}
#line 922 "../lib/chess-state.vala"
							_tmp63_ = FALSE;
#line 922 "../lib/chess-state.vala"
							_tmp65_ = file;
#line 922 "../lib/chess-state.vala"
							if (!(_tmp65_ < 8)) {
#line 922 "../lib/chess-state.vala"
								break;
#line 5460 "chess-state.c"
							}
#line 924 "../lib/chess-state.vala"
							_tmp67_ = _vala_f0;
#line 924 "../lib/chess-state.vala"
							if (_tmp67_ >= 0) {
#line 5466 "chess-state.c"
								gint _tmp68_;
								gint _tmp69_;
#line 924 "../lib/chess-state.vala"
								_tmp68_ = file;
#line 924 "../lib/chess-state.vala"
								_tmp69_ = _vala_f0;
#line 924 "../lib/chess-state.vala"
								_tmp66_ = _tmp68_ != _tmp69_;
#line 5475 "chess-state.c"
							} else {
#line 924 "../lib/chess-state.vala"
								_tmp66_ = FALSE;
#line 5479 "chess-state.c"
							}
#line 924 "../lib/chess-state.vala"
							if (_tmp66_) {
#line 925 "../lib/chess-state.vala"
								continue;
#line 5485 "chess-state.c"
							}
							{
								gint rank = 0;
#line 927 "../lib/chess-state.vala"
								rank = 0;
#line 5491 "chess-state.c"
								{
									gboolean _tmp70_ = FALSE;
#line 927 "../lib/chess-state.vala"
									_tmp70_ = TRUE;
#line 927 "../lib/chess-state.vala"
									while (TRUE) {
#line 5498 "chess-state.c"
										gint _tmp72_;
										gboolean _tmp73_ = FALSE;
										gint _tmp74_;
										ChessPiece* piece = NULL;
										gint _tmp77_;
										gint _tmp78_;
										ChessPiece* _tmp79_;
										ChessPiece* _tmp80_;
										gboolean _tmp81_ = FALSE;
										gboolean _tmp82_ = FALSE;
										ChessPiece* _tmp83_;
										gint _tmp89_;
										gint _tmp90_;
										gint _tmp91_;
										gint _tmp92_;
										gint _tmp93_;
										gint _tmp94_;
										gint _tmp95_;
#line 927 "../lib/chess-state.vala"
										if (!_tmp70_) {
#line 5519 "chess-state.c"
											gint _tmp71_;
#line 927 "../lib/chess-state.vala"
											_tmp71_ = rank;
#line 927 "../lib/chess-state.vala"
											rank = _tmp71_ + 1;
#line 5525 "chess-state.c"
										}
#line 927 "../lib/chess-state.vala"
										_tmp70_ = FALSE;
#line 927 "../lib/chess-state.vala"
										_tmp72_ = rank;
#line 927 "../lib/chess-state.vala"
										if (!(_tmp72_ < 8)) {
#line 927 "../lib/chess-state.vala"
											break;
#line 5535 "chess-state.c"
										}
#line 929 "../lib/chess-state.vala"
										_tmp74_ = _vala_r0;
#line 929 "../lib/chess-state.vala"
										if (_tmp74_ >= 0) {
#line 5541 "chess-state.c"
											gint _tmp75_;
											gint _tmp76_;
#line 929 "../lib/chess-state.vala"
											_tmp75_ = rank;
#line 929 "../lib/chess-state.vala"
											_tmp76_ = _vala_r0;
#line 929 "../lib/chess-state.vala"
											_tmp73_ = _tmp75_ != _tmp76_;
#line 5550 "chess-state.c"
										} else {
#line 929 "../lib/chess-state.vala"
											_tmp73_ = FALSE;
#line 5554 "chess-state.c"
										}
#line 929 "../lib/chess-state.vala"
										if (_tmp73_) {
#line 930 "../lib/chess-state.vala"
											continue;
#line 5560 "chess-state.c"
										}
#line 933 "../lib/chess-state.vala"
										_tmp77_ = rank;
#line 933 "../lib/chess-state.vala"
										_tmp78_ = file;
#line 933 "../lib/chess-state.vala"
										_tmp79_ = self->board[chess_state_get_index (self, _tmp77_, _tmp78_)];
#line 933 "../lib/chess-state.vala"
										_tmp80_ = _g_object_ref0 (_tmp79_);
#line 933 "../lib/chess-state.vala"
										piece = _tmp80_;
#line 934 "../lib/chess-state.vala"
										_tmp83_ = piece;
#line 934 "../lib/chess-state.vala"
										if (_tmp83_ == NULL) {
#line 934 "../lib/chess-state.vala"
											_tmp82_ = TRUE;
#line 5578 "chess-state.c"
										} else {
											ChessPiece* _tmp84_;
											PieceType _tmp85_;
											PieceType _tmp86_;
#line 934 "../lib/chess-state.vala"
											_tmp84_ = piece;
#line 934 "../lib/chess-state.vala"
											_tmp85_ = _tmp84_->type;
#line 934 "../lib/chess-state.vala"
											_tmp86_ = type;
#line 934 "../lib/chess-state.vala"
											_tmp82_ = _tmp85_ != _tmp86_;
#line 5591 "chess-state.c"
										}
#line 934 "../lib/chess-state.vala"
										if (_tmp82_) {
#line 934 "../lib/chess-state.vala"
											_tmp81_ = TRUE;
#line 5597 "chess-state.c"
										} else {
											ChessPiece* _tmp87_;
											ChessPlayer* _tmp88_;
#line 934 "../lib/chess-state.vala"
											_tmp87_ = piece;
#line 934 "../lib/chess-state.vala"
											_tmp88_ = _tmp87_->player;
#line 934 "../lib/chess-state.vala"
											_tmp81_ = _tmp88_ != player;
#line 5607 "chess-state.c"
										}
#line 934 "../lib/chess-state.vala"
										if (_tmp81_) {
#line 935 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 935 "../lib/chess-state.vala"
											continue;
#line 5615 "chess-state.c"
										}
#line 938 "../lib/chess-state.vala"
										_tmp89_ = rank;
#line 938 "../lib/chess-state.vala"
										_tmp90_ = file;
#line 938 "../lib/chess-state.vala"
										_tmp91_ = _vala_r1;
#line 938 "../lib/chess-state.vala"
										_tmp92_ = _vala_f1;
#line 938 "../lib/chess-state.vala"
										if (!chess_state_move_with_coords (self, player, _tmp89_, _tmp90_, _tmp91_, _tmp92_, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
#line 939 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 939 "../lib/chess-state.vala"
											continue;
#line 5631 "chess-state.c"
										}
#line 942 "../lib/chess-state.vala"
										_tmp93_ = match_rank;
#line 942 "../lib/chess-state.vala"
										if (_tmp93_ >= 0) {
#line 944 "../lib/chess-state.vala"
											g_debug ("chess-state.vala:944: Move %s is ambiguous", move);
#line 945 "../lib/chess-state.vala"
											result = FALSE;
#line 945 "../lib/chess-state.vala"
											_g_object_unref0 (piece);
#line 945 "../lib/chess-state.vala"
											if (r0) {
#line 945 "../lib/chess-state.vala"
												*r0 = _vala_r0;
#line 5647 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (f0) {
#line 945 "../lib/chess-state.vala"
												*f0 = _vala_f0;
#line 5653 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (r1) {
#line 945 "../lib/chess-state.vala"
												*r1 = _vala_r1;
#line 5659 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (f1) {
#line 945 "../lib/chess-state.vala"
												*f1 = _vala_f1;
#line 5665 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											if (promotion_type) {
#line 945 "../lib/chess-state.vala"
												*promotion_type = _vala_promotion_type;
#line 5671 "chess-state.c"
											}
#line 945 "../lib/chess-state.vala"
											return result;
#line 5675 "chess-state.c"
										}
#line 948 "../lib/chess-state.vala"
										_tmp94_ = rank;
#line 948 "../lib/chess-state.vala"
										match_rank = _tmp94_;
#line 949 "../lib/chess-state.vala"
										_tmp95_ = file;
#line 949 "../lib/chess-state.vala"
										match_file = _tmp95_;
#line 927 "../lib/chess-state.vala"
										_g_object_unref0 (piece);
#line 5687 "chess-state.c"
									}
								}
							}
						}
					}
				}
#line 953 "../lib/chess-state.vala"
				_tmp96_ = match_rank;
#line 953 "../lib/chess-state.vala"
				if (_tmp96_ < 0) {
#line 955 "../lib/chess-state.vala"
					g_debug ("chess-state.vala:955: Move %s has no matches", move);
#line 956 "../lib/chess-state.vala"
					result = FALSE;
#line 956 "../lib/chess-state.vala"
					if (r0) {
#line 956 "../lib/chess-state.vala"
						*r0 = _vala_r0;
#line 5706 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (f0) {
#line 956 "../lib/chess-state.vala"
						*f0 = _vala_f0;
#line 5712 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (r1) {
#line 956 "../lib/chess-state.vala"
						*r1 = _vala_r1;
#line 5718 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (f1) {
#line 956 "../lib/chess-state.vala"
						*f1 = _vala_f1;
#line 5724 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					if (promotion_type) {
#line 956 "../lib/chess-state.vala"
						*promotion_type = _vala_promotion_type;
#line 5730 "chess-state.c"
					}
#line 956 "../lib/chess-state.vala"
					return result;
#line 5734 "chess-state.c"
				}
#line 959 "../lib/chess-state.vala"
				_tmp97_ = match_rank;
#line 959 "../lib/chess-state.vala"
				_vala_r0 = _tmp97_;
#line 960 "../lib/chess-state.vala"
				_tmp98_ = match_file;
#line 960 "../lib/chess-state.vala"
				_vala_f0 = _tmp98_;
#line 5744 "chess-state.c"
			}
		}
	}
#line 964 "../lib/chess-state.vala"
	_tmp99_ = i;
#line 964 "../lib/chess-state.vala"
	if (string_get (move, (glong) _tmp99_) == '+') {
#line 5752 "chess-state.c"
		gint _tmp100_;
#line 965 "../lib/chess-state.vala"
		_tmp100_ = i;
#line 965 "../lib/chess-state.vala"
		i = _tmp100_ + 1;
#line 5758 "chess-state.c"
	} else {
		gint _tmp101_;
#line 966 "../lib/chess-state.vala"
		_tmp101_ = i;
#line 966 "../lib/chess-state.vala"
		if (string_get (move, (glong) _tmp101_) == '#') {
#line 5765 "chess-state.c"
			gint _tmp102_;
#line 967 "../lib/chess-state.vala"
			_tmp102_ = i;
#line 967 "../lib/chess-state.vala"
			i = _tmp102_ + 1;
#line 5771 "chess-state.c"
		}
	}
#line 969 "../lib/chess-state.vala"
	_tmp103_ = i;
#line 969 "../lib/chess-state.vala"
	if (string_get (move, (glong) _tmp103_) != '\0') {
#line 971 "../lib/chess-state.vala"
		g_debug ("chess-state.vala:971: Move %s has unexpected characters", move);
#line 972 "../lib/chess-state.vala"
		result = FALSE;
#line 972 "../lib/chess-state.vala"
		if (r0) {
#line 972 "../lib/chess-state.vala"
			*r0 = _vala_r0;
#line 5786 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (f0) {
#line 972 "../lib/chess-state.vala"
			*f0 = _vala_f0;
#line 5792 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (r1) {
#line 972 "../lib/chess-state.vala"
			*r1 = _vala_r1;
#line 5798 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (f1) {
#line 972 "../lib/chess-state.vala"
			*f1 = _vala_f1;
#line 5804 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		if (promotion_type) {
#line 972 "../lib/chess-state.vala"
			*promotion_type = _vala_promotion_type;
#line 5810 "chess-state.c"
		}
#line 972 "../lib/chess-state.vala"
		return result;
#line 5814 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	result = TRUE;
#line 975 "../lib/chess-state.vala"
	if (r0) {
#line 975 "../lib/chess-state.vala"
		*r0 = _vala_r0;
#line 5822 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (f0) {
#line 975 "../lib/chess-state.vala"
		*f0 = _vala_f0;
#line 5828 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (r1) {
#line 975 "../lib/chess-state.vala"
		*r1 = _vala_r1;
#line 5834 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (f1) {
#line 975 "../lib/chess-state.vala"
		*f1 = _vala_f1;
#line 5840 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	if (promotion_type) {
#line 975 "../lib/chess-state.vala"
		*promotion_type = _vala_promotion_type;
#line 5846 "chess-state.c"
	}
#line 975 "../lib/chess-state.vala"
	return result;
#line 5850 "chess-state.c"
}


ChessPlayer*
chess_state_get_opponent (ChessState* self)
{
	ChessPlayer* result;
	ChessPlayer* _tmp0_ = NULL;
	ChessPlayer* _tmp1_;
	Color _tmp2_;
#line 27 "../lib/chess-state.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../lib/chess-state.vala"
	_tmp1_ = self->current_player;
#line 27 "../lib/chess-state.vala"
	_tmp2_ = _tmp1_->color;
#line 27 "../lib/chess-state.vala"
	if (_tmp2_ == COLOR_WHITE) {
#line 5869 "chess-state.c"
		ChessPlayer* _tmp3_;
#line 27 "../lib/chess-state.vala"
		_tmp3_ = self->players[COLOR_BLACK];
#line 27 "../lib/chess-state.vala"
		_tmp0_ = _tmp3_;
#line 5875 "chess-state.c"
	} else {
		ChessPlayer* _tmp4_;
#line 27 "../lib/chess-state.vala"
		_tmp4_ = self->players[COLOR_WHITE];
#line 27 "../lib/chess-state.vala"
		_tmp0_ = _tmp4_;
#line 5882 "chess-state.c"
	}
#line 27 "../lib/chess-state.vala"
	result = _tmp0_;
#line 27 "../lib/chess-state.vala"
	return result;
#line 5888 "chess-state.c"
}


static void
chess_state_class_init (ChessStateClass * klass)
{
#line 20 "../lib/chess-state.vala"
	chess_state_parent_class = g_type_class_peek_parent (klass);
#line 20 "../lib/chess-state.vala"
	g_type_class_adjust_private_offset (klass, &ChessState_private_offset);
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_state_get_property;
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_state_finalize;
#line 20 "../lib/chess-state.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_STATE_OPPONENT_PROPERTY, chess_state_properties[CHESS_STATE_OPPONENT_PROPERTY] = g_param_spec_object ("opponent", "opponent", "opponent", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5905 "chess-state.c"
}


static void
chess_state_instance_init (ChessState * self)
{
#line 20 "../lib/chess-state.vala"
	self->priv = chess_state_get_instance_private (self);
#line 22 "../lib/chess-state.vala"
	self->number = 0;
#line 31 "../lib/chess-state.vala"
	self->en_passant_index = -1;
#line 36 "../lib/chess-state.vala"
	self->last_move = NULL;
#line 5920 "chess-state.c"
}


static void
chess_state_finalize (GObject * obj)
{
	ChessState * self;
#line 20 "../lib/chess-state.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_STATE, ChessState);
#line 23 "../lib/chess-state.vala"
	_vala_array_destroy (self->players, 2, (GDestroyNotify) g_object_unref);
#line 24 "../lib/chess-state.vala"
	_g_object_unref0 (self->current_player);
#line 35 "../lib/chess-state.vala"
	_vala_array_destroy (self->board, 64, (GDestroyNotify) g_object_unref);
#line 36 "../lib/chess-state.vala"
	_g_object_unref0 (self->last_move);
#line 20 "../lib/chess-state.vala"
	G_OBJECT_CLASS (chess_state_parent_class)->finalize (obj);
#line 5940 "chess-state.c"
}


GType
chess_state_get_type (void)
{
	static volatile gsize chess_state_type_id__volatile = 0;
	if (g_once_init_enter (&chess_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessState), 0, (GInstanceInitFunc) chess_state_instance_init, NULL };
		GType chess_state_type_id;
		chess_state_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessState", &g_define_type_info, 0);
		ChessState_private_offset = g_type_add_instance_private (chess_state_type_id, sizeof (ChessStatePrivate));
		g_once_init_leave (&chess_state_type_id__volatile, chess_state_type_id);
	}
	return chess_state_type_id__volatile;
}


static void
_vala_chess_state_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_STATE, ChessState);
#line 20 "../lib/chess-state.vala"
	switch (property_id) {
#line 20 "../lib/chess-state.vala"
		case CHESS_STATE_OPPONENT_PROPERTY:
#line 20 "../lib/chess-state.vala"
		g_value_set_object (value, chess_state_get_opponent (self));
#line 20 "../lib/chess-state.vala"
		break;
#line 5975 "chess-state.c"
		default:
#line 20 "../lib/chess-state.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../lib/chess-state.vala"
		break;
#line 5981 "chess-state.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



